/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

static struct {
        uint32_t reg_address_hi;
        uint32_t reg_address_lo;
        uint32_t reg_tmp;

        uint32_t regs_to_dump[128];
        uint32_t regs_count;
} meta_print_data;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create_at_end(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("u8_32", *type, 5)) {
		*type += 5;
		return TYPE_U8_32;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_buf_init_val(uint32_t val)
{
	assert(info->num_bufs > 0);
	unsigned idx = info->num_bufs - 1;

	if (!info->buf_init_data[idx]) {
		unsigned sz = info->buf_sizes[idx] * 4;
		info->buf_init_data[idx] = malloc(sz);
		memset(info->buf_init_data[idx], 0, sz);
	}

	assert(info->buf_init_data_sizes[idx] < info->buf_sizes[idx]);
	info->buf_init_data[idx][info->buf_init_data_sizes[idx]++] = val;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 363 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 48,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 49,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 50,                     /* T_RPT  */
  YYSYMBOL_T_UL = 51,                      /* T_UL  */
  YYSYMBOL_T_NOP = 52,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 53,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 54,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 55,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 56,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 57,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 58,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 59,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 60,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 61,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 62,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 63,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 64,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 65,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 66,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 67,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 68,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 69,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 70,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 71,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 72,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 73,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 74,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 75,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 76,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 77,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 78,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 79,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 80,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 81,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 82,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 83,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 84,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 85,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 86,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 87,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 88,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 89,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 90,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 91,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 92,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 93,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 94,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 95,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 96,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 97,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 98,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 99,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 100,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 101,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 102,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 103,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 104,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 105,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 106,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 107,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 108,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 109,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 110,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 111,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 112,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 113,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 114,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 115,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 116,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 117,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 118,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 119,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 120,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 121,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 122,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 123,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 124,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 125,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 126,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 127,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 128,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 129,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 130,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 131,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 132,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 133,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 134,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 135,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 136,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 137,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 138,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 139,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 140,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 141,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 142,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 143,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 144,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 145,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 146,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 147,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 148,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 149,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 150,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 151,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 152,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 153,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 154,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 155,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 156,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 157,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 158,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 159,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 160,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 161,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 162,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 163,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 164,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 165,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 166,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 167,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 168,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 169,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 170,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 171,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 172,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 173,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 174,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 175,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 176,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 177,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 178,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 179,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 180,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 181,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 182,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 183,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 184,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 185,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 186,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 187,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 188,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 189,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 190,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 191,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 192,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 193,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 194,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 195,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 196,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 197,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 198,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 199,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 200,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 201,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 202,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 203,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 204,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 205,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 206,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 207,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 208,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 209,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDG_K = 210,               /* T_OP_LDG_K  */
  YYSYMBOL_T_OP_LDL = 211,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 212,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 213,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 214,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 215,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 216,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 217,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 218,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 219,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 220,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 221,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 222,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 223,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 224,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 225,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 226,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 227,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 228,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 229,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 230,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 231,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 232,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 233,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 234,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 235,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 236,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 237,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 238,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 239,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 240,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 241,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 242,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 243,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 244,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 245,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 246,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 247,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 248,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 249,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 250,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 251,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 252,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 253,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 254,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 255,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 256,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 257,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 258,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 259,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 260,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 261,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 262,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 263,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 264,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 265,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 266,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 267,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 268,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 269,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 270,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 271,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 272,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 273,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 274,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 275,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 276,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 277,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 278,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 279,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 280,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 281,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_BAR = 282,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 283,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 284,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 285,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 286,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 287,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 288,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_CCINV = 289,               /* T_OP_CCINV  */
  YYSYMBOL_T_OP_LOCK = 290,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 291,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 292,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 293,                    /* T_RAW  */
  YYSYMBOL_T_OP_PRINT = 294,               /* T_OP_PRINT  */
  YYSYMBOL_T_TYPE_F16 = 295,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 296,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 297,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 298,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 299,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 300,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 301,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_U8_32 = 302,             /* T_TYPE_U8_32  */
  YYSYMBOL_T_UNTYPED = 303,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 304,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 305,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 306,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 307,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 308,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 309,                     /* T_1D  */
  YYSYMBOL_T_2D = 310,                     /* T_2D  */
  YYSYMBOL_T_3D = 311,                     /* T_3D  */
  YYSYMBOL_T_4D = 312,                     /* T_4D  */
  YYSYMBOL_T_LT = 313,                     /* T_LT  */
  YYSYMBOL_T_LE = 314,                     /* T_LE  */
  YYSYMBOL_T_GT = 315,                     /* T_GT  */
  YYSYMBOL_T_GE = 316,                     /* T_GE  */
  YYSYMBOL_T_EQ = 317,                     /* T_EQ  */
  YYSYMBOL_T_NE = 318,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 319,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 320,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 321,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 322,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 323,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 324,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 325,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 326,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 327,                    /* T_NAN  */
  YYSYMBOL_T_INF = 328,                    /* T_INF  */
  YYSYMBOL_T_A0 = 329,                     /* T_A0  */
  YYSYMBOL_T_A1 = 330,                     /* T_A1  */
  YYSYMBOL_T_P0 = 331,                     /* T_P0  */
  YYSYMBOL_T_W = 332,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 333,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 334,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 335,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 336,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 337,                 /* T_MOD_RT  */
  YYSYMBOL_338_ = 338,                     /* '-'  */
  YYSYMBOL_339_ = 339,                     /* ','  */
  YYSYMBOL_340_ = 340,                     /* '('  */
  YYSYMBOL_341_ = 341,                     /* ')'  */
  YYSYMBOL_342_ = 342,                     /* '='  */
  YYSYMBOL_343_ = 343,                     /* ':'  */
  YYSYMBOL_344_ = 344,                     /* '!'  */
  YYSYMBOL_345_ = 345,                     /* '#'  */
  YYSYMBOL_346_ = 346,                     /* '.'  */
  YYSYMBOL_347_a_ = 347,                   /* 'a'  */
  YYSYMBOL_348_o_ = 348,                   /* 'o'  */
  YYSYMBOL_349_p_ = 349,                   /* 'p'  */
  YYSYMBOL_350_s_ = 350,                   /* 's'  */
  YYSYMBOL_351_v_ = 351,                   /* 'v'  */
  YYSYMBOL_352_ = 352,                     /* '+'  */
  YYSYMBOL_353_ = 353,                     /* '<'  */
  YYSYMBOL_354_g_ = 354,                   /* 'g'  */
  YYSYMBOL_355_ = 355,                     /* '['  */
  YYSYMBOL_356_ = 356,                     /* ']'  */
  YYSYMBOL_357_c_ = 357,                   /* 'c'  */
  YYSYMBOL_358_l_ = 358,                   /* 'l'  */
  YYSYMBOL_359_u_ = 359,                   /* 'u'  */
  YYSYMBOL_360_k_ = 360,                   /* 'k'  */
  YYSYMBOL_361_w_ = 361,                   /* 'w'  */
  YYSYMBOL_362_r_ = 362,                   /* 'r'  */
  YYSYMBOL_363_ = 363,                     /* '>'  */
  YYSYMBOL_364_h_ = 364,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 365,                 /* $accept  */
  YYSYMBOL_shader = 366,                   /* shader  */
  YYSYMBOL_367_1 = 367,                    /* $@1  */
  YYSYMBOL_headers = 368,                  /* headers  */
  YYSYMBOL_header = 369,                   /* header  */
  YYSYMBOL_const_val = 370,                /* const_val  */
  YYSYMBOL_localsize_header = 371,         /* localsize_header  */
  YYSYMBOL_const_header = 372,             /* const_header  */
  YYSYMBOL_buf_header_init_val = 373,      /* buf_header_init_val  */
  YYSYMBOL_buf_header_init_vals = 374,     /* buf_header_init_vals  */
  YYSYMBOL_buf_header_addr_reg = 375,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 376,               /* buf_header  */
  YYSYMBOL_377_2 = 377,                    /* $@2  */
  YYSYMBOL_invocationid_header = 378,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 379,              /* wgid_header  */
  YYSYMBOL_numwg_header = 380,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 381,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 382,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 383,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 384,                /* in_header  */
  YYSYMBOL_out_header = 385,               /* out_header  */
  YYSYMBOL_tex_header = 386,               /* tex_header  */
  YYSYMBOL_iflag = 387,                    /* iflag  */
  YYSYMBOL_iflags = 388,                   /* iflags  */
  YYSYMBOL_instrs = 389,                   /* instrs  */
  YYSYMBOL_instr = 390,                    /* instr  */
  YYSYMBOL_label = 391,                    /* label  */
  YYSYMBOL_cat0_src1 = 392,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 393,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 394,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 395,               /* cat0_instr  */
  YYSYMBOL_396_3 = 396,                    /* $@3  */
  YYSYMBOL_397_4 = 397,                    /* $@4  */
  YYSYMBOL_398_5 = 398,                    /* $@5  */
  YYSYMBOL_399_6 = 399,                    /* $@6  */
  YYSYMBOL_400_7 = 400,                    /* $@7  */
  YYSYMBOL_401_8 = 401,                    /* $@8  */
  YYSYMBOL_402_9 = 402,                    /* $@9  */
  YYSYMBOL_403_10 = 403,                   /* $@10  */
  YYSYMBOL_404_11 = 404,                   /* $@11  */
  YYSYMBOL_405_12 = 405,                   /* $@12  */
  YYSYMBOL_406_13 = 406,                   /* $@13  */
  YYSYMBOL_407_14 = 407,                   /* $@14  */
  YYSYMBOL_408_15 = 408,                   /* $@15  */
  YYSYMBOL_409_16 = 409,                   /* $@16  */
  YYSYMBOL_cat1_opc = 410,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 411,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 412,              /* cat1_movmsk  */
  YYSYMBOL_413_17 = 413,                   /* $@17  */
  YYSYMBOL_mova_src = 414,                 /* mova_src  */
  YYSYMBOL_cat1_mova1 = 415,               /* cat1_mova1  */
  YYSYMBOL_416_18 = 416,                   /* $@18  */
  YYSYMBOL_cat1_mova = 417,                /* cat1_mova  */
  YYSYMBOL_418_19 = 418,                   /* $@19  */
  YYSYMBOL_cat1_swz = 419,                 /* cat1_swz  */
  YYSYMBOL_420_20 = 420,                   /* $@20  */
  YYSYMBOL_cat1_gat = 421,                 /* cat1_gat  */
  YYSYMBOL_422_21 = 422,                   /* $@21  */
  YYSYMBOL_cat1_sct = 423,                 /* cat1_sct  */
  YYSYMBOL_424_22 = 424,                   /* $@22  */
  YYSYMBOL_cat1_instr = 425,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 426,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 427,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 428,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 429,                     /* cond  */
  YYSYMBOL_cat2_instr = 430,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 431,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 432,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 433,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 434,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 435,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 436,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 437,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 438,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 439,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 440,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc_isam = 441,            /* cat5_opc_isam  */
  YYSYMBOL_cat5_opc = 442,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 443,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 444,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 445,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 446,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 447,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 448,                  /* cat5_a1  */
  YYSYMBOL_cat5_samp_tex = 449,            /* cat5_samp_tex  */
  YYSYMBOL_cat5_samp_tex_all = 450,        /* cat5_samp_tex_all  */
  YYSYMBOL_cat5_instr = 451,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 452,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 453,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 454,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 455,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 456,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 457,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 458,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 459, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 460, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 461, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 462,                /* cat6_load  */
  YYSYMBOL_463_23 = 463,                   /* $@23  */
  YYSYMBOL_464_24 = 464,                   /* $@24  */
  YYSYMBOL_465_25 = 465,                   /* $@25  */
  YYSYMBOL_466_26 = 466,                   /* $@26  */
  YYSYMBOL_467_27 = 467,                   /* $@27  */
  YYSYMBOL_468_28 = 468,                   /* $@28  */
  YYSYMBOL_469_29 = 469,                   /* $@29  */
  YYSYMBOL_470_30 = 470,                   /* $@30  */
  YYSYMBOL_cat6_store = 471,               /* cat6_store  */
  YYSYMBOL_472_31 = 472,                   /* $@31  */
  YYSYMBOL_473_32 = 473,                   /* $@32  */
  YYSYMBOL_474_33 = 474,                   /* $@33  */
  YYSYMBOL_475_34 = 475,                   /* $@34  */
  YYSYMBOL_476_35 = 476,                   /* $@35  */
  YYSYMBOL_cat6_loadib = 477,              /* cat6_loadib  */
  YYSYMBOL_478_36 = 478,                   /* $@36  */
  YYSYMBOL_cat6_storeib = 479,             /* cat6_storeib  */
  YYSYMBOL_480_37 = 480,                   /* $@37  */
  YYSYMBOL_cat6_prefetch = 481,            /* cat6_prefetch  */
  YYSYMBOL_482_38 = 482,                   /* $@38  */
  YYSYMBOL_cat6_atomic_opc = 483,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 484,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 485,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 486,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 487,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 488,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 489,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 490,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 491,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 492,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 493,                 /* cat6_ibo  */
  YYSYMBOL_494_39 = 494,                   /* $@39  */
  YYSYMBOL_cat6_id_opc = 495,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 496,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 497,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 498,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 499,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 500, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 501, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src = 502, /* cat6_bindless_ibo_opc_3src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src_dst = 503, /* cat6_bindless_ibo_opc_3src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 504,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 505,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 506, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 507,        /* cat6_bindless_ldc  */
  YYSYMBOL_const_dst = 508,                /* const_dst  */
  YYSYMBOL_cat6_stc = 509,                 /* cat6_stc  */
  YYSYMBOL_510_40 = 510,                   /* $@40  */
  YYSYMBOL_511_41 = 511,                   /* $@41  */
  YYSYMBOL_cat6_todo = 512,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 513,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 514,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 515,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 516,             /* cat7_barrier  */
  YYSYMBOL_517_42 = 517,                   /* $@42  */
  YYSYMBOL_518_43 = 518,                   /* $@43  */
  YYSYMBOL_cat7_data_cache = 519,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 520,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 521,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 522,               /* cat7_instr  */
  YYSYMBOL_523_44 = 523,                   /* $@44  */
  YYSYMBOL_raw_instr = 524,                /* raw_instr  */
  YYSYMBOL_meta_print_regs = 525,          /* meta_print_regs  */
  YYSYMBOL_meta_print_reg = 526,           /* meta_print_reg  */
  YYSYMBOL_meta_print_start = 527,         /* meta_print_start  */
  YYSYMBOL_meta_print = 528,               /* meta_print  */
  YYSYMBOL_src = 529,                      /* src  */
  YYSYMBOL_dst = 530,                      /* dst  */
  YYSYMBOL_const = 531,                    /* const  */
  YYSYMBOL_dst_reg_flag = 532,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 533,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 534,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 535,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 536,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 537,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 538,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 539,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 540,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 541,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 542, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 543,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_uoffset = 544,                  /* uoffset  */
  YYSYMBOL_offset = 545,                   /* offset  */
  YYSYMBOL_src_uoffset = 546,              /* src_uoffset  */
  YYSYMBOL_relative_gpr_src = 547,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 548,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 549,           /* relative_const  */
  YYSYMBOL_relative = 550,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 551,           /* immediate_cat1  */
  YYSYMBOL_immediate = 552,                /* immediate  */
  YYSYMBOL_flut_immed = 553,               /* flut_immed  */
  YYSYMBOL_integer = 554,                  /* integer  */
  YYSYMBOL_float = 555,                    /* float  */
  YYSYMBOL_type = 556                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 332 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 964 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1511

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  365
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  192
/* YYNRULES -- Number of rules.  */
#define YYNRULES  586
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1257

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   592


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   344,     2,   345,     2,     2,     2,     2,
     340,   341,     2,   352,   339,   338,   346,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   343,     2,
     353,   342,   363,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   355,     2,   356,     2,     2,     2,   347,     2,   357,
       2,     2,     2,   354,   364,     2,     2,   360,   358,     2,
       2,   348,   349,     2,   362,   350,     2,   359,   351,   361,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   737,   737,   737,   739,   740,   742,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   755,   756,
     757,   758,   760,   766,   770,   771,   772,   773,   776,   784,
     786,   786,   792,   798,   805,   812,   821,   823,   825,   828,
     830,   832,   839,   840,   841,   842,   843,   844,   845,   846,
     848,   849,   851,   852,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   866,   868,   869,   871,   872,
     874,   875,   877,   878,   878,   879,   879,   880,   880,   881,
     881,   882,   882,   883,   883,   884,   884,   885,   885,   886,
     886,   887,   888,   888,   889,   890,   891,   892,   893,   894,
     895,   895,   896,   897,   898,   899,   900,   900,   901,   902,
     902,   903,   904,   905,   906,   907,   907,   909,   912,   916,
     917,   919,   919,   935,   936,   937,   939,   939,   946,   946,
     953,   953,   955,   955,   957,   957,   960,   961,   962,   963,
     964,   965,   966,   967,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   984,   985,
     986,   987,   988,   989,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1019,  1020,  1021,  1022,  1023,  1024,  1026,  1027,  1028,
    1030,  1031,  1033,  1034,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    1053,  1054,  1055,  1056,  1057,  1059,  1060,  1062,  1063,  1065,
    1066,  1067,  1068,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1081,  1083,  1084,  1086,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,  1131,
    1133,  1134,  1135,  1136,  1138,  1139,  1140,  1141,  1143,  1144,
    1145,  1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,
    1157,  1158,  1160,  1161,  1162,  1163,  1165,  1166,  1167,  1168,
    1169,  1170,  1172,  1175,  1180,  1186,  1192,  1195,  1197,  1197,
    1198,  1198,  1199,  1199,  1200,  1200,  1201,  1201,  1202,  1202,
    1203,  1203,  1203,  1207,  1207,  1208,  1208,  1209,  1209,  1210,
    1210,  1211,  1211,  1213,  1213,  1214,  1214,  1216,  1216,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,  1252,  1254,  1256,  1258,  1260,  1261,  1262,  1264,  1266,
    1267,  1269,  1270,  1271,  1271,  1274,  1275,  1276,  1278,  1280,
    1281,  1283,  1284,  1285,  1287,  1288,  1290,  1292,  1293,  1294,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1304,  1306,
    1308,  1309,  1310,  1311,  1313,  1317,  1318,  1319,  1321,  1327,
    1328,  1329,  1332,  1332,  1333,  1333,  1335,  1336,  1337,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,
    1350,  1352,  1353,  1354,  1355,  1357,  1358,  1360,  1360,  1361,
    1361,  1363,  1364,  1365,  1367,  1368,  1370,  1371,  1372,  1374,
    1375,  1376,  1377,  1378,  1379,  1380,  1381,  1381,  1388,  1390,
    1391,  1393,  1397,  1404,  1462,  1463,  1464,  1465,  1467,  1468,
    1469,  1470,  1472,  1474,  1475,  1476,  1477,  1478,  1480,  1481,
    1484,  1485,  1487,  1488,  1489,  1490,  1491,  1493,  1494,  1496,
    1497,  1499,  1500,  1502,  1503,  1505,  1506,  1508,  1509,  1510,
    1512,  1513,  1514,  1516,  1517,  1518,  1520,  1521,  1523,  1524,
    1526,  1528,  1529,  1531,  1532,  1534,  1535,  1537,  1538,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1552,  1553,  1554,  1555,
    1556,  1559,  1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,
    1568,  1569,  1570,  1572,  1573,  1574,  1575,  1577,  1578,  1580,
    1581,  1582,  1583,  1584,  1585,  1586,  1587
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP",
  "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC",
  "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL",
  "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT",
  "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS",
  "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDG_K", "T_OP_LDL", "T_OP_LDP", "T_OP_STG",
  "T_OP_STG_A", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP",
  "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_OP_CCINV",
  "T_OP_LOCK", "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW", "T_OP_PRINT",
  "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16",
  "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_U8_32", "T_UNTYPED", "T_TYPED",
  "T_MIXED", "T_UNSIGNED", "T_LOW", "T_HIGH", "T_1D", "T_2D", "T_3D",
  "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN",
  "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM",
  "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX", "T_MOD_MEM", "T_MOD_RT",
  "'-'", "','", "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'",
  "'o'", "'p'", "'s'", "'v'", "'+'", "'<'", "'g'", "'['", "']'", "'c'",
  "'l'", "'u'", "'k'", "'w'", "'r'", "'>'", "'h'", "$accept", "shader",
  "$@1", "headers", "header", "const_val", "localsize_header",
  "const_header", "buf_header_init_val", "buf_header_init_vals",
  "buf_header_addr_reg", "buf_header", "$@2", "invocationid_header",
  "wgid_header", "numwg_header", "branchstack_header", "pvtmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16",
  "cat1_opc", "cat1_src", "cat1_movmsk", "$@17", "mova_src", "cat1_mova1",
  "$@18", "cat1_mova", "$@19", "cat1_swz", "$@20", "cat1_gat", "$@21",
  "cat1_sct", "$@22", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_dp_signedness",
  "cat3_dp_pack", "cat3_opc", "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp",
  "cat5_opc_isam", "cat5_opc", "cat5_flag", "cat5_flags", "cat5_samp",
  "cat5_tex", "cat5_type", "cat5_a1", "cat5_samp_tex", "cat5_samp_tex_all",
  "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset",
  "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_a6xx_global_address_pt3", "cat6_a6xx_global_address_pt2",
  "cat6_a6xx_global_address", "cat6_load", "$@23", "$@24", "$@25", "$@26",
  "$@27", "$@28", "$@29", "$@30", "cat6_store", "$@31", "$@32", "$@33",
  "$@34", "$@35", "cat6_loadib", "$@36", "cat6_storeib", "$@37",
  "cat6_prefetch", "$@38", "cat6_atomic_opc", "cat6_a3xx_atomic_opc",
  "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@39", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_3src", "cat6_bindless_ibo_opc_3src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "const_dst", "cat6_stc", "$@40", "$@41",
  "cat6_todo", "cat6_instr", "cat7_scope", "cat7_scopes", "cat7_barrier",
  "$@42", "$@43", "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope",
  "cat7_instr", "$@44", "raw_instr", "meta_print_regs", "meta_print_reg",
  "meta_print_start", "meta_print", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "uoffset", "offset", "src_uoffset",
  "relative_gpr_src", "relative_gpr_dst", "relative_const", "relative",
  "immediate_cat1", "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-932)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -932,     4,  1055,  -932,    54,  -310,    54,  -290,  -261,  -259,
      54,  -253,  -243,  -228,    54,  -932,   242,  1055,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,   117,  -203,   134,  -932,   154,   138,   167,
    -932,   183,   186,   189,  -932,  -137,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,   203,   958,  1177,    80,  -932,
    -932,  -932,  -127,  -932,  -932,  -932,    54,  -115,  -104,  -100,
     -94,   -92,   -79,   -75,   -64,   -57,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,   -33,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   -20,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
      -2,    25,    32,    18,    23,    34,    37,    38,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
     185,  -932,  -932,  -932,  -932,  -932,  -932,  -932,    78,    41,
      78,  -932,    78,    78,    78,    42,  -932,    78,  -932,    45,
      47,    45,  -932,  -932,  -932,  -932,  -932,  -932,    50,    50,
      50,  -932,  -932,  -932,  -932,    58,    50,    50,  -932,    58,
    -932,    50,    50,    50,    50,  -932,    59,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,   375,  -932,  -127,    64,    54,
     398,    54,  -932,  -932,  -932,  -932,   407,   412,   415,  -254,
    -254,  -254,    57,  -254,  -254,    81,    81,    81,  -254,    81,
      92,    81,    81,    93,    96,   113,    98,   122,   125,   126,
     128,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      50,   108,    58,    58,    50,    58,    58,    58,   127,   127,
     129,  -932,   119,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,   135,  -932,   436,    -6,   142,   143,   148,   445,   152,
     153,   157,   160,   -85,   133,   161,  1161,    45,    78,   842,
     163,   163,   -34,   164,   164,   164,   831,   164,   164,   164,
      78,   164,   164,   164,   164,    22,  -932,  -932,    54,   162,
     165,  -932,   172,  -932,   180,   181,   182,  -932,   192,   190,
     194,   195,  -932,  -932,   292,  -932,   198,   199,    72,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,    78,    78,   137,    78,    78,
     171,   177,   184,   196,   164,   191,    78,   200,   164,    78,
     193,   209,  -190,   127,  -932,  -932,   -76,   212,   219,  -932,
    -932,   155,   155,   294,  -932,  -932,  -932,  -932,  -932,  -932,
      78,   294,   664,   819,   178,  -932,  -932,    -8,    78,   294,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   210,    45,   831,    78,    78,  -932,  -932,  -194,
      58,    58,    58,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,    78,    58,    58,  -932,    58,    58,    58,    58,
     214,   221,   223,   236,  -932,  -932,    54,  -932,    54,   576,
     577,    57,  -932,    81,  -171,  -171,  -932,  -932,    81,    81,
      81,  -932,  -932,    81,    78,   155,   155,    78,    78,    78,
     237,   246,   235,   252,   253,   238,   240,   241,   245,    58,
      36,   269,   263,    58,   280,   267,   272,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,   283,  -219,  -219,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,   273,   277,  -932,  -932,  -932,
      24,   278,   282,   293,  -932,  -932,  -932,   591,   224,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,    57,   877,   865,  -932,  -932,  -932,  -932,  -932,   297,
     298,   302,    36,  -932,   305,  -932,  -932,  -932,   306,  -932,
    -932,  -932,   307,  -932,   685,   163,   308,   311,   313,  -932,
    -932,  -932,  -932,   309,   315,   321,   314,   323,   327,   328,
     331,   336,   337,    57,   334,   299,    48,   345,  -932,   312,
     352,   359,  -932,  -932,   368,   361,   362,  -932,  -932,  -932,
    -932,  -932,  -932,   140,  -932,  -932,  -932,   364,   365,   366,
     357,   363,    33,   358,   370,    36,   718,    36,    36,   369,
    -217,   372,    36,   376,   377,    33,    33,   393,    57,    57,
    -932,   371,   373,   399,   408,  -932,   397,   403,   271,   405,
     424,   438,   439,    79,  -932,  -932,  -932,  -932,   428,    57,
    -932,  -932,   294,   294,   718,   718,   685,   819,  -932,    78,
    -932,   685,   641,    57,    57,    57,   416,    57,    57,    57,
      57,    57,    57,   425,   427,   431,   433,  -932,  -932,    54,
      57,    57,   772,  -932,    81,    81,  -932,    78,   685,    78,
     430,   432,   429,   435,  -932,   437,   440,  -219,   441,   249,
     434,  -214,  -214,    57,    48,  -932,   444,  -932,   446,  -214,
      57,   449,   452,   453,   442,  -932,  -932,  -932,  -932,  -219,
    -219,  -932,  -932,  -932,  -932,  -932,  -219,  -219,   455,   464,
    -932,   471,   443,  -932,   454,   474,   476,   477,   478,   480,
    -932,  -932,   481,  -932,  -932,   482,   484,   485,   486,   469,
      78,  -932,   488,   491,   492,   501,   -44,    57,   -44,    48,
     509,   508,   530,   532,  -932,  -932,   511,   536,   537,    36,
     718,    57,   538,    36,    36,   525,   543,    10,    48,   527,
    -932,   528,    78,  -932,   547,    36,   531,   473,    57,   550,
     551,    57,   417,   420,   533,   534,  -932,  -932,  -932,   294,
     664,   819,    30,   718,   685,   641,   567,   641,   535,   540,
     541,    48,   583,   569,   -44,   -44,   -44,   -44,   578,   578,
     578,    78,   580,   572,  -932,    54,  -932,  -932,    57,   685,
     685,    78,  -217,   571,  -932,   579,  -217,  -217,   595,    36,
      36,  -932,   -10,  -932,   596,   607,   608,    57,  -217,   611,
     575,   599,   685,    30,    78,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,   617,   605,   620,   621,  -932,  -932,   624,
    -932,  -932,   625,    78,    78,    78,   609,   612,   614,    78,
     685,   685,    78,   645,  -932,  -932,  -932,  -932,   -44,   618,
    -932,   635,   638,   639,   640,   629,   647,   636,   642,   655,
      36,   653,  -219,    48,   627,  -932,    36,    36,   658,  -932,
     657,    36,    30,  -932,   678,   679,   680,   819,  -932,   681,
     549,   685,   641,   641,   683,   684,   686,  -932,   669,    48,
     689,   694,   697,   701,  -932,    78,   715,  1045,   685,   685,
      78,   713,    30,    36,   714,   716,   722,    30,   735,  -932,
      57,   739,   740,   699,   743,   744,   728,   746,    57,    57,
     426,  -932,   641,  -932,  -932,  -932,  -932,  -932,  -932,   732,
     703,    36,    48,   736,    48,    48,    48,    48,  -932,   741,
     753,  -932,   757,   763,    30,  -932,  -217,    30,    30,    30,
    -932,   750,  -219,    30,    30,    30,    30,    30,   773,    30,
    -932,  -932,  -932,  -932,  -932,  -932,   759,   760,   777,   761,
     795,  -932,   796,   605,   605,  -932,    57,   685,   685,  -932,
     780,  -932,  -932,  -932,   784,   785,  -932,  -932,   783,  -932,
    -932,    36,  -932,    48,    48,    36,   801,    36,    48,   802,
     803,   804,  -932,  -932,   805,    57,   792,   807,   808,   798,
     799,  -932,    36,   813,  -932,    48,    48,  1150,    30,  -932,
      57,    36,    36,   821,   823,   824,    48,  -932,  -932,   816,
    -932,  -932,   829,   832,    36,    36,    36,   833,    57,    36,
      36,  -932,   834,  -932,    36,   836,  -932,  -932,    36,  -932,
    1164,   838,   837,    36,    57,  -932,  -932
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    38,    50,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    30,     0,     0,     0,
      36,     0,     0,     0,    37,     0,    42,    43,    44,    45,
      46,    47,    48,    49,   488,     0,    50,     0,    50,    53,
      64,    62,     0,    63,     5,    20,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,    65,   492,    51,    72,
      73,    75,    77,     0,    81,    83,    85,    87,    89,    91,
      92,    94,    95,    96,    97,    98,    99,   100,   102,   103,
     104,   105,     0,   106,   108,   109,   111,   112,   113,   114,
       0,     0,     0,     0,     0,     0,     0,     0,   164,   165,
     166,   167,   148,   158,   144,   161,   149,   150,   151,   152,
     153,   168,   169,   170,   171,   159,   160,   172,   173,   174,
     175,   145,   176,   177,   154,   178,   162,   163,   179,   180,
     181,   155,   147,   146,   182,   183,   184,   185,   186,   187,
     188,   156,   157,   189,   190,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   227,   228,   225,   226,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   244,   245,   270,   271,   272,   273,
     274,   275,   276,   309,   328,   330,   332,   336,   334,   343,
     345,   349,   347,   353,   446,   447,   357,   338,   351,   448,
     398,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   416,   429,   428,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   399,   400,
     355,   434,   340,   405,   406,   407,   442,   444,   467,   469,
     481,   483,   471,   472,   473,   482,   484,   485,   486,    54,
       0,   136,   137,   138,   139,   140,   141,    55,     0,     0,
       0,    56,     0,     0,     0,     0,    57,     0,    58,   288,
     288,   288,    59,   449,   451,   450,   452,   453,     0,     0,
       0,   396,   397,   395,   454,     0,     0,     0,   455,     0,
     456,     0,     0,     0,     0,   458,     0,   457,   459,   460,
      60,   479,   480,    61,    52,     0,   493,   489,     0,     0,
       0,    27,    32,    33,    34,    35,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   465,   465,
       0,   498,     0,   503,   504,   505,   506,   507,   499,   500,
     501,     0,   510,   508,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   288,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   491,   490,     0,     0,
       0,    24,    25,    31,     0,     0,     0,    67,     0,     0,
       0,     0,   573,   575,     0,    79,     0,     0,     0,    86,
      88,    90,    93,   101,   115,   107,   110,   121,   126,   128,
     117,   118,   130,   132,   134,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   465,   468,   470,     0,     0,     0,   509,
     511,     0,     0,     0,   191,   192,   193,   194,   195,   196,
       0,     0,     0,     0,     0,   200,   201,     0,     0,     0,
     283,   277,   282,   286,   284,   285,   287,   278,   279,   280,
     281,   289,     0,   288,     0,     0,     0,   310,   311,     0,
       0,     0,     0,   579,   580,   581,   582,   583,   584,   585,
     586,   316,     0,     0,     0,   408,     0,     0,     0,     0,
       0,     0,     0,     0,   322,    22,     0,    28,    27,     0,
       0,     0,    66,     0,     0,     0,   574,   576,     0,     0,
       0,    71,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   464,   463,   461,
     462,   466,   476,   477,   478,     0,   536,   536,   494,   502,
     512,   513,   514,   515,   516,     0,     0,   495,   496,   497,
       0,     0,     0,     0,   142,   519,   523,   517,     0,   525,
     526,   527,   119,   547,   548,   528,   120,   549,   143,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,     0,     0,     0,   530,   197,   532,   558,   556,     0,
       0,     0,     0,   533,     0,   534,   535,   521,     0,   522,
     202,   203,     0,   243,     0,     0,     0,     0,   305,   312,
     313,   314,   315,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    74,    69,     0,     0,     0,    80,    82,    84,
     116,   122,   127,     0,   123,   124,   129,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     536,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     538,     0,     0,     0,     0,   577,     0,     0,     0,     0,
       0,     0,     0,     0,   518,   520,   524,   529,     0,     0,
     560,   531,     0,     0,     0,     0,     0,     0,   301,     0,
     292,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   414,   415,     0,
       0,     0,     0,    68,     0,     0,   125,     0,     0,     0,
       0,     0,   440,     0,   439,     0,     0,   536,     0,     0,
       0,   536,   536,     0,     0,   318,     0,   317,     0,   536,
       0,     0,     0,     0,     0,   539,   537,   544,   543,   536,
     536,   554,   555,   578,   550,   551,   536,   536,     0,     0,
     557,     0,     0,   199,     0,     0,     0,     0,     0,     0,
     290,   291,   296,   297,   304,   294,     0,     0,     0,     0,
       0,   403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    76,    78,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     320,     0,     0,   319,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   552,   553,   559,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,   409,
     409,     0,     0,     0,   438,     0,    39,    40,     0,     0,
       0,     0,   536,     0,   441,     0,   536,   536,     0,     0,
       0,   327,     0,   321,     0,     0,     0,     0,   536,     0,
       0,     0,     0,     0,     0,   542,   546,   545,   541,   198,
     229,   230,   231,     0,   536,   296,   297,   298,   307,   294,
     295,   303,   294,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   412,   413,   411,   435,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   536,     0,     0,   326,     0,     0,     0,   358,
       0,     0,     0,   341,     0,     0,     0,     0,   540,     0,
       0,     0,     0,     0,     0,     0,     0,   401,     0,     0,
       0,     0,     0,     0,   410,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   324,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   232,     0,   299,   293,   300,   306,   294,   302,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   436,     0,
       0,   131,     0,     0,     0,   331,   536,     0,     0,     0,
     346,     0,   536,     0,     0,     0,     0,     0,     0,     0,
     443,   445,   487,   474,   475,   308,     0,     0,     0,     0,
       0,   430,     0,   536,   536,   437,     0,     0,     0,   329,
       0,   337,   335,   344,     0,     0,   350,   348,     0,   339,
     352,     0,   342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   133,   135,     0,     0,     0,     0,     0,     0,
       0,   393,     0,     0,   431,     0,     0,     0,     0,   325,
       0,     0,     0,     0,     0,     0,     0,   432,   433,     0,
     333,   323,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   394,     0,   402,     0,     0,   354,   356,     0,   404,
       0,     0,     0,     0,     0,   392,    41
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -932,  -932,  -932,  1163,  -932,    -4,  -932,  -932,  -932,   574,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  1122,  -932,  1126,  -932,  -207,   573,  -355,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,   643,  -932,  -932,   560,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -227,
     378,  -733,  -453,   106,   379,  -913,  -932,   626,   570,   526,
     340,  -774,  -712,  -729,  -932,  -932,   268,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -631,  -223,  -105,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -432,  -932,  -932,  -932,  -932,  -932,  -932,
    -394,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
     822,  -932,  -932,  -932,  -135,   758,  -459,  -932,   764,  -321,
    -932,  -503,  -402,  -932,  -932,  -723,  -521,  -527,  -772,  -931,
    -634,  -816,   650,  -932,  -932,  -538,  -607,  -550,   504,  -387,
     406,   634
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,   481,    18,    19,   482,   483,
     381,    20,    68,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    56,    57,    58,    59,    60,   489,   755,   499,
     319,   389,   390,   391,   618,   393,   394,   395,   396,   397,
     398,   399,   401,   402,   623,   320,   674,   321,   624,   762,
     322,   625,   323,   626,   324,   627,   325,   628,   326,   629,
     327,   328,   329,   330,   550,   331,   454,   558,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   457,   458,
    1025,  1026,   575,  1123,  1027,  1028,   342,   463,   580,   467,
     865,   866,   939,   602,  1065,  1001,   858,   343,   411,   412,
     413,   415,   414,   422,   425,  1117,   344,   416,   417,   419,
     418,   423,   345,   420,   346,   424,   347,   421,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   973,
     359,   360,  1044,   981,   836,   361,   362,   363,   364,   365,
     366,   603,   367,   853,   368,   426,   427,   369,   370,   533,
     534,   371,   428,   429,   372,  1162,   655,   373,   430,    61,
     376,   377,    62,    63,   675,   442,   676,   443,   444,   445,
     677,   712,   679,   718,   680,   681,   704,   705,   714,   790,
     867,  1079,   683,   446,   684,   685,   686,   706,   707,   708,
     800,   591
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      34,   431,    36,   716,     3,   495,    40,   447,   576,   449,
      44,   450,   451,   452,   833,   715,   455,   658,   765,   765,
     682,   682,   791,   792,   710,   492,   493,   492,   493,   795,
      35,   711,   723,   492,   493,   535,   492,   493,   678,   678,
     703,   500,   501,   658,   503,   897,   505,   506,   703,   678,
      37,   492,   493,   860,  1031,   658,   703,    30,    31,    32,
     492,   493,   378,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   492,   493,   487,   621,    38,
      -3,    39,   492,   493,   795,   431,    45,    41,   604,   903,
     488,   894,   895,  1078,   906,   907,   908,    42,   910,   911,
     912,   913,   914,   915,   764,   764,   433,   434,   435,   436,
     437,   622,    43,   460,   461,   729,   730,   731,   732,   788,
      65,   788,   763,   763,   788,    46,    47,    48,    49,    50,
      51,    52,    53,   789,   942,   864,    66,   572,   938,   651,
     807,   947,    67,   492,   493,    70,    71,   658,   659,   595,
     941,   713,   717,   811,   687,   687,   846,   946,   492,   493,
     753,    69,   658,   659,   647,   807,   665,   666,   648,  1126,
    1128,   649,   650,   754,   804,    72,   660,   661,   662,   663,
     664,   665,   666,   490,   491,   658,   496,   497,   982,  1021,
      73,   502,   431,    74,   630,   631,    75,   633,   634,   660,
     661,   662,   663,   664,   665,   641,    76,   860,   644,  1165,
      77,   432,   375,   433,   434,   435,   436,   437,  1055,   806,
     555,   556,  1058,  1059,   751,   807,   379,   940,   940,   709,
     571,   658,   659,  1030,  1070,   940,   380,   722,   687,   687,
    1023,   382,  1078,  1078,   806,   952,   953,   383,    45,   384,
     665,   666,   954,   955,   727,   728,   658,   659,   752,   652,
     653,   654,   385,   757,   758,   759,   386,   716,   760,   577,
     578,   736,   819,   859,   616,   617,   883,   387,  1069,   715,
     978,   979,   980,   799,   388,   892,   893,    46,    47,    48,
      49,    50,    51,    52,    53,   616,   617,   492,   493,   720,
     721,   658,   659,   761,   806,  1121,   767,   768,   769,   703,
     703,   859,   859,   392,   808,   660,   661,   662,   663,   664,
     665,   666,   818,   438,   439,   440,   400,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   667,
     668,   669,  1063,  1064,   403,   600,   725,  1030,  1045,  1046,
    1000,   796,   797,   872,   873,   404,   604,  1199,  1200,   838,
     494,   405,   798,   852,   406,   667,   668,   669,   494,   407,
     701,   494,  1180,    54,    55,   479,   687,   667,   668,   669,
     408,   601,   476,   409,   410,   854,   494,   448,   453,  1160,
    1161,   456,    33,   459,   702,   494,   462,  1163,   854,   854,
     806,   875,   876,   478,   466,   475,   480,   438,   439,   440,
     494,   716,  1022,   484,   896,   713,   888,   798,   485,   899,
     905,   486,   891,   715,   504,   507,   498,   859,  1108,   492,
     493,   510,  1019,   658,   659,   508,   604,   604,   604,  1020,
     604,   604,   604,   604,   604,   604,   927,   660,   661,   662,
     663,   664,   509,   921,   922,   511,   703,   678,   512,   513,
     859,   514,   525,  1075,   433,   434,   435,   436,   437,   667,
     668,   669,   537,   532,   605,   536,   604,   876,   494,   557,
     670,   541,   542,   604,   667,   668,   669,   543,   538,   924,
     925,   551,   552,   494,   632,   670,   553,   671,   898,   554,
     559,   606,   672,   574,   673,   780,   607,   667,   668,   669,
     579,   608,   671,  1164,   438,   439,   440,   672,  1185,   673,
     609,   610,  1116,   612,   611,   635,   926,   716,   928,   613,
     604,   636,   838,   614,   615,    54,    55,   619,   620,   715,
     672,   656,   637,   805,   994,   638,   640,   441,   657,   724,
     645,   876,  1145,   667,   668,   669,   658,  1150,   642,   713,
     743,  1011,  1024,  1029,  1014,  1032,   646,   744,   805,   745,
     660,   661,   662,   663,   664,   746,   770,   805,   667,   668,
     669,   671,   749,   750,   838,   771,   672,  1052,  1053,   972,
     772,   773,   774,   775,  1179,   776,   777,  1181,  1182,  1183,
     778,  1051,   747,  1186,  1187,  1188,  1189,  1190,   781,  1192,
    1074,   837,   660,   661,   662,   663,   664,   859,   782,   784,
     604,  1006,   785,   667,   668,   669,   793,   786,   805,   787,
     794,   801,   494,   803,   701,   802,   812,   813,  1091,  1092,
     857,   814,   861,   862,   815,   816,   817,   869,   658,   820,
     821,   671,   822,   826,   840,   823,   672,   834,   702,   835,
    1047,   824,   660,   661,   662,   663,   664,   825,  1230,   827,
    1054,   658,   659,   828,   829,   713,   838,   830,  1124,  1124,
    1127,  1127,   831,   832,   839,   660,   661,   662,   663,   664,
     665,   666,   658,  1076,   841,   983,  1141,  1142,   842,   843,
     844,   845,   838,   847,   848,   849,   660,   661,   662,   663,
     664,   850,  1084,  1085,  1086,   863,   855,   851,  1090,   856,
    1127,  1093,   870,  1152,   805,   658,   659,   874,   879,   943,
     868,   604,   604,   687,   877,   871,   878,   880,   881,   660,
     661,   662,   663,   664,   882,   838,   884,   838,   838,   838,
     838,  1039,  1040,  1041,  1042,   667,   668,   669,   544,   545,
     546,   547,   548,   549,   494,   885,   670,   886,   887,   890,
     909,   916,   919,   917,  1138,  1202,  1203,   918,   923,  1143,
    1015,   931,   959,  1016,   837,   929,   937,   930,   951,  1201,
     673,   932,   933,   960,   992,   934,   956,   936,   996,   997,
     944,   945,  1002,  1003,   948,   957,   838,   838,   949,   950,
    1008,   838,   958,   961,   984,   962,   963,   964,  1219,   965,
     966,   967,   492,   493,   971,  1095,   658,  1010,   838,   838,
     968,   969,   970,  1231,   974,   920,   837,   975,   976,   838,
     660,   661,   662,   663,   664,   665,   666,   977,   985,   986,
     989,  1245,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,  1061,  1062,  1036,  1256,   492,   493,
     901,   987,   658,   659,   988,   990,   991,   995,   667,   668,
     669,   998,   999,  1004,  1005,   470,  1007,  1009,   901,  1012,
    1013,   665,   666,  1033,  1034,  1035,  1017,  1018,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,  1037,  1038,  1043,  1106,  1048,  1056,   837,  1049,
    1072,  1111,  1112,  1057,  1060,  1066,  1115,   515,   516,   517,
     518,   519,   520,   521,   522,   523,  1067,  1068,   526,   527,
    1071,   529,   530,   531,   837,  1073,  1077,   789,  1109,  1080,
    1081,   900,   901,  1082,  1083,  1087,  1088,  1094,  1146,  1089,
     667,   668,   669,  1096,  1097,   464,   465,  1098,  1099,  1100,
    1110,  1050,   468,   469,  1133,  1101,  1102,   471,   472,   473,
     474,  1103,  1107,   667,   668,   669,  1168,   837,  1104,   837,
     837,   837,   837,    46,    47,    48,    49,    50,    51,    52,
      53,  1105,  1113,  1114,   667,   668,   669,  1118,  1119,  1120,
    1122,   671,  1129,  1130,  1132,  1131,   672,  1169,  1134,  1171,
    1172,  1173,  1174,  1135,   581,   582,  1136,   592,   593,   594,
    1137,   596,   597,   598,   599,  1139,   524,   667,   668,   669,
     528,  1140,  1144,  1147,  1155,  1148,  1208,  1167,   837,   837,
    1211,  1149,  1213,   837,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,  1151,  1225,  1153,  1154,
     837,   837,  1156,  1157,  1158,  1159,  1232,  1233,  1209,  1210,
    1166,   837,  1170,  1214,   639,  1176,  1177,  1175,   643,  1241,
    1242,  1243,  1178,  1184,  1246,  1247,   733,   734,   735,  1249,
    1227,  1228,  1191,  1251,  1193,  1194,  1195,  1196,  1255,   737,
     738,  1237,   739,   740,   741,   742,   583,   584,   585,   586,
     587,   588,   589,   590,  1197,  1198,  1204,  1205,  1206,  1207,
    1212,  1215,  1216,  1217,  1218,  1220,  1221,  1222,   667,   668,
     669,   560,  1226,   561,  1223,  1224,  1229,   494,  1238,   701,
    1234,   562,  1235,  1236,   563,   779,   564,   565,  1239,   783,
    1252,  1240,  1244,  1248,   566,  1250,   671,  1253,    78,  1254,
      64,   672,   748,   702,   374,   688,   766,  1125,   756,   567,
     568,   569,   570,   573,   667,   668,   669,   935,   993,   477,
     902,   904,   540,   494,   719,   701,   810,   539,   726,   889,
       0,     0,     0,     0,     0,     0,     0,   809,     0,     0,
       0,     0,   671,     0,     0,     0,     0,   672,     0,   702,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     560,     0,   561,     0,     0,     0,     0,     0,     0,     0,
     562,     0,     0,   563,     0,   564,   565,     0,     0,     0,
       0,     0,     0,   566,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   567,   568,
     569,   570
};

static const yytype_int16 yycheck[] =
{
       4,     7,     6,   553,     0,   392,    10,   328,   461,   330,
      14,   332,   333,   334,   743,   553,   337,     7,   625,   626,
     541,   542,   656,   657,   551,     3,     4,     3,     4,     5,
     340,   552,   559,     3,     4,   429,     3,     4,   541,   542,
     543,   396,   397,     7,   399,   817,   401,   402,   551,   552,
     340,     3,     4,   776,   967,     7,   559,     3,     4,     5,
       3,     4,    66,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,     3,     4,   331,     6,   340,
       0,   340,     3,     4,     5,     7,     6,   340,   475,   822,
     344,   814,   815,  1024,   823,   824,   825,   340,   827,   828,
     829,   830,   831,   832,   625,   626,    28,    29,    30,    31,
      32,   498,   340,   340,   341,   309,   310,   311,   312,   338,
       3,   338,   625,   626,   338,    45,    46,    47,    48,    49,
      50,    51,    52,   352,   863,   352,   339,   458,   352,   533,
     678,   870,     8,     3,     4,     7,     8,     7,     8,   470,
     862,   553,   554,   703,   541,   542,   763,   869,     3,     4,
     331,     7,     7,     8,   354,   703,    26,    27,   358,  1082,
    1083,   361,   362,   344,   677,     8,    21,    22,    23,    24,
      25,    26,    27,   390,   391,     7,   393,   394,   917,   961,
       7,   398,     7,     7,   515,   516,     7,   518,   519,    21,
      22,    23,    24,    25,    26,   526,   343,   930,   529,  1122,
       7,    26,   339,    28,    29,    30,    31,    32,   992,   678,
     305,   306,   996,   997,   611,   763,   341,   861,   862,   550,
     457,     7,     8,   966,  1008,   869,   340,   558,   625,   626,
     963,   341,  1173,  1174,   703,   879,   880,   341,     6,   341,
      26,    27,   886,   887,   575,   576,     7,     8,   613,   335,
     336,   337,   341,   618,   619,   620,   341,   817,   623,   303,
     304,   592,   725,   776,     3,     4,     5,   341,  1007,   817,
     324,   325,   326,   670,   341,   812,   813,    45,    46,    47,
      48,    49,    50,    51,    52,     3,     4,     3,     4,   307,
     308,     7,     8,   624,   763,  1077,   627,   628,   629,   812,
     813,   814,   815,   346,   701,    21,    22,    23,    24,    25,
      26,    27,   724,   329,   330,   331,   346,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,   329,
     330,   331,   352,   353,   346,   323,   573,  1080,   979,   980,
     340,   327,   328,   785,   786,   330,   743,  1173,  1174,   746,
     338,   329,   338,   330,   346,   329,   330,   331,   338,   346,
     340,   338,  1146,   293,   294,   379,   763,   329,   330,   331,
     346,   359,     7,   346,   346,   772,   338,   346,   346,  1118,
    1119,   346,   338,   346,   364,   338,   346,  1120,   785,   786,
     859,   788,   789,   339,   346,   346,     8,   329,   330,   331,
     338,   961,   962,     6,   816,   817,   803,   338,     6,   821,
     822,     6,   809,   961,   332,   332,   345,   930,  1062,     3,
       4,   333,   959,     7,     8,   339,   823,   824,   825,   960,
     827,   828,   829,   830,   831,   832,   848,    21,    22,    23,
      24,    25,   339,   840,   841,   333,   959,   960,   333,   333,
     963,   333,   354,  1013,    28,    29,    30,    31,    32,   329,
     330,   331,   353,   346,   478,   346,   863,   864,   338,   346,
     340,   339,   339,   870,   329,   330,   331,   339,   353,   844,
     845,   339,   339,   338,   357,   340,   339,   357,   819,   339,
     339,   339,   362,   340,   364,   640,   341,   329,   330,   331,
     346,   339,   357,  1120,   329,   330,   331,   362,  1152,   364,
     340,   340,  1072,   331,   342,   354,   847,  1077,   849,   339,
     917,   354,   919,   339,   339,   293,   294,   339,   339,  1077,
     362,   329,   358,   678,   931,   349,   355,   362,   329,   339,
     357,   938,  1102,   329,   330,   331,     7,  1107,   358,   961,
     346,   948,   964,   965,   951,   967,   357,   346,   703,   346,
      21,    22,    23,    24,    25,   339,   339,   712,   329,   330,
     331,   357,     6,     6,   971,   339,   362,   989,   990,   910,
     355,   339,   339,   355,  1144,   355,   355,  1147,  1148,  1149,
     355,   988,   606,  1153,  1154,  1155,  1156,  1157,   339,  1159,
    1012,   746,    21,    22,    23,    24,    25,  1120,   355,   339,
    1007,   942,   355,   329,   330,   331,   353,   355,   763,   346,
     353,   353,   338,   340,   340,   353,   339,   339,  1040,  1041,
     775,   339,   777,   778,   339,   339,   339,   782,     7,   341,
     339,   357,   339,   339,   342,   346,   362,   323,   364,   360,
     981,   346,    21,    22,    23,    24,    25,   346,  1218,   346,
     991,     7,     8,   346,   346,  1077,  1063,   346,  1080,  1081,
    1082,  1083,   346,   346,   339,    21,    22,    23,    24,    25,
      26,    27,     7,  1014,   342,   918,  1098,  1099,   339,   331,
     339,   339,  1089,   339,   339,   339,    21,    22,    23,    24,
      25,   354,  1033,  1034,  1035,   346,   358,   354,  1039,   349,
    1122,  1042,   346,  1110,   859,     7,     8,   334,   329,   864,
     358,  1118,  1119,  1120,   363,   358,   363,   329,   341,    21,
      22,    23,    24,    25,   341,  1132,   341,  1134,  1135,  1136,
    1137,   974,   975,   976,   977,   329,   330,   331,   313,   314,
     315,   316,   317,   318,   338,   341,   340,   329,   329,   341,
     354,   346,   339,   346,  1095,  1177,  1178,   346,     6,  1100,
     363,   352,   339,   363,   919,   355,   352,   355,   346,  1176,
     364,   356,   355,   339,   929,   355,   341,   356,   933,   934,
     356,   355,   937,   938,   355,   341,  1193,  1194,   356,   356,
     945,  1198,   341,   339,   919,   339,   339,   339,  1205,   339,
     339,   339,     3,     4,   355,  1048,     7,   354,  1215,  1216,
     346,   346,   346,  1220,   346,   839,   971,   346,   346,  1226,
      21,    22,    23,    24,    25,    26,    27,   346,   339,   341,
     339,  1238,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,   999,  1000,   971,  1254,     3,     4,
     321,   341,     7,     8,   342,   339,   339,   339,   329,   330,
     331,   356,   339,   356,   356,   359,   339,   356,   321,   339,
     339,    26,    27,   358,   354,   354,   363,   363,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,   339,   354,   346,  1060,   346,   356,  1063,   357,
     355,  1066,  1067,   354,   339,   339,  1071,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   339,   339,   422,   423,
     339,   425,   426,   427,  1089,   356,   339,   352,  1063,   339,
     339,   320,   321,   339,   339,   356,   354,   322,  1103,   355,
     329,   330,   331,   355,   339,   349,   350,   339,   339,   339,
     353,   985,   356,   357,  1089,   356,   339,   361,   362,   363,
     364,   355,   339,   329,   330,   331,  1131,  1132,   356,  1134,
    1135,  1136,  1137,    45,    46,    47,    48,    49,    50,    51,
      52,   356,   354,   356,   329,   330,   331,   339,   339,   339,
     339,   357,   339,   339,   355,   339,   362,  1132,   339,  1134,
    1135,  1136,  1137,   339,   464,   465,   339,   467,   468,   469,
     339,   471,   472,   473,   474,   330,   420,   329,   330,   331,
     424,     6,   339,   339,   355,   339,  1191,   354,  1193,  1194,
    1195,   339,  1197,  1198,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   341,  1212,   339,   339,
    1215,  1216,   339,   339,   356,   339,  1221,  1222,  1193,  1194,
     358,  1226,   356,  1198,   524,   342,   339,   356,   528,  1234,
    1235,  1236,   339,   353,  1239,  1240,   580,   581,   582,  1244,
    1215,  1216,   339,  1248,   355,   355,   339,   356,  1253,   593,
     594,  1226,   596,   597,   598,   599,   295,   296,   297,   298,
     299,   300,   301,   302,   339,   339,   356,   353,   353,   356,
     339,   339,   339,   339,   339,   353,   339,   339,   329,   330,
     331,   309,   339,   311,   356,   356,     6,   338,   342,   340,
     339,   319,   339,   339,   322,   639,   324,   325,   339,   643,
       6,   339,   339,   339,   332,   339,   357,   339,    56,   342,
      17,   362,   608,   364,    58,   542,   626,  1081,   615,   347,
     348,   349,   350,   351,   329,   330,   331,   857,   930,   377,
     822,   822,   444,   338,   554,   340,   702,   443,   574,   803,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,
      -1,    -1,   357,    -1,    -1,    -1,    -1,   362,    -1,   364,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     309,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     319,    -1,    -1,   322,    -1,   324,   325,    -1,    -1,    -1,
      -1,    -1,    -1,   332,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,   348,
     349,   350
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   366,   367,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   368,   369,   371,   372,
     376,   378,   379,   380,   381,   382,   383,   384,   385,   386,
       3,     4,     5,   338,   370,   340,   370,   340,   340,   340,
     370,   340,   340,   340,   370,     6,    45,    46,    47,    48,
      49,    50,    51,    52,   293,   294,   387,   388,   389,   390,
     391,   524,   527,   528,   368,     3,   339,     8,   377,     7,
       7,     8,     8,     7,     7,     7,   343,     7,   388,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   395,
     410,   412,   415,   417,   419,   421,   423,   425,   426,   427,
     428,   430,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   451,   462,   471,   477,   479,   481,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   495,
     496,   500,   501,   502,   503,   504,   505,   507,   509,   512,
     513,   516,   519,   522,   390,   339,   525,   526,   370,   341,
     340,   375,   341,   341,   341,   341,   341,   341,   341,   396,
     397,   398,   346,   400,   401,   402,   403,   404,   405,   406,
     346,   407,   408,   346,   330,   329,   346,   346,   346,   346,
     346,   463,   464,   465,   467,   466,   472,   473,   475,   474,
     478,   482,   468,   476,   480,   469,   510,   511,   517,   518,
     523,     7,    26,    28,    29,    30,    31,    32,   329,   330,
     331,   362,   530,   532,   533,   534,   548,   534,   346,   534,
     534,   534,   534,   346,   431,   534,   346,   443,   444,   346,
     444,   444,   346,   452,   452,   452,   346,   454,   452,   452,
     454,   452,   452,   452,   452,   346,     7,   525,   339,   370,
       8,   370,   373,   374,     6,     6,     6,   331,   344,   392,
     392,   392,     3,     4,   338,   554,   392,   392,   345,   394,
     394,   394,   392,   394,   332,   394,   394,   332,   339,   339,
     333,   333,   333,   333,   333,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   452,   354,   454,   454,   452,   454,
     454,   454,   346,   514,   515,   515,   346,   353,   353,   533,
     530,   339,   339,   339,   313,   314,   315,   316,   317,   318,
     429,   339,   339,   339,   339,   305,   306,   346,   432,   339,
     309,   311,   319,   322,   324,   325,   332,   347,   348,   349,
     350,   444,   534,   351,   340,   447,   447,   303,   304,   346,
     453,   453,   453,   295,   296,   297,   298,   299,   300,   301,
     302,   556,   453,   453,   453,   534,   453,   453,   453,   453,
     323,   359,   458,   506,   554,   370,   339,   341,   339,   340,
     340,   342,   331,   339,   339,   339,     3,     4,   399,   339,
     339,     6,   554,   409,   413,   416,   418,   420,   422,   424,
     534,   534,   357,   534,   534,   354,   354,   358,   349,   453,
     355,   534,   358,   453,   534,   357,   357,   354,   358,   361,
     362,   515,   335,   336,   337,   521,   329,   329,     7,     8,
      21,    22,    23,    24,    25,    26,    27,   329,   330,   331,
     340,   357,   362,   364,   411,   529,   531,   535,   536,   537,
     539,   540,   541,   547,   549,   550,   551,   554,   411,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,   340,   364,   536,   541,   542,   552,   553,   554,   534,
     542,   541,   536,   537,   543,   550,   552,   537,   538,   547,
     307,   308,   534,   542,   339,   444,   556,   534,   534,   309,
     310,   311,   312,   454,   454,   454,   534,   454,   454,   454,
     454,   454,   454,   346,   346,   346,   339,   370,   374,     6,
       6,   554,   394,   331,   344,   393,   393,   394,   394,   394,
     394,   534,   414,   536,   541,   551,   414,   534,   534,   534,
     339,   339,   355,   339,   339,   355,   355,   355,   355,   454,
     529,   339,   355,   454,   339,   355,   355,   346,   338,   352,
     544,   545,   545,   353,   353,     5,   327,   328,   338,   554,
     555,   353,   353,   340,   536,   529,   531,   550,   554,   340,
     553,   552,   339,   339,   339,   339,   339,   339,   537,   447,
     341,   339,   339,   346,   346,   346,   339,   346,   346,   346,
     346,   346,   346,   458,   323,   360,   499,   529,   554,   339,
     342,   342,   339,   331,   339,   339,   551,   339,   339,   339,
     354,   354,   330,   508,   554,   358,   349,   529,   461,   536,
     540,   529,   529,   346,   352,   455,   456,   545,   358,   529,
     346,   358,   508,   508,   334,   554,   554,   363,   363,   329,
     329,   341,   341,     5,   341,   341,   329,   329,   554,   555,
     341,   554,   542,   542,   540,   540,   537,   543,   534,   537,
     320,   321,   445,   446,   449,   537,   458,   458,   458,   354,
     458,   458,   458,   458,   458,   458,   346,   346,   346,   339,
     370,   554,   554,     6,   394,   394,   534,   537,   534,   355,
     355,   352,   356,   355,   355,   455,   356,   352,   352,   457,
     545,   457,   458,   529,   356,   355,   457,   458,   355,   356,
     356,   346,   545,   545,   545,   545,   341,   341,   341,   339,
     339,   339,   339,   339,   339,   339,   339,   339,   346,   346,
     346,   355,   534,   494,   346,   346,   346,   346,   324,   325,
     326,   498,   458,   498,   499,   339,   341,   341,   342,   339,
     339,   339,   529,   461,   554,   339,   529,   529,   356,   339,
     340,   460,   529,   529,   356,   356,   534,   339,   529,   356,
     354,   554,   339,   339,   554,   363,   363,   363,   363,   542,
     541,   543,   552,   540,   537,   445,   446,   449,   450,   537,
     446,   450,   537,   358,   354,   354,   499,   339,   354,   498,
     498,   498,   498,   346,   497,   497,   497,   534,   346,   357,
     370,   554,   537,   537,   534,   456,   356,   354,   456,   456,
     339,   529,   529,   352,   353,   459,   339,   339,   339,   458,
     456,   339,   355,   356,   537,   552,   534,   339,   544,   546,
     339,   339,   339,   339,   534,   534,   534,   356,   354,   355,
     534,   537,   537,   534,   322,   498,   355,   339,   339,   339,
     339,   356,   339,   355,   356,   356,   529,   339,   545,   499,
     353,   529,   529,   354,   356,   529,   552,   470,   339,   339,
     339,   543,   339,   448,   537,   448,   450,   537,   450,   339,
     339,   339,   355,   499,   339,   339,   339,   339,   534,   330,
       6,   537,   537,   534,   339,   552,   529,   339,   339,   339,
     552,   341,   554,   339,   339,   355,   339,   339,   356,   339,
     458,   458,   520,   540,   551,   450,   358,   354,   529,   499,
     356,   499,   499,   499,   499,   356,   342,   339,   339,   552,
     456,   552,   552,   552,   353,   545,   552,   552,   552,   552,
     552,   339,   552,   355,   355,   339,   356,   339,   339,   546,
     546,   554,   537,   537,   356,   353,   353,   356,   529,   499,
     499,   529,   339,   529,   499,   339,   339,   339,   339,   554,
     353,   339,   339,   356,   356,   529,   339,   499,   499,     6,
     552,   554,   529,   529,   339,   339,   339,   499,   342,   339,
     339,   529,   529,   529,   339,   554,   529,   529,   339,   529,
     339,   529,     6,   339,   342,   529,   554
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   365,   367,   366,   368,   368,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   370,   370,
     370,   370,   371,   372,   373,   374,   374,   374,   375,   375,
     377,   376,   378,   379,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   387,   387,   387,   387,   387,   387,   387,
     388,   388,   389,   389,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   391,   392,   392,   393,   393,
     394,   394,   395,   396,   395,   397,   395,   398,   395,   399,
     395,   400,   395,   401,   395,   402,   395,   403,   395,   404,
     395,   395,   405,   395,   395,   395,   395,   395,   395,   395,
     406,   395,   395,   395,   395,   395,   407,   395,   395,   408,
     395,   395,   395,   395,   395,   409,   395,   410,   410,   411,
     411,   413,   412,   414,   414,   414,   416,   415,   418,   417,
     420,   419,   422,   421,   424,   423,   425,   425,   425,   425,
     425,   425,   425,   425,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   427,   427,
     427,   427,   427,   427,   428,   428,   428,   428,   428,   428,
     428,   428,   428,   428,   428,   428,   428,   428,   428,   428,
     428,   428,   428,   428,   428,   428,   428,   428,   428,   428,
     428,   429,   429,   429,   429,   429,   429,   430,   430,   430,
     431,   431,   432,   432,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     434,   434,   434,   434,   434,   435,   435,   436,   436,   437,
     437,   437,   437,   438,   438,   438,   438,   438,   438,   438,
     438,   438,   438,   439,   440,   440,   441,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   443,   444,   444,
     445,   446,   447,   448,   449,   449,   449,   449,   450,   450,
     450,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     452,   452,   453,   453,   453,   453,   454,   455,   456,   456,
     457,   457,   458,   459,   459,   460,   460,   461,   463,   462,
     464,   462,   465,   462,   466,   462,   467,   462,   468,   462,
     469,   470,   462,   472,   471,   473,   471,   474,   471,   475,
     471,   476,   471,   478,   477,   480,   479,   482,   481,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   486,   487,   488,   489,   489,   489,   490,   491,
     492,   493,   493,   494,   493,   495,   495,   495,   496,   497,
     497,   498,   498,   498,   499,   499,   500,   501,   501,   501,
     501,   501,   501,   501,   501,   501,   501,   501,   502,   503,
     504,   504,   504,   504,   505,   506,   506,   506,   507,   508,
     508,   508,   510,   509,   511,   509,   512,   512,   512,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   514,   514,   514,   514,   515,   515,   517,   516,   518,
     516,   519,   519,   519,   520,   520,   521,   521,   521,   522,
     522,   522,   522,   522,   522,   522,   523,   522,   524,   525,
     525,   526,   527,   528,   529,   529,   529,   529,   530,   530,
     530,   530,   531,   532,   532,   532,   532,   532,   533,   533,
     534,   534,   535,   535,   535,   535,   535,   536,   536,   537,
     537,   538,   538,   539,   539,   540,   540,   541,   541,   541,
     542,   542,   542,   543,   543,   543,   544,   544,   545,   545,
     546,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     551,   551,   551,   551,   551,   551,   552,   552,   552,   552,
     552,   553,   553,   553,   553,   553,   553,   553,   553,   553,
     553,   553,   553,   554,   554,   554,   554,   555,   555,   556,
     556,   556,   556,   556,   556,   556,   556
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     1,     1,     3,     0,     3,     0,
       0,     5,     4,     4,     4,     4,     2,     2,     1,    10,
      10,    23,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     2,     1,     0,     5,     0,     7,     0,     7,     0,
       5,     0,     5,     0,     5,     0,     3,     0,     3,     0,
       3,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       0,     3,     1,     1,     1,     1,     0,     3,     1,     0,
       3,     1,     1,     1,     1,     0,     5,     3,     3,     1,
       1,     0,     5,     1,     1,     2,     0,     5,     0,     5,
       0,    11,     0,    13,     0,    13,     1,     1,     1,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     8,     6,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     8,
       8,     8,    10,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       1,     1,     3,     1,     1,     3,     1,     1,     1,     3,
       3,     5,    10,     8,     6,     4,    10,     8,    11,     1,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       1,     2,     1,     7,     2,     7,     2,     3,     0,    12,
       0,    11,     0,    15,     0,    12,     0,    12,     0,    12,
       0,     0,    12,     0,    12,     0,    11,     0,    12,     0,
      12,     0,    12,     0,    17,     0,    17,     0,     9,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,    20,    13,    16,     1,     1,     1,     1,     1,
       1,     9,    16,     0,    17,     1,     1,     1,     3,     0,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
      11,    13,    14,    14,     1,     6,     8,     9,     7,     1,
       1,     3,     0,    11,     0,    11,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     2,     0,     3,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,    11,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     0,     2,     1,     2,
       1,     5,     5,     5,     5,     5,     5,     1,     1,     1,
       3,     3,     4,     4,     3,     3,     1,     3,     1,     4,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 737 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 755 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 756 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 757 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 758 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 760 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3248 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 766 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_init_val: const_val  */
#line 770 "../src/freedreno/ir3/ir3_parser.y"
                                { add_buf_init_val((yyvsp[0].unum)); }
#line 3262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 776 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3275 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* $@2: %empty  */
#line 786 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3285 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 792 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3295 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 798 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3307 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 805 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 812 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3331 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 821 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3343 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 825 "../src/freedreno/ir3/ir3_parser.y"
                                        { variant->early_preamble = 1; }
#line 3349 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 828 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 830 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3361 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 837 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3367 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_SY  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3373 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_SS  */
#line 840 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3379 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_JP  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3385 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* iflag: T_EQ_FLAG  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3391 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 46: /* iflag: T_SAT  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3397 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 47: /* iflag: T_RPT  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3403 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 48: /* iflag: T_UL  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3409 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 49: /* iflag: T_NOP  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3415 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* instr: iflags cat5_instr  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3421 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* label: T_IDENTIFIER ':'  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3427 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_src1: '!' T_P0  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3433 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* cat0_src1: T_P0  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3439 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* cat0_src2: '!' T_P0  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3445 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* cat0_src2: T_P0  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3451 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 70: /* cat0_immed: '#' integer  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3457 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* cat0_immed: '#' T_IDENTIFIER  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3463 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 72: /* cat0_instr: T_OP_NOP  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3469 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@3: %empty  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BR);   }
#line 3475 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@4: %empty  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAO); }
#line 3481 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@5: %empty  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAA); }
#line 3487 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@6: %empty  */
#line 881 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_BRAC)->cat0.idx = (yyvsp[0].num); }
#line 3493 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@7: %empty  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BANY); }
#line 3499 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@8: %empty  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BALL); }
#line 3505 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@9: %empty  */
#line 884 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAX); }
#line 3511 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* $@10: %empty  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3517 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* $@11: %empty  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3523 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_RET  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3529 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* $@12: %empty  */
#line 888 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3535 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_END  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3541 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* cat0_instr: T_OP_EMIT  */
#line 890 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3547 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_CUT  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* cat0_instr: T_OP_CHMASK  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3559 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_CHSH  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3565 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_FLOW_REV  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3571 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@13: %empty  */
#line 895 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat0_instr: T_OP_STKS  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3583 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* cat0_instr: T_OP_STKR  */
#line 897 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3589 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_XSET  */
#line 898 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3595 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat0_instr: T_OP_XCLR  */
#line 899 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3601 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* $@14: %empty  */
#line 900 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* cat0_instr: T_OP_DBG  */
#line 901 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* $@15: %empty  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* cat0_instr: T_OP_SHPE  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* cat0_instr: T_OP_PREDT  */
#line 904 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat0_instr: T_OP_PREDF  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat0_instr: T_OP_PREDE  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* $@16: %empty  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 909 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3657 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 912 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3665 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@17: %empty  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3675 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@17 dst_reg  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 126: /* $@18: %empty  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3702 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 128: /* $@19: %empty  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3713 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 130: /* $@20: %empty  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3719 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* $@21: %empty  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3725 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 134: /* $@22: %empty  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3731 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3737 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3743 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3749 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3755 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3761 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3767 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3773 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3779 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3785 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3791 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_1src: T_OP_NOT_B  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3797 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3803 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_1src: T_OP_SETRM  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3809 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3815 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3821 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 985 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3827 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3833 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3839 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3845 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3851 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_ADD_F  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3857 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_MIN_F  */
#line 992 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3863 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MAX_F  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3869 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MUL_F  */
#line 994 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3875 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_ADD_U  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3881 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_ADD_S  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3887 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_SUB_U  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3893 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_SUB_S  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3899 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_MIN_U  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3905 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_MIN_S  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3911 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MAX_U  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3917 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MAX_S  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3923 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_AND_B  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3929 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_OR_B  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3935 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_XOR_B  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3941 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3947 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_MULL_U  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3959 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_SHL_B  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_SHR_B  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3971 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3977 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat2_opc_2src: T_OP_BARY_F  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3983 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3989 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3995 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 4001 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat2_opc_2src: T_OP_SHB  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 4007 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat2_opc_2src: T_OP_MSAD  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 4013 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cond: T_LT  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 4019 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cond: T_LE  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 4025 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cond: T_GT  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 4031 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cond: T_GE  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 4037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cond: T_EQ  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 4043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cond: T_NE  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 4049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_dp_signedness: '.' T_MIXED  */
#line 1030 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 4055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 4061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_dp_pack: '.' T_LOW  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 4067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_dp_pack: '.' T_HIGH  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 4073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_U16  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 4079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_MADSH_U16  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 4085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_MAD_S16  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_MADSH_M16  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_MAD_U24  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_MAD_S24  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_MAD_F16  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_MAD_F32  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SEL_B16  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_opc: T_OP_SEL_B32  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_opc: T_OP_SEL_S16  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_opc: T_OP_SEL_S32  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_opc: T_OP_SEL_F16  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_opc: T_OP_SEL_F32  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_opc: T_OP_SAD_S16  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_opc: T_OP_SAD_S32  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4193 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4199 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat3_wmm: T_OP_WMM  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4205 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4211 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat3_dp: T_OP_DP2ACC  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4217 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat3_dp: T_OP_DP4ACC  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4223 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_RCP  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4229 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_RSQ  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4235 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_LOG2  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4241 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat4_opc: T_OP_EXP2  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4247 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat4_opc: T_OP_SIN  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4253 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat4_opc: T_OP_COS  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4259 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat4_opc: T_OP_SQRT  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4265 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat4_opc: T_OP_HRSQ  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4271 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat4_opc: T_OP_HLOG2  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4277 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat4_opc: T_OP_HEXP2  */
#line 1079 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4283 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4289 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4295 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc_isam: T_OP_ISAM  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM)->flags |= IR3_INSTR_INV_1D; }
#line 4301 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_ISAML  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4307 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_ISAMM  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4313 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_SAM  */
#line 1090 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4319 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_SAMB  */
#line 1091 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4325 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_SAML  */
#line 1092 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4331 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_SAMGQ  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_GETLOD  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4343 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_CONV  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4349 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_CONVM  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_GETSIZE  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4361 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GETBUF  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4367 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GETPOS  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4373 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_GETINFO  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4379 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_DSX  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4385 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_DSY  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4391 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_GATHER4R  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4397 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_GATHER4G  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4403 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_GATHER4B  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4409 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_GATHER4A  */
#line 1106 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4415 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_SAMGP0  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4421 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_SAMGP1  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4427 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_SAMGP2  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4433 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_SAMGP3  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4439 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_RGETPOS  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4445 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_opc: T_OP_RGETINFO  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4451 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_opc: T_OP_BRCST_A  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4457 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4463 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4469 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4475 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4481 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_3D  */
#line 1119 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4487 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' 'a'  */
#line 1120 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4493 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' 'o'  */
#line 1121 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4499 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_flag: '.' 'p'  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4505 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat5_flag: '.' 's'  */
#line 1123 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4511 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat5_flag: '.' T_S2EN  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4517 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_flag: '.' T_1D  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags &= ~IR3_INSTR_INV_1D; }
#line 4523 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_flag: '.' T_UNIFORM  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4529 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4535 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_flag: '.' T_BASE  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4541 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat5_flag: '.' T_W  */
#line 1129 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4547 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 290: /* cat5_samp: T_SAMP  */
#line 1133 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 291: /* cat5_tex: T_TEX  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4559 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 292: /* cat5_type: '(' type ')'  */
#line 1135 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4565 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 293: /* cat5_a1: src_reg  */
#line 1136 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4571 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat5_instr: cat5_opc_isam '.' 'v' cat5_flags cat5_type dst_reg ',' src_reg src_uoffset ',' cat5_samp_tex_all  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                    { instr->flags |= IR3_INSTR_V; }
#line 4577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat5_instr: T_OP_TCINV  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4583 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_typed: '.' T_UNTYPED  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4589 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* cat6_typed: '.' T_TYPED  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4595 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* cat6_dim: '.' T_1D  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4601 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_dim: '.' T_2D  */
#line 1161 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_dim: '.' T_3D  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_dim: '.' T_4D  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_type: '.' type  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_imm_offset: offset  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_dst_offset: offset  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_immed: integer  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4653 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_a6xx_global_address_pt3: '+' cat6_reg_or_immed  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                         {
                        // Dummy src to smooth the difference between a6xx and a7xx
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                   }
#line 4662 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4672 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* $@23: %empty  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4678 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 330: /* $@24: %empty  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4684 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 332: /* $@25: %empty  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_K); }
#line 4690 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* $@26: %empty  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4696 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* $@27: %empty  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4702 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@28: %empty  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4708 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* $@29: %empty  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4714 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* $@30: %empty  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4722 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* $@31: %empty  */
#line 1207 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4728 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* $@32: %empty  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4734 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* $@33: %empty  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4740 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* $@34: %empty  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4746 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* $@35: %empty  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4752 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* $@36: %empty  */
#line 1213 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4758 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* $@37: %empty  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4764 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* $@38: %empty  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4770 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1218 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4776 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4782 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4788 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4794 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1222 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4800 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1223 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4806 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4812 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4818 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1226 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4830 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4842 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4848 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1232 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4854 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1233 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4860 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1234 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4866 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1235 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4872 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4878 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1237 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1239 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1242 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1243 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1244 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1246 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 387: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 388: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1250 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1251 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1252 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4974 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4980 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4986 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 403: /* $@39: %empty  */
#line 1271 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4992 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_id_opc: T_OP_GETSPID  */
#line 1274 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4998 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* cat6_id_opc: T_OP_GETWID  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 5004 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1276 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 5010 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_bindless_base: '.' T_BASE  */
#line 1281 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 5016 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1285 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 5022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_reg_or_immed: integer  */
#line 1288 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1290 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 5034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1292 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 5040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1293 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 5046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1294 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 5052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1295 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 5058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1296 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 5064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1297 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 5070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1298 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 5076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1299 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 5082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 425: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1300 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 5088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1301 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 5094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1302 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 5100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ibo_opc_3src: T_OP_STIB_B  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 5106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* cat6_bindless_ibo_opc_3src_dst: T_OP_LDIB_B  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 5112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1309 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1310 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                  { swap(instr->srcs[0], instr->srcs[3]); }
#line 5124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1311 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); swap(instr->srcs[1], instr->srcs[2]); }
#line 5130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1313 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1317 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* cat6_bindless_ldc_middle: 'u' '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1318 "../src/freedreno/ir3/ir3_parser.y"
                                                                                       { instr->flags |= IR3_INSTR_U; instr->cat6.d = (yyvsp[-5].tok); }
#line 5148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1319 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1321 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5164 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* const_dst: integer  */
#line 1327 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5170 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* const_dst: T_A1  */
#line 1328 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5176 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* const_dst: T_A1 '+' integer  */
#line 1329 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5182 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 442: /* $@40: %empty  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5188 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 444: /* $@41: %empty  */
#line 1333 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5194 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* cat6_todo: T_OP_G2L  */
#line 1335 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5200 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* cat6_todo: T_OP_L2G  */
#line 1336 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5206 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* cat6_todo: T_OP_RESFMT  */
#line 1337 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5212 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 461: /* cat7_scope: '.' 'w'  */
#line 1352 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5218 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* cat7_scope: '.' 'r'  */
#line 1353 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5224 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 463: /* cat7_scope: '.' 'l'  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5230 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 464: /* cat7_scope: '.' 'g'  */
#line 1355 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5236 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* $@42: %empty  */
#line 1360 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5242 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* $@43: %empty  */
#line 1361 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5248 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_data_cache: T_OP_DCCLN  */
#line 1363 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5254 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* cat7_data_cache: T_OP_DCINV  */
#line 1364 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5260 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* cat7_data_cache: T_OP_DCFLU  */
#line 1365 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5266 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* cat7_alias_scope: T_MOD_TEX  */
#line 1370 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5272 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* cat7_alias_scope: T_MOD_MEM  */
#line 1371 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5278 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* cat7_alias_scope: T_MOD_RT  */
#line 1372 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5284 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* cat7_instr: T_OP_SLEEP  */
#line 1376 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5290 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* cat7_instr: T_OP_CCINV  */
#line 1377 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_CCINV); }
#line 5296 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* cat7_instr: T_OP_ICINV  */
#line 1378 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5302 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* cat7_instr: T_OP_LOCK  */
#line 1379 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5308 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* cat7_instr: T_OP_UNLOCK  */
#line 1380 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5314 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* $@44: %empty  */
#line 1381 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5323 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* cat7_instr: T_OP_ALIAS $@44 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1384 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5331 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 488: /* raw_instr: T_RAW  */
#line 1388 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* meta_print_reg: ',' T_REGISTER  */
#line 1393 "../src/freedreno/ir3/ir3_parser.y"
                               {
	meta_print_data.regs_to_dump[meta_print_data.regs_count++] = (yyvsp[0].num);
}
#line 5345 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 492: /* meta_print_start: T_OP_PRINT T_REGISTER  */
#line 1397 "../src/freedreno/ir3/ir3_parser.y"
                                        {
	meta_print_data.reg_address_lo = (yyvsp[0].num);
	meta_print_data.reg_address_hi = (yyvsp[0].num) + 2;
	meta_print_data.reg_tmp = (yyvsp[0].num) + 4;
	meta_print_data.regs_count = 0;
}
#line 5356 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* meta_print: meta_print_start meta_print_regs  */
#line 1404 "../src/freedreno/ir3/ir3_parser.y"
                                             {
	/* low */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova & 0xffffffff;

	/* high */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_hi, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova >> 32;

	/* offset */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_tmp, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = 4 * meta_print_data.regs_count;

	new_instr(OPC_NOP);
	instr->repeat = 5;

	/* Increment and get current offset into print buffer */
	new_instr(OPC_ATOMIC_G_ADD);
	instr->cat6.d = 1;
	instr->cat6.typed = 0;
	instr->cat6.type = TYPE_U32;
	instr->cat6.iim_val = 1;

	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_tmp, 0);

	/* Store all regs */
	for (uint32_t i = 0; i < meta_print_data.regs_count; i++) {
		new_instr(OPC_STG);
		dummy_dst();
		instr->cat6.type = TYPE_U32;
		instr->flags = IR3_INSTR_SY;
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->iim_val = 0;
		new_src(meta_print_data.regs_to_dump[i], IR3_REG_R);
		new_src(0, IR3_REG_IMMED)->iim_val = 1;

		new_instr(OPC_ADD_U);
		instr->flags = IR3_INSTR_SS;
		new_dst(meta_print_data.reg_address_lo, 0);
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->uim_val = 4;

		new_instr(OPC_NOP);
		instr->repeat = 5;
	}
}
#line 5418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* src: T_REGISTER  */
#line 1462 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* src: T_A0  */
#line 1463 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* src: T_A1  */
#line 1464 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* src: T_P0  */
#line 1465 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 498: /* dst: T_REGISTER  */
#line 1467 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 499: /* dst: T_A0  */
#line 1468 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 500: /* dst: T_A1  */
#line 1469 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 501: /* dst: T_P0  */
#line 1470 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 502: /* const: T_CONSTANT  */
#line 1472 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 503: /* dst_reg_flag: T_EVEN  */
#line 1474 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* dst_reg_flag: T_POS_INFINITY  */
#line 1475 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1476 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 506: /* dst_reg_flag: T_EI  */
#line 1477 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 507: /* dst_reg_flag: T_WRMASK  */
#line 1478 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 510: /* dst_reg: dst  */
#line 1484 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 511: /* dst_reg: dst_reg_flags dst  */
#line 1485 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 512: /* src_reg_flag: T_ABSNEG  */
#line 1487 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 513: /* src_reg_flag: T_NEG  */
#line 1488 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 514: /* src_reg_flag: T_ABS  */
#line 1489 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 515: /* src_reg_flag: T_R  */
#line 1490 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 516: /* src_reg_flag: T_LAST  */
#line 1491 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* uoffset: %empty  */
#line 1520 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* uoffset: '+' integer  */
#line 1521 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* offset: '-' integer  */
#line 1524 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* src_uoffset: uoffset  */
#line 1526 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); if ((yyvsp[0].num)) instr->flags |= IR3_INSTR_IMM_OFFSET; }
#line 5568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1528 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 542: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1529 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 543: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1531 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 544: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1532 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 545: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1534 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 546: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1535 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 549: /* immediate_cat1: integer  */
#line 1544 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 550: /* immediate_cat1: '(' integer ')'  */
#line 1545 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 551: /* immediate_cat1: '(' float ')'  */
#line 1546 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 552: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1547 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 553: /* immediate_cat1: 'h' '(' float ')'  */
#line 1548 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 554: /* immediate_cat1: '(' T_NAN ')'  */
#line 1549 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 555: /* immediate_cat1: '(' T_INF ')'  */
#line 1550 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 556: /* immediate: integer  */
#line 1552 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 557: /* immediate: '(' integer ')'  */
#line 1553 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 558: /* immediate: flut_immed  */
#line 1554 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 559: /* immediate: 'h' '(' integer ')'  */
#line 1555 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* immediate: 'h' flut_immed  */
#line 1556 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 573: /* integer: T_INT  */
#line 1572 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 574: /* integer: '-' T_INT  */
#line 1573 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 575: /* integer: T_HEX  */
#line 1574 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 576: /* integer: '-' T_HEX  */
#line 1575 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 577: /* float: T_FLOAT  */
#line 1577 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 578: /* float: '-' T_FLOAT  */
#line 1578 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 579: /* type: T_TYPE_F16  */
#line 1580 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F16;   }
#line 5718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 580: /* type: T_TYPE_F32  */
#line 1581 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F32;   }
#line 5724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 581: /* type: T_TYPE_U16  */
#line 1582 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U16;   }
#line 5730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 582: /* type: T_TYPE_U32  */
#line 1583 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U32;   }
#line 5736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 583: /* type: T_TYPE_S16  */
#line 1584 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S16;   }
#line 5742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 584: /* type: T_TYPE_S32  */
#line 1585 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S32;   }
#line 5748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 585: /* type: T_TYPE_U8  */
#line 1586 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8;    }
#line 5754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 586: /* type: T_TYPE_U8_32  */
#line 1587 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8_32; }
#line 5760 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5764 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

