
/* Generated code, see midgard.xml and gen_pack_header.py
 *
 * Packets, enums and structures for Panfrost.
 *
 * This file has been generated, do not hand edit.
 */

#ifndef PAN_PACK_H
#define PAN_PACK_H

#include <stdio.h>
#include <inttypes.h>

#include "util/bitpack_helpers.h"

#define __gen_unpack_float(x, y, z) uif(__gen_unpack_uint(x, y, z))

static inline uint32_t
__gen_padded(uint32_t v, uint32_t start, uint32_t end)
{
    unsigned shift = __builtin_ctz(v);
    unsigned odd = v >> (shift + 1);

#ifndef NDEBUG
    assert((v >> shift) & 1);
    assert(shift <= 31);
    assert(odd <= 7);
    assert((end - start + 1) == 8);
#endif

    return util_bitpack_uint(shift | (odd << 5), start, end);
}


static inline uint64_t
__gen_unpack_uint(const uint8_t *restrict cl, uint32_t start, uint32_t end)
{
   uint64_t val = 0;
   const int width = end - start + 1;
   const uint64_t mask = (width == 64 ? ~0 : (1ull << width) - 1 );

   for (uint32_t byte = start / 8; byte <= end / 8; byte++) {
      val |= ((uint64_t) cl[byte]) << ((byte - start / 8) * 8);
   }

   return (val >> (start % 8)) & mask;
}

static inline uint64_t
__gen_unpack_sint(const uint8_t *restrict cl, uint32_t start, uint32_t end)
{
   int size = end - start + 1;
   int64_t val = __gen_unpack_uint(cl, start, end);

   return util_sign_extend(val, size);
}

static inline float
__gen_unpack_ulod(const uint8_t *restrict cl, uint32_t start, uint32_t end)
{
   uint32_t u = __gen_unpack_uint(cl, start, end);

   return ((float)u) / 256.0;
}

static inline float
__gen_unpack_slod(const uint8_t *restrict cl, uint32_t start, uint32_t end)
{
   int32_t u = __gen_unpack_sint(cl, start, end);

   return ((float)u) / 256.0;
}

static inline uint64_t
__gen_unpack_padded(const uint8_t *restrict cl, uint32_t start, uint32_t end)
{
   unsigned val = __gen_unpack_uint(cl, start, end);
   unsigned shift = val & 0b11111;
   unsigned odd = val >> 5;

   return (2*odd + 1) << shift;
}

#define PREFIX1(A) MALI_ ## A
#define PREFIX2(A, B) MALI_ ## A ## _ ## B
#define PREFIX4(A, B, C, D) MALI_ ## A ## _ ## B ## _ ## C ## _ ## D

#define pan_pack(dst, T, name)                              \
   for (struct PREFIX1(T) name = { PREFIX2(T, header) }, \
        *_loop_terminate = &name;                           \
        __builtin_expect(_loop_terminate != NULL, 1);       \
        ({ PREFIX2(T, pack)((uint32_t *) (dst), &name);  \
           _loop_terminate = NULL; }))

#define pan_unpack(src, T, name)                        \
        struct PREFIX1(T) name;                         \
        PREFIX2(T, unpack)((uint8_t *)(src), &name)

#define pan_print(fp, T, var, indent)                   \
        PREFIX2(T, print)(fp, &(var), indent)

#define pan_size(T) PREFIX2(T, LENGTH)
#define pan_alignment(T) PREFIX2(T, ALIGN)

#define pan_section_offset(A, S) \
        PREFIX4(A, SECTION, S, OFFSET)

#define pan_section_ptr(base, A, S) \
        ((void *)((uint8_t *)(base) + pan_section_offset(A, S)))

#define pan_section_pack(dst, A, S, name)                                                         \
   for (PREFIX4(A, SECTION, S, TYPE) name = { PREFIX4(A, SECTION, S, header) }, \
        *_loop_terminate = (void *) (dst);                                                        \
        __builtin_expect(_loop_terminate != NULL, 1);                                             \
        ({ PREFIX4(A, SECTION, S, pack) (pan_section_ptr(dst, A, S), &name);              \
           _loop_terminate = NULL; }))

#define pan_section_unpack(src, A, S, name)                               \
        PREFIX4(A, SECTION, S, TYPE) name;                             \
        PREFIX4(A, SECTION, S, unpack)(pan_section_ptr(src, A, S), &name)

#define pan_section_print(fp, A, S, var, indent)                          \
        PREFIX4(A, SECTION, S, print)(fp, &(var), indent)

static inline void pan_merge_helper(uint32_t *dst, const uint32_t *src, size_t bytes)
{
        assert((bytes & 3) == 0);

        for (unsigned i = 0; i < (bytes / 4); ++i)
                dst[i] |= src[i];
}

#define pan_merge(packed1, packed2, type)         pan_merge_helper((packed1).opaque, (packed2).opaque, pan_size(type))

/* From presentations, 16x16 tiles externally. Use shift for fast computation
 * of tile numbers. */

#define MALI_TILE_SHIFT 4
#define MALI_TILE_LENGTH (1 << MALI_TILE_SHIFT)




#define mali_pixel_format_print(fp, format) \
    fprintf(fp, "%*sFormat (v7): %s%s %s%s\n", indent, "", \
        mali_format_as_str((enum mali_format)((format >> 12) & 0xFF)), \
        (format & (1 << 20)) ? " sRGB" : "", \
        mali_rgb_component_order_as_str((enum mali_rgb_component_order)(format & ((1 << 12) - 1))), \
        (format & (1 << 21)) ? " XXX BAD BIT" : "");


enum mali_attribute_type {
        MALI_ATTRIBUTE_TYPE_1D               =      1,
        MALI_ATTRIBUTE_TYPE_1D_POT_DIVISOR   =      2,
        MALI_ATTRIBUTE_TYPE_1D_NPOT_DIVISOR  =      3,
        MALI_ATTRIBUTE_TYPE_1D_PRIMITIVE_INDEX_BUFFER =      5,
        MALI_ATTRIBUTE_TYPE_VERTEX_PACKET    =      6,
};

static inline const char *
mali_attribute_type_as_str(enum mali_attribute_type imm)
{
    switch (imm) {
    case MALI_ATTRIBUTE_TYPE_1D: return "1D";
    case MALI_ATTRIBUTE_TYPE_1D_POT_DIVISOR: return "1D POT Divisor";
    case MALI_ATTRIBUTE_TYPE_1D_NPOT_DIVISOR: return "1D NPOT Divisor";
    case MALI_ATTRIBUTE_TYPE_1D_PRIMITIVE_INDEX_BUFFER: return "1D Primitive Index Buffer";
    case MALI_ATTRIBUTE_TYPE_VERTEX_PACKET: return "Vertex packet";
    default: return "XXX: INVALID";
    }
}

enum mali_channel {
        MALI_CHANNEL_R                       =      0,
        MALI_CHANNEL_G                       =      1,
        MALI_CHANNEL_B                       =      2,
        MALI_CHANNEL_A                       =      3,
        MALI_CHANNEL_0                       =      4,
        MALI_CHANNEL_1                       =      5,
};

static inline const char *
mali_channel_as_str(enum mali_channel imm)
{
    switch (imm) {
    case MALI_CHANNEL_R: return "R";
    case MALI_CHANNEL_G: return "G";
    case MALI_CHANNEL_B: return "B";
    case MALI_CHANNEL_A: return "A";
    case MALI_CHANNEL_0: return "0";
    case MALI_CHANNEL_1: return "1";
    default: return "XXX: INVALID";
    }
}

enum mali_depth_source {
        MALI_DEPTH_SOURCE_MINIMUM            =      0,
        MALI_DEPTH_SOURCE_MAXIMUM            =      1,
        MALI_DEPTH_SOURCE_FIXED_FUNCTION     =      2,
        MALI_DEPTH_SOURCE_SHADER             =      3,
};

static inline const char *
mali_depth_source_as_str(enum mali_depth_source imm)
{
    switch (imm) {
    case MALI_DEPTH_SOURCE_MINIMUM: return "Minimum";
    case MALI_DEPTH_SOURCE_MAXIMUM: return "Maximum";
    case MALI_DEPTH_SOURCE_FIXED_FUNCTION: return "Fixed function";
    case MALI_DEPTH_SOURCE_SHADER: return "Shader";
    default: return "XXX: INVALID";
    }
}

enum mali_depth_clamp_mode {
        MALI_DEPTH_CLAMP_MODE_0_1            =      1,
        MALI_DEPTH_CLAMP_MODE_BOUNDS         =      2,
};

static inline const char *
mali_depth_clamp_mode_as_str(enum mali_depth_clamp_mode imm)
{
    switch (imm) {
    case MALI_DEPTH_CLAMP_MODE_0_1: return "[0, 1]";
    case MALI_DEPTH_CLAMP_MODE_BOUNDS: return "Bounds";
    default: return "XXX: INVALID";
    }
}

enum mali_shader_stage {
        MALI_SHADER_STAGE_COMPUTE            =      1,
        MALI_SHADER_STAGE_FRAGMENT           =      2,
        MALI_SHADER_STAGE_VERTEX             =      3,
};

static inline const char *
mali_shader_stage_as_str(enum mali_shader_stage imm)
{
    switch (imm) {
    case MALI_SHADER_STAGE_COMPUTE: return "Compute";
    case MALI_SHADER_STAGE_FRAGMENT: return "Fragment";
    case MALI_SHADER_STAGE_VERTEX: return "Vertex";
    default: return "XXX: INVALID";
    }
}

enum mali_descriptor_type {
        MALI_DESCRIPTOR_TYPE_SAMPLER         =      1,
        MALI_DESCRIPTOR_TYPE_TEXTURE         =      2,
        MALI_DESCRIPTOR_TYPE_ATTRIBUTE       =      5,
        MALI_DESCRIPTOR_TYPE_DEPTH_STENCIL   =      7,
        MALI_DESCRIPTOR_TYPE_SHADER          =      8,
        MALI_DESCRIPTOR_TYPE_BUFFER          =      9,
        MALI_DESCRIPTOR_TYPE_PLANE           =     10,
};

static inline const char *
mali_descriptor_type_as_str(enum mali_descriptor_type imm)
{
    switch (imm) {
    case MALI_DESCRIPTOR_TYPE_SAMPLER: return "Sampler";
    case MALI_DESCRIPTOR_TYPE_TEXTURE: return "Texture";
    case MALI_DESCRIPTOR_TYPE_ATTRIBUTE: return "Attribute";
    case MALI_DESCRIPTOR_TYPE_DEPTH_STENCIL: return "Depth/stencil";
    case MALI_DESCRIPTOR_TYPE_SHADER: return "Shader";
    case MALI_DESCRIPTOR_TYPE_BUFFER: return "Buffer";
    case MALI_DESCRIPTOR_TYPE_PLANE: return "Plane";
    default: return "XXX: INVALID";
    }
}

enum mali_buffer_type {
        MALI_BUFFER_TYPE_SIMPLE              =      1,
        MALI_BUFFER_TYPE_TILER_HEAP          =      2,
        MALI_BUFFER_TYPE_STRUCTURE           =      3,
        MALI_BUFFER_TYPE_VERTEX_PACKET       =      4,
};

static inline const char *
mali_buffer_type_as_str(enum mali_buffer_type imm)
{
    switch (imm) {
    case MALI_BUFFER_TYPE_SIMPLE: return "Simple";
    case MALI_BUFFER_TYPE_TILER_HEAP: return "Tiler heap";
    case MALI_BUFFER_TYPE_STRUCTURE: return "Structure";
    case MALI_BUFFER_TYPE_VERTEX_PACKET: return "Vertex packet";
    default: return "XXX: INVALID";
    }
}

enum mali_draw_mode {
        MALI_DRAW_MODE_NONE                  =      0,
        MALI_DRAW_MODE_POINTS                =      1,
        MALI_DRAW_MODE_LINES                 =      2,
        MALI_DRAW_MODE_LINE_STRIP            =      4,
        MALI_DRAW_MODE_LINE_LOOP             =      6,
        MALI_DRAW_MODE_TRIANGLES             =      8,
        MALI_DRAW_MODE_TRIANGLE_STRIP        =     10,
        MALI_DRAW_MODE_TRIANGLE_FAN          =     12,
        MALI_DRAW_MODE_POLYGON               =     13,
        MALI_DRAW_MODE_QUADS                 =     14,
};

static inline const char *
mali_draw_mode_as_str(enum mali_draw_mode imm)
{
    switch (imm) {
    case MALI_DRAW_MODE_NONE: return "None";
    case MALI_DRAW_MODE_POINTS: return "Points";
    case MALI_DRAW_MODE_LINES: return "Lines";
    case MALI_DRAW_MODE_LINE_STRIP: return "Line strip";
    case MALI_DRAW_MODE_LINE_LOOP: return "Line loop";
    case MALI_DRAW_MODE_TRIANGLES: return "Triangles";
    case MALI_DRAW_MODE_TRIANGLE_STRIP: return "Triangle strip";
    case MALI_DRAW_MODE_TRIANGLE_FAN: return "Triangle fan";
    case MALI_DRAW_MODE_POLYGON: return "Polygon";
    case MALI_DRAW_MODE_QUADS: return "Quads";
    default: return "XXX: INVALID";
    }
}

enum mali_func {
        MALI_FUNC_NEVER                      =      0,
        MALI_FUNC_LESS                       =      1,
        MALI_FUNC_EQUAL                      =      2,
        MALI_FUNC_LEQUAL                     =      3,
        MALI_FUNC_GREATER                    =      4,
        MALI_FUNC_NOT_EQUAL                  =      5,
        MALI_FUNC_GEQUAL                     =      6,
        MALI_FUNC_ALWAYS                     =      7,
};

static inline const char *
mali_func_as_str(enum mali_func imm)
{
    switch (imm) {
    case MALI_FUNC_NEVER: return "Never";
    case MALI_FUNC_LESS: return "Less";
    case MALI_FUNC_EQUAL: return "Equal";
    case MALI_FUNC_LEQUAL: return "Lequal";
    case MALI_FUNC_GREATER: return "Greater";
    case MALI_FUNC_NOT_EQUAL: return "Not Equal";
    case MALI_FUNC_GEQUAL: return "Gequal";
    case MALI_FUNC_ALWAYS: return "Always";
    default: return "XXX: INVALID";
    }
}

enum mali_address_mode {
        MALI_ADDRESS_MODE_FLAT               =      0,
        MALI_ADDRESS_MODE_PACKED             =      1,
};

static inline const char *
mali_address_mode_as_str(enum mali_address_mode imm)
{
    switch (imm) {
    case MALI_ADDRESS_MODE_FLAT: return "Flat";
    case MALI_ADDRESS_MODE_PACKED: return "Packed";
    default: return "XXX: INVALID";
    }
}

enum mali_format {
        MALI_ETC2_RGB8                       =      1,
        MALI_ETC2_R11_UNORM                  =      2,
        MALI_ETC2_RGBA8                      =      3,
        MALI_ETC2_RG11_UNORM                 =      4,
        MALI_BC1_UNORM                       =      7,
        MALI_BC2_UNORM                       =      8,
        MALI_BC3_UNORM                       =      9,
        MALI_BC4_UNORM                       =     10,
        MALI_BC4_SNORM                       =     11,
        MALI_BC5_UNORM                       =     12,
        MALI_BC5_SNORM                       =     13,
        MALI_BC6H_UF16                       =     14,
        MALI_BC6H_SF16                       =     15,
        MALI_BC7_UNORM                       =     16,
        MALI_ETC2_R11_SNORM                  =     17,
        MALI_ETC2_RG11_SNORM                 =     18,
        MALI_ETC2_RGB8A1                     =     19,
        MALI_ASTC_3D_LDR                     =     20,
        MALI_ASTC_3D_HDR                     =     21,
        MALI_ASTC_2D_LDR                     =     22,
        MALI_ASTC_2D_HDR                     =     23,
        MALI_AFBC                            =     24,
        MALI_AFRC                            =     25,
        MALI_ASTC_2D_NARROW                  =     62,
        MALI_ASTC_3D_NARROW                  =     63,
        MALI_YUV8                            =     32,
        MALI_YUVA8                           =     33,
        MALI_YUYV8                           =     34,
        MALI_VYUY8                           =     35,
        MALI_Y8_UV8_422                      =     36,
        MALI_Y8_U8_V8_422                    =     37,
        MALI_Y8_UV8_420                      =     38,
        MALI_Y8_U8_V8_420                    =     39,
        MALI_YUV10_A2                        =     40,
        MALI_A2_YUV10                        =     41,
        MALI_YUYAAYVYAA                      =     42,
        MALI_YUYV10                          =     44,
        MALI_VYUY10                          =     45,
        MALI_Y10_UV10_422                    =     46,
        MALI_Y10_UV10_420                    =     47,
        MALI_YUV16                           =     48,
        MALI_YUVA16                          =     49,
        MALI_YUYV16                          =     50,
        MALI_VYUY16                          =     51,
        MALI_Y10X6_U10X6V10X6_422            =     52,
        MALI_Y16_UV16_422                    =     53,
        MALI_Y16_UV16_420                    =     55,
        MALI_RGB565                          =     64,
        MALI_RGB5_A1_UNORM                   =     65,
        MALI_A1_BGR5_UNORM                   =     66,
        MALI_RGB10_A2_UNORM                  =     67,
        MALI_A2_BGR10_UNORM                  =     68,
        MALI_RGB10_A2_SNORM                  =     69,
        MALI_A2_BGR10_SNORM                  =     70,
        MALI_RGB10_A2UI                      =     71,
        MALI_A2_BGR10UI                      =     72,
        MALI_RGB10_A2I                       =     73,
        MALI_A2_BGR10I                       =     74,
        MALI_Z16_UNORM                       =     75,
        MALI_Z32                             =     76,
        MALI_Z24X8_UNORM                     =     77,
        MALI_X8Z24                           =     78,
        MALI_R32_FIXED                       =     81,
        MALI_RG32_FIXED                      =     82,
        MALI_RGB32_FIXED                     =     83,
        MALI_RGBA32_FIXED                    =     84,
        MALI_R11F_G11F_B10F                  =     89,
        MALI_B10F_G11F_R11F                  =     90,
        MALI_R9F_G9F_B9F_E5F                 =     91,
        MALI_E5F_B9F_G9F_R9F                 =     92,
        MALI_S8                              =     93,
        MALI_SNAP_4                          =     94,
        MALI_CONSTANT                        =     95,
        MALI_R8_SNORM                        =     99,
        MALI_R16_SNORM                       =    100,
        MALI_R32_SNORM                       =    101,
        MALI_RG4_SNORM                       =    106,
        MALI_RG8_SNORM                       =    107,
        MALI_RG16_SNORM                      =    108,
        MALI_RG32_SNORM                      =    109,
        MALI_RGB8_SNORM                      =    115,
        MALI_RGB16_SNORM                     =    116,
        MALI_RGB32_SNORM                     =    117,
        MALI_RGBA2_SNORM                     =    121,
        MALI_RGBA4_SNORM                     =    122,
        MALI_RGBA8_SNORM                     =    123,
        MALI_RGBA16_SNORM                    =    124,
        MALI_RGBA32_SNORM                    =    125,
        MALI_R8UI                            =    131,
        MALI_R16UI                           =    132,
        MALI_R32UI                           =    133,
        MALI_RG4UI                           =    138,
        MALI_RG8UI                           =    139,
        MALI_RG16UI                          =    140,
        MALI_RG32UI                          =    141,
        MALI_RGB8UI                          =    147,
        MALI_RGB16UI                         =    148,
        MALI_RGB32UI                         =    149,
        MALI_RGBA2UI                         =    153,
        MALI_RGBA4UI                         =    154,
        MALI_RGBA8UI                         =    155,
        MALI_RGBA16UI                        =    156,
        MALI_RGBA32UI                        =    157,
        MALI_R8_UNORM                        =    163,
        MALI_R16_UNORM                       =    164,
        MALI_R32_UNORM                       =    165,
        MALI_R32F                            =    167,
        MALI_RG4_UNORM                       =    170,
        MALI_RG8_UNORM                       =    171,
        MALI_RG16_UNORM                      =    172,
        MALI_RG32_UNORM                      =    173,
        MALI_RG32F                           =    175,
        MALI_RGB8_UNORM                      =    179,
        MALI_RGB16_UNORM                     =    180,
        MALI_RGB32_UNORM                     =    181,
        MALI_RGB32F                          =    183,
        MALI_RGBA2_UNORM                     =    185,
        MALI_RGBA4_UNORM                     =    186,
        MALI_RGBA8_UNORM                     =    187,
        MALI_RGBA16_UNORM                    =    188,
        MALI_RGBA32_UNORM                    =    189,
        MALI_RGBA32F                         =    191,
        MALI_R8I                             =    195,
        MALI_R16I                            =    196,
        MALI_R32I                            =    197,
        MALI_R16F                            =    199,
        MALI_RG4I                            =    202,
        MALI_RG8I                            =    203,
        MALI_RG16I                           =    204,
        MALI_RG32I                           =    205,
        MALI_RG16F                           =    207,
        MALI_RGB8I                           =    211,
        MALI_RGB16I                          =    212,
        MALI_RGB32I                          =    213,
        MALI_RGB16F                          =    215,
        MALI_RGBA2I                          =    217,
        MALI_RGBA4I                          =    218,
        MALI_RGBA8I                          =    219,
        MALI_RGBA16I                         =    220,
        MALI_RGBA32I                         =    221,
        MALI_RGBA16F                         =    223,
        MALI_RGB5_A1_AU                      =    224,
        MALI_RGB5_A1_PU                      =    225,
        MALI_R5G6B5_AU                       =    226,
        MALI_R5G6B5_PU                       =    227,
        MALI_SNAP4_V                         =    230,
        MALI_R32F_RTZ                        =    231,
        MALI_RGBA4_AU                        =    232,
        MALI_RGBA4_PU                        =    233,
        MALI_RGBA8_TB                        =    237,
        MALI_RGB10_A2_TB                     =    238,
        MALI_RG32F_RTZ                       =    239,
        MALI_TESS_VERTEX_PACK                =    240,
        MALI_RGB8_A2_AU                      =    241,
        MALI_RGB8_A2_PU                      =    242,
        MALI_RGB32F_RTZ                      =    247,
        MALI_RGBA32F_RTZ                     =    255,
};

static inline const char *
mali_format_as_str(enum mali_format imm)
{
    switch (imm) {
    case MALI_ETC2_RGB8: return "ETC2 RGB8";
    case MALI_ETC2_R11_UNORM: return "ETC2 R11 UNORM";
    case MALI_ETC2_RGBA8: return "ETC2 RGBA8";
    case MALI_ETC2_RG11_UNORM: return "ETC2 RG11 UNORM";
    case MALI_BC1_UNORM: return "BC1 UNORM";
    case MALI_BC2_UNORM: return "BC2 UNORM";
    case MALI_BC3_UNORM: return "BC3 UNORM";
    case MALI_BC4_UNORM: return "BC4 UNORM";
    case MALI_BC4_SNORM: return "BC4 SNORM";
    case MALI_BC5_UNORM: return "BC5 UNORM";
    case MALI_BC5_SNORM: return "BC5 SNORM";
    case MALI_BC6H_UF16: return "BC6H UF16";
    case MALI_BC6H_SF16: return "BC6H SF16";
    case MALI_BC7_UNORM: return "BC7 UNORM";
    case MALI_ETC2_R11_SNORM: return "ETC2 R11 SNORM";
    case MALI_ETC2_RG11_SNORM: return "ETC2 RG11 SNORM";
    case MALI_ETC2_RGB8A1: return "ETC2 RGB8A1";
    case MALI_ASTC_3D_LDR: return "ASTC 3D LDR";
    case MALI_ASTC_3D_HDR: return "ASTC 3D HDR";
    case MALI_ASTC_2D_LDR: return "ASTC 2D LDR";
    case MALI_ASTC_2D_HDR: return "ASTC 2D HDR";
    case MALI_AFBC: return "AFBC";
    case MALI_AFRC: return "AFRC";
    case MALI_ASTC_2D_NARROW: return "ASTC 2D NARROW";
    case MALI_ASTC_3D_NARROW: return "ASTC 3D NARROW";
    case MALI_YUV8: return "YUV8";
    case MALI_YUVA8: return "YUVA8";
    case MALI_YUYV8: return "YUYV8";
    case MALI_VYUY8: return "VYUY8";
    case MALI_Y8_UV8_422: return "Y8 UV8 422";
    case MALI_Y8_U8_V8_422: return "Y8 U8 V8 422";
    case MALI_Y8_UV8_420: return "Y8 UV8 420";
    case MALI_Y8_U8_V8_420: return "Y8 U8 V8 420";
    case MALI_YUV10_A2: return "YUV10 A2";
    case MALI_A2_YUV10: return "A2 YUV10";
    case MALI_YUYAAYVYAA: return "YUYAAYVYAA";
    case MALI_YUYV10: return "YUYV10";
    case MALI_VYUY10: return "VYUY10";
    case MALI_Y10_UV10_422: return "Y10 UV10 422";
    case MALI_Y10_UV10_420: return "Y10 UV10 420";
    case MALI_YUV16: return "YUV16";
    case MALI_YUVA16: return "YUVA16";
    case MALI_YUYV16: return "YUYV16";
    case MALI_VYUY16: return "VYUY16";
    case MALI_Y10X6_U10X6V10X6_422: return "Y10X6 U10X6V10X6 422";
    case MALI_Y16_UV16_422: return "Y16 UV16 422";
    case MALI_Y16_UV16_420: return "Y16 UV16 420";
    case MALI_RGB565: return "RGB565";
    case MALI_RGB5_A1_UNORM: return "RGB5 A1 UNORM";
    case MALI_A1_BGR5_UNORM: return "A1 BGR5 UNORM";
    case MALI_RGB10_A2_UNORM: return "RGB10 A2 UNORM";
    case MALI_A2_BGR10_UNORM: return "A2 BGR10 UNORM";
    case MALI_RGB10_A2_SNORM: return "RGB10 A2 SNORM";
    case MALI_A2_BGR10_SNORM: return "A2 BGR10 SNORM";
    case MALI_RGB10_A2UI: return "RGB10 A2UI";
    case MALI_A2_BGR10UI: return "A2 BGR10UI";
    case MALI_RGB10_A2I: return "RGB10 A2I";
    case MALI_A2_BGR10I: return "A2 BGR10I";
    case MALI_Z16_UNORM: return "Z16 UNORM";
    case MALI_Z32: return "Z32";
    case MALI_Z24X8_UNORM: return "Z24X8 UNORM";
    case MALI_X8Z24: return "X8Z24";
    case MALI_R32_FIXED: return "R32 FIXED";
    case MALI_RG32_FIXED: return "RG32 FIXED";
    case MALI_RGB32_FIXED: return "RGB32 FIXED";
    case MALI_RGBA32_FIXED: return "RGBA32 FIXED";
    case MALI_R11F_G11F_B10F: return "R11F G11F B10F";
    case MALI_B10F_G11F_R11F: return "B10F G11F R11F";
    case MALI_R9F_G9F_B9F_E5F: return "R9F G9F B9F E5F";
    case MALI_E5F_B9F_G9F_R9F: return "E5F B9F G9F R9F";
    case MALI_S8: return "S8";
    case MALI_SNAP_4: return "Snap 4";
    case MALI_CONSTANT: return "Constant";
    case MALI_R8_SNORM: return "R8 SNORM";
    case MALI_R16_SNORM: return "R16 SNORM";
    case MALI_R32_SNORM: return "R32 SNORM";
    case MALI_RG4_SNORM: return "RG4 SNORM";
    case MALI_RG8_SNORM: return "RG8 SNORM";
    case MALI_RG16_SNORM: return "RG16 SNORM";
    case MALI_RG32_SNORM: return "RG32 SNORM";
    case MALI_RGB8_SNORM: return "RGB8 SNORM";
    case MALI_RGB16_SNORM: return "RGB16 SNORM";
    case MALI_RGB32_SNORM: return "RGB32 SNORM";
    case MALI_RGBA2_SNORM: return "RGBA2 SNORM";
    case MALI_RGBA4_SNORM: return "RGBA4 SNORM";
    case MALI_RGBA8_SNORM: return "RGBA8 SNORM";
    case MALI_RGBA16_SNORM: return "RGBA16 SNORM";
    case MALI_RGBA32_SNORM: return "RGBA32 SNORM";
    case MALI_R8UI: return "R8UI";
    case MALI_R16UI: return "R16UI";
    case MALI_R32UI: return "R32UI";
    case MALI_RG4UI: return "RG4UI";
    case MALI_RG8UI: return "RG8UI";
    case MALI_RG16UI: return "RG16UI";
    case MALI_RG32UI: return "RG32UI";
    case MALI_RGB8UI: return "RGB8UI";
    case MALI_RGB16UI: return "RGB16UI";
    case MALI_RGB32UI: return "RGB32UI";
    case MALI_RGBA2UI: return "RGBA2UI";
    case MALI_RGBA4UI: return "RGBA4UI";
    case MALI_RGBA8UI: return "RGBA8UI";
    case MALI_RGBA16UI: return "RGBA16UI";
    case MALI_RGBA32UI: return "RGBA32UI";
    case MALI_R8_UNORM: return "R8 UNORM";
    case MALI_R16_UNORM: return "R16 UNORM";
    case MALI_R32_UNORM: return "R32 UNORM";
    case MALI_R32F: return "R32F";
    case MALI_RG4_UNORM: return "RG4 UNORM";
    case MALI_RG8_UNORM: return "RG8 UNORM";
    case MALI_RG16_UNORM: return "RG16 UNORM";
    case MALI_RG32_UNORM: return "RG32 UNORM";
    case MALI_RG32F: return "RG32F";
    case MALI_RGB8_UNORM: return "RGB8 UNORM";
    case MALI_RGB16_UNORM: return "RGB16 UNORM";
    case MALI_RGB32_UNORM: return "RGB32 UNORM";
    case MALI_RGB32F: return "RGB32F";
    case MALI_RGBA2_UNORM: return "RGBA2 UNORM";
    case MALI_RGBA4_UNORM: return "RGBA4 UNORM";
    case MALI_RGBA8_UNORM: return "RGBA8 UNORM";
    case MALI_RGBA16_UNORM: return "RGBA16 UNORM";
    case MALI_RGBA32_UNORM: return "RGBA32 UNORM";
    case MALI_RGBA32F: return "RGBA32F";
    case MALI_R8I: return "R8I";
    case MALI_R16I: return "R16I";
    case MALI_R32I: return "R32I";
    case MALI_R16F: return "R16F";
    case MALI_RG4I: return "RG4I";
    case MALI_RG8I: return "RG8I";
    case MALI_RG16I: return "RG16I";
    case MALI_RG32I: return "RG32I";
    case MALI_RG16F: return "RG16F";
    case MALI_RGB8I: return "RGB8I";
    case MALI_RGB16I: return "RGB16I";
    case MALI_RGB32I: return "RGB32I";
    case MALI_RGB16F: return "RGB16F";
    case MALI_RGBA2I: return "RGBA2I";
    case MALI_RGBA4I: return "RGBA4I";
    case MALI_RGBA8I: return "RGBA8I";
    case MALI_RGBA16I: return "RGBA16I";
    case MALI_RGBA32I: return "RGBA32I";
    case MALI_RGBA16F: return "RGBA16F";
    case MALI_RGB5_A1_AU: return "RGB5 A1 AU";
    case MALI_RGB5_A1_PU: return "RGB5 A1 PU";
    case MALI_R5G6B5_AU: return "R5G6B5 AU";
    case MALI_R5G6B5_PU: return "R5G6B5 PU";
    case MALI_SNAP4_V: return "Snap4 V";
    case MALI_R32F_RTZ: return "R32F RTZ";
    case MALI_RGBA4_AU: return "RGBA4 AU";
    case MALI_RGBA4_PU: return "RGBA4 PU";
    case MALI_RGBA8_TB: return "RGBA8 TB";
    case MALI_RGB10_A2_TB: return "RGB10 A2 TB";
    case MALI_RG32F_RTZ: return "RG32F RTZ";
    case MALI_TESS_VERTEX_PACK: return "Tess Vertex Pack";
    case MALI_RGB8_A2_AU: return "RGB8 A2 AU";
    case MALI_RGB8_A2_PU: return "RGB8 A2 PU";
    case MALI_RGB32F_RTZ: return "RGB32F RTZ";
    case MALI_RGBA32F_RTZ: return "RGBA32F RTZ";
    default: return "XXX: INVALID";
    }
}

enum mali_rgb_component_order {
        MALI_RGB_COMPONENT_ORDER_RGBA        =      0,
        MALI_RGB_COMPONENT_ORDER_GRBA        =      2,
        MALI_RGB_COMPONENT_ORDER_BGRA        =      4,
        MALI_RGB_COMPONENT_ORDER_ARGB        =      8,
        MALI_RGB_COMPONENT_ORDER_AGRB        =     10,
        MALI_RGB_COMPONENT_ORDER_ABGR        =     12,
        MALI_RGB_COMPONENT_ORDER_RGB1        =     16,
        MALI_RGB_COMPONENT_ORDER_GRB1        =     18,
        MALI_RGB_COMPONENT_ORDER_BGR1        =     20,
        MALI_RGB_COMPONENT_ORDER_1RGB        =     24,
        MALI_RGB_COMPONENT_ORDER_1GRB        =     26,
        MALI_RGB_COMPONENT_ORDER_1BGR        =     28,
        MALI_RGB_COMPONENT_ORDER_RRRR        =    226,
        MALI_RGB_COMPONENT_ORDER_RRR1        =    227,
        MALI_RGB_COMPONENT_ORDER_RRRA        =    228,
        MALI_RGB_COMPONENT_ORDER_000A        =    229,
        MALI_RGB_COMPONENT_ORDER_0001        =    230,
        MALI_RGB_COMPONENT_ORDER_0000        =    231,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V9    =    232,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V10   =    233,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V11   =    234,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V12   =    235,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V13   =    236,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V14   =    237,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V15   =    238,
        MALI_RGB_COMPONENT_ORDER_SNAP4_V16   =    239,
        MALI_RGB_COMPONENT_ORDER_R000        =    240,
        MALI_RGB_COMPONENT_ORDER_RBGA        =    242,
};

static inline const char *
mali_rgb_component_order_as_str(enum mali_rgb_component_order imm)
{
    switch (imm) {
    case MALI_RGB_COMPONENT_ORDER_RGBA: return "RGBA";
    case MALI_RGB_COMPONENT_ORDER_GRBA: return "GRBA";
    case MALI_RGB_COMPONENT_ORDER_BGRA: return "BGRA";
    case MALI_RGB_COMPONENT_ORDER_ARGB: return "ARGB";
    case MALI_RGB_COMPONENT_ORDER_AGRB: return "AGRB";
    case MALI_RGB_COMPONENT_ORDER_ABGR: return "ABGR";
    case MALI_RGB_COMPONENT_ORDER_RGB1: return "RGB1";
    case MALI_RGB_COMPONENT_ORDER_GRB1: return "GRB1";
    case MALI_RGB_COMPONENT_ORDER_BGR1: return "BGR1";
    case MALI_RGB_COMPONENT_ORDER_1RGB: return "1RGB";
    case MALI_RGB_COMPONENT_ORDER_1GRB: return "1GRB";
    case MALI_RGB_COMPONENT_ORDER_1BGR: return "1BGR";
    case MALI_RGB_COMPONENT_ORDER_RRRR: return "RRRR";
    case MALI_RGB_COMPONENT_ORDER_RRR1: return "RRR1";
    case MALI_RGB_COMPONENT_ORDER_RRRA: return "RRRA";
    case MALI_RGB_COMPONENT_ORDER_000A: return "000A";
    case MALI_RGB_COMPONENT_ORDER_0001: return "0001";
    case MALI_RGB_COMPONENT_ORDER_0000: return "0000";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V9: return "Snap4 v9";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V10: return "Snap4 v10";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V11: return "Snap4 v11";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V12: return "Snap4 v12";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V13: return "Snap4 v13";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V14: return "Snap4 v14";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V15: return "Snap4 v15";
    case MALI_RGB_COMPONENT_ORDER_SNAP4_V16: return "Snap4 v16";
    case MALI_RGB_COMPONENT_ORDER_R000: return "R000";
    case MALI_RGB_COMPONENT_ORDER_RBGA: return "RBGA";
    default: return "XXX: INVALID";
    }
}

enum mali_yuv_swizzle {
        MALI_YUV_SWIZZLE_YUVA                =      0,
        MALI_YUV_SWIZZLE_YVUA                =      1,
        MALI_YUV_SWIZZLE_UYVA                =      2,
        MALI_YUV_SWIZZLE_UVYA                =      3,
        MALI_YUV_SWIZZLE_VUYA                =      4,
        MALI_YUV_SWIZZLE_VYUA                =      5,
        MALI_YUV_SWIZZLE_Y00A                =      6,
        MALI_YUV_SWIZZLE_YXXA                =      7,
};

static inline const char *
mali_yuv_swizzle_as_str(enum mali_yuv_swizzle imm)
{
    switch (imm) {
    case MALI_YUV_SWIZZLE_YUVA: return "YUVA";
    case MALI_YUV_SWIZZLE_YVUA: return "YVUA";
    case MALI_YUV_SWIZZLE_UYVA: return "UYVA";
    case MALI_YUV_SWIZZLE_UVYA: return "UVYA";
    case MALI_YUV_SWIZZLE_VUYA: return "VUYA";
    case MALI_YUV_SWIZZLE_VYUA: return "VYUA";
    case MALI_YUV_SWIZZLE_Y00A: return "Y00A";
    case MALI_YUV_SWIZZLE_YXXA: return "YXXA";
    default: return "XXX: INVALID";
    }
}

enum mali_yuv_conversion_mode {
        MALI_YUV_CONVERSION_MODE_NO_CONVERSION =      0,
        MALI_YUV_CONVERSION_MODE_BT_601      =      3,
        MALI_YUV_CONVERSION_MODE_BT_709      =      4,
        MALI_YUV_CONVERSION_MODE_BT_2020     =      6,
};

static inline const char *
mali_yuv_conversion_mode_as_str(enum mali_yuv_conversion_mode imm)
{
    switch (imm) {
    case MALI_YUV_CONVERSION_MODE_NO_CONVERSION: return "No Conversion";
    case MALI_YUV_CONVERSION_MODE_BT_601: return "BT 601";
    case MALI_YUV_CONVERSION_MODE_BT_709: return "BT 709";
    case MALI_YUV_CONVERSION_MODE_BT_2020: return "BT 2020";
    default: return "XXX: INVALID";
    }
}

enum mali_yuv_cr_siting {
        MALI_YUV_CR_SITING_CO_SITED          =      0,
        MALI_YUV_CR_SITING_CENTER_Y          =      1,
        MALI_YUV_CR_SITING_CENTER_X          =      2,
        MALI_YUV_CR_SITING_CENTER            =      3,
        MALI_YUV_CR_SITING_ONE_QUARTER       =      4,
        MALI_YUV_CR_SITING_THREE_QUARTERS    =      5,
        MALI_YUV_CR_SITING_REPLICATED        =      7,
};

static inline const char *
mali_yuv_cr_siting_as_str(enum mali_yuv_cr_siting imm)
{
    switch (imm) {
    case MALI_YUV_CR_SITING_CO_SITED: return "Co-Sited";
    case MALI_YUV_CR_SITING_CENTER_Y: return "Center Y";
    case MALI_YUV_CR_SITING_CENTER_X: return "Center X";
    case MALI_YUV_CR_SITING_CENTER: return "Center";
    case MALI_YUV_CR_SITING_ONE_QUARTER: return "One Quarter";
    case MALI_YUV_CR_SITING_THREE_QUARTERS: return "Three Quarters";
    case MALI_YUV_CR_SITING_REPLICATED: return "Replicated";
    default: return "XXX: INVALID";
    }
}

enum mali_astc_2d_dimension {
        MALI_ASTC_2D_DIMENSION_4             =      0,
        MALI_ASTC_2D_DIMENSION_5             =      1,
        MALI_ASTC_2D_DIMENSION_6             =      2,
        MALI_ASTC_2D_DIMENSION_8             =      4,
        MALI_ASTC_2D_DIMENSION_10            =      6,
        MALI_ASTC_2D_DIMENSION_12            =      7,
};

static inline const char *
mali_astc_2d_dimension_as_str(enum mali_astc_2d_dimension imm)
{
    switch (imm) {
    case MALI_ASTC_2D_DIMENSION_4: return "4";
    case MALI_ASTC_2D_DIMENSION_5: return "5";
    case MALI_ASTC_2D_DIMENSION_6: return "6";
    case MALI_ASTC_2D_DIMENSION_8: return "8";
    case MALI_ASTC_2D_DIMENSION_10: return "10";
    case MALI_ASTC_2D_DIMENSION_12: return "12";
    default: return "XXX: INVALID";
    }
}

enum mali_astc_3d_dimension {
        MALI_ASTC_3D_DIMENSION_4             =      0,
        MALI_ASTC_3D_DIMENSION_5             =      1,
        MALI_ASTC_3D_DIMENSION_6             =      2,
        MALI_ASTC_3D_DIMENSION_3             =      3,
};

static inline const char *
mali_astc_3d_dimension_as_str(enum mali_astc_3d_dimension imm)
{
    switch (imm) {
    case MALI_ASTC_3D_DIMENSION_4: return "4";
    case MALI_ASTC_3D_DIMENSION_5: return "5";
    case MALI_ASTC_3D_DIMENSION_6: return "6";
    case MALI_ASTC_3D_DIMENSION_3: return "3";
    default: return "XXX: INVALID";
    }
}

enum mali_pixel_kill {
        MALI_PIXEL_KILL_FORCE_EARLY          =      0,
        MALI_PIXEL_KILL_STRONG_EARLY         =      1,
        MALI_PIXEL_KILL_WEAK_EARLY           =      2,
        MALI_PIXEL_KILL_FORCE_LATE           =      3,
};

static inline const char *
mali_pixel_kill_as_str(enum mali_pixel_kill imm)
{
    switch (imm) {
    case MALI_PIXEL_KILL_FORCE_EARLY: return "Force Early";
    case MALI_PIXEL_KILL_STRONG_EARLY: return "Strong Early";
    case MALI_PIXEL_KILL_WEAK_EARLY: return "Weak Early";
    case MALI_PIXEL_KILL_FORCE_LATE: return "Force Late";
    default: return "XXX: INVALID";
    }
}

enum mali_block_format {
        MALI_BLOCK_FORMAT_NO_WRITE           =      0,
        MALI_BLOCK_FORMAT_TILED_U_INTERLEAVED =      1,
        MALI_BLOCK_FORMAT_LINEAR             =      2,
        MALI_BLOCK_FORMAT_AFBC               =     12,
        MALI_BLOCK_FORMAT_AFBC_TILED         =     13,
};

static inline const char *
mali_block_format_as_str(enum mali_block_format imm)
{
    switch (imm) {
    case MALI_BLOCK_FORMAT_NO_WRITE: return "No Write";
    case MALI_BLOCK_FORMAT_TILED_U_INTERLEAVED: return "Tiled U-Interleaved";
    case MALI_BLOCK_FORMAT_LINEAR: return "Linear";
    case MALI_BLOCK_FORMAT_AFBC: return "AFBC";
    case MALI_BLOCK_FORMAT_AFBC_TILED: return "AFBC Tiled";
    default: return "XXX: INVALID";
    }
}

enum mali_writeback_mode {
        MALI_WRITEBACK_MODE_COMPAT           =      0,
        MALI_WRITEBACK_MODE_AFRC_RGB         =      6,
        MALI_WRITEBACK_MODE_AFRC_YUV         =      7,
};

static inline const char *
mali_writeback_mode_as_str(enum mali_writeback_mode imm)
{
    switch (imm) {
    case MALI_WRITEBACK_MODE_COMPAT: return "Compat";
    case MALI_WRITEBACK_MODE_AFRC_RGB: return "AFRC RGB";
    case MALI_WRITEBACK_MODE_AFRC_YUV: return "AFRC YUV";
    default: return "XXX: INVALID";
    }
}

enum mali_mipmap_mode {
        MALI_MIPMAP_MODE_NEAREST             =      0,
        MALI_MIPMAP_MODE_NONE                =      1,
        MALI_MIPMAP_MODE_TRILINEAR           =      3,
};

static inline const char *
mali_mipmap_mode_as_str(enum mali_mipmap_mode imm)
{
    switch (imm) {
    case MALI_MIPMAP_MODE_NEAREST: return "Nearest";
    case MALI_MIPMAP_MODE_NONE: return "None";
    case MALI_MIPMAP_MODE_TRILINEAR: return "Trilinear";
    default: return "XXX: INVALID";
    }
}

enum mali_lod_algorithm {
        MALI_LOD_ALGORITHM_ISOTROPIC         =      0,
        MALI_LOD_ALGORITHM_ANISOTROPIC       =      3,
};

static inline const char *
mali_lod_algorithm_as_str(enum mali_lod_algorithm imm)
{
    switch (imm) {
    case MALI_LOD_ALGORITHM_ISOTROPIC: return "Isotropic";
    case MALI_LOD_ALGORITHM_ANISOTROPIC: return "Anisotropic";
    default: return "XXX: INVALID";
    }
}

enum mali_msaa {
        MALI_MSAA_SINGLE                     =      0,
        MALI_MSAA_AVERAGE                    =      1,
        MALI_MSAA_MULTIPLE                   =      2,
        MALI_MSAA_LAYERED                    =      3,
};

static inline const char *
mali_msaa_as_str(enum mali_msaa imm)
{
    switch (imm) {
    case MALI_MSAA_SINGLE: return "Single";
    case MALI_MSAA_AVERAGE: return "Average";
    case MALI_MSAA_MULTIPLE: return "Multiple";
    case MALI_MSAA_LAYERED: return "Layered";
    default: return "XXX: INVALID";
    }
}

enum mali_index_type {
        MALI_INDEX_TYPE_NONE                 =      0,
        MALI_INDEX_TYPE_UINT8                =      1,
        MALI_INDEX_TYPE_UINT16               =      2,
        MALI_INDEX_TYPE_UINT32               =      3,
};

static inline const char *
mali_index_type_as_str(enum mali_index_type imm)
{
    switch (imm) {
    case MALI_INDEX_TYPE_NONE: return "None";
    case MALI_INDEX_TYPE_UINT8: return "UINT8";
    case MALI_INDEX_TYPE_UINT16: return "UINT16";
    case MALI_INDEX_TYPE_UINT32: return "UINT32";
    default: return "XXX: INVALID";
    }
}

enum mali_occlusion_mode {
        MALI_OCCLUSION_MODE_DISABLED         =      0,
        MALI_OCCLUSION_MODE_PREDICATE        =      1,
        MALI_OCCLUSION_MODE_COUNTER          =      3,
};

static inline const char *
mali_occlusion_mode_as_str(enum mali_occlusion_mode imm)
{
    switch (imm) {
    case MALI_OCCLUSION_MODE_DISABLED: return "Disabled";
    case MALI_OCCLUSION_MODE_PREDICATE: return "Predicate";
    case MALI_OCCLUSION_MODE_COUNTER: return "Counter";
    default: return "XXX: INVALID";
    }
}

enum mali_stencil_op {
        MALI_STENCIL_OP_KEEP                 =      0,
        MALI_STENCIL_OP_REPLACE              =      1,
        MALI_STENCIL_OP_ZERO                 =      2,
        MALI_STENCIL_OP_INVERT               =      3,
        MALI_STENCIL_OP_INCR_WRAP            =      4,
        MALI_STENCIL_OP_DECR_WRAP            =      5,
        MALI_STENCIL_OP_INCR_SAT             =      6,
        MALI_STENCIL_OP_DECR_SAT             =      7,
};

static inline const char *
mali_stencil_op_as_str(enum mali_stencil_op imm)
{
    switch (imm) {
    case MALI_STENCIL_OP_KEEP: return "Keep";
    case MALI_STENCIL_OP_REPLACE: return "Replace";
    case MALI_STENCIL_OP_ZERO: return "Zero";
    case MALI_STENCIL_OP_INVERT: return "Invert";
    case MALI_STENCIL_OP_INCR_WRAP: return "Incr Wrap";
    case MALI_STENCIL_OP_DECR_WRAP: return "Decr Wrap";
    case MALI_STENCIL_OP_INCR_SAT: return "Incr Sat";
    case MALI_STENCIL_OP_DECR_SAT: return "Decr Sat";
    default: return "XXX: INVALID";
    }
}

enum mali_texture_dimension {
        MALI_TEXTURE_DIMENSION_CUBE          =      0,
        MALI_TEXTURE_DIMENSION_1D            =      1,
        MALI_TEXTURE_DIMENSION_2D            =      2,
        MALI_TEXTURE_DIMENSION_3D            =      3,
};

static inline const char *
mali_texture_dimension_as_str(enum mali_texture_dimension imm)
{
    switch (imm) {
    case MALI_TEXTURE_DIMENSION_CUBE: return "Cube";
    case MALI_TEXTURE_DIMENSION_1D: return "1D";
    case MALI_TEXTURE_DIMENSION_2D: return "2D";
    case MALI_TEXTURE_DIMENSION_3D: return "3D";
    default: return "XXX: INVALID";
    }
}

enum mali_wrap_mode {
        MALI_WRAP_MODE_REPEAT                =      8,
        MALI_WRAP_MODE_CLAMP_TO_EDGE         =      9,
        MALI_WRAP_MODE_CLAMP_TO_BORDER       =     11,
        MALI_WRAP_MODE_MIRRORED_REPEAT       =     12,
        MALI_WRAP_MODE_MIRRORED_CLAMP_TO_EDGE =     13,
        MALI_WRAP_MODE_MIRRORED_CLAMP_TO_BORDER =     15,
};

static inline const char *
mali_wrap_mode_as_str(enum mali_wrap_mode imm)
{
    switch (imm) {
    case MALI_WRAP_MODE_REPEAT: return "Repeat";
    case MALI_WRAP_MODE_CLAMP_TO_EDGE: return "Clamp to Edge";
    case MALI_WRAP_MODE_CLAMP_TO_BORDER: return "Clamp to Border";
    case MALI_WRAP_MODE_MIRRORED_REPEAT: return "Mirrored Repeat";
    case MALI_WRAP_MODE_MIRRORED_CLAMP_TO_EDGE: return "Mirrored Clamp to Edge";
    case MALI_WRAP_MODE_MIRRORED_CLAMP_TO_BORDER: return "Mirrored Clamp to Border";
    default: return "XXX: INVALID";
    }
}

enum mali_tile_render_order {
        MALI_TILE_RENDER_ORDER_Z_ORDER       =      0,
        MALI_TILE_RENDER_ORDER_HORIZONTAL    =      1,
        MALI_TILE_RENDER_ORDER_VERTICAL      =      2,
        MALI_TILE_RENDER_ORDER_REVERSE_HORIZONTAL =      5,
        MALI_TILE_RENDER_ORDER_REVERSE_VERTICAL =      6,
};

static inline const char *
mali_tile_render_order_as_str(enum mali_tile_render_order imm)
{
    switch (imm) {
    case MALI_TILE_RENDER_ORDER_Z_ORDER: return "Z Order";
    case MALI_TILE_RENDER_ORDER_HORIZONTAL: return "Horizontal";
    case MALI_TILE_RENDER_ORDER_VERTICAL: return "Vertical";
    case MALI_TILE_RENDER_ORDER_REVERSE_HORIZONTAL: return "Reverse horizontal";
    case MALI_TILE_RENDER_ORDER_REVERSE_VERTICAL: return "Reverse vertical";
    default: return "XXX: INVALID";
    }
}

enum mali_task_axis {
        MALI_TASK_AXIS_X                     =      0,
        MALI_TASK_AXIS_Y                     =      1,
        MALI_TASK_AXIS_Z                     =      2,
};

static inline const char *
mali_task_axis_as_str(enum mali_task_axis imm)
{
    switch (imm) {
    case MALI_TASK_AXIS_X: return "X";
    case MALI_TASK_AXIS_Y: return "Y";
    case MALI_TASK_AXIS_Z: return "Z";
    default: return "XXX: INVALID";
    }
}

enum mali_attribute_frequency {
        MALI_ATTRIBUTE_FREQUENCY_VERTEX      =      0,
        MALI_ATTRIBUTE_FREQUENCY_INSTANCE    =      1,
};

static inline const char *
mali_attribute_frequency_as_str(enum mali_attribute_frequency imm)
{
    switch (imm) {
    case MALI_ATTRIBUTE_FREQUENCY_VERTEX: return "Vertex";
    case MALI_ATTRIBUTE_FREQUENCY_INSTANCE: return "Instance";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_condition {
        MALI_CS_CONDITION_LEQUAL             =      0,
        MALI_CS_CONDITION_GREATER            =      1,
        MALI_CS_CONDITION_EQUAL              =      2,
        MALI_CS_CONDITION_NEQUAL             =      3,
        MALI_CS_CONDITION_LESS               =      4,
        MALI_CS_CONDITION_GEQUAL             =      5,
        MALI_CS_CONDITION_ALWAYS             =      6,
};

static inline const char *
mali_cs_condition_as_str(enum mali_cs_condition imm)
{
    switch (imm) {
    case MALI_CS_CONDITION_LEQUAL: return "Lequal";
    case MALI_CS_CONDITION_GREATER: return "Greater";
    case MALI_CS_CONDITION_EQUAL: return "Equal";
    case MALI_CS_CONDITION_NEQUAL: return "Nequal";
    case MALI_CS_CONDITION_LESS: return "Less";
    case MALI_CS_CONDITION_GEQUAL: return "Gequal";
    case MALI_CS_CONDITION_ALWAYS: return "Always";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_state {
        MALI_CS_STATE_TIMESTAMP              =      0,
        MALI_CS_STATE_CYCLE_COUNT            =      1,
        MALI_CS_STATE_DISJOINT_COUNT         =      2,
        MALI_CS_STATE_ERROR_STATUS           =      3,
};

static inline const char *
mali_cs_state_as_str(enum mali_cs_state imm)
{
    switch (imm) {
    case MALI_CS_STATE_TIMESTAMP: return "Timestamp";
    case MALI_CS_STATE_CYCLE_COUNT: return "Cycle count";
    case MALI_CS_STATE_DISJOINT_COUNT: return "Disjoint count";
    case MALI_CS_STATE_ERROR_STATUS: return "Error status";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_heap_operation {
        MALI_CS_HEAP_OPERATION_VERTEX_TILER_STARTED =      0,
        MALI_CS_HEAP_OPERATION_VERTEX_TILER_COMPLETED =      1,
        MALI_CS_HEAP_OPERATION_FRAGMENT_COMPLETED =      3,
};

static inline const char *
mali_cs_heap_operation_as_str(enum mali_cs_heap_operation imm)
{
    switch (imm) {
    case MALI_CS_HEAP_OPERATION_VERTEX_TILER_STARTED: return "Vertex/Tiler Started";
    case MALI_CS_HEAP_OPERATION_VERTEX_TILER_COMPLETED: return "Vertex/Tiler Completed";
    case MALI_CS_HEAP_OPERATION_FRAGMENT_COMPLETED: return "Fragment Completed";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_flush_mode {
        MALI_CS_FLUSH_MODE_NONE              =      0,
        MALI_CS_FLUSH_MODE_CLEAN             =      1,
        MALI_CS_FLUSH_MODE_CLEAN_AND_INVALIDATE =      3,
};

static inline const char *
mali_cs_flush_mode_as_str(enum mali_cs_flush_mode imm)
{
    switch (imm) {
    case MALI_CS_FLUSH_MODE_NONE: return "None";
    case MALI_CS_FLUSH_MODE_CLEAN: return "Clean";
    case MALI_CS_FLUSH_MODE_CLEAN_AND_INVALIDATE: return "Clean and invalidate";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_sync_scope {
        MALI_CS_SYNC_SCOPE_SYSTEM            =      0,
        MALI_CS_SYNC_SCOPE_CSG               =      2,
};

static inline const char *
mali_cs_sync_scope_as_str(enum mali_cs_sync_scope imm)
{
    switch (imm) {
    case MALI_CS_SYNC_SCOPE_SYSTEM: return "System";
    case MALI_CS_SYNC_SCOPE_CSG: return "CSG";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_exception_type {
        MALI_CS_EXCEPTION_TYPE_TILER_OOM     =      2,
};

static inline const char *
mali_cs_exception_type_as_str(enum mali_cs_exception_type imm)
{
    switch (imm) {
    case MALI_CS_EXCEPTION_TYPE_TILER_OOM: return "Tiler OOM";
    default: return "XXX: INVALID";
    }
}

enum mali_cs_opcode {
        MALI_CS_OPCODE_NOP                   =      0,
        MALI_CS_OPCODE_MOVE                  =      1,
        MALI_CS_OPCODE_MOVE32                =      2,
        MALI_CS_OPCODE_WAIT                  =      3,
        MALI_CS_OPCODE_RUN_COMPUTE           =      4,
        MALI_CS_OPCODE_RUN_TILING            =      5,
        MALI_CS_OPCODE_RUN_IDVS              =      6,
        MALI_CS_OPCODE_RUN_FRAGMENT          =      7,
        MALI_CS_OPCODE_RUN_FULLSCREEN        =      8,
        MALI_CS_OPCODE_FINISH_TILING         =      9,
        MALI_CS_OPCODE_FINISH_FRAGMENT       =     11,
        MALI_CS_OPCODE_ADD_IMMEDIATE32       =     16,
        MALI_CS_OPCODE_ADD_IMMEDIATE64       =     17,
        MALI_CS_OPCODE_UMIN32                =     18,
        MALI_CS_OPCODE_LOAD_MULTIPLE         =     20,
        MALI_CS_OPCODE_STORE_MULTIPLE        =     21,
        MALI_CS_OPCODE_BRANCH                =     22,
        MALI_CS_OPCODE_SET_SB_ENTRY          =     23,
        MALI_CS_OPCODE_PROGRESS_WAIT         =     24,
        MALI_CS_OPCODE_SET_EXCEPTION_HANDLER =     25,
        MALI_CS_OPCODE_CALL                  =     32,
        MALI_CS_OPCODE_JUMP                  =     33,
        MALI_CS_OPCODE_REQ_RESOURCE          =     34,
        MALI_CS_OPCODE_FLUSH_CACHE2          =     36,
        MALI_CS_OPCODE_SYNC_ADD32            =     37,
        MALI_CS_OPCODE_SYNC_SET32            =     38,
        MALI_CS_OPCODE_SYNC_WAIT32           =     39,
        MALI_CS_OPCODE_STORE_STATE           =     40,
        MALI_CS_OPCODE_PROT_REGION           =     41,
        MALI_CS_OPCODE_PROGRESS_STORE        =     42,
        MALI_CS_OPCODE_PROGRESS_LOAD         =     43,
        MALI_CS_OPCODE_RUN_COMPUTE_INDIRECT  =     44,
        MALI_CS_OPCODE_ERROR_BARRIER         =     47,
        MALI_CS_OPCODE_HEAP_SET              =     48,
        MALI_CS_OPCODE_HEAP_OPERATION        =     49,
        MALI_CS_OPCODE_TRACE_POINT           =     50,
        MALI_CS_OPCODE_SYNC_ADD64            =     51,
        MALI_CS_OPCODE_SYNC_SET64            =     52,
        MALI_CS_OPCODE_SYNC_WAIT64           =     53,
};

static inline const char *
mali_cs_opcode_as_str(enum mali_cs_opcode imm)
{
    switch (imm) {
    case MALI_CS_OPCODE_NOP: return "NOP";
    case MALI_CS_OPCODE_MOVE: return "MOVE";
    case MALI_CS_OPCODE_MOVE32: return "MOVE32";
    case MALI_CS_OPCODE_WAIT: return "WAIT";
    case MALI_CS_OPCODE_RUN_COMPUTE: return "RUN_COMPUTE";
    case MALI_CS_OPCODE_RUN_TILING: return "RUN_TILING";
    case MALI_CS_OPCODE_RUN_IDVS: return "RUN_IDVS";
    case MALI_CS_OPCODE_RUN_FRAGMENT: return "RUN_FRAGMENT";
    case MALI_CS_OPCODE_RUN_FULLSCREEN: return "RUN_FULLSCREEN";
    case MALI_CS_OPCODE_FINISH_TILING: return "FINISH_TILING";
    case MALI_CS_OPCODE_FINISH_FRAGMENT: return "FINISH_FRAGMENT";
    case MALI_CS_OPCODE_ADD_IMMEDIATE32: return "ADD_IMMEDIATE32";
    case MALI_CS_OPCODE_ADD_IMMEDIATE64: return "ADD_IMMEDIATE64";
    case MALI_CS_OPCODE_UMIN32: return "UMIN32";
    case MALI_CS_OPCODE_LOAD_MULTIPLE: return "LOAD_MULTIPLE";
    case MALI_CS_OPCODE_STORE_MULTIPLE: return "STORE_MULTIPLE";
    case MALI_CS_OPCODE_BRANCH: return "BRANCH";
    case MALI_CS_OPCODE_SET_SB_ENTRY: return "SET_SB_ENTRY";
    case MALI_CS_OPCODE_PROGRESS_WAIT: return "PROGRESS_WAIT";
    case MALI_CS_OPCODE_SET_EXCEPTION_HANDLER: return "SET_EXCEPTION_HANDLER";
    case MALI_CS_OPCODE_CALL: return "CALL";
    case MALI_CS_OPCODE_JUMP: return "JUMP";
    case MALI_CS_OPCODE_REQ_RESOURCE: return "REQ_RESOURCE";
    case MALI_CS_OPCODE_FLUSH_CACHE2: return "FLUSH_CACHE2";
    case MALI_CS_OPCODE_SYNC_ADD32: return "SYNC_ADD32";
    case MALI_CS_OPCODE_SYNC_SET32: return "SYNC_SET32";
    case MALI_CS_OPCODE_SYNC_WAIT32: return "SYNC_WAIT32";
    case MALI_CS_OPCODE_STORE_STATE: return "STORE_STATE";
    case MALI_CS_OPCODE_PROT_REGION: return "PROT_REGION";
    case MALI_CS_OPCODE_PROGRESS_STORE: return "PROGRESS_STORE";
    case MALI_CS_OPCODE_PROGRESS_LOAD: return "PROGRESS_LOAD";
    case MALI_CS_OPCODE_RUN_COMPUTE_INDIRECT: return "RUN_COMPUTE_INDIRECT";
    case MALI_CS_OPCODE_ERROR_BARRIER: return "ERROR_BARRIER";
    case MALI_CS_OPCODE_HEAP_SET: return "HEAP_SET";
    case MALI_CS_OPCODE_HEAP_OPERATION: return "HEAP_OPERATION";
    case MALI_CS_OPCODE_TRACE_POINT: return "TRACE_POINT";
    case MALI_CS_OPCODE_SYNC_ADD64: return "SYNC_ADD64";
    case MALI_CS_OPCODE_SYNC_SET64: return "SYNC_SET64";
    case MALI_CS_OPCODE_SYNC_WAIT64: return "SYNC_WAIT64";
    default: return "XXX: INVALID";
    }
}

struct MALI_CS_BASE {
   uint64_t                             data;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_BASE_header                     \
   0

static ALWAYS_INLINE void
MALI_CS_BASE_pack(uint32_t * restrict cl,
                  const struct MALI_CS_BASE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->data, 0, 55);
   cl[ 1] = util_bitpack_uint(values->data, 0, 55) >> 32 |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_BASE_LENGTH 8
struct mali_cs_base_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_BASE_unpack(const uint8_t * restrict cl,
                    struct MALI_CS_BASE * restrict values)
{
   values->data = __gen_unpack_uint(cl, 0, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_BASE_print(FILE *fp, const struct MALI_CS_BASE * values, unsigned indent)
{
   fprintf(fp, "%*sData: 0x%" PRIx64 "\n", indent, "", values->data);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_NOP {
   uint64_t                             ignored;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_NOP_header                      \
   .opcode = MALI_CS_OPCODE_NOP

static ALWAYS_INLINE void
MALI_CS_NOP_pack(uint32_t * restrict cl,
                 const struct MALI_CS_NOP * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->ignored, 0, 55);
   cl[ 1] = util_bitpack_uint(values->ignored, 0, 55) >> 32 |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_NOP_LENGTH 8
struct mali_cs_nop_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_NOP_unpack(const uint8_t * restrict cl,
                   struct MALI_CS_NOP * restrict values)
{
   values->ignored = __gen_unpack_uint(cl, 0, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_NOP_print(FILE *fp, const struct MALI_CS_NOP * values, unsigned indent)
{
   fprintf(fp, "%*sIgnored: 0x%" PRIx64 "\n", indent, "", values->ignored);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_MOVE {
   uint64_t                             immediate;
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_MOVE_header                     \
   .opcode = MALI_CS_OPCODE_MOVE

static ALWAYS_INLINE void
MALI_CS_MOVE_pack(uint32_t * restrict cl,
                  const struct MALI_CS_MOVE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->immediate, 0, 47);
   cl[ 1] = util_bitpack_uint(values->immediate, 0, 47) >> 32 |
            util_bitpack_uint(values->destination, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_MOVE_LENGTH 8
struct mali_cs_move_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_MOVE_unpack(const uint8_t * restrict cl,
                    struct MALI_CS_MOVE * restrict values)
{
   values->immediate = __gen_unpack_uint(cl, 0, 47);
   values->destination = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_MOVE_print(FILE *fp, const struct MALI_CS_MOVE * values, unsigned indent)
{
   fprintf(fp, "%*sImmediate: 0x%" PRIx64 "\n", indent, "", values->immediate);
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_MOVE32 {
   uint32_t                             immediate;
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_MOVE32_header                   \
   .opcode = MALI_CS_OPCODE_MOVE32

static ALWAYS_INLINE void
MALI_CS_MOVE32_pack(uint32_t * restrict cl,
                    const struct MALI_CS_MOVE32 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->immediate, 0, 31);
   cl[ 1] = util_bitpack_uint(values->destination, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_MOVE32_LENGTH 8
struct mali_cs_move32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_MOVE32_unpack(const uint8_t * restrict cl,
                      struct MALI_CS_MOVE32 * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xffff) fprintf(stderr, "XXX: Invalid field of CS MOVE32 unpacked at word 1\n");
   values->immediate = __gen_unpack_uint(cl, 0, 31);
   values->destination = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_MOVE32_print(FILE *fp, const struct MALI_CS_MOVE32 * values, unsigned indent)
{
   fprintf(fp, "%*sImmediate: 0x%x\n", indent, "", values->immediate);
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_WAIT {
   uint32_t                             wait_mask;
   bool                                 progress_increment;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_WAIT_header                     \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_WAIT

static ALWAYS_INLINE void
MALI_CS_WAIT_pack(uint32_t * restrict cl,
                  const struct MALI_CS_WAIT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->wait_mask, 16, 23);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_WAIT_LENGTH 8
struct mali_cs_wait_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_WAIT_unpack(const uint8_t * restrict cl,
                    struct MALI_CS_WAIT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff00ffff) fprintf(stderr, "XXX: Invalid field of CS WAIT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xfffffe) fprintf(stderr, "XXX: Invalid field of CS WAIT unpacked at word 1\n");
   values->wait_mask = __gen_unpack_uint(cl, 16, 23);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_WAIT_print(FILE *fp, const struct MALI_CS_WAIT * values, unsigned indent)
{
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_COMPUTE {
   uint32_t                             task_increment;
   enum mali_task_axis                  task_axis;
   bool                                 progress_increment;
   uint32_t                             srt_select;
   uint32_t                             spd_select;
   uint32_t                             tsd_select;
   uint32_t                             fau_select;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_COMPUTE_header              \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_COMPUTE

static ALWAYS_INLINE void
MALI_CS_RUN_COMPUTE_pack(uint32_t * restrict cl,
                         const struct MALI_CS_RUN_COMPUTE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->task_increment, 0, 13) |
            util_bitpack_uint(values->task_axis, 14, 15);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->srt_select, 8, 9) |
            util_bitpack_uint(values->spd_select, 10, 11) |
            util_bitpack_uint(values->tsd_select, 12, 13) |
            util_bitpack_uint(values->fau_select, 14, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_COMPUTE_LENGTH 8
struct mali_cs_run_compute_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_COMPUTE_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_RUN_COMPUTE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of CS RUN_COMPUTE unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00fe) fprintf(stderr, "XXX: Invalid field of CS RUN_COMPUTE unpacked at word 1\n");
   values->task_increment = __gen_unpack_uint(cl, 0, 13);
   values->task_axis = (enum mali_task_axis)__gen_unpack_uint(cl, 14, 15);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->srt_select = __gen_unpack_uint(cl, 40, 41);
   values->spd_select = __gen_unpack_uint(cl, 42, 43);
   values->tsd_select = __gen_unpack_uint(cl, 44, 45);
   values->fau_select = __gen_unpack_uint(cl, 46, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_COMPUTE_print(FILE *fp, const struct MALI_CS_RUN_COMPUTE * values, unsigned indent)
{
   fprintf(fp, "%*sTask increment: %u\n", indent, "", values->task_increment);
   fprintf(fp, "%*sTask axis: %s\n", indent, "", mali_task_axis_as_str(values->task_axis));
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sSRT select: %u\n", indent, "", values->srt_select);
   fprintf(fp, "%*sSPD select: %u\n", indent, "", values->spd_select);
   fprintf(fp, "%*sTSD select: %u\n", indent, "", values->tsd_select);
   fprintf(fp, "%*sFAU select: %u\n", indent, "", values->fau_select);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_TILING {
   uint32_t                             flags_override;
   bool                                 progress_increment;
   uint32_t                             srt_select;
   uint32_t                             spd_select;
   uint32_t                             tsd_select;
   uint32_t                             fau_select;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_TILING_header               \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_TILING

static ALWAYS_INLINE void
MALI_CS_RUN_TILING_pack(uint32_t * restrict cl,
                        const struct MALI_CS_RUN_TILING * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->flags_override, 0, 31);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->srt_select, 8, 9) |
            util_bitpack_uint(values->spd_select, 10, 11) |
            util_bitpack_uint(values->tsd_select, 12, 13) |
            util_bitpack_uint(values->fau_select, 14, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_TILING_LENGTH 8
struct mali_cs_run_tiling_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_TILING_unpack(const uint8_t * restrict cl,
                          struct MALI_CS_RUN_TILING * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff00fe) fprintf(stderr, "XXX: Invalid field of CS RUN_TILING unpacked at word 1\n");
   values->flags_override = __gen_unpack_uint(cl, 0, 31);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->srt_select = __gen_unpack_uint(cl, 40, 41);
   values->spd_select = __gen_unpack_uint(cl, 42, 43);
   values->tsd_select = __gen_unpack_uint(cl, 44, 45);
   values->fau_select = __gen_unpack_uint(cl, 46, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_TILING_print(FILE *fp, const struct MALI_CS_RUN_TILING * values, unsigned indent)
{
   fprintf(fp, "%*sFlags override: 0x%x\n", indent, "", values->flags_override);
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sSRT select: %u\n", indent, "", values->srt_select);
   fprintf(fp, "%*sSPD select: %u\n", indent, "", values->spd_select);
   fprintf(fp, "%*sTSD select: %u\n", indent, "", values->tsd_select);
   fprintf(fp, "%*sFAU select: %u\n", indent, "", values->fau_select);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_IDVS {
   uint32_t                             flags_override;
   bool                                 progress_increment;
   bool                                 malloc_enable;
   bool                                 draw_id_register_enable;
   bool                                 varying_srt_select;
   bool                                 varying_fau_select;
   bool                                 varying_tsd_select;
   bool                                 fragment_srt_select;
   bool                                 fragment_tsd_select;
   uint32_t                             draw_id;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_IDVS_header                 \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_IDVS

static ALWAYS_INLINE void
MALI_CS_RUN_IDVS_pack(uint32_t * restrict cl,
                      const struct MALI_CS_RUN_IDVS * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->flags_override, 0, 31);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->malloc_enable, 1, 1) |
            util_bitpack_uint(values->draw_id_register_enable, 2, 2) |
            util_bitpack_uint(values->varying_srt_select, 3, 3) |
            util_bitpack_uint(values->varying_fau_select, 4, 4) |
            util_bitpack_uint(values->varying_tsd_select, 5, 5) |
            util_bitpack_uint(values->fragment_srt_select, 6, 6) |
            util_bitpack_uint(values->fragment_tsd_select, 7, 7) |
            util_bitpack_uint(values->draw_id, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_IDVS_LENGTH 8
struct mali_cs_run_idvs_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_IDVS_unpack(const uint8_t * restrict cl,
                        struct MALI_CS_RUN_IDVS * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff0000) fprintf(stderr, "XXX: Invalid field of CS RUN_IDVS unpacked at word 1\n");
   values->flags_override = __gen_unpack_uint(cl, 0, 31);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->malloc_enable = __gen_unpack_uint(cl, 33, 33);
   values->draw_id_register_enable = __gen_unpack_uint(cl, 34, 34);
   values->varying_srt_select = __gen_unpack_uint(cl, 35, 35);
   values->varying_fau_select = __gen_unpack_uint(cl, 36, 36);
   values->varying_tsd_select = __gen_unpack_uint(cl, 37, 37);
   values->fragment_srt_select = __gen_unpack_uint(cl, 38, 38);
   values->fragment_tsd_select = __gen_unpack_uint(cl, 39, 39);
   values->draw_id = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_IDVS_print(FILE *fp, const struct MALI_CS_RUN_IDVS * values, unsigned indent)
{
   fprintf(fp, "%*sFlags override: 0x%x\n", indent, "", values->flags_override);
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sMalloc enable: %s\n", indent, "", values->malloc_enable ? "true" : "false");
   fprintf(fp, "%*sDraw ID register enable: %s\n", indent, "", values->draw_id_register_enable ? "true" : "false");
   fprintf(fp, "%*sVarying SRT select: %s\n", indent, "", values->varying_srt_select ? "true" : "false");
   fprintf(fp, "%*sVarying FAU select: %s\n", indent, "", values->varying_fau_select ? "true" : "false");
   fprintf(fp, "%*sVarying TSD select: %s\n", indent, "", values->varying_tsd_select ? "true" : "false");
   fprintf(fp, "%*sFragment SRT select: %s\n", indent, "", values->fragment_srt_select ? "true" : "false");
   fprintf(fp, "%*sFragment TSD select: %s\n", indent, "", values->fragment_tsd_select ? "true" : "false");
   fprintf(fp, "%*sDraw ID: %u\n", indent, "", values->draw_id);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_FRAGMENT {
   bool                                 enable_tem;
   enum mali_tile_render_order          tile_order;
   bool                                 progress_increment;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_FRAGMENT_header             \
   .tile_order = MALI_TILE_RENDER_ORDER_Z_ORDER,  \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_FRAGMENT

static ALWAYS_INLINE void
MALI_CS_RUN_FRAGMENT_pack(uint32_t * restrict cl,
                          const struct MALI_CS_RUN_FRAGMENT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->enable_tem, 0, 0) |
            util_bitpack_uint(values->tile_order, 4, 7);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_FRAGMENT_LENGTH 8
struct mali_cs_run_fragment_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_FRAGMENT_unpack(const uint8_t * restrict cl,
                            struct MALI_CS_RUN_FRAGMENT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffff0e) fprintf(stderr, "XXX: Invalid field of CS RUN_FRAGMENT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xfffffe) fprintf(stderr, "XXX: Invalid field of CS RUN_FRAGMENT unpacked at word 1\n");
   values->enable_tem = __gen_unpack_uint(cl, 0, 0);
   values->tile_order = (enum mali_tile_render_order)__gen_unpack_uint(cl, 4, 7);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_FRAGMENT_print(FILE *fp, const struct MALI_CS_RUN_FRAGMENT * values, unsigned indent)
{
   fprintf(fp, "%*sEnable TEM: %s\n", indent, "", values->enable_tem ? "true" : "false");
   fprintf(fp, "%*sTile order: %s\n", indent, "", mali_tile_render_order_as_str(values->tile_order));
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_FULLSCREEN {
   uint32_t                             flags_override;
   bool                                 progress_increment;
   uint32_t                             dcd;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_FULLSCREEN_header           \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_FULLSCREEN

static ALWAYS_INLINE void
MALI_CS_RUN_FULLSCREEN_pack(uint32_t * restrict cl,
                            const struct MALI_CS_RUN_FULLSCREEN * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->flags_override, 0, 31);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->dcd, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_FULLSCREEN_LENGTH 8
struct mali_cs_run_fullscreen_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_FULLSCREEN_unpack(const uint8_t * restrict cl,
                              struct MALI_CS_RUN_FULLSCREEN * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff00fe) fprintf(stderr, "XXX: Invalid field of CS RUN_FULLSCREEN unpacked at word 1\n");
   values->flags_override = __gen_unpack_uint(cl, 0, 31);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->dcd = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_FULLSCREEN_print(FILE *fp, const struct MALI_CS_RUN_FULLSCREEN * values, unsigned indent)
{
   fprintf(fp, "%*sFlags override: 0x%x\n", indent, "", values->flags_override);
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sDCD: %u\n", indent, "", values->dcd);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_FINISH_TILING {
   bool                                 progress_increment;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_FINISH_TILING_header            \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_FINISH_TILING

static ALWAYS_INLINE void
MALI_CS_FINISH_TILING_pack(uint32_t * restrict cl,
                           const struct MALI_CS_FINISH_TILING * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_FINISH_TILING_LENGTH 8
struct mali_cs_finish_tiling_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_FINISH_TILING_unpack(const uint8_t * restrict cl,
                             struct MALI_CS_FINISH_TILING * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS FINISH_TILING unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xfffffe) fprintf(stderr, "XXX: Invalid field of CS FINISH_TILING unpacked at word 1\n");
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_FINISH_TILING_print(FILE *fp, const struct MALI_CS_FINISH_TILING * values, unsigned indent)
{
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_FINISH_FRAGMENT {
   bool                                 increment_fragment_completed;
   uint32_t                             wait_mask;
   uint32_t                             last_heap_chunk;
   uint32_t                             first_heap_chunk;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_FINISH_FRAGMENT_header          \
   .opcode = MALI_CS_OPCODE_FINISH_FRAGMENT

static ALWAYS_INLINE void
MALI_CS_FINISH_FRAGMENT_pack(uint32_t * restrict cl,
                             const struct MALI_CS_FINISH_FRAGMENT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->increment_fragment_completed, 0, 0) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->last_heap_chunk, 0, 7) |
            util_bitpack_uint(values->first_heap_chunk, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_FINISH_FRAGMENT_LENGTH 8
struct mali_cs_finish_fragment_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_FINISH_FRAGMENT_unpack(const uint8_t * restrict cl,
                               struct MALI_CS_FINISH_FRAGMENT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfffe) fprintf(stderr, "XXX: Invalid field of CS FINISH_FRAGMENT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS FINISH_FRAGMENT unpacked at word 1\n");
   values->increment_fragment_completed = __gen_unpack_uint(cl, 0, 0);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->last_heap_chunk = __gen_unpack_uint(cl, 32, 39);
   values->first_heap_chunk = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_FINISH_FRAGMENT_print(FILE *fp, const struct MALI_CS_FINISH_FRAGMENT * values, unsigned indent)
{
   fprintf(fp, "%*sIncrement Fragment Completed: %s\n", indent, "", values->increment_fragment_completed ? "true" : "false");
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sLast Heap Chunk: 0x%x\n", indent, "", values->last_heap_chunk);
   fprintf(fp, "%*sFirst Heap Chunk: 0x%x\n", indent, "", values->first_heap_chunk);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_ADD_IMMEDIATE32 {
   int32_t                              immediate;
   uint32_t                             source;
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_ADD_IMMEDIATE32_header          \
   .opcode = MALI_CS_OPCODE_ADD_IMMEDIATE32

static ALWAYS_INLINE void
MALI_CS_ADD_IMMEDIATE32_pack(uint32_t * restrict cl,
                             const struct MALI_CS_ADD_IMMEDIATE32 * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->immediate, 0, 31);
   cl[ 1] = util_bitpack_uint(values->source, 8, 15) |
            util_bitpack_uint(values->destination, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_ADD_IMMEDIATE32_LENGTH 8
struct mali_cs_add_immediate32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_ADD_IMMEDIATE32_unpack(const uint8_t * restrict cl,
                               struct MALI_CS_ADD_IMMEDIATE32 * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff) fprintf(stderr, "XXX: Invalid field of CS ADD_IMMEDIATE32 unpacked at word 1\n");
   values->immediate = __gen_unpack_sint(cl, 0, 31);
   values->source = __gen_unpack_uint(cl, 40, 47);
   values->destination = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_ADD_IMMEDIATE32_print(FILE *fp, const struct MALI_CS_ADD_IMMEDIATE32 * values, unsigned indent)
{
   fprintf(fp, "%*sImmediate: %d\n", indent, "", values->immediate);
   fprintf(fp, "%*sSource: %u\n", indent, "", values->source);
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_ADD_IMMEDIATE64 {
   int32_t                              immediate;
   uint32_t                             source;
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_ADD_IMMEDIATE64_header          \
   .opcode = MALI_CS_OPCODE_ADD_IMMEDIATE64

static ALWAYS_INLINE void
MALI_CS_ADD_IMMEDIATE64_pack(uint32_t * restrict cl,
                             const struct MALI_CS_ADD_IMMEDIATE64 * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->immediate, 0, 31);
   cl[ 1] = util_bitpack_uint(values->source, 8, 15) |
            util_bitpack_uint(values->destination, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_ADD_IMMEDIATE64_LENGTH 8
struct mali_cs_add_immediate64_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_ADD_IMMEDIATE64_unpack(const uint8_t * restrict cl,
                               struct MALI_CS_ADD_IMMEDIATE64 * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff) fprintf(stderr, "XXX: Invalid field of CS ADD_IMMEDIATE64 unpacked at word 1\n");
   values->immediate = __gen_unpack_sint(cl, 0, 31);
   values->source = __gen_unpack_uint(cl, 40, 47);
   values->destination = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_ADD_IMMEDIATE64_print(FILE *fp, const struct MALI_CS_ADD_IMMEDIATE64 * values, unsigned indent)
{
   fprintf(fp, "%*sImmediate: %d\n", indent, "", values->immediate);
   fprintf(fp, "%*sSource: %u\n", indent, "", values->source);
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_UMIN32 {
   uint32_t                             source_1;
   uint32_t                             source_2;
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_UMIN32_header                   \
   .opcode = MALI_CS_OPCODE_UMIN32

static ALWAYS_INLINE void
MALI_CS_UMIN32_pack(uint32_t * restrict cl,
                    const struct MALI_CS_UMIN32 * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->source_1, 0, 7) |
            util_bitpack_uint(values->source_2, 8, 15) |
            util_bitpack_uint(values->destination, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_UMIN32_LENGTH 8
struct mali_cs_umin32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_UMIN32_unpack(const uint8_t * restrict cl,
                      struct MALI_CS_UMIN32 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS UMIN32 unpacked at word 0\n");
   values->source_1 = __gen_unpack_uint(cl, 32, 39);
   values->source_2 = __gen_unpack_uint(cl, 40, 47);
   values->destination = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_UMIN32_print(FILE *fp, const struct MALI_CS_UMIN32 * values, unsigned indent)
{
   fprintf(fp, "%*sSource 1: %u\n", indent, "", values->source_1);
   fprintf(fp, "%*sSource 2: %u\n", indent, "", values->source_2);
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_LOAD_MULTIPLE {
   int32_t                              offset;
   uint32_t                             mask;
   uint32_t                             address;
   uint32_t                             base_register;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_LOAD_MULTIPLE_header            \
   .opcode = MALI_CS_OPCODE_LOAD_MULTIPLE

static ALWAYS_INLINE void
MALI_CS_LOAD_MULTIPLE_pack(uint32_t * restrict cl,
                           const struct MALI_CS_LOAD_MULTIPLE * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->offset, 0, 15) |
            util_bitpack_uint(values->mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->base_register, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_LOAD_MULTIPLE_LENGTH 8
struct mali_cs_load_multiple_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_LOAD_MULTIPLE_unpack(const uint8_t * restrict cl,
                             struct MALI_CS_LOAD_MULTIPLE * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff) fprintf(stderr, "XXX: Invalid field of CS LOAD_MULTIPLE unpacked at word 1\n");
   values->offset = __gen_unpack_sint(cl, 0, 15);
   values->mask = __gen_unpack_uint(cl, 16, 31);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->base_register = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_LOAD_MULTIPLE_print(FILE *fp, const struct MALI_CS_LOAD_MULTIPLE * values, unsigned indent)
{
   fprintf(fp, "%*sOffset: %d\n", indent, "", values->offset);
   fprintf(fp, "%*sMask: 0x%x\n", indent, "", values->mask);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sBase register: %u\n", indent, "", values->base_register);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_STORE_MULTIPLE {
   int32_t                              offset;
   uint32_t                             mask;
   uint32_t                             address;
   uint32_t                             base_register;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_STORE_MULTIPLE_header           \
   .opcode = MALI_CS_OPCODE_STORE_MULTIPLE

static ALWAYS_INLINE void
MALI_CS_STORE_MULTIPLE_pack(uint32_t * restrict cl,
                            const struct MALI_CS_STORE_MULTIPLE * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->offset, 0, 15) |
            util_bitpack_uint(values->mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->base_register, 16, 23) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_STORE_MULTIPLE_LENGTH 8
struct mali_cs_store_multiple_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_STORE_MULTIPLE_unpack(const uint8_t * restrict cl,
                              struct MALI_CS_STORE_MULTIPLE * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xff) fprintf(stderr, "XXX: Invalid field of CS STORE_MULTIPLE unpacked at word 1\n");
   values->offset = __gen_unpack_sint(cl, 0, 15);
   values->mask = __gen_unpack_uint(cl, 16, 31);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->base_register = __gen_unpack_uint(cl, 48, 55);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_STORE_MULTIPLE_print(FILE *fp, const struct MALI_CS_STORE_MULTIPLE * values, unsigned indent)
{
   fprintf(fp, "%*sOffset: %d\n", indent, "", values->offset);
   fprintf(fp, "%*sMask: 0x%x\n", indent, "", values->mask);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sBase register: %u\n", indent, "", values->base_register);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_BRANCH {
   int32_t                              offset;
   enum mali_cs_condition               condition;
   uint32_t                             value;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_BRANCH_header                   \
   .opcode = MALI_CS_OPCODE_BRANCH

static ALWAYS_INLINE void
MALI_CS_BRANCH_pack(uint32_t * restrict cl,
                    const struct MALI_CS_BRANCH * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->offset, 0, 15) |
            util_bitpack_uint(values->condition, 28, 30);
   cl[ 1] = util_bitpack_uint(values->value, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_BRANCH_LENGTH 8
struct mali_cs_branch_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_BRANCH_unpack(const uint8_t * restrict cl,
                      struct MALI_CS_BRANCH * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x8fff0000) fprintf(stderr, "XXX: Invalid field of CS BRANCH unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00ff) fprintf(stderr, "XXX: Invalid field of CS BRANCH unpacked at word 1\n");
   values->offset = __gen_unpack_sint(cl, 0, 15);
   values->condition = (enum mali_cs_condition)__gen_unpack_uint(cl, 28, 30);
   values->value = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_BRANCH_print(FILE *fp, const struct MALI_CS_BRANCH * values, unsigned indent)
{
   fprintf(fp, "%*sOffset: %d\n", indent, "", values->offset);
   fprintf(fp, "%*sCondition: %s\n", indent, "", mali_cs_condition_as_str(values->condition));
   fprintf(fp, "%*sValue: %u\n", indent, "", values->value);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SET_SB_ENTRY {
   uint32_t                             endpoint_entry;
   uint32_t                             other_entry;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SET_SB_ENTRY_header             \
   .opcode = MALI_CS_OPCODE_SET_SB_ENTRY

static ALWAYS_INLINE void
MALI_CS_SET_SB_ENTRY_pack(uint32_t * restrict cl,
                          const struct MALI_CS_SET_SB_ENTRY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->endpoint_entry, 0, 3) |
            util_bitpack_uint(values->other_entry, 4, 7);
   cl[ 1] = util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SET_SB_ENTRY_LENGTH 8
struct mali_cs_set_sb_entry_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SET_SB_ENTRY_unpack(const uint8_t * restrict cl,
                            struct MALI_CS_SET_SB_ENTRY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of CS SET_SB_ENTRY unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffff) fprintf(stderr, "XXX: Invalid field of CS SET_SB_ENTRY unpacked at word 1\n");
   values->endpoint_entry = __gen_unpack_uint(cl, 0, 3);
   values->other_entry = __gen_unpack_uint(cl, 4, 7);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SET_SB_ENTRY_print(FILE *fp, const struct MALI_CS_SET_SB_ENTRY * values, unsigned indent)
{
   fprintf(fp, "%*sEndpoint entry: %u\n", indent, "", values->endpoint_entry);
   fprintf(fp, "%*sOther entry: %u\n", indent, "", values->other_entry);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_PROGRESS_WAIT {
   uint32_t                             queue;
   uint32_t                             source;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_PROGRESS_WAIT_header            \
   .opcode = MALI_CS_OPCODE_PROGRESS_WAIT

static ALWAYS_INLINE void
MALI_CS_PROGRESS_WAIT_pack(uint32_t * restrict cl,
                           const struct MALI_CS_PROGRESS_WAIT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->queue, 0, 4);
   cl[ 1] = util_bitpack_uint(values->source, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_PROGRESS_WAIT_LENGTH 8
struct mali_cs_progress_wait_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_PROGRESS_WAIT_unpack(const uint8_t * restrict cl,
                             struct MALI_CS_PROGRESS_WAIT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffe0) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_WAIT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00ff) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_WAIT unpacked at word 1\n");
   values->queue = __gen_unpack_uint(cl, 0, 4);
   values->source = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_PROGRESS_WAIT_print(FILE *fp, const struct MALI_CS_PROGRESS_WAIT * values, unsigned indent)
{
   fprintf(fp, "%*sQueue: %u\n", indent, "", values->queue);
   fprintf(fp, "%*sSource: %u\n", indent, "", values->source);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SET_EXCEPTION_HANDLER {
   enum mali_cs_exception_type          exception_type;
   uint32_t                             length;
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SET_EXCEPTION_HANDLER_header    \
   .opcode = MALI_CS_OPCODE_SET_EXCEPTION_HANDLER

static ALWAYS_INLINE void
MALI_CS_SET_EXCEPTION_HANDLER_pack(uint32_t * restrict cl,
                                   const struct MALI_CS_SET_EXCEPTION_HANDLER * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->exception_type, 0, 7);
   cl[ 1] = util_bitpack_uint(values->length, 0, 7) |
            util_bitpack_uint(values->address, 0, 7) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SET_EXCEPTION_HANDLER_LENGTH 8
struct mali_cs_set_exception_handler_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SET_EXCEPTION_HANDLER_unpack(const uint8_t * restrict cl,
                                     struct MALI_CS_SET_EXCEPTION_HANDLER * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of CS SET_EXCEPTION_HANDLER unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffff00) fprintf(stderr, "XXX: Invalid field of CS SET_EXCEPTION_HANDLER unpacked at word 1\n");
   values->exception_type = (enum mali_cs_exception_type)__gen_unpack_uint(cl, 0, 7);
   values->length = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 32, 39);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SET_EXCEPTION_HANDLER_print(FILE *fp, const struct MALI_CS_SET_EXCEPTION_HANDLER * values, unsigned indent)
{
   fprintf(fp, "%*sException type: %s\n", indent, "", mali_cs_exception_type_as_str(values->exception_type));
   fprintf(fp, "%*sLength: %u\n", indent, "", values->length);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_CALL {
   uint32_t                             length;
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_CALL_header                     \
   .opcode = MALI_CS_OPCODE_CALL

static ALWAYS_INLINE void
MALI_CS_CALL_pack(uint32_t * restrict cl,
                  const struct MALI_CS_CALL * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->length, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_CALL_LENGTH 8
struct mali_cs_call_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_CALL_unpack(const uint8_t * restrict cl,
                    struct MALI_CS_CALL * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS CALL unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff0000) fprintf(stderr, "XXX: Invalid field of CS CALL unpacked at word 1\n");
   values->length = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_CALL_print(FILE *fp, const struct MALI_CS_CALL * values, unsigned indent)
{
   fprintf(fp, "%*sLength: %u\n", indent, "", values->length);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_JUMP {
   uint32_t                             length;
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_JUMP_header                     \
   .opcode = MALI_CS_OPCODE_JUMP

static ALWAYS_INLINE void
MALI_CS_JUMP_pack(uint32_t * restrict cl,
                  const struct MALI_CS_JUMP * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->length, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_JUMP_LENGTH 8
struct mali_cs_jump_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_JUMP_unpack(const uint8_t * restrict cl,
                    struct MALI_CS_JUMP * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS JUMP unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff0000) fprintf(stderr, "XXX: Invalid field of CS JUMP unpacked at word 1\n");
   values->length = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_JUMP_print(FILE *fp, const struct MALI_CS_JUMP * values, unsigned indent)
{
   fprintf(fp, "%*sLength: %u\n", indent, "", values->length);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_REQ_RESOURCE {
   bool                                 compute;
   bool                                 fragment;
   bool                                 tiler;
   bool                                 idvs;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_REQ_RESOURCE_header             \
   .opcode = MALI_CS_OPCODE_REQ_RESOURCE

static ALWAYS_INLINE void
MALI_CS_REQ_RESOURCE_pack(uint32_t * restrict cl,
                          const struct MALI_CS_REQ_RESOURCE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->compute, 0, 0) |
            util_bitpack_uint(values->fragment, 1, 1) |
            util_bitpack_uint(values->tiler, 2, 2) |
            util_bitpack_uint(values->idvs, 3, 3);
   cl[ 1] = util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_REQ_RESOURCE_LENGTH 8
struct mali_cs_req_resource_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_REQ_RESOURCE_unpack(const uint8_t * restrict cl,
                            struct MALI_CS_REQ_RESOURCE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfffffff0) fprintf(stderr, "XXX: Invalid field of CS REQ_RESOURCE unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffff) fprintf(stderr, "XXX: Invalid field of CS REQ_RESOURCE unpacked at word 1\n");
   values->compute = __gen_unpack_uint(cl, 0, 0);
   values->fragment = __gen_unpack_uint(cl, 1, 1);
   values->tiler = __gen_unpack_uint(cl, 2, 2);
   values->idvs = __gen_unpack_uint(cl, 3, 3);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_REQ_RESOURCE_print(FILE *fp, const struct MALI_CS_REQ_RESOURCE * values, unsigned indent)
{
   fprintf(fp, "%*sCompute: %s\n", indent, "", values->compute ? "true" : "false");
   fprintf(fp, "%*sFragment: %s\n", indent, "", values->fragment ? "true" : "false");
   fprintf(fp, "%*sTiler: %s\n", indent, "", values->tiler ? "true" : "false");
   fprintf(fp, "%*sIDVS: %s\n", indent, "", values->idvs ? "true" : "false");
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_FLUSH_CACHE2 {
   enum mali_cs_flush_mode              l2_flush_mode;
   enum mali_cs_flush_mode              lsc_flush_mode;
   bool                                 other_invalidate;
   uint32_t                             wait_mask;
   uint32_t                             latest_flush_id;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_FLUSH_CACHE2_header             \
   .opcode = MALI_CS_OPCODE_FLUSH_CACHE2

static ALWAYS_INLINE void
MALI_CS_FLUSH_CACHE2_pack(uint32_t * restrict cl,
                          const struct MALI_CS_FLUSH_CACHE2 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->l2_flush_mode, 0, 3) |
            util_bitpack_uint(values->lsc_flush_mode, 4, 7) |
            util_bitpack_uint(values->other_invalidate, 9, 9) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->latest_flush_id, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_FLUSH_CACHE2_LENGTH 8
struct mali_cs_flush_cache2_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_FLUSH_CACHE2_unpack(const uint8_t * restrict cl,
                            struct MALI_CS_FLUSH_CACHE2 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfd00) fprintf(stderr, "XXX: Invalid field of CS FLUSH_CACHE2 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf000ff) fprintf(stderr, "XXX: Invalid field of CS FLUSH_CACHE2 unpacked at word 1\n");
   values->l2_flush_mode = (enum mali_cs_flush_mode)__gen_unpack_uint(cl, 0, 3);
   values->lsc_flush_mode = (enum mali_cs_flush_mode)__gen_unpack_uint(cl, 4, 7);
   values->other_invalidate = __gen_unpack_uint(cl, 9, 9);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->latest_flush_id = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_FLUSH_CACHE2_print(FILE *fp, const struct MALI_CS_FLUSH_CACHE2 * values, unsigned indent)
{
   fprintf(fp, "%*sL2 flush mode: %s\n", indent, "", mali_cs_flush_mode_as_str(values->l2_flush_mode));
   fprintf(fp, "%*sLSC flush mode: %s\n", indent, "", mali_cs_flush_mode_as_str(values->lsc_flush_mode));
   fprintf(fp, "%*sOther invalidate: %s\n", indent, "", values->other_invalidate ? "true" : "false");
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sLatest Flush ID: %u\n", indent, "", values->latest_flush_id);
   fprintf(fp, "%*sSignal slot: %u\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_ADD32 {
   bool                                 error_propagate;
   enum mali_cs_sync_scope              scope;
   uint32_t                             wait_mask;
   uint32_t                             data;
   uint32_t                             address;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_ADD32_header               \
   .opcode = MALI_CS_OPCODE_SYNC_ADD32

static ALWAYS_INLINE void
MALI_CS_SYNC_ADD32_pack(uint32_t * restrict cl,
                        const struct MALI_CS_SYNC_ADD32 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_propagate, 0, 0) |
            util_bitpack_uint(values->scope, 1, 2) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_ADD32_LENGTH 8
struct mali_cs_sync_add32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_ADD32_unpack(const uint8_t * restrict cl,
                          struct MALI_CS_SYNC_ADD32 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff8) fprintf(stderr, "XXX: Invalid field of CS SYNC_ADD32 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS SYNC_ADD32 unpacked at word 1\n");
   values->error_propagate = __gen_unpack_uint(cl, 0, 0);
   values->scope = (enum mali_cs_sync_scope)__gen_unpack_uint(cl, 1, 2);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_ADD32_print(FILE *fp, const struct MALI_CS_SYNC_ADD32 * values, unsigned indent)
{
   fprintf(fp, "%*sError propagate: %s\n", indent, "", values->error_propagate ? "true" : "false");
   fprintf(fp, "%*sScope: %s\n", indent, "", mali_cs_sync_scope_as_str(values->scope));
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_SET32 {
   bool                                 error_propagate;
   enum mali_cs_sync_scope              scope;
   uint32_t                             wait_mask;
   uint32_t                             data;
   uint32_t                             address;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_SET32_header               \
   .opcode = MALI_CS_OPCODE_SYNC_SET32

static ALWAYS_INLINE void
MALI_CS_SYNC_SET32_pack(uint32_t * restrict cl,
                        const struct MALI_CS_SYNC_SET32 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_propagate, 0, 0) |
            util_bitpack_uint(values->scope, 1, 2) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_SET32_LENGTH 8
struct mali_cs_sync_set32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_SET32_unpack(const uint8_t * restrict cl,
                          struct MALI_CS_SYNC_SET32 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff8) fprintf(stderr, "XXX: Invalid field of CS SYNC_SET32 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS SYNC_SET32 unpacked at word 1\n");
   values->error_propagate = __gen_unpack_uint(cl, 0, 0);
   values->scope = (enum mali_cs_sync_scope)__gen_unpack_uint(cl, 1, 2);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_SET32_print(FILE *fp, const struct MALI_CS_SYNC_SET32 * values, unsigned indent)
{
   fprintf(fp, "%*sError propagate: %s\n", indent, "", values->error_propagate ? "true" : "false");
   fprintf(fp, "%*sScope: %s\n", indent, "", mali_cs_sync_scope_as_str(values->scope));
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_WAIT32 {
   bool                                 error_reject;
   enum mali_cs_condition               condition;
   uint32_t                             data;
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_WAIT32_header              \
   .opcode = MALI_CS_OPCODE_SYNC_WAIT32

static ALWAYS_INLINE void
MALI_CS_SYNC_WAIT32_pack(uint32_t * restrict cl,
                         const struct MALI_CS_SYNC_WAIT32 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_reject, 0, 0) |
            util_bitpack_uint(values->condition, 28, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_WAIT32_LENGTH 8
struct mali_cs_sync_wait32_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_WAIT32_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_SYNC_WAIT32 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffe) fprintf(stderr, "XXX: Invalid field of CS SYNC_WAIT32 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff0000) fprintf(stderr, "XXX: Invalid field of CS SYNC_WAIT32 unpacked at word 1\n");
   values->error_reject = __gen_unpack_uint(cl, 0, 0);
   values->condition = (enum mali_cs_condition)__gen_unpack_uint(cl, 28, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_WAIT32_print(FILE *fp, const struct MALI_CS_SYNC_WAIT32 * values, unsigned indent)
{
   fprintf(fp, "%*sError reject: %s\n", indent, "", values->error_reject ? "true" : "false");
   fprintf(fp, "%*sCondition: %s\n", indent, "", mali_cs_condition_as_str(values->condition));
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_STORE_STATE {
   int32_t                              offset;
   uint32_t                             wait_mask;
   enum mali_cs_state                   state;
   uint32_t                             address;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_STORE_STATE_header              \
   .opcode = MALI_CS_OPCODE_STORE_STATE

static ALWAYS_INLINE void
MALI_CS_STORE_STATE_pack(uint32_t * restrict cl,
                         const struct MALI_CS_STORE_STATE * restrict values)
{
   cl[ 0] = util_bitpack_sint(values->offset, 0, 15) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->state, 0, 1) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_STORE_STATE_LENGTH 8
struct mali_cs_store_state_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_STORE_STATE_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_STORE_STATE * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xf000fc) fprintf(stderr, "XXX: Invalid field of CS STORE_STATE unpacked at word 1\n");
   values->offset = __gen_unpack_sint(cl, 0, 15);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->state = (enum mali_cs_state)__gen_unpack_uint(cl, 32, 33);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_STORE_STATE_print(FILE *fp, const struct MALI_CS_STORE_STATE * values, unsigned indent)
{
   fprintf(fp, "%*sOffset: %d\n", indent, "", values->offset);
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sState: %s\n", indent, "", mali_cs_state_as_str(values->state));
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_PROT_REGION {
   uint32_t                             size;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_PROT_REGION_header              \
   .opcode = MALI_CS_OPCODE_PROT_REGION

static ALWAYS_INLINE void
MALI_CS_PROT_REGION_pack(uint32_t * restrict cl,
                         const struct MALI_CS_PROT_REGION * restrict values)
{
   assert((values->size & 0x7) == 0);
   cl[ 0] = util_bitpack_uint(values->size >> 3, 0, 15);
   cl[ 1] = util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_PROT_REGION_LENGTH 8
struct mali_cs_prot_region_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_PROT_REGION_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_PROT_REGION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of CS PROT_REGION unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffff) fprintf(stderr, "XXX: Invalid field of CS PROT_REGION unpacked at word 1\n");
   values->size = __gen_unpack_uint(cl, 0, 15) << 3;
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_PROT_REGION_print(FILE *fp, const struct MALI_CS_PROT_REGION * values, unsigned indent)
{
   fprintf(fp, "%*sSize: %u\n", indent, "", values->size);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_PROGRESS_STORE {
   uint32_t                             source;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_PROGRESS_STORE_header           \
   .opcode = MALI_CS_OPCODE_PROGRESS_STORE

static ALWAYS_INLINE void
MALI_CS_PROGRESS_STORE_pack(uint32_t * restrict cl,
                            const struct MALI_CS_PROGRESS_STORE * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->source, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_PROGRESS_STORE_LENGTH 8
struct mali_cs_progress_store_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_PROGRESS_STORE_unpack(const uint8_t * restrict cl,
                              struct MALI_CS_PROGRESS_STORE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_STORE unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00ff) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_STORE unpacked at word 1\n");
   values->source = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_PROGRESS_STORE_print(FILE *fp, const struct MALI_CS_PROGRESS_STORE * values, unsigned indent)
{
   fprintf(fp, "%*sSource: %u\n", indent, "", values->source);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_PROGRESS_LOAD {
   uint32_t                             destination;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_PROGRESS_LOAD_header            \
   .opcode = MALI_CS_OPCODE_PROGRESS_LOAD

static ALWAYS_INLINE void
MALI_CS_PROGRESS_LOAD_pack(uint32_t * restrict cl,
                           const struct MALI_CS_PROGRESS_LOAD * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->destination, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_PROGRESS_LOAD_LENGTH 8
struct mali_cs_progress_load_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_PROGRESS_LOAD_unpack(const uint8_t * restrict cl,
                             struct MALI_CS_PROGRESS_LOAD * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_LOAD unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00ff) fprintf(stderr, "XXX: Invalid field of CS PROGRESS_LOAD unpacked at word 1\n");
   values->destination = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_PROGRESS_LOAD_print(FILE *fp, const struct MALI_CS_PROGRESS_LOAD * values, unsigned indent)
{
   fprintf(fp, "%*sDestination: %u\n", indent, "", values->destination);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_RUN_COMPUTE_INDIRECT {
   uint32_t                             workgroups_per_task;
   bool                                 progress_increment;
   uint32_t                             srt_select;
   uint32_t                             spd_select;
   uint32_t                             tsd_select;
   uint32_t                             fau_select;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_RUN_COMPUTE_INDIRECT_header     \
   .progress_increment = false,  \
   .opcode = MALI_CS_OPCODE_RUN_COMPUTE_INDIRECT

static ALWAYS_INLINE void
MALI_CS_RUN_COMPUTE_INDIRECT_pack(uint32_t * restrict cl,
                                  const struct MALI_CS_RUN_COMPUTE_INDIRECT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->workgroups_per_task, 0, 15);
   cl[ 1] = util_bitpack_uint(values->progress_increment, 0, 0) |
            util_bitpack_uint(values->srt_select, 8, 9) |
            util_bitpack_uint(values->spd_select, 10, 11) |
            util_bitpack_uint(values->tsd_select, 12, 13) |
            util_bitpack_uint(values->fau_select, 14, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_RUN_COMPUTE_INDIRECT_LENGTH 8
struct mali_cs_run_compute_indirect_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_RUN_COMPUTE_INDIRECT_unpack(const uint8_t * restrict cl,
                                    struct MALI_CS_RUN_COMPUTE_INDIRECT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of CS RUN_COMPUTE_INDIRECT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00fe) fprintf(stderr, "XXX: Invalid field of CS RUN_COMPUTE_INDIRECT unpacked at word 1\n");
   values->workgroups_per_task = __gen_unpack_uint(cl, 0, 15);
   values->progress_increment = __gen_unpack_uint(cl, 32, 32);
   values->srt_select = __gen_unpack_uint(cl, 40, 41);
   values->spd_select = __gen_unpack_uint(cl, 42, 43);
   values->tsd_select = __gen_unpack_uint(cl, 44, 45);
   values->fau_select = __gen_unpack_uint(cl, 46, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_RUN_COMPUTE_INDIRECT_print(FILE *fp, const struct MALI_CS_RUN_COMPUTE_INDIRECT * values, unsigned indent)
{
   fprintf(fp, "%*sWorkgroups per task: %u\n", indent, "", values->workgroups_per_task);
   fprintf(fp, "%*sProgress increment: %s\n", indent, "", values->progress_increment ? "true" : "false");
   fprintf(fp, "%*sSRT select: %u\n", indent, "", values->srt_select);
   fprintf(fp, "%*sSPD select: %u\n", indent, "", values->spd_select);
   fprintf(fp, "%*sTSD select: %u\n", indent, "", values->tsd_select);
   fprintf(fp, "%*sFAU select: %u\n", indent, "", values->fau_select);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_ERROR_BARRIER {
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_ERROR_BARRIER_header            \
   .opcode = MALI_CS_OPCODE_ERROR_BARRIER

static ALWAYS_INLINE void
MALI_CS_ERROR_BARRIER_pack(uint32_t * restrict cl,
                           const struct MALI_CS_ERROR_BARRIER * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_ERROR_BARRIER_LENGTH 8
struct mali_cs_error_barrier_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_ERROR_BARRIER_unpack(const uint8_t * restrict cl,
                             struct MALI_CS_ERROR_BARRIER * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS ERROR_BARRIER unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffff) fprintf(stderr, "XXX: Invalid field of CS ERROR_BARRIER unpacked at word 1\n");
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_ERROR_BARRIER_print(FILE *fp, const struct MALI_CS_ERROR_BARRIER * values, unsigned indent)
{
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_HEAP_SET {
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_HEAP_SET_header                 \
   .opcode = MALI_CS_OPCODE_HEAP_SET

static ALWAYS_INLINE void
MALI_CS_HEAP_SET_pack(uint32_t * restrict cl,
                      const struct MALI_CS_HEAP_SET * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_HEAP_SET_LENGTH 8
struct mali_cs_heap_set_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_HEAP_SET_unpack(const uint8_t * restrict cl,
                        struct MALI_CS_HEAP_SET * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of CS HEAP_SET unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff00ff) fprintf(stderr, "XXX: Invalid field of CS HEAP_SET unpacked at word 1\n");
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_HEAP_SET_print(FILE *fp, const struct MALI_CS_HEAP_SET * values, unsigned indent)
{
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_HEAP_OPERATION {
   uint32_t                             wait_mask;
   enum mali_cs_heap_operation          operation;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_HEAP_OPERATION_header           \
   .opcode = MALI_CS_OPCODE_HEAP_OPERATION

static ALWAYS_INLINE void
MALI_CS_HEAP_OPERATION_pack(uint32_t * restrict cl,
                            const struct MALI_CS_HEAP_OPERATION * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->operation, 0, 1) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_HEAP_OPERATION_LENGTH 8
struct mali_cs_heap_operation_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_HEAP_OPERATION_unpack(const uint8_t * restrict cl,
                              struct MALI_CS_HEAP_OPERATION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff) fprintf(stderr, "XXX: Invalid field of CS HEAP_OPERATION unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf0fffc) fprintf(stderr, "XXX: Invalid field of CS HEAP_OPERATION unpacked at word 1\n");
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->operation = (enum mali_cs_heap_operation)__gen_unpack_uint(cl, 32, 33);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_HEAP_OPERATION_print(FILE *fp, const struct MALI_CS_HEAP_OPERATION * values, unsigned indent)
{
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sOperation: %s\n", indent, "", mali_cs_heap_operation_as_str(values->operation));
   fprintf(fp, "%*sSignal slot: %u\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_TRACE_POINT {
   uint32_t                             wait_mask;
   uint32_t                             base_register;
   uint32_t                             register_count;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_TRACE_POINT_header              \
   .opcode = MALI_CS_OPCODE_TRACE_POINT

static ALWAYS_INLINE void
MALI_CS_TRACE_POINT_pack(uint32_t * restrict cl,
                         const struct MALI_CS_TRACE_POINT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->base_register, 0, 7) |
            util_bitpack_uint(values->register_count, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_TRACE_POINT_LENGTH 8
struct mali_cs_trace_point_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_TRACE_POINT_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_TRACE_POINT * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff) fprintf(stderr, "XXX: Invalid field of CS TRACE_POINT unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS TRACE_POINT unpacked at word 1\n");
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->base_register = __gen_unpack_uint(cl, 32, 39);
   values->register_count = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_TRACE_POINT_print(FILE *fp, const struct MALI_CS_TRACE_POINT * values, unsigned indent)
{
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sBase Register: %u\n", indent, "", values->base_register);
   fprintf(fp, "%*sRegister Count: %u\n", indent, "", values->register_count);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_ADD64 {
   bool                                 error_propagate;
   enum mali_cs_sync_scope              scope;
   uint32_t                             wait_mask;
   uint32_t                             data;
   uint32_t                             address;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_ADD64_header               \
   .opcode = MALI_CS_OPCODE_SYNC_ADD64

static ALWAYS_INLINE void
MALI_CS_SYNC_ADD64_pack(uint32_t * restrict cl,
                        const struct MALI_CS_SYNC_ADD64 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_propagate, 0, 0) |
            util_bitpack_uint(values->scope, 1, 2) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_ADD64_LENGTH 8
struct mali_cs_sync_add64_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_ADD64_unpack(const uint8_t * restrict cl,
                          struct MALI_CS_SYNC_ADD64 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff8) fprintf(stderr, "XXX: Invalid field of CS SYNC_ADD64 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS SYNC_ADD64 unpacked at word 1\n");
   values->error_propagate = __gen_unpack_uint(cl, 0, 0);
   values->scope = (enum mali_cs_sync_scope)__gen_unpack_uint(cl, 1, 2);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_ADD64_print(FILE *fp, const struct MALI_CS_SYNC_ADD64 * values, unsigned indent)
{
   fprintf(fp, "%*sError propagate: %s\n", indent, "", values->error_propagate ? "true" : "false");
   fprintf(fp, "%*sScope: %s\n", indent, "", mali_cs_sync_scope_as_str(values->scope));
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_SET64 {
   bool                                 error_propagate;
   enum mali_cs_sync_scope              scope;
   uint32_t                             wait_mask;
   uint32_t                             data;
   uint32_t                             address;
   uint32_t                             signal_slot;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_SET64_header               \
   .opcode = MALI_CS_OPCODE_SYNC_SET64

static ALWAYS_INLINE void
MALI_CS_SYNC_SET64_pack(uint32_t * restrict cl,
                        const struct MALI_CS_SYNC_SET64 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_propagate, 0, 0) |
            util_bitpack_uint(values->scope, 1, 2) |
            util_bitpack_uint(values->wait_mask, 16, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->signal_slot, 16, 19) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_SET64_LENGTH 8
struct mali_cs_sync_set64_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_SET64_unpack(const uint8_t * restrict cl,
                          struct MALI_CS_SYNC_SET64 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff8) fprintf(stderr, "XXX: Invalid field of CS SYNC_SET64 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf00000) fprintf(stderr, "XXX: Invalid field of CS SYNC_SET64 unpacked at word 1\n");
   values->error_propagate = __gen_unpack_uint(cl, 0, 0);
   values->scope = (enum mali_cs_sync_scope)__gen_unpack_uint(cl, 1, 2);
   values->wait_mask = __gen_unpack_uint(cl, 16, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->signal_slot = __gen_unpack_uint(cl, 48, 51);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_SET64_print(FILE *fp, const struct MALI_CS_SYNC_SET64 * values, unsigned indent)
{
   fprintf(fp, "%*sError propagate: %s\n", indent, "", values->error_propagate ? "true" : "false");
   fprintf(fp, "%*sScope: %s\n", indent, "", mali_cs_sync_scope_as_str(values->scope));
   fprintf(fp, "%*sWait mask: 0x%x\n", indent, "", values->wait_mask);
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sSignal slot: 0x%x\n", indent, "", values->signal_slot);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_CS_SYNC_WAIT64 {
   bool                                 error_reject;
   enum mali_cs_condition               condition;
   uint32_t                             data;
   uint32_t                             address;
   enum mali_cs_opcode                  opcode;
};

#define MALI_CS_SYNC_WAIT64_header              \
   .opcode = MALI_CS_OPCODE_SYNC_WAIT64

static ALWAYS_INLINE void
MALI_CS_SYNC_WAIT64_pack(uint32_t * restrict cl,
                         const struct MALI_CS_SYNC_WAIT64 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->error_reject, 0, 0) |
            util_bitpack_uint(values->condition, 28, 31);
   cl[ 1] = util_bitpack_uint(values->data, 0, 7) |
            util_bitpack_uint(values->address, 8, 15) |
            util_bitpack_uint(values->opcode, 24, 31);
}


#define MALI_CS_SYNC_WAIT64_LENGTH 8
struct mali_cs_sync_wait64_packed { uint32_t opaque[2]; };
static inline void
MALI_CS_SYNC_WAIT64_unpack(const uint8_t * restrict cl,
                           struct MALI_CS_SYNC_WAIT64 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffe) fprintf(stderr, "XXX: Invalid field of CS SYNC_WAIT64 unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff0000) fprintf(stderr, "XXX: Invalid field of CS SYNC_WAIT64 unpacked at word 1\n");
   values->error_reject = __gen_unpack_uint(cl, 0, 0);
   values->condition = (enum mali_cs_condition)__gen_unpack_uint(cl, 28, 31);
   values->data = __gen_unpack_uint(cl, 32, 39);
   values->address = __gen_unpack_uint(cl, 40, 47);
   values->opcode = (enum mali_cs_opcode)__gen_unpack_uint(cl, 56, 63);
}

static inline void
MALI_CS_SYNC_WAIT64_print(FILE *fp, const struct MALI_CS_SYNC_WAIT64 * values, unsigned indent)
{
   fprintf(fp, "%*sError reject: %s\n", indent, "", values->error_reject ? "true" : "false");
   fprintf(fp, "%*sCondition: %s\n", indent, "", mali_cs_condition_as_str(values->condition));
   fprintf(fp, "%*sData: %u\n", indent, "", values->data);
   fprintf(fp, "%*sAddress: %u\n", indent, "", values->address);
   fprintf(fp, "%*sOpcode: %s\n", indent, "", mali_cs_opcode_as_str(values->opcode));
}

struct MALI_ATTRIBUTE {
   enum mali_descriptor_type            type;
   enum mali_attribute_type             attribute_type;
   bool                                 offset_enable;
   uint32_t                             format;
   uint32_t                             table;
   enum mali_attribute_frequency        frequency;
   uint32_t                             divisor_r;
   uint32_t                             divisor_e;
   int32_t                              offset;
   uint32_t                             buffer_index;
   uint32_t                             stride;
   uint32_t                             packet_stride;
   uint32_t                             attribute_stride;
   uint32_t                             divisor_d;
};

#define MALI_ATTRIBUTE_header                   \
   .type = MALI_DESCRIPTOR_TYPE_ATTRIBUTE

static ALWAYS_INLINE void
MALI_ATTRIBUTE_pack(uint32_t * restrict cl,
                    const struct MALI_ATTRIBUTE * restrict values)
{
   assert((values->packet_stride & 0x3f) == 0);
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->attribute_type, 4, 7) |
            util_bitpack_uint(values->offset_enable, 8, 8) |
            util_bitpack_uint(values->format, 10, 31);
   cl[ 1] = util_bitpack_uint(values->table, 0, 5) |
            util_bitpack_uint(values->frequency, 6, 7) |
            util_bitpack_uint(values->divisor_r, 24, 28) |
            util_bitpack_uint(values->divisor_e, 29, 29);
   cl[ 2] = util_bitpack_sint(values->offset, 0, 31);
   cl[ 3] = util_bitpack_uint(values->buffer_index, 0, 31);
   cl[ 4] = util_bitpack_uint(values->stride, 0, 31) |
            util_bitpack_uint(values->packet_stride >> 6, 0, 15) |
            util_bitpack_uint(values->attribute_stride, 16, 31);
   cl[ 5] = util_bitpack_uint(values->divisor_d, 0, 31);
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_ATTRIBUTE_LENGTH 32
#define MALI_ATTRIBUTE_ALIGN 32
struct mali_attribute_packed { uint32_t opaque[8]; };
static inline void
MALI_ATTRIBUTE_unpack(const uint8_t * restrict cl,
                      struct MALI_ATTRIBUTE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x200) fprintf(stderr, "XXX: Invalid field of Attribute unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xc0ffff00) fprintf(stderr, "XXX: Invalid field of Attribute unpacked at word 1\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Attribute unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Attribute unpacked at word 7\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->attribute_type = (enum mali_attribute_type)__gen_unpack_uint(cl, 4, 7);
   values->offset_enable = __gen_unpack_uint(cl, 8, 8);
   values->format = __gen_unpack_uint(cl, 10, 31);
   values->table = __gen_unpack_uint(cl, 32, 37);
   values->frequency = (enum mali_attribute_frequency)__gen_unpack_uint(cl, 38, 39);
   values->divisor_r = __gen_unpack_uint(cl, 56, 60);
   values->divisor_e = __gen_unpack_uint(cl, 61, 61);
   values->offset = __gen_unpack_sint(cl, 64, 95);
   values->buffer_index = __gen_unpack_uint(cl, 96, 127);
   values->stride = __gen_unpack_uint(cl, 128, 159);
   values->packet_stride = __gen_unpack_uint(cl, 128, 143) << 6;
   values->attribute_stride = __gen_unpack_uint(cl, 144, 159);
   values->divisor_d = __gen_unpack_uint(cl, 160, 191);
}

static inline void
MALI_ATTRIBUTE_print(FILE *fp, const struct MALI_ATTRIBUTE * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sAttribute type: %s\n", indent, "", mali_attribute_type_as_str(values->attribute_type));
   fprintf(fp, "%*sOffset enable: %s\n", indent, "", values->offset_enable ? "true" : "false");
   mali_pixel_format_print(fp, values->format);
   fprintf(fp, "%*sTable: %u\n", indent, "", values->table);
   fprintf(fp, "%*sFrequency: %s\n", indent, "", mali_attribute_frequency_as_str(values->frequency));
   fprintf(fp, "%*sDivisor R: %u\n", indent, "", values->divisor_r);
   fprintf(fp, "%*sDivisor E: %u\n", indent, "", values->divisor_e);
   fprintf(fp, "%*sOffset: %d\n", indent, "", values->offset);
   fprintf(fp, "%*sBuffer index: %u\n", indent, "", values->buffer_index);
   fprintf(fp, "%*sStride: %u\n", indent, "", values->stride);
   fprintf(fp, "%*sPacket stride: %u\n", indent, "", values->packet_stride);
   fprintf(fp, "%*sAttribute stride: %u\n", indent, "", values->attribute_stride);
   fprintf(fp, "%*sDivisor D: %u\n", indent, "", values->divisor_d);
}

struct MALI_BUFFER {
   enum mali_descriptor_type            type;
   enum mali_buffer_type                buffer_type;
   uint32_t                             size;
   uint64_t                             address;
   uint32_t                             stride;
   uint32_t                             packet_stride;
   uint32_t                             attribute_stride;
};

#define MALI_BUFFER_header                      \
   .type = MALI_DESCRIPTOR_TYPE_BUFFER,  \
   .buffer_type = MALI_BUFFER_TYPE_SIMPLE

static ALWAYS_INLINE void
MALI_BUFFER_pack(uint32_t * restrict cl,
                 const struct MALI_BUFFER * restrict values)
{
   assert((values->packet_stride & 0x3f) == 0);
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->buffer_type, 4, 7);
   cl[ 1] = util_bitpack_uint(values->size, 0, 31);
   cl[ 2] = util_bitpack_uint(values->address, 0, 63);
   cl[ 3] = util_bitpack_uint(values->address, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->stride, 0, 31) |
            util_bitpack_uint(values->packet_stride >> 6, 0, 15) |
            util_bitpack_uint(values->attribute_stride, 16, 31);
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_BUFFER_LENGTH 32
#define MALI_BUFFER_ALIGN 32
struct mali_buffer_packed { uint32_t opaque[8]; };
static inline void
MALI_BUFFER_unpack(const uint8_t * restrict cl,
                   struct MALI_BUFFER * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of Buffer unpacked at word 0\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Buffer unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Buffer unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Buffer unpacked at word 7\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->buffer_type = (enum mali_buffer_type)__gen_unpack_uint(cl, 4, 7);
   values->size = __gen_unpack_uint(cl, 32, 63);
   values->address = __gen_unpack_uint(cl, 64, 127);
   values->stride = __gen_unpack_uint(cl, 128, 159);
   values->packet_stride = __gen_unpack_uint(cl, 128, 143) << 6;
   values->attribute_stride = __gen_unpack_uint(cl, 144, 159);
}

static inline void
MALI_BUFFER_print(FILE *fp, const struct MALI_BUFFER * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sBuffer type: %s\n", indent, "", mali_buffer_type_as_str(values->buffer_type));
   fprintf(fp, "%*sSize: %u\n", indent, "", values->size);
   fprintf(fp, "%*sAddress: 0x%" PRIx64 "\n", indent, "", values->address);
   fprintf(fp, "%*sStride: %u\n", indent, "", values->stride);
   fprintf(fp, "%*sPacket stride: %u\n", indent, "", values->packet_stride);
   fprintf(fp, "%*sAttribute stride: %u\n", indent, "", values->attribute_stride);
}

enum mali_blend_operand_a {
        MALI_BLEND_OPERAND_A_ZERO            =      1,
        MALI_BLEND_OPERAND_A_SRC             =      2,
        MALI_BLEND_OPERAND_A_DEST            =      3,
};

static inline const char *
mali_blend_operand_a_as_str(enum mali_blend_operand_a imm)
{
    switch (imm) {
    case MALI_BLEND_OPERAND_A_ZERO: return "Zero";
    case MALI_BLEND_OPERAND_A_SRC: return "Src";
    case MALI_BLEND_OPERAND_A_DEST: return "Dest";
    default: return "XXX: INVALID";
    }
}

enum mali_blend_operand_b {
        MALI_BLEND_OPERAND_B_SRC_MINUS_DEST  =      0,
        MALI_BLEND_OPERAND_B_SRC_PLUS_DEST   =      1,
        MALI_BLEND_OPERAND_B_SRC             =      2,
        MALI_BLEND_OPERAND_B_DEST            =      3,
};

static inline const char *
mali_blend_operand_b_as_str(enum mali_blend_operand_b imm)
{
    switch (imm) {
    case MALI_BLEND_OPERAND_B_SRC_MINUS_DEST: return "Src Minus Dest";
    case MALI_BLEND_OPERAND_B_SRC_PLUS_DEST: return "Src Plus Dest";
    case MALI_BLEND_OPERAND_B_SRC: return "Src";
    case MALI_BLEND_OPERAND_B_DEST: return "Dest";
    default: return "XXX: INVALID";
    }
}

enum mali_blend_operand_c {
        MALI_BLEND_OPERAND_C_ZERO            =      1,
        MALI_BLEND_OPERAND_C_SRC             =      2,
        MALI_BLEND_OPERAND_C_DEST            =      3,
        MALI_BLEND_OPERAND_C_SRC_X_2         =      4,
        MALI_BLEND_OPERAND_C_SRC_ALPHA       =      5,
        MALI_BLEND_OPERAND_C_DEST_ALPHA      =      6,
        MALI_BLEND_OPERAND_C_CONSTANT        =      7,
};

static inline const char *
mali_blend_operand_c_as_str(enum mali_blend_operand_c imm)
{
    switch (imm) {
    case MALI_BLEND_OPERAND_C_ZERO: return "Zero";
    case MALI_BLEND_OPERAND_C_SRC: return "Src";
    case MALI_BLEND_OPERAND_C_DEST: return "Dest";
    case MALI_BLEND_OPERAND_C_SRC_X_2: return "Src x 2";
    case MALI_BLEND_OPERAND_C_SRC_ALPHA: return "Src Alpha";
    case MALI_BLEND_OPERAND_C_DEST_ALPHA: return "Dest Alpha";
    case MALI_BLEND_OPERAND_C_CONSTANT: return "Constant";
    default: return "XXX: INVALID";
    }
}

struct MALI_BLEND_FUNCTION {
   enum mali_blend_operand_a            a;
   bool                                 negate_a;
   enum mali_blend_operand_b            b;
   bool                                 negate_b;
   enum mali_blend_operand_c            c;
   bool                                 invert_c;
};

#define MALI_BLEND_FUNCTION_header              \
   0

static inline void
MALI_BLEND_FUNCTION_print(FILE *fp, const struct MALI_BLEND_FUNCTION * values, unsigned indent)
{
   fprintf(fp, "%*sA: %s\n", indent, "", mali_blend_operand_a_as_str(values->a));
   fprintf(fp, "%*sNegate A: %s\n", indent, "", values->negate_a ? "true" : "false");
   fprintf(fp, "%*sB: %s\n", indent, "", mali_blend_operand_b_as_str(values->b));
   fprintf(fp, "%*sNegate B: %s\n", indent, "", values->negate_b ? "true" : "false");
   fprintf(fp, "%*sC: %s\n", indent, "", mali_blend_operand_c_as_str(values->c));
   fprintf(fp, "%*sInvert C: %s\n", indent, "", values->invert_c ? "true" : "false");
}

struct MALI_BLEND_EQUATION {
   struct MALI_BLEND_FUNCTION           rgb;
   struct MALI_BLEND_FUNCTION           alpha;
   uint32_t                             color_mask;
};

#define MALI_BLEND_EQUATION_header              \
   .rgb = { MALI_BLEND_FUNCTION_header },  \
   .alpha = { MALI_BLEND_FUNCTION_header }

static ALWAYS_INLINE void
MALI_BLEND_EQUATION_pack(uint32_t * restrict cl,
                         const struct MALI_BLEND_EQUATION * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->rgb.a, 0, 1) |
            util_bitpack_uint(values->rgb.negate_a, 3, 3) |
            util_bitpack_uint(values->rgb.b, 4, 5) |
            util_bitpack_uint(values->rgb.negate_b, 7, 7) |
            util_bitpack_uint(values->rgb.c, 8, 10) |
            util_bitpack_uint(values->rgb.invert_c, 11, 11) |
            util_bitpack_uint(values->alpha.a, 12, 13) |
            util_bitpack_uint(values->alpha.negate_a, 15, 15) |
            util_bitpack_uint(values->alpha.b, 16, 17) |
            util_bitpack_uint(values->alpha.negate_b, 19, 19) |
            util_bitpack_uint(values->alpha.c, 20, 22) |
            util_bitpack_uint(values->alpha.invert_c, 23, 23) |
            util_bitpack_uint(values->color_mask, 28, 31);
}


#define MALI_BLEND_EQUATION_LENGTH 4
struct mali_blend_equation_packed { uint32_t opaque[1]; };
static inline void
MALI_BLEND_EQUATION_unpack(const uint8_t * restrict cl,
                           struct MALI_BLEND_EQUATION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xf044044) fprintf(stderr, "XXX: Invalid field of Blend Equation unpacked at word 0\n");
   values->rgb.a = (enum mali_blend_operand_a)__gen_unpack_uint(cl, 0, 1);
   values->rgb.negate_a = __gen_unpack_uint(cl, 3, 3);
   values->rgb.b = (enum mali_blend_operand_b)__gen_unpack_uint(cl, 4, 5);
   values->rgb.negate_b = __gen_unpack_uint(cl, 7, 7);
   values->rgb.c = (enum mali_blend_operand_c)__gen_unpack_uint(cl, 8, 10);
   values->rgb.invert_c = __gen_unpack_uint(cl, 11, 11);
   values->alpha.a = (enum mali_blend_operand_a)__gen_unpack_uint(cl, 12, 13);
   values->alpha.negate_a = __gen_unpack_uint(cl, 15, 15);
   values->alpha.b = (enum mali_blend_operand_b)__gen_unpack_uint(cl, 16, 17);
   values->alpha.negate_b = __gen_unpack_uint(cl, 19, 19);
   values->alpha.c = (enum mali_blend_operand_c)__gen_unpack_uint(cl, 20, 22);
   values->alpha.invert_c = __gen_unpack_uint(cl, 23, 23);
   values->color_mask = __gen_unpack_uint(cl, 28, 31);
}

static inline void
MALI_BLEND_EQUATION_print(FILE *fp, const struct MALI_BLEND_EQUATION * values, unsigned indent)
{
   fprintf(fp, "%*sRGB:\n", indent, "");
   MALI_BLEND_FUNCTION_print(fp, &values->rgb, indent + 2);
   fprintf(fp, "%*sAlpha:\n", indent, "");
   MALI_BLEND_FUNCTION_print(fp, &values->alpha, indent + 2);
   fprintf(fp, "%*sColor Mask: %u\n", indent, "", values->color_mask);
}

enum mali_register_file_format {
        MALI_REGISTER_FILE_FORMAT_F16        =      0,
        MALI_REGISTER_FILE_FORMAT_F32        =      1,
        MALI_REGISTER_FILE_FORMAT_I32        =      2,
        MALI_REGISTER_FILE_FORMAT_U32        =      3,
        MALI_REGISTER_FILE_FORMAT_I16        =      4,
        MALI_REGISTER_FILE_FORMAT_U16        =      5,
};

static inline const char *
mali_register_file_format_as_str(enum mali_register_file_format imm)
{
    switch (imm) {
    case MALI_REGISTER_FILE_FORMAT_F16: return "F16";
    case MALI_REGISTER_FILE_FORMAT_F32: return "F32";
    case MALI_REGISTER_FILE_FORMAT_I32: return "I32";
    case MALI_REGISTER_FILE_FORMAT_U32: return "U32";
    case MALI_REGISTER_FILE_FORMAT_I16: return "I16";
    case MALI_REGISTER_FILE_FORMAT_U16: return "U16";
    default: return "XXX: INVALID";
    }
}

enum mali_blend_mode {
        MALI_BLEND_MODE_SHADER               =      0,
        MALI_BLEND_MODE_OPAQUE               =      1,
        MALI_BLEND_MODE_FIXED_FUNCTION       =      2,
        MALI_BLEND_MODE_OFF                  =      3,
};

static inline const char *
mali_blend_mode_as_str(enum mali_blend_mode imm)
{
    switch (imm) {
    case MALI_BLEND_MODE_SHADER: return "Shader";
    case MALI_BLEND_MODE_OPAQUE: return "Opaque";
    case MALI_BLEND_MODE_FIXED_FUNCTION: return "Fixed-Function";
    case MALI_BLEND_MODE_OFF: return "Off";
    default: return "XXX: INVALID";
    }
}

struct MALI_BLEND_SHADER {
   uint32_t                             pc;
};

#define MALI_BLEND_SHADER_header                \
   0

static ALWAYS_INLINE void
MALI_BLEND_SHADER_pack(uint32_t * restrict cl,
                       const struct MALI_BLEND_SHADER * restrict values)
{
   assert((values->pc & 0xf) == 0);
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->pc >> 4, 4, 31);
}


#define MALI_BLEND_SHADER_LENGTH 8
struct mali_blend_shader_packed { uint32_t opaque[2]; };
static inline void
MALI_BLEND_SHADER_unpack(const uint8_t * restrict cl,
                         struct MALI_BLEND_SHADER * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Blend Shader unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf) fprintf(stderr, "XXX: Invalid field of Blend Shader unpacked at word 1\n");
   values->pc = __gen_unpack_uint(cl, 36, 63) << 4;
}

static inline void
MALI_BLEND_SHADER_print(FILE *fp, const struct MALI_BLEND_SHADER * values, unsigned indent)
{
   fprintf(fp, "%*sPC: %u\n", indent, "", values->pc);
}

struct MALI_INTERNAL_CONVERSION {
   uint32_t                             memory_format;
   bool                                 raw;
   enum mali_register_file_format       register_format;
};

#define MALI_INTERNAL_CONVERSION_header         \
   0

static ALWAYS_INLINE void
MALI_INTERNAL_CONVERSION_pack(uint32_t * restrict cl,
                              const struct MALI_INTERNAL_CONVERSION * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->memory_format, 0, 21) |
            util_bitpack_uint(values->raw, 22, 22) |
            util_bitpack_uint(values->register_format, 24, 26);
}


#define MALI_INTERNAL_CONVERSION_LENGTH 4
#define MALI_INTERNAL_CONVERSION_ALIGN 4
struct mali_internal_conversion_packed { uint32_t opaque[1]; };
static inline void
MALI_INTERNAL_CONVERSION_unpack(const uint8_t * restrict cl,
                                struct MALI_INTERNAL_CONVERSION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xf8800000) fprintf(stderr, "XXX: Invalid field of Internal Conversion unpacked at word 0\n");
   values->memory_format = __gen_unpack_uint(cl, 0, 21);
   values->raw = __gen_unpack_uint(cl, 22, 22);
   values->register_format = (enum mali_register_file_format)__gen_unpack_uint(cl, 24, 26);
}

static inline void
MALI_INTERNAL_CONVERSION_print(FILE *fp, const struct MALI_INTERNAL_CONVERSION * values, unsigned indent)
{
   mali_pixel_format_print(fp, values->memory_format);
   fprintf(fp, "%*sRaw: %s\n", indent, "", values->raw ? "true" : "false");
   fprintf(fp, "%*sRegister Format: %s\n", indent, "", mali_register_file_format_as_str(values->register_format));
}

struct MALI_BLEND_FIXED_FUNCTION {
   uint32_t                             num_comps;
   uint32_t                             rt;
#define MALI_BIFROST_BLEND_MAX_RT                8
   struct MALI_INTERNAL_CONVERSION      conversion;
};

#define MALI_BLEND_FIXED_FUNCTION_header        \
   .num_comps = 1,  \
   .conversion = { MALI_INTERNAL_CONVERSION_header }

static ALWAYS_INLINE void
MALI_BLEND_FIXED_FUNCTION_pack(uint32_t * restrict cl,
                               const struct MALI_BLEND_FIXED_FUNCTION * restrict values)
{
   assert(values->num_comps >= 1);
   cl[ 0] = util_bitpack_uint(values->num_comps - 1, 3, 4) |
            util_bitpack_uint(values->rt, 16, 19);
   cl[ 1] = util_bitpack_uint(values->conversion.memory_format, 0, 21) |
            util_bitpack_uint(values->conversion.raw, 22, 22) |
            util_bitpack_uint(values->conversion.register_format, 24, 26);
}


#define MALI_BLEND_FIXED_FUNCTION_LENGTH 8
struct mali_blend_fixed_function_packed { uint32_t opaque[2]; };
static inline void
MALI_BLEND_FIXED_FUNCTION_unpack(const uint8_t * restrict cl,
                                 struct MALI_BLEND_FIXED_FUNCTION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff0ffe7) fprintf(stderr, "XXX: Invalid field of Blend Fixed-Function unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf8800000) fprintf(stderr, "XXX: Invalid field of Blend Fixed-Function unpacked at word 1\n");
   values->num_comps = __gen_unpack_uint(cl, 3, 4) + 1;
   values->rt = __gen_unpack_uint(cl, 16, 19);
   values->conversion.memory_format = __gen_unpack_uint(cl, 32, 53);
   values->conversion.raw = __gen_unpack_uint(cl, 54, 54);
   values->conversion.register_format = (enum mali_register_file_format)__gen_unpack_uint(cl, 56, 58);
}

static inline void
MALI_BLEND_FIXED_FUNCTION_print(FILE *fp, const struct MALI_BLEND_FIXED_FUNCTION * values, unsigned indent)
{
   fprintf(fp, "%*sNum Comps: %u\n", indent, "", values->num_comps);
   fprintf(fp, "%*sRT: %u\n", indent, "", values->rt);
   fprintf(fp, "%*sConversion:\n", indent, "");
   MALI_INTERNAL_CONVERSION_print(fp, &values->conversion, indent + 2);
}

struct MALI_INTERNAL_BLEND {
   enum mali_blend_mode                 mode;
   struct MALI_BLEND_SHADER             shader;
   struct MALI_BLEND_FIXED_FUNCTION     fixed_function;
};

#define MALI_INTERNAL_BLEND_header              \
   .shader = { MALI_BLEND_SHADER_header },  \
   .fixed_function = { MALI_BLEND_FIXED_FUNCTION_header }

static ALWAYS_INLINE void
MALI_INTERNAL_BLEND_pack(uint32_t * restrict cl,
                         const struct MALI_INTERNAL_BLEND * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->mode, 0, 1) |
            util_bitpack_uint(values->fixed_function.num_comps - 1, 3, 4) |
            util_bitpack_uint(values->fixed_function.rt, 16, 19);
   cl[ 1] = util_bitpack_uint(values->shader.pc >> 4, 4, 31) |
            util_bitpack_uint(values->fixed_function.conversion.memory_format, 0, 21) |
            util_bitpack_uint(values->fixed_function.conversion.raw, 22, 22) |
            util_bitpack_uint(values->fixed_function.conversion.register_format, 24, 26);
}


#define MALI_INTERNAL_BLEND_LENGTH 8
#define MALI_INTERNAL_BLEND_ALIGN 8
struct mali_internal_blend_packed { uint32_t opaque[2]; };
static inline void
MALI_INTERNAL_BLEND_unpack(const uint8_t * restrict cl,
                           struct MALI_INTERNAL_BLEND * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff0ffe4) fprintf(stderr, "XXX: Invalid field of Internal Blend unpacked at word 0\n");
   values->mode = (enum mali_blend_mode)__gen_unpack_uint(cl, 0, 1);
   values->shader.pc = __gen_unpack_uint(cl, 36, 63) << 4;
   values->fixed_function.num_comps = __gen_unpack_uint(cl, 3, 4) + 1;
   values->fixed_function.rt = __gen_unpack_uint(cl, 16, 19);
   values->fixed_function.conversion.memory_format = __gen_unpack_uint(cl, 32, 53);
   values->fixed_function.conversion.raw = __gen_unpack_uint(cl, 54, 54);
   values->fixed_function.conversion.register_format = (enum mali_register_file_format)__gen_unpack_uint(cl, 56, 58);
}

static inline void
MALI_INTERNAL_BLEND_print(FILE *fp, const struct MALI_INTERNAL_BLEND * values, unsigned indent)
{
   fprintf(fp, "%*sMode: %s\n", indent, "", mali_blend_mode_as_str(values->mode));
   fprintf(fp, "%*sShader:\n", indent, "");
   MALI_BLEND_SHADER_print(fp, &values->shader, indent + 2);
   fprintf(fp, "%*sFixed-Function:\n", indent, "");
   MALI_BLEND_FIXED_FUNCTION_print(fp, &values->fixed_function, indent + 2);
}

struct MALI_BLEND {
   bool                                 load_destination;
   bool                                 alpha_to_one;
   bool                                 enable;
   bool                                 srgb;
   bool                                 round_to_fb_precision;
   uint32_t                             constant;
   struct MALI_BLEND_EQUATION           equation;
   struct MALI_INTERNAL_BLEND           internal;
};

#define MALI_BLEND_header                       \
   .load_destination = false,  \
   .enable = true,  \
   .srgb = false,  \
   .round_to_fb_precision = false,  \
   .equation = { MALI_BLEND_EQUATION_header },  \
   .internal = { MALI_INTERNAL_BLEND_header }

static ALWAYS_INLINE void
MALI_BLEND_pack(uint32_t * restrict cl,
                const struct MALI_BLEND * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->load_destination, 0, 0) |
            util_bitpack_uint(values->alpha_to_one, 8, 8) |
            util_bitpack_uint(values->enable, 9, 9) |
            util_bitpack_uint(values->srgb, 10, 10) |
            util_bitpack_uint(values->round_to_fb_precision, 11, 11) |
            util_bitpack_uint(values->constant, 16, 31);
   cl[ 1] = util_bitpack_uint(values->equation.rgb.a, 0, 1) |
            util_bitpack_uint(values->equation.rgb.negate_a, 3, 3) |
            util_bitpack_uint(values->equation.rgb.b, 4, 5) |
            util_bitpack_uint(values->equation.rgb.negate_b, 7, 7) |
            util_bitpack_uint(values->equation.rgb.c, 8, 10) |
            util_bitpack_uint(values->equation.rgb.invert_c, 11, 11) |
            util_bitpack_uint(values->equation.alpha.a, 12, 13) |
            util_bitpack_uint(values->equation.alpha.negate_a, 15, 15) |
            util_bitpack_uint(values->equation.alpha.b, 16, 17) |
            util_bitpack_uint(values->equation.alpha.negate_b, 19, 19) |
            util_bitpack_uint(values->equation.alpha.c, 20, 22) |
            util_bitpack_uint(values->equation.alpha.invert_c, 23, 23) |
            util_bitpack_uint(values->equation.color_mask, 28, 31);
   cl[ 2] = util_bitpack_uint(values->internal.mode, 0, 1) |
            util_bitpack_uint(values->internal.fixed_function.num_comps - 1, 3, 4) |
            util_bitpack_uint(values->internal.fixed_function.rt, 16, 19);
   cl[ 3] = util_bitpack_uint(values->internal.shader.pc >> 4, 4, 31) |
            util_bitpack_uint(values->internal.fixed_function.conversion.memory_format, 0, 21) |
            util_bitpack_uint(values->internal.fixed_function.conversion.raw, 22, 22) |
            util_bitpack_uint(values->internal.fixed_function.conversion.register_format, 24, 26);
}


#define MALI_BLEND_LENGTH 16
#define MALI_BLEND_ALIGN 16
struct mali_blend_packed { uint32_t opaque[4]; };
static inline void
MALI_BLEND_unpack(const uint8_t * restrict cl,
                  struct MALI_BLEND * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xf0fe) fprintf(stderr, "XXX: Invalid field of Blend unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf044044) fprintf(stderr, "XXX: Invalid field of Blend unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xfff0ffe4) fprintf(stderr, "XXX: Invalid field of Blend unpacked at word 2\n");
   values->load_destination = __gen_unpack_uint(cl, 0, 0);
   values->alpha_to_one = __gen_unpack_uint(cl, 8, 8);
   values->enable = __gen_unpack_uint(cl, 9, 9);
   values->srgb = __gen_unpack_uint(cl, 10, 10);
   values->round_to_fb_precision = __gen_unpack_uint(cl, 11, 11);
   values->constant = __gen_unpack_uint(cl, 16, 31);
   values->equation.rgb.a = (enum mali_blend_operand_a)__gen_unpack_uint(cl, 32, 33);
   values->equation.rgb.negate_a = __gen_unpack_uint(cl, 35, 35);
   values->equation.rgb.b = (enum mali_blend_operand_b)__gen_unpack_uint(cl, 36, 37);
   values->equation.rgb.negate_b = __gen_unpack_uint(cl, 39, 39);
   values->equation.rgb.c = (enum mali_blend_operand_c)__gen_unpack_uint(cl, 40, 42);
   values->equation.rgb.invert_c = __gen_unpack_uint(cl, 43, 43);
   values->equation.alpha.a = (enum mali_blend_operand_a)__gen_unpack_uint(cl, 44, 45);
   values->equation.alpha.negate_a = __gen_unpack_uint(cl, 47, 47);
   values->equation.alpha.b = (enum mali_blend_operand_b)__gen_unpack_uint(cl, 48, 49);
   values->equation.alpha.negate_b = __gen_unpack_uint(cl, 51, 51);
   values->equation.alpha.c = (enum mali_blend_operand_c)__gen_unpack_uint(cl, 52, 54);
   values->equation.alpha.invert_c = __gen_unpack_uint(cl, 55, 55);
   values->equation.color_mask = __gen_unpack_uint(cl, 60, 63);
   values->internal.mode = (enum mali_blend_mode)__gen_unpack_uint(cl, 64, 65);
   values->internal.shader.pc = __gen_unpack_uint(cl, 100, 127) << 4;
   values->internal.fixed_function.num_comps = __gen_unpack_uint(cl, 67, 68) + 1;
   values->internal.fixed_function.rt = __gen_unpack_uint(cl, 80, 83);
   values->internal.fixed_function.conversion.memory_format = __gen_unpack_uint(cl, 96, 117);
   values->internal.fixed_function.conversion.raw = __gen_unpack_uint(cl, 118, 118);
   values->internal.fixed_function.conversion.register_format = (enum mali_register_file_format)__gen_unpack_uint(cl, 120, 122);
}

static inline void
MALI_BLEND_print(FILE *fp, const struct MALI_BLEND * values, unsigned indent)
{
   fprintf(fp, "%*sLoad Destination: %s\n", indent, "", values->load_destination ? "true" : "false");
   fprintf(fp, "%*sAlpha To One: %s\n", indent, "", values->alpha_to_one ? "true" : "false");
   fprintf(fp, "%*sEnable: %s\n", indent, "", values->enable ? "true" : "false");
   fprintf(fp, "%*ssRGB: %s\n", indent, "", values->srgb ? "true" : "false");
   fprintf(fp, "%*sRound to FB precision: %s\n", indent, "", values->round_to_fb_precision ? "true" : "false");
   fprintf(fp, "%*sConstant: %u\n", indent, "", values->constant);
   fprintf(fp, "%*sEquation:\n", indent, "");
   MALI_BLEND_EQUATION_print(fp, &values->equation, indent + 2);
   fprintf(fp, "%*sInternal:\n", indent, "");
   MALI_INTERNAL_BLEND_print(fp, &values->internal, indent + 2);
}

enum mali_point_size_array_format {
        MALI_POINT_SIZE_ARRAY_FORMAT_NONE    =      0,
        MALI_POINT_SIZE_ARRAY_FORMAT_FP16    =      2,
        MALI_POINT_SIZE_ARRAY_FORMAT_FP32    =      3,
};

static inline const char *
mali_point_size_array_format_as_str(enum mali_point_size_array_format imm)
{
    switch (imm) {
    case MALI_POINT_SIZE_ARRAY_FORMAT_NONE: return "None";
    case MALI_POINT_SIZE_ARRAY_FORMAT_FP16: return "FP16";
    case MALI_POINT_SIZE_ARRAY_FORMAT_FP32: return "FP32";
    default: return "XXX: INVALID";
    }
}

enum mali_fifo_format {
        MALI_FIFO_FORMAT_AUTO                =      0,
        MALI_FIFO_FORMAT_BASIC               =      1,
        MALI_FIFO_FORMAT_EXTENDED            =      2,
};

static inline const char *
mali_fifo_format_as_str(enum mali_fifo_format imm)
{
    switch (imm) {
    case MALI_FIFO_FORMAT_AUTO: return "Auto";
    case MALI_FIFO_FORMAT_BASIC: return "Basic";
    case MALI_FIFO_FORMAT_EXTENDED: return "Extended";
    default: return "XXX: INVALID";
    }
}

struct MALI_PRIMITIVE_FLAGS {
   enum mali_draw_mode                  draw_mode;
   enum mali_index_type                 index_type;
   enum mali_point_size_array_format    point_size_array_format;
   bool                                 primitive_index_enable;
   bool                                 primitive_index_writeback;
   bool                                 allow_rotating_primitives;
   bool                                 low_depth_cull;
   bool                                 high_depth_cull;
   bool                                 secondary_shader;
   bool                                 primitive_restart;
   bool                                 layer_index_enable;
   bool                                 scissor_array_enable;
   enum mali_fifo_format                position_fifo_format;
   uint32_t                             view_mask;
};

#define MALI_PRIMITIVE_FLAGS_header             \
   .draw_mode = MALI_DRAW_MODE_NONE,  \
   .index_type = MALI_INDEX_TYPE_NONE,  \
   .low_depth_cull = true,  \
   .high_depth_cull = true

static ALWAYS_INLINE void
MALI_PRIMITIVE_FLAGS_pack(uint32_t * restrict cl,
                          const struct MALI_PRIMITIVE_FLAGS * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->draw_mode, 0, 7) |
            util_bitpack_uint(values->index_type, 8, 10) |
            util_bitpack_uint(values->point_size_array_format, 11, 12) |
            util_bitpack_uint(values->primitive_index_enable, 13, 13) |
            util_bitpack_uint(values->primitive_index_writeback, 14, 14) |
            util_bitpack_uint(values->allow_rotating_primitives, 15, 15) |
            util_bitpack_uint(values->low_depth_cull, 16, 16) |
            util_bitpack_uint(values->high_depth_cull, 17, 17) |
            util_bitpack_uint(values->secondary_shader, 18, 18) |
            util_bitpack_uint(values->primitive_restart, 19, 19) |
            util_bitpack_uint(values->layer_index_enable, 20, 20) |
            util_bitpack_uint(values->scissor_array_enable, 21, 21) |
            util_bitpack_uint(values->position_fifo_format, 22, 23) |
            util_bitpack_uint(values->view_mask, 24, 31);
}


#define MALI_PRIMITIVE_FLAGS_LENGTH 4
struct mali_primitive_flags_packed { uint32_t opaque[1]; };
static inline void
MALI_PRIMITIVE_FLAGS_unpack(const uint8_t * restrict cl,
                            struct MALI_PRIMITIVE_FLAGS * restrict values)
{
   values->draw_mode = (enum mali_draw_mode)__gen_unpack_uint(cl, 0, 7);
   values->index_type = (enum mali_index_type)__gen_unpack_uint(cl, 8, 10);
   values->point_size_array_format = (enum mali_point_size_array_format)__gen_unpack_uint(cl, 11, 12);
   values->primitive_index_enable = __gen_unpack_uint(cl, 13, 13);
   values->primitive_index_writeback = __gen_unpack_uint(cl, 14, 14);
   values->allow_rotating_primitives = __gen_unpack_uint(cl, 15, 15);
   values->low_depth_cull = __gen_unpack_uint(cl, 16, 16);
   values->high_depth_cull = __gen_unpack_uint(cl, 17, 17);
   values->secondary_shader = __gen_unpack_uint(cl, 18, 18);
   values->primitive_restart = __gen_unpack_uint(cl, 19, 19);
   values->layer_index_enable = __gen_unpack_uint(cl, 20, 20);
   values->scissor_array_enable = __gen_unpack_uint(cl, 21, 21);
   values->position_fifo_format = (enum mali_fifo_format)__gen_unpack_uint(cl, 22, 23);
   values->view_mask = __gen_unpack_uint(cl, 24, 31);
}

static inline void
MALI_PRIMITIVE_FLAGS_print(FILE *fp, const struct MALI_PRIMITIVE_FLAGS * values, unsigned indent)
{
   fprintf(fp, "%*sDraw mode: %s\n", indent, "", mali_draw_mode_as_str(values->draw_mode));
   fprintf(fp, "%*sIndex type: %s\n", indent, "", mali_index_type_as_str(values->index_type));
   fprintf(fp, "%*sPoint size array format: %s\n", indent, "", mali_point_size_array_format_as_str(values->point_size_array_format));
   fprintf(fp, "%*sPrimitive Index Enable: %s\n", indent, "", values->primitive_index_enable ? "true" : "false");
   fprintf(fp, "%*sPrimitive Index Writeback: %s\n", indent, "", values->primitive_index_writeback ? "true" : "false");
   fprintf(fp, "%*sAllow rotating primitives: %s\n", indent, "", values->allow_rotating_primitives ? "true" : "false");
   fprintf(fp, "%*sLow Depth Cull: %s\n", indent, "", values->low_depth_cull ? "true" : "false");
   fprintf(fp, "%*sHigh Depth Cull: %s\n", indent, "", values->high_depth_cull ? "true" : "false");
   fprintf(fp, "%*sSecondary Shader: %s\n", indent, "", values->secondary_shader ? "true" : "false");
   fprintf(fp, "%*sPrimitive restart: %s\n", indent, "", values->primitive_restart ? "true" : "false");
   fprintf(fp, "%*sLayer index enable: %s\n", indent, "", values->layer_index_enable ? "true" : "false");
   fprintf(fp, "%*sScissor array enable: %s\n", indent, "", values->scissor_array_enable ? "true" : "false");
   fprintf(fp, "%*sPosition FIFO format: %s\n", indent, "", mali_fifo_format_as_str(values->position_fifo_format));
   fprintf(fp, "%*sView mask: 0x%x\n", indent, "", values->view_mask);
}

struct MALI_PRIMITIVE {
   enum mali_draw_mode                  draw_mode;
   enum mali_index_type                 index_type;
   enum mali_point_size_array_format    point_size_array_format;
   bool                                 primitive_index_enable;
   bool                                 primitive_index_writeback;
   bool                                 allow_rotating_primitives;
   bool                                 low_depth_cull;
   bool                                 high_depth_cull;
   bool                                 secondary_shader;
   bool                                 primitive_restart;
   bool                                 layer_index_enable;
   bool                                 scissor_array_enable;
   int32_t                              base_vertex_offset;
   uint32_t                             instance_offset;
   uint32_t                             index_count;
};

#define MALI_PRIMITIVE_header                   \
   .draw_mode = MALI_DRAW_MODE_NONE,  \
   .index_type = MALI_INDEX_TYPE_NONE,  \
   .low_depth_cull = true,  \
   .high_depth_cull = true

static ALWAYS_INLINE void
MALI_PRIMITIVE_pack(uint32_t * restrict cl,
                    const struct MALI_PRIMITIVE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->draw_mode, 0, 7) |
            util_bitpack_uint(values->index_type, 8, 10) |
            util_bitpack_uint(values->point_size_array_format, 11, 12) |
            util_bitpack_uint(values->primitive_index_enable, 13, 13) |
            util_bitpack_uint(values->primitive_index_writeback, 14, 14) |
            util_bitpack_uint(values->allow_rotating_primitives, 15, 15) |
            util_bitpack_uint(values->low_depth_cull, 16, 16) |
            util_bitpack_uint(values->high_depth_cull, 17, 17) |
            util_bitpack_uint(values->secondary_shader, 18, 18) |
            util_bitpack_uint(values->primitive_restart, 19, 19) |
            util_bitpack_uint(values->layer_index_enable, 20, 20) |
            util_bitpack_uint(values->scissor_array_enable, 21, 21);
   cl[ 1] = util_bitpack_sint(values->base_vertex_offset, 0, 31);
   cl[ 2] = util_bitpack_uint(values->instance_offset, 0, 31);
   cl[ 3] = util_bitpack_uint(values->index_count, 0, 31);
}


#define MALI_PRIMITIVE_LENGTH 16
struct mali_primitive_packed { uint32_t opaque[4]; };
static inline void
MALI_PRIMITIVE_unpack(const uint8_t * restrict cl,
                      struct MALI_PRIMITIVE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffc00000) fprintf(stderr, "XXX: Invalid field of Primitive unpacked at word 0\n");
   values->draw_mode = (enum mali_draw_mode)__gen_unpack_uint(cl, 0, 7);
   values->index_type = (enum mali_index_type)__gen_unpack_uint(cl, 8, 10);
   values->point_size_array_format = (enum mali_point_size_array_format)__gen_unpack_uint(cl, 11, 12);
   values->primitive_index_enable = __gen_unpack_uint(cl, 13, 13);
   values->primitive_index_writeback = __gen_unpack_uint(cl, 14, 14);
   values->allow_rotating_primitives = __gen_unpack_uint(cl, 15, 15);
   values->low_depth_cull = __gen_unpack_uint(cl, 16, 16);
   values->high_depth_cull = __gen_unpack_uint(cl, 17, 17);
   values->secondary_shader = __gen_unpack_uint(cl, 18, 18);
   values->primitive_restart = __gen_unpack_uint(cl, 19, 19);
   values->layer_index_enable = __gen_unpack_uint(cl, 20, 20);
   values->scissor_array_enable = __gen_unpack_uint(cl, 21, 21);
   values->base_vertex_offset = __gen_unpack_sint(cl, 32, 63);
   values->instance_offset = __gen_unpack_uint(cl, 64, 95);
   values->index_count = __gen_unpack_uint(cl, 96, 127);
}

static inline void
MALI_PRIMITIVE_print(FILE *fp, const struct MALI_PRIMITIVE * values, unsigned indent)
{
   fprintf(fp, "%*sDraw mode: %s\n", indent, "", mali_draw_mode_as_str(values->draw_mode));
   fprintf(fp, "%*sIndex type: %s\n", indent, "", mali_index_type_as_str(values->index_type));
   fprintf(fp, "%*sPoint size array format: %s\n", indent, "", mali_point_size_array_format_as_str(values->point_size_array_format));
   fprintf(fp, "%*sPrimitive Index Enable: %s\n", indent, "", values->primitive_index_enable ? "true" : "false");
   fprintf(fp, "%*sPrimitive Index Writeback: %s\n", indent, "", values->primitive_index_writeback ? "true" : "false");
   fprintf(fp, "%*sAllow rotating primitives: %s\n", indent, "", values->allow_rotating_primitives ? "true" : "false");
   fprintf(fp, "%*sLow Depth Cull: %s\n", indent, "", values->low_depth_cull ? "true" : "false");
   fprintf(fp, "%*sHigh Depth Cull: %s\n", indent, "", values->high_depth_cull ? "true" : "false");
   fprintf(fp, "%*sSecondary Shader: %s\n", indent, "", values->secondary_shader ? "true" : "false");
   fprintf(fp, "%*sPrimitive restart: %s\n", indent, "", values->primitive_restart ? "true" : "false");
   fprintf(fp, "%*sLayer index enable: %s\n", indent, "", values->layer_index_enable ? "true" : "false");
   fprintf(fp, "%*sScissor array enable: %s\n", indent, "", values->scissor_array_enable ? "true" : "false");
   fprintf(fp, "%*sBase vertex offset: %d\n", indent, "", values->base_vertex_offset);
   fprintf(fp, "%*sInstance offset: %u\n", indent, "", values->instance_offset);
   fprintf(fp, "%*sIndex count: %u\n", indent, "", values->index_count);
}

enum mali_reduction_mode {
        MALI_REDUCTION_MODE_AVERAGE          =      0,
        MALI_REDUCTION_MODE_MINIMUM          =      2,
        MALI_REDUCTION_MODE_MAXIMUM          =      3,
};

static inline const char *
mali_reduction_mode_as_str(enum mali_reduction_mode imm)
{
    switch (imm) {
    case MALI_REDUCTION_MODE_AVERAGE: return "Average";
    case MALI_REDUCTION_MODE_MINIMUM: return "Minimum";
    case MALI_REDUCTION_MODE_MAXIMUM: return "Maximum";
    default: return "XXX: INVALID";
    }
}

struct MALI_SAMPLER {
   enum mali_descriptor_type            type;
   enum mali_reduction_mode             reduction_mode;
   enum mali_wrap_mode                  wrap_mode_r;
   enum mali_wrap_mode                  wrap_mode_t;
   enum mali_wrap_mode                  wrap_mode_s;
   bool                                 round_to_nearest_even;
   bool                                 srgb_override;
   bool                                 seamless_cube_map;
   bool                                 clamp_integer_coordinates;
   bool                                 normalized_coordinates;
   bool                                 clamp_integer_array_indices;
   bool                                 minify_nearest;
   bool                                 magnify_nearest;
   bool                                 magnify_cutoff;
   enum mali_mipmap_mode                mipmap_mode;
   float                                minimum_lod;
   enum mali_func                       compare_function;
   float                                maximum_lod;
   float                                lod_bias;
   uint32_t                             maximum_anisotropy;
   enum mali_lod_algorithm              lod_algorithm;
   uint32_t                             border_color_r;
   uint32_t                             border_color_g;
   uint32_t                             border_color_b;
   uint32_t                             border_color_a;
};

#define MALI_SAMPLER_header                     \
   .type = MALI_DESCRIPTOR_TYPE_SAMPLER,  \
   .reduction_mode = MALI_REDUCTION_MODE_AVERAGE,  \
   .wrap_mode_r = MALI_WRAP_MODE_CLAMP_TO_EDGE,  \
   .wrap_mode_t = MALI_WRAP_MODE_CLAMP_TO_EDGE,  \
   .wrap_mode_s = MALI_WRAP_MODE_CLAMP_TO_EDGE,  \
   .round_to_nearest_even = true,  \
   .srgb_override = false,  \
   .seamless_cube_map = true,  \
   .normalized_coordinates = true,  \
   .clamp_integer_array_indices = true,  \
   .minify_nearest = false,  \
   .magnify_nearest = false,  \
   .magnify_cutoff = false,  \
   .mipmap_mode = MALI_MIPMAP_MODE_NEAREST,  \
   .minimum_lod = 0,  \
   .compare_function = MALI_FUNC_NEVER,  \
   .maximum_lod = 0,  \
   .lod_bias = 0,  \
   .maximum_anisotropy = 1,  \
   .lod_algorithm = MALI_LOD_ALGORITHM_ISOTROPIC,  \
   .border_color_r = 0.0,  \
   .border_color_g = 0.0,  \
   .border_color_b = 0.0,  \
   .border_color_a = 0.0

static ALWAYS_INLINE void
MALI_SAMPLER_pack(uint32_t * restrict cl,
                  const struct MALI_SAMPLER * restrict values)
{
   assert(values->maximum_anisotropy >= 1);
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->reduction_mode, 4, 5) |
            util_bitpack_uint(values->wrap_mode_r, 8, 11) |
            util_bitpack_uint(values->wrap_mode_t, 12, 15) |
            util_bitpack_uint(values->wrap_mode_s, 16, 19) |
            util_bitpack_uint(values->round_to_nearest_even, 21, 21) |
            util_bitpack_uint(values->srgb_override, 22, 22) |
            util_bitpack_uint(values->seamless_cube_map, 23, 23) |
            util_bitpack_uint(values->clamp_integer_coordinates, 24, 24) |
            util_bitpack_uint(values->normalized_coordinates, 25, 25) |
            util_bitpack_uint(values->clamp_integer_array_indices, 26, 26) |
            util_bitpack_uint(values->minify_nearest, 27, 27) |
            util_bitpack_uint(values->magnify_nearest, 28, 28) |
            util_bitpack_uint(values->magnify_cutoff, 29, 29) |
            util_bitpack_uint(values->mipmap_mode, 30, 31);
   cl[ 1] = util_bitpack_ufixed_clamp(values->minimum_lod, 0, 12, 8) |
            util_bitpack_uint(values->compare_function, 13, 15) |
            util_bitpack_ufixed_clamp(values->maximum_lod, 16, 28, 8);
   cl[ 2] = util_bitpack_sfixed_clamp(values->lod_bias, 0, 15, 8) |
            util_bitpack_uint(values->maximum_anisotropy - 1, 16, 20) |
            util_bitpack_uint(values->lod_algorithm, 24, 25);
   cl[ 3] = 0;
   cl[ 4] = util_bitpack_uint(values->border_color_r, 0, 31);
   cl[ 5] = util_bitpack_uint(values->border_color_g, 0, 31);
   cl[ 6] = util_bitpack_uint(values->border_color_b, 0, 31);
   cl[ 7] = util_bitpack_uint(values->border_color_a, 0, 31);
}


#define MALI_SAMPLER_LENGTH 32
#define MALI_SAMPLER_ALIGN 32
struct mali_sampler_packed { uint32_t opaque[8]; };
static inline void
MALI_SAMPLER_unpack(const uint8_t * restrict cl,
                    struct MALI_SAMPLER * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x1000c0) fprintf(stderr, "XXX: Invalid field of Sampler unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xe0000000) fprintf(stderr, "XXX: Invalid field of Sampler unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xfce00000) fprintf(stderr, "XXX: Invalid field of Sampler unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Sampler unpacked at word 3\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->reduction_mode = (enum mali_reduction_mode)__gen_unpack_uint(cl, 4, 5);
   values->wrap_mode_r = (enum mali_wrap_mode)__gen_unpack_uint(cl, 8, 11);
   values->wrap_mode_t = (enum mali_wrap_mode)__gen_unpack_uint(cl, 12, 15);
   values->wrap_mode_s = (enum mali_wrap_mode)__gen_unpack_uint(cl, 16, 19);
   values->round_to_nearest_even = __gen_unpack_uint(cl, 21, 21);
   values->srgb_override = __gen_unpack_uint(cl, 22, 22);
   values->seamless_cube_map = __gen_unpack_uint(cl, 23, 23);
   values->clamp_integer_coordinates = __gen_unpack_uint(cl, 24, 24);
   values->normalized_coordinates = __gen_unpack_uint(cl, 25, 25);
   values->clamp_integer_array_indices = __gen_unpack_uint(cl, 26, 26);
   values->minify_nearest = __gen_unpack_uint(cl, 27, 27);
   values->magnify_nearest = __gen_unpack_uint(cl, 28, 28);
   values->magnify_cutoff = __gen_unpack_uint(cl, 29, 29);
   values->mipmap_mode = (enum mali_mipmap_mode)__gen_unpack_uint(cl, 30, 31);
   values->minimum_lod = __gen_unpack_ulod(cl, 32, 44);
   values->compare_function = (enum mali_func)__gen_unpack_uint(cl, 45, 47);
   values->maximum_lod = __gen_unpack_ulod(cl, 48, 60);
   values->lod_bias = __gen_unpack_slod(cl, 64, 79);
   values->maximum_anisotropy = __gen_unpack_uint(cl, 80, 84) + 1;
   values->lod_algorithm = (enum mali_lod_algorithm)__gen_unpack_uint(cl, 88, 89);
   values->border_color_r = __gen_unpack_uint(cl, 128, 159);
   values->border_color_g = __gen_unpack_uint(cl, 160, 191);
   values->border_color_b = __gen_unpack_uint(cl, 192, 223);
   values->border_color_a = __gen_unpack_uint(cl, 224, 255);
}

static inline void
MALI_SAMPLER_print(FILE *fp, const struct MALI_SAMPLER * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sReduction mode: %s\n", indent, "", mali_reduction_mode_as_str(values->reduction_mode));
   fprintf(fp, "%*sWrap Mode R: %s\n", indent, "", mali_wrap_mode_as_str(values->wrap_mode_r));
   fprintf(fp, "%*sWrap Mode T: %s\n", indent, "", mali_wrap_mode_as_str(values->wrap_mode_t));
   fprintf(fp, "%*sWrap Mode S: %s\n", indent, "", mali_wrap_mode_as_str(values->wrap_mode_s));
   fprintf(fp, "%*sRound to nearest even: %s\n", indent, "", values->round_to_nearest_even ? "true" : "false");
   fprintf(fp, "%*ssRGB override: %s\n", indent, "", values->srgb_override ? "true" : "false");
   fprintf(fp, "%*sSeamless Cube Map: %s\n", indent, "", values->seamless_cube_map ? "true" : "false");
   fprintf(fp, "%*sClamp integer coordinates: %s\n", indent, "", values->clamp_integer_coordinates ? "true" : "false");
   fprintf(fp, "%*sNormalized Coordinates: %s\n", indent, "", values->normalized_coordinates ? "true" : "false");
   fprintf(fp, "%*sClamp integer array indices: %s\n", indent, "", values->clamp_integer_array_indices ? "true" : "false");
   fprintf(fp, "%*sMinify nearest: %s\n", indent, "", values->minify_nearest ? "true" : "false");
   fprintf(fp, "%*sMagnify nearest: %s\n", indent, "", values->magnify_nearest ? "true" : "false");
   fprintf(fp, "%*sMagnify cutoff: %s\n", indent, "", values->magnify_cutoff ? "true" : "false");
   fprintf(fp, "%*sMipmap Mode: %s\n", indent, "", mali_mipmap_mode_as_str(values->mipmap_mode));
   fprintf(fp, "%*sMinimum LOD: %f\n", indent, "", values->minimum_lod);
   fprintf(fp, "%*sCompare Function: %s\n", indent, "", mali_func_as_str(values->compare_function));
   fprintf(fp, "%*sMaximum LOD: %f\n", indent, "", values->maximum_lod);
   fprintf(fp, "%*sLOD bias: %f\n", indent, "", values->lod_bias);
   fprintf(fp, "%*sMaximum anisotropy: %u\n", indent, "", values->maximum_anisotropy);
   fprintf(fp, "%*sLOD algorithm: %s\n", indent, "", mali_lod_algorithm_as_str(values->lod_algorithm));
   fprintf(fp, "%*sBorder Color R: 0x%X (%f)\n", indent, "", values->border_color_r, uif(values->border_color_r));
   fprintf(fp, "%*sBorder Color G: 0x%X (%f)\n", indent, "", values->border_color_g, uif(values->border_color_g));
   fprintf(fp, "%*sBorder Color B: 0x%X (%f)\n", indent, "", values->border_color_b, uif(values->border_color_b));
   fprintf(fp, "%*sBorder Color A: 0x%X (%f)\n", indent, "", values->border_color_a, uif(values->border_color_a));
}

enum mali_plane_type {
        MALI_PLANE_TYPE_NULL                 =      0,
        MALI_PLANE_TYPE_GENERIC              =      1,
        MALI_PLANE_TYPE_ASTC_2D              =      4,
        MALI_PLANE_TYPE_ASTC_3D              =      5,
        MALI_PLANE_TYPE_AFBC                 =      6,
        MALI_PLANE_TYPE_CHROMA_2P            =      8,
        MALI_PLANE_TYPE_AFRC                 =     10,
        MALI_PLANE_TYPE_AFRC_CHROMA_2P       =     11,
};

static inline const char *
mali_plane_type_as_str(enum mali_plane_type imm)
{
    switch (imm) {
    case MALI_PLANE_TYPE_NULL: return "Null";
    case MALI_PLANE_TYPE_GENERIC: return "Generic";
    case MALI_PLANE_TYPE_ASTC_2D: return "ASTC 2D";
    case MALI_PLANE_TYPE_ASTC_3D: return "ASTC 3D";
    case MALI_PLANE_TYPE_AFBC: return "AFBC";
    case MALI_PLANE_TYPE_CHROMA_2P: return "Chroma 2p";
    case MALI_PLANE_TYPE_AFRC: return "AFRC";
    case MALI_PLANE_TYPE_AFRC_CHROMA_2P: return "AFRC Chroma 2p";
    default: return "XXX: INVALID";
    }
}

enum mali_clump_ordering {
        MALI_CLUMP_ORDERING_TILED_U_INTERLEAVED =      1,
        MALI_CLUMP_ORDERING_LINEAR           =      2,
};

static inline const char *
mali_clump_ordering_as_str(enum mali_clump_ordering imm)
{
    switch (imm) {
    case MALI_CLUMP_ORDERING_TILED_U_INTERLEAVED: return "Tiled U-Interleaved";
    case MALI_CLUMP_ORDERING_LINEAR: return "Linear";
    default: return "XXX: INVALID";
    }
}

enum mali_clump_format {
        MALI_CLUMP_FORMAT_RAW8               =      0,
        MALI_CLUMP_FORMAT_RAW16              =      1,
        MALI_CLUMP_FORMAT_RAW32              =      2,
        MALI_CLUMP_FORMAT_RAW64              =      3,
        MALI_CLUMP_FORMAT_RAW128             =      4,
        MALI_CLUMP_FORMAT_RAW24              =      8,
        MALI_CLUMP_FORMAT_RAW48              =      9,
        MALI_CLUMP_FORMAT_RAW96              =     10,
        MALI_CLUMP_FORMAT_D32X32             =     16,
        MALI_CLUMP_FORMAT_X32D32             =     17,
        MALI_CLUMP_FORMAT_X32S8X24           =     18,
        MALI_CLUMP_FORMAT_X24S8X32           =     19,
        MALI_CLUMP_FORMAT_X24S8              =     20,
        MALI_CLUMP_FORMAT_S8X24              =     21,
        MALI_CLUMP_FORMAT_S8                 =     22,
        MALI_CLUMP_FORMAT_L4A4               =     24,
        MALI_CLUMP_FORMAT_L8A8               =     25,
        MALI_CLUMP_FORMAT_A8                 =     26,
        MALI_CLUMP_FORMAT_ETC2_RGB8          =     32,
        MALI_CLUMP_FORMAT_ETC2_R11_UNORM     =     33,
        MALI_CLUMP_FORMAT_ETC2_R11_SNORM     =     34,
        MALI_CLUMP_FORMAT_ETC2_RG11_UNORM    =     35,
        MALI_CLUMP_FORMAT_ETC2_RG11_SNORM    =     36,
        MALI_CLUMP_FORMAT_ETC2_RGBA8         =     37,
        MALI_CLUMP_FORMAT_ETC2_RGB8A1        =     38,
        MALI_CLUMP_FORMAT_BC1_UNORM          =     48,
        MALI_CLUMP_FORMAT_BC2_UNORM          =     49,
        MALI_CLUMP_FORMAT_BC3_UNORM          =     50,
        MALI_CLUMP_FORMAT_BC4_UNORM          =     51,
        MALI_CLUMP_FORMAT_BC4_SNORM          =     52,
        MALI_CLUMP_FORMAT_BC5_UNORM          =     53,
        MALI_CLUMP_FORMAT_BC5_SNORM          =     54,
        MALI_CLUMP_FORMAT_BC6H_UF16          =     55,
        MALI_CLUMP_FORMAT_BC6H_SF16          =     56,
        MALI_CLUMP_FORMAT_BC7_UNORM          =     57,
        MALI_CLUMP_FORMAT_Y8_UV8_422         =     64,
        MALI_CLUMP_FORMAT_Y10_UV10_422       =     65,
        MALI_CLUMP_FORMAT_Y16_UV16_422       =     67,
        MALI_CLUMP_FORMAT_Y8_UV8_420         =     72,
        MALI_CLUMP_FORMAT_Y10_UV10_420       =     73,
        MALI_CLUMP_FORMAT_Y16_UV16_420       =     75,
        MALI_CLUMP_FORMAT_YUV420_10X6        =     76,
        MALI_CLUMP_FORMAT_RAW10              =    120,
        MALI_CLUMP_FORMAT_RAW12              =    121,
        MALI_CLUMP_FORMAT_R8G8B8G8           =    124,
        MALI_CLUMP_FORMAT_G8R8G8B8           =    125,
};

static inline const char *
mali_clump_format_as_str(enum mali_clump_format imm)
{
    switch (imm) {
    case MALI_CLUMP_FORMAT_RAW8: return "RAW8";
    case MALI_CLUMP_FORMAT_RAW16: return "RAW16";
    case MALI_CLUMP_FORMAT_RAW32: return "RAW32";
    case MALI_CLUMP_FORMAT_RAW64: return "RAW64";
    case MALI_CLUMP_FORMAT_RAW128: return "RAW128";
    case MALI_CLUMP_FORMAT_RAW24: return "RAW24";
    case MALI_CLUMP_FORMAT_RAW48: return "RAW48";
    case MALI_CLUMP_FORMAT_RAW96: return "RAW96";
    case MALI_CLUMP_FORMAT_D32X32: return "D32X32";
    case MALI_CLUMP_FORMAT_X32D32: return "X32D32";
    case MALI_CLUMP_FORMAT_X32S8X24: return "X32S8X24";
    case MALI_CLUMP_FORMAT_X24S8X32: return "X24S8X32";
    case MALI_CLUMP_FORMAT_X24S8: return "X24S8";
    case MALI_CLUMP_FORMAT_S8X24: return "S8X24";
    case MALI_CLUMP_FORMAT_S8: return "S8";
    case MALI_CLUMP_FORMAT_L4A4: return "L4A4";
    case MALI_CLUMP_FORMAT_L8A8: return "L8A8";
    case MALI_CLUMP_FORMAT_A8: return "A8";
    case MALI_CLUMP_FORMAT_ETC2_RGB8: return "ETC2 RGB8";
    case MALI_CLUMP_FORMAT_ETC2_R11_UNORM: return "ETC2 R11 UNORM";
    case MALI_CLUMP_FORMAT_ETC2_R11_SNORM: return "ETC2 R11 SNORM";
    case MALI_CLUMP_FORMAT_ETC2_RG11_UNORM: return "ETC2 RG11 UNORM";
    case MALI_CLUMP_FORMAT_ETC2_RG11_SNORM: return "ETC2 RG11 SNORM";
    case MALI_CLUMP_FORMAT_ETC2_RGBA8: return "ETC2 RGBA8";
    case MALI_CLUMP_FORMAT_ETC2_RGB8A1: return "ETC2 RGB8A1";
    case MALI_CLUMP_FORMAT_BC1_UNORM: return "BC1 UNORM";
    case MALI_CLUMP_FORMAT_BC2_UNORM: return "BC2 UNORM";
    case MALI_CLUMP_FORMAT_BC3_UNORM: return "BC3 UNORM";
    case MALI_CLUMP_FORMAT_BC4_UNORM: return "BC4 UNORM";
    case MALI_CLUMP_FORMAT_BC4_SNORM: return "BC4 SNORM";
    case MALI_CLUMP_FORMAT_BC5_UNORM: return "BC5 UNORM";
    case MALI_CLUMP_FORMAT_BC5_SNORM: return "BC5 SNORM";
    case MALI_CLUMP_FORMAT_BC6H_UF16: return "BC6H UF16";
    case MALI_CLUMP_FORMAT_BC6H_SF16: return "BC6H SF16";
    case MALI_CLUMP_FORMAT_BC7_UNORM: return "BC7 UNORM";
    case MALI_CLUMP_FORMAT_Y8_UV8_422: return "Y8 UV8 422";
    case MALI_CLUMP_FORMAT_Y10_UV10_422: return "Y10 UV10 422";
    case MALI_CLUMP_FORMAT_Y16_UV16_422: return "Y16 UV16 422";
    case MALI_CLUMP_FORMAT_Y8_UV8_420: return "Y8 UV8 420";
    case MALI_CLUMP_FORMAT_Y10_UV10_420: return "Y10 UV10 420";
    case MALI_CLUMP_FORMAT_Y16_UV16_420: return "Y16 UV16 420";
    case MALI_CLUMP_FORMAT_YUV420_10X6: return "YUV420 10x6";
    case MALI_CLUMP_FORMAT_RAW10: return "RAW10";
    case MALI_CLUMP_FORMAT_RAW12: return "RAW12";
    case MALI_CLUMP_FORMAT_R8G8B8G8: return "R8G8B8G8";
    case MALI_CLUMP_FORMAT_G8R8G8B8: return "G8R8G8B8";
    default: return "XXX: INVALID";
    }
}

enum mali_afbc_superblock_size {
        MALI_AFBC_SUPERBLOCK_SIZE_16X16      =      0,
        MALI_AFBC_SUPERBLOCK_SIZE_32X8       =      1,
        MALI_AFBC_SUPERBLOCK_SIZE_64X4       =      2,
};

static inline const char *
mali_afbc_superblock_size_as_str(enum mali_afbc_superblock_size imm)
{
    switch (imm) {
    case MALI_AFBC_SUPERBLOCK_SIZE_16X16: return "16x16";
    case MALI_AFBC_SUPERBLOCK_SIZE_32X8: return "32x8";
    case MALI_AFBC_SUPERBLOCK_SIZE_64X4: return "64x4";
    default: return "XXX: INVALID";
    }
}

enum mali_afbc_compression_mode {
        MALI_AFBC_COMPRESSION_MODE_R8        =      0,
        MALI_AFBC_COMPRESSION_MODE_R8G8      =      3,
        MALI_AFBC_COMPRESSION_MODE_R5G6B5    =      4,
        MALI_AFBC_COMPRESSION_MODE_R4G4B4A4  =      5,
        MALI_AFBC_COMPRESSION_MODE_R5G5B5A1  =      6,
        MALI_AFBC_COMPRESSION_MODE_R8G8B8    =      9,
        MALI_AFBC_COMPRESSION_MODE_R8G8B8A8  =     10,
        MALI_AFBC_COMPRESSION_MODE_R10G10B10A2 =     11,
        MALI_AFBC_COMPRESSION_MODE_R11G11B10 =     12,
        MALI_AFBC_COMPRESSION_MODE_S8        =     14,
        MALI_AFBC_COMPRESSION_MODE_X24S8     =     15,
        MALI_AFBC_COMPRESSION_MODE_YUV420_6C8 =     32,
        MALI_AFBC_COMPRESSION_MODE_YUV420_2C8 =     34,
        MALI_AFBC_COMPRESSION_MODE_YUV420_1C8 =     35,
        MALI_AFBC_COMPRESSION_MODE_YUV422_4C8 =     37,
        MALI_AFBC_COMPRESSION_MODE_YUV422_2C8 =     38,
        MALI_AFBC_COMPRESSION_MODE_YUV422_1C8 =     39,
        MALI_AFBC_COMPRESSION_MODE_YUV420_6C10 =     40,
        MALI_AFBC_COMPRESSION_MODE_YUV420_2C10 =     42,
        MALI_AFBC_COMPRESSION_MODE_YUV420_1C10 =     43,
        MALI_AFBC_COMPRESSION_MODE_YUV422_4C10 =     45,
        MALI_AFBC_COMPRESSION_MODE_YUV422_2C10 =     46,
        MALI_AFBC_COMPRESSION_MODE_YUV422_1C10 =     47,
};

static inline const char *
mali_afbc_compression_mode_as_str(enum mali_afbc_compression_mode imm)
{
    switch (imm) {
    case MALI_AFBC_COMPRESSION_MODE_R8: return "R8";
    case MALI_AFBC_COMPRESSION_MODE_R8G8: return "R8G8";
    case MALI_AFBC_COMPRESSION_MODE_R5G6B5: return "R5G6B5";
    case MALI_AFBC_COMPRESSION_MODE_R4G4B4A4: return "R4G4B4A4";
    case MALI_AFBC_COMPRESSION_MODE_R5G5B5A1: return "R5G5B5A1";
    case MALI_AFBC_COMPRESSION_MODE_R8G8B8: return "R8G8B8";
    case MALI_AFBC_COMPRESSION_MODE_R8G8B8A8: return "R8G8B8A8";
    case MALI_AFBC_COMPRESSION_MODE_R10G10B10A2: return "R10G10B10A2";
    case MALI_AFBC_COMPRESSION_MODE_R11G11B10: return "R11G11B10";
    case MALI_AFBC_COMPRESSION_MODE_S8: return "S8";
    case MALI_AFBC_COMPRESSION_MODE_X24S8: return "X24S8";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_6C8: return "YUV420 6c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_2C8: return "YUV420 2c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_1C8: return "YUV420 1c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_4C8: return "YUV422 4c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_2C8: return "YUV422 2c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_1C8: return "YUV422 1c8";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_6C10: return "YUV420 6c10";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_2C10: return "YUV420 2c10";
    case MALI_AFBC_COMPRESSION_MODE_YUV420_1C10: return "YUV420 1c10";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_4C10: return "YUV422 4c10";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_2C10: return "YUV422 2c10";
    case MALI_AFBC_COMPRESSION_MODE_YUV422_1C10: return "YUV422 1c10";
    default: return "XXX: INVALID";
    }
}

enum mali_afrc_block_size {
        MALI_AFRC_BLOCK_SIZE_16              =      4,
        MALI_AFRC_BLOCK_SIZE_24              =      5,
        MALI_AFRC_BLOCK_SIZE_32              =      6,
};

static inline const char *
mali_afrc_block_size_as_str(enum mali_afrc_block_size imm)
{
    switch (imm) {
    case MALI_AFRC_BLOCK_SIZE_16: return "16";
    case MALI_AFRC_BLOCK_SIZE_24: return "24";
    case MALI_AFRC_BLOCK_SIZE_32: return "32";
    default: return "XXX: INVALID";
    }
}

enum mali_afrc_format {
        MALI_AFRC_FORMAT_R8_SCAN             =      0,
        MALI_AFRC_FORMAT_R8G8_SCAN           =      1,
        MALI_AFRC_FORMAT_R8G8B8_SCAN         =      2,
        MALI_AFRC_FORMAT_R8G8B8A8_SCAN       =      3,
        MALI_AFRC_FORMAT_R8_ROT              =      4,
        MALI_AFRC_FORMAT_R8G8_ROT            =      5,
        MALI_AFRC_FORMAT_R8G8B8_ROT          =      6,
        MALI_AFRC_FORMAT_R8G8B8A8_ROT        =      7,
        MALI_AFRC_FORMAT_R10G10B10A10_SCAN   =     11,
        MALI_AFRC_FORMAT_R10G10B10A10_ROT    =     15,
        MALI_AFRC_FORMAT_R8_444_SCAN         =     64,
        MALI_AFRC_FORMAT_R8_422_SCAN         =     65,
        MALI_AFRC_FORMAT_R8_420_SCAN         =     66,
        MALI_AFRC_FORMAT_R8_444_ROT          =     68,
        MALI_AFRC_FORMAT_R8_422_ROT          =     69,
        MALI_AFRC_FORMAT_R8_420_ROT          =     70,
        MALI_AFRC_FORMAT_R8G8_444_SCAN       =     72,
        MALI_AFRC_FORMAT_R8G8_422_SCAN       =     73,
        MALI_AFRC_FORMAT_R8G8_420_SCAN       =     74,
        MALI_AFRC_FORMAT_R8G8_444_ROT        =     76,
        MALI_AFRC_FORMAT_R8G8_422_ROT        =     77,
        MALI_AFRC_FORMAT_R8G8_420_ROT        =     78,
        MALI_AFRC_FORMAT_R10_444_SCAN        =     80,
        MALI_AFRC_FORMAT_R10_422_SCAN        =     81,
        MALI_AFRC_FORMAT_R10_420_SCAN        =     82,
        MALI_AFRC_FORMAT_R10_444_ROT         =     84,
        MALI_AFRC_FORMAT_R10_422_ROT         =     85,
        MALI_AFRC_FORMAT_R10_420_ROT         =     86,
        MALI_AFRC_FORMAT_R10G10_422_SCAN     =     89,
        MALI_AFRC_FORMAT_R10G10_420_SCAN     =     90,
        MALI_AFRC_FORMAT_R10G10_422_ROT      =     93,
        MALI_AFRC_FORMAT_R10G10_420_ROT      =     94,
        MALI_AFRC_FORMAT_INVALID             =    256,
};

static inline const char *
mali_afrc_format_as_str(enum mali_afrc_format imm)
{
    switch (imm) {
    case MALI_AFRC_FORMAT_R8_SCAN: return "R8 SCAN";
    case MALI_AFRC_FORMAT_R8G8_SCAN: return "R8G8 SCAN";
    case MALI_AFRC_FORMAT_R8G8B8_SCAN: return "R8G8B8 SCAN";
    case MALI_AFRC_FORMAT_R8G8B8A8_SCAN: return "R8G8B8A8 SCAN";
    case MALI_AFRC_FORMAT_R8_ROT: return "R8 ROT";
    case MALI_AFRC_FORMAT_R8G8_ROT: return "R8G8 ROT";
    case MALI_AFRC_FORMAT_R8G8B8_ROT: return "R8G8B8 ROT";
    case MALI_AFRC_FORMAT_R8G8B8A8_ROT: return "R8G8B8A8 ROT";
    case MALI_AFRC_FORMAT_R10G10B10A10_SCAN: return "R10G10B10A10 SCAN";
    case MALI_AFRC_FORMAT_R10G10B10A10_ROT: return "R10G10B10A10 ROT";
    case MALI_AFRC_FORMAT_R8_444_SCAN: return "R8_444 SCAN";
    case MALI_AFRC_FORMAT_R8_422_SCAN: return "R8_422 SCAN";
    case MALI_AFRC_FORMAT_R8_420_SCAN: return "R8_420 SCAN";
    case MALI_AFRC_FORMAT_R8_444_ROT: return "R8_444 ROT";
    case MALI_AFRC_FORMAT_R8_422_ROT: return "R8_422 ROT";
    case MALI_AFRC_FORMAT_R8_420_ROT: return "R8_420 ROT";
    case MALI_AFRC_FORMAT_R8G8_444_SCAN: return "R8G8_444 SCAN";
    case MALI_AFRC_FORMAT_R8G8_422_SCAN: return "R8G8_422 SCAN";
    case MALI_AFRC_FORMAT_R8G8_420_SCAN: return "R8G8_420 SCAN";
    case MALI_AFRC_FORMAT_R8G8_444_ROT: return "R8G8_444 ROT";
    case MALI_AFRC_FORMAT_R8G8_422_ROT: return "R8G8_422 ROT";
    case MALI_AFRC_FORMAT_R8G8_420_ROT: return "R8G8_420 ROT";
    case MALI_AFRC_FORMAT_R10_444_SCAN: return "R10_444 SCAN";
    case MALI_AFRC_FORMAT_R10_422_SCAN: return "R10_422 SCAN";
    case MALI_AFRC_FORMAT_R10_420_SCAN: return "R10_420 SCAN";
    case MALI_AFRC_FORMAT_R10_444_ROT: return "R10_444 ROT";
    case MALI_AFRC_FORMAT_R10_422_ROT: return "R10_422 ROT";
    case MALI_AFRC_FORMAT_R10_420_ROT: return "R10_420 ROT";
    case MALI_AFRC_FORMAT_R10G10_422_SCAN: return "R10G10_422 SCAN";
    case MALI_AFRC_FORMAT_R10G10_420_SCAN: return "R10G10_420 SCAN";
    case MALI_AFRC_FORMAT_R10G10_422_ROT: return "R10G10_422 ROT";
    case MALI_AFRC_FORMAT_R10G10_420_ROT: return "R10G10_420 ROT";
    case MALI_AFRC_FORMAT_INVALID: return "INVALID";
    default: return "XXX: INVALID";
    }
}

struct MALI_PLANE_AFBC_OVERLAY {
   enum mali_afbc_superblock_size       superblock_size;
   bool                                 ytr;
   bool                                 split_block;
   bool                                 alpha_hint;
   bool                                 tiled_header;
   bool                                 prefetch;
   enum mali_afbc_compression_mode      compression_mode;
   uint32_t                             header_stride;
};

#define MALI_PLANE_AFBC_OVERLAY_header          \
   0

static ALWAYS_INLINE void
MALI_PLANE_AFBC_OVERLAY_pack(uint32_t * restrict cl,
                             const struct MALI_PLANE_AFBC_OVERLAY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->superblock_size, 8, 10) |
            util_bitpack_uint(values->ytr, 16, 16) |
            util_bitpack_uint(values->split_block, 17, 17) |
            util_bitpack_uint(values->alpha_hint, 18, 18) |
            util_bitpack_uint(values->tiled_header, 19, 19) |
            util_bitpack_uint(values->prefetch, 20, 20) |
            util_bitpack_uint(values->compression_mode, 26, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = util_bitpack_uint(values->header_stride, 0, 31);
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_PLANE_AFBC_OVERLAY_LENGTH 32
struct mali_plane_afbc_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_AFBC_OVERLAY_unpack(const uint8_t * restrict cl,
                               struct MALI_PLANE_AFBC_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x3e0f8ff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFBC Overlay unpacked at word 7\n");
   values->superblock_size = (enum mali_afbc_superblock_size)__gen_unpack_uint(cl, 8, 10);
   values->ytr = __gen_unpack_uint(cl, 16, 16);
   values->split_block = __gen_unpack_uint(cl, 17, 17);
   values->alpha_hint = __gen_unpack_uint(cl, 18, 18);
   values->tiled_header = __gen_unpack_uint(cl, 19, 19);
   values->prefetch = __gen_unpack_uint(cl, 20, 20);
   values->compression_mode = (enum mali_afbc_compression_mode)__gen_unpack_uint(cl, 26, 31);
   values->header_stride = __gen_unpack_uint(cl, 160, 191);
}

static inline void
MALI_PLANE_AFBC_OVERLAY_print(FILE *fp, const struct MALI_PLANE_AFBC_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sSuperblock size: %s\n", indent, "", mali_afbc_superblock_size_as_str(values->superblock_size));
   fprintf(fp, "%*sYTR: %s\n", indent, "", values->ytr ? "true" : "false");
   fprintf(fp, "%*sSplit block: %s\n", indent, "", values->split_block ? "true" : "false");
   fprintf(fp, "%*sAlpha hint: %s\n", indent, "", values->alpha_hint ? "true" : "false");
   fprintf(fp, "%*sTiled header: %s\n", indent, "", values->tiled_header ? "true" : "false");
   fprintf(fp, "%*sPrefetch: %s\n", indent, "", values->prefetch ? "true" : "false");
   fprintf(fp, "%*sCompression mode: %s\n", indent, "", mali_afbc_compression_mode_as_str(values->compression_mode));
   fprintf(fp, "%*sHeader stride: %u\n", indent, "", values->header_stride);
}

struct MALI_PLANE_ASTC_2D_OVERLAY {
   enum mali_astc_2d_dimension          block_width;
   enum mali_astc_2d_dimension          block_height;
};

#define MALI_PLANE_ASTC_2D_OVERLAY_header       \
   0

static ALWAYS_INLINE void
MALI_PLANE_ASTC_2D_OVERLAY_pack(uint32_t * restrict cl,
                                const struct MALI_PLANE_ASTC_2D_OVERLAY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->block_width, 26, 28) |
            util_bitpack_uint(values->block_height, 29, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_PLANE_ASTC_2D_OVERLAY_LENGTH 32
struct mali_plane_astc_2d_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_ASTC_2D_OVERLAY_unpack(const uint8_t * restrict cl,
                                  struct MALI_PLANE_ASTC_2D_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x3ffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 2D Overlay unpacked at word 7\n");
   values->block_width = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 26, 28);
   values->block_height = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 29, 31);
}

static inline void
MALI_PLANE_ASTC_2D_OVERLAY_print(FILE *fp, const struct MALI_PLANE_ASTC_2D_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sBlock width: %s\n", indent, "", mali_astc_2d_dimension_as_str(values->block_width));
   fprintf(fp, "%*sBlock height: %s\n", indent, "", mali_astc_2d_dimension_as_str(values->block_height));
}

struct MALI_PLANE_ASTC_3D_OVERLAY {
   enum mali_astc_3d_dimension          block_width;
   enum mali_astc_3d_dimension          block_height;
   enum mali_astc_3d_dimension          block_depth;
};

#define MALI_PLANE_ASTC_3D_OVERLAY_header       \
   0

static ALWAYS_INLINE void
MALI_PLANE_ASTC_3D_OVERLAY_pack(uint32_t * restrict cl,
                                const struct MALI_PLANE_ASTC_3D_OVERLAY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->block_width, 26, 27) |
            util_bitpack_uint(values->block_height, 28, 29) |
            util_bitpack_uint(values->block_depth, 30, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_PLANE_ASTC_3D_OVERLAY_LENGTH 32
struct mali_plane_astc_3d_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_ASTC_3D_OVERLAY_unpack(const uint8_t * restrict cl,
                                  struct MALI_PLANE_ASTC_3D_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x3ffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC 3D Overlay unpacked at word 7\n");
   values->block_width = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 26, 27);
   values->block_height = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 28, 29);
   values->block_depth = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 30, 31);
}

static inline void
MALI_PLANE_ASTC_3D_OVERLAY_print(FILE *fp, const struct MALI_PLANE_ASTC_3D_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sBlock width: %s\n", indent, "", mali_astc_3d_dimension_as_str(values->block_width));
   fprintf(fp, "%*sBlock height: %s\n", indent, "", mali_astc_3d_dimension_as_str(values->block_height));
   fprintf(fp, "%*sBlock depth: %s\n", indent, "", mali_astc_3d_dimension_as_str(values->block_depth));
}

struct MALI_PLANE_ASTC_OVERLAY {
   bool                                 decode_hdr;
   bool                                 decode_wide;
   struct MALI_PLANE_ASTC_2D_OVERLAY    _2d;
   struct MALI_PLANE_ASTC_3D_OVERLAY    _3d;
};

#define MALI_PLANE_ASTC_OVERLAY_header          \
   ._2d = { MALI_PLANE_ASTC_2D_OVERLAY_header },  \
   ._3d = { MALI_PLANE_ASTC_3D_OVERLAY_header }

static ALWAYS_INLINE void
MALI_PLANE_ASTC_OVERLAY_pack(uint32_t * restrict cl,
                             const struct MALI_PLANE_ASTC_OVERLAY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->decode_hdr, 24, 24) |
            util_bitpack_uint(values->decode_wide, 25, 25) |
            util_bitpack_uint(values->_2d.block_width, 26, 28) |
            util_bitpack_uint(values->_2d.block_height, 29, 31) |
            util_bitpack_uint(values->_3d.block_width, 26, 27) |
            util_bitpack_uint(values->_3d.block_height, 28, 29) |
            util_bitpack_uint(values->_3d.block_depth, 30, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_PLANE_ASTC_OVERLAY_LENGTH 32
struct mali_plane_astc_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_ASTC_OVERLAY_unpack(const uint8_t * restrict cl,
                               struct MALI_PLANE_ASTC_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane ASTC Overlay unpacked at word 7\n");
   values->decode_hdr = __gen_unpack_uint(cl, 24, 24);
   values->decode_wide = __gen_unpack_uint(cl, 25, 25);
   values->_2d.block_width = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 26, 28);
   values->_2d.block_height = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 29, 31);
   values->_3d.block_width = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 26, 27);
   values->_3d.block_height = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 28, 29);
   values->_3d.block_depth = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 30, 31);
}

static inline void
MALI_PLANE_ASTC_OVERLAY_print(FILE *fp, const struct MALI_PLANE_ASTC_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sDecode HDR: %s\n", indent, "", values->decode_hdr ? "true" : "false");
   fprintf(fp, "%*sDecode Wide: %s\n", indent, "", values->decode_wide ? "true" : "false");
   fprintf(fp, "%*s2D:\n", indent, "");
   MALI_PLANE_ASTC_2D_OVERLAY_print(fp, &values->_2d, indent + 2);
   fprintf(fp, "%*s3D:\n", indent, "");
   MALI_PLANE_ASTC_3D_OVERLAY_print(fp, &values->_3d, indent + 2);
}

struct MALI_TWO_PLANE_YUV_CHROMA_OVERLAY {
   uint32_t                             width;
   uint32_t                             height;
   uint64_t                             secondary_pointer;
};

#define MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_header\
   0

static ALWAYS_INLINE void
MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_pack(uint32_t * restrict cl,
                                       const struct MALI_TWO_PLANE_YUV_CHROMA_OVERLAY * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = util_bitpack_uint(values->width, 0, 15) |
            util_bitpack_uint(values->height, 16, 31);
   cl[ 6] = util_bitpack_uint(values->secondary_pointer, 0, 63);
   cl[ 7] = util_bitpack_uint(values->secondary_pointer, 0, 63) >> 32;
}


#define MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_LENGTH 32
struct mali_two_plane_yuv_chroma_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_unpack(const uint8_t * restrict cl,
                                         struct MALI_TWO_PLANE_YUV_CHROMA_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Two-Plane YUV Chroma Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Two-Plane YUV Chroma Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Two-Plane YUV Chroma Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Two-Plane YUV Chroma Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Two-Plane YUV Chroma Overlay unpacked at word 4\n");
   values->width = __gen_unpack_uint(cl, 160, 175);
   values->height = __gen_unpack_uint(cl, 176, 191);
   values->secondary_pointer = __gen_unpack_uint(cl, 192, 255);
}

static inline void
MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_print(FILE *fp, const struct MALI_TWO_PLANE_YUV_CHROMA_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sWidth: %u\n", indent, "", values->width);
   fprintf(fp, "%*sHeight: %u\n", indent, "", values->height);
   fprintf(fp, "%*sSecondary Pointer: 0x%" PRIx64 "\n", indent, "", values->secondary_pointer);
}

struct MALI_PLANE_AFRC_OVERLAY {
   uint32_t                             codec_arguments;
   enum mali_afrc_block_size            block_size;
   enum mali_afrc_format                format;
};

#define MALI_PLANE_AFRC_OVERLAY_header          \
   0

static ALWAYS_INLINE void
MALI_PLANE_AFRC_OVERLAY_pack(uint32_t * restrict cl,
                             const struct MALI_PLANE_AFRC_OVERLAY * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->codec_arguments, 8, 15) |
            util_bitpack_uint(values->block_size, 20, 23) |
            util_bitpack_uint(values->format, 24, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_PLANE_AFRC_OVERLAY_LENGTH 32
struct mali_plane_afrc_overlay_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_AFRC_OVERLAY_unpack(const uint8_t * restrict cl,
                               struct MALI_PLANE_AFRC_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xf00ff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Plane AFRC Overlay unpacked at word 7\n");
   values->codec_arguments = __gen_unpack_uint(cl, 8, 15);
   values->block_size = (enum mali_afrc_block_size)__gen_unpack_uint(cl, 20, 23);
   values->format = (enum mali_afrc_format)__gen_unpack_uint(cl, 24, 31);
}

static inline void
MALI_PLANE_AFRC_OVERLAY_print(FILE *fp, const struct MALI_PLANE_AFRC_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sCodec arguments: %u\n", indent, "", values->codec_arguments);
   fprintf(fp, "%*sBlock size: %s\n", indent, "", mali_afrc_block_size_as_str(values->block_size));
   fprintf(fp, "%*sFormat: %s\n", indent, "", mali_afrc_format_as_str(values->format));
}

struct MALI_PLANE {
   enum mali_descriptor_type            type;
   enum mali_plane_type                 plane_type;
   struct MALI_PLANE_AFBC_OVERLAY       afbc;
   struct MALI_PLANE_ASTC_OVERLAY       astc;
   struct MALI_PLANE_AFRC_OVERLAY       afrc;
   struct MALI_TWO_PLANE_YUV_CHROMA_OVERLAY two_plane_yuv_chroma;
   enum mali_clump_ordering             clump_ordering;
   enum mali_clump_format               clump_format;
   uint32_t                             size;
   uint64_t                             pointer;
   uint32_t                             row_stride;
   int32_t                              slice_stride;
   uint32_t                             width;
   uint32_t                             height;
};

#define MALI_PLANE_header                       \
   .type = MALI_DESCRIPTOR_TYPE_PLANE,  \
   .afbc = { MALI_PLANE_AFBC_OVERLAY_header },  \
   .astc = { MALI_PLANE_ASTC_OVERLAY_header },  \
   .afrc = { MALI_PLANE_AFRC_OVERLAY_header },  \
   .two_plane_yuv_chroma = { MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_header }

static ALWAYS_INLINE void
MALI_PLANE_pack(uint32_t * restrict cl,
                const struct MALI_PLANE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->plane_type, 4, 7) |
            util_bitpack_uint(values->afbc.superblock_size, 8, 10) |
            util_bitpack_uint(values->afbc.ytr, 16, 16) |
            util_bitpack_uint(values->afbc.split_block, 17, 17) |
            util_bitpack_uint(values->afbc.alpha_hint, 18, 18) |
            util_bitpack_uint(values->afbc.tiled_header, 19, 19) |
            util_bitpack_uint(values->afbc.prefetch, 20, 20) |
            util_bitpack_uint(values->afbc.compression_mode, 26, 31) |
            util_bitpack_uint(values->astc.decode_hdr, 24, 24) |
            util_bitpack_uint(values->astc.decode_wide, 25, 25) |
            util_bitpack_uint(values->astc._2d.block_width, 26, 28) |
            util_bitpack_uint(values->astc._2d.block_height, 29, 31) |
            util_bitpack_uint(values->astc._3d.block_width, 26, 27) |
            util_bitpack_uint(values->astc._3d.block_height, 28, 29) |
            util_bitpack_uint(values->astc._3d.block_depth, 30, 31) |
            util_bitpack_uint(values->afrc.codec_arguments, 8, 15) |
            util_bitpack_uint(values->afrc.block_size, 20, 23) |
            util_bitpack_uint(values->afrc.format, 24, 31) |
            util_bitpack_uint(values->clump_ordering, 8, 11) |
            util_bitpack_uint(values->clump_format, 24, 31);
   cl[ 1] = util_bitpack_uint(values->size, 0, 31);
   cl[ 2] = util_bitpack_uint(values->pointer, 0, 63);
   cl[ 3] = util_bitpack_uint(values->pointer, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->row_stride, 0, 31);
   cl[ 5] = util_bitpack_uint(values->afbc.header_stride, 0, 31) |
            util_bitpack_uint(values->two_plane_yuv_chroma.width, 0, 15) |
            util_bitpack_uint(values->two_plane_yuv_chroma.height, 16, 31);
   cl[ 6] = util_bitpack_uint(values->two_plane_yuv_chroma.secondary_pointer, 0, 63) |
            util_bitpack_sint(values->slice_stride, 0, 31);
   cl[ 7] = util_bitpack_uint(values->two_plane_yuv_chroma.secondary_pointer, 0, 63) >> 32 |
            util_bitpack_uint(values->width, 0, 15) |
            util_bitpack_uint(values->height, 16, 31);
}


#define MALI_PLANE_LENGTH 32
#define MALI_PLANE_ALIGN 32
struct mali_plane_packed { uint32_t opaque[8]; };
static inline void
MALI_PLANE_unpack(const uint8_t * restrict cl,
                  struct MALI_PLANE * restrict values)
{
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->plane_type = (enum mali_plane_type)__gen_unpack_uint(cl, 4, 7);
   values->afbc.superblock_size = (enum mali_afbc_superblock_size)__gen_unpack_uint(cl, 8, 10);
   values->afbc.ytr = __gen_unpack_uint(cl, 16, 16);
   values->afbc.split_block = __gen_unpack_uint(cl, 17, 17);
   values->afbc.alpha_hint = __gen_unpack_uint(cl, 18, 18);
   values->afbc.tiled_header = __gen_unpack_uint(cl, 19, 19);
   values->afbc.prefetch = __gen_unpack_uint(cl, 20, 20);
   values->afbc.compression_mode = (enum mali_afbc_compression_mode)__gen_unpack_uint(cl, 26, 31);
   values->afbc.header_stride = __gen_unpack_uint(cl, 160, 191);
   values->astc.decode_hdr = __gen_unpack_uint(cl, 24, 24);
   values->astc.decode_wide = __gen_unpack_uint(cl, 25, 25);
   values->astc._2d.block_width = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 26, 28);
   values->astc._2d.block_height = (enum mali_astc_2d_dimension)__gen_unpack_uint(cl, 29, 31);
   values->astc._3d.block_width = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 26, 27);
   values->astc._3d.block_height = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 28, 29);
   values->astc._3d.block_depth = (enum mali_astc_3d_dimension)__gen_unpack_uint(cl, 30, 31);
   values->afrc.codec_arguments = __gen_unpack_uint(cl, 8, 15);
   values->afrc.block_size = (enum mali_afrc_block_size)__gen_unpack_uint(cl, 20, 23);
   values->afrc.format = (enum mali_afrc_format)__gen_unpack_uint(cl, 24, 31);
   values->two_plane_yuv_chroma.width = __gen_unpack_uint(cl, 160, 175);
   values->two_plane_yuv_chroma.height = __gen_unpack_uint(cl, 176, 191);
   values->two_plane_yuv_chroma.secondary_pointer = __gen_unpack_uint(cl, 192, 255);
   values->clump_ordering = (enum mali_clump_ordering)__gen_unpack_uint(cl, 8, 11);
   values->clump_format = (enum mali_clump_format)__gen_unpack_uint(cl, 24, 31);
   values->size = __gen_unpack_uint(cl, 32, 63);
   values->pointer = __gen_unpack_uint(cl, 64, 127);
   values->row_stride = __gen_unpack_uint(cl, 128, 159);
   values->slice_stride = __gen_unpack_sint(cl, 192, 223);
   values->width = __gen_unpack_uint(cl, 224, 239);
   values->height = __gen_unpack_uint(cl, 240, 255);
}

static inline void
MALI_PLANE_print(FILE *fp, const struct MALI_PLANE * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sPlane type: %s\n", indent, "", mali_plane_type_as_str(values->plane_type));
   fprintf(fp, "%*sAFBC:\n", indent, "");
   MALI_PLANE_AFBC_OVERLAY_print(fp, &values->afbc, indent + 2);
   fprintf(fp, "%*sASTC:\n", indent, "");
   MALI_PLANE_ASTC_OVERLAY_print(fp, &values->astc, indent + 2);
   fprintf(fp, "%*sAFRC:\n", indent, "");
   MALI_PLANE_AFRC_OVERLAY_print(fp, &values->afrc, indent + 2);
   fprintf(fp, "%*sTwo-Plane YUV Chroma:\n", indent, "");
   MALI_TWO_PLANE_YUV_CHROMA_OVERLAY_print(fp, &values->two_plane_yuv_chroma, indent + 2);
   fprintf(fp, "%*sClump ordering: %s\n", indent, "", mali_clump_ordering_as_str(values->clump_ordering));
   fprintf(fp, "%*sClump format: %s\n", indent, "", mali_clump_format_as_str(values->clump_format));
   fprintf(fp, "%*sSize: %u\n", indent, "", values->size);
   fprintf(fp, "%*sPointer: 0x%" PRIx64 "\n", indent, "", values->pointer);
   fprintf(fp, "%*sRow stride: %u\n", indent, "", values->row_stride);
   fprintf(fp, "%*sSlice stride: %d\n", indent, "", values->slice_stride);
   fprintf(fp, "%*sWidth: %u\n", indent, "", values->width);
   fprintf(fp, "%*sHeight: %u\n", indent, "", values->height);
}

struct MALI_TEXTURE {
   enum mali_descriptor_type            type;
   enum mali_texture_dimension          dimension;
   bool                                 sample_corner_position;
   bool                                 normalize_coordinates;
   uint32_t                             format;
   uint32_t                             width;
   uint32_t                             height;
   uint32_t                             swizzle;
   bool                                 texel_interleave;
   uint32_t                             levels;
   uint32_t                             minimum_level;
   float                                minimum_lod;
   uint32_t                             sample_count;
   float                                maximum_lod;
   uint64_t                             surfaces;
   uint32_t                             array_size;
   uint32_t                             depth;
};

#define MALI_TEXTURE_header                     \
   .type = MALI_DESCRIPTOR_TYPE_TEXTURE,  \
   .sample_corner_position = false,  \
   .normalize_coordinates = false,  \
   .levels = 1,  \
   .minimum_lod = 0,  \
   .sample_count = 1,  \
   .maximum_lod = 0,  \
   .array_size = 1,  \
   .depth = 1

static ALWAYS_INLINE void
MALI_TEXTURE_pack(uint32_t * restrict cl,
                  const struct MALI_TEXTURE * restrict values)
{
   assert(values->width >= 1);
   assert(values->height >= 1);
   assert(values->levels >= 1);
   assert(IS_POT_NONZERO(values->sample_count));
   assert(values->array_size >= 1);
   assert(values->depth >= 1);
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->dimension, 4, 5) |
            util_bitpack_uint(values->sample_corner_position, 8, 8) |
            util_bitpack_uint(values->normalize_coordinates, 9, 9) |
            util_bitpack_uint(values->format, 10, 31);
   cl[ 1] = util_bitpack_uint(values->width - 1, 0, 15) |
            util_bitpack_uint(values->height - 1, 16, 31);
   cl[ 2] = util_bitpack_uint(values->swizzle, 0, 11) |
            util_bitpack_uint(values->texel_interleave, 12, 12) |
            util_bitpack_uint(values->levels - 1, 16, 20) |
            util_bitpack_uint(values->minimum_level, 24, 28);
   cl[ 3] = util_bitpack_ufixed_clamp(values->minimum_lod, 0, 12, 8) |
            util_bitpack_uint(util_logbase2(values->sample_count), 13, 15) |
            util_bitpack_ufixed_clamp(values->maximum_lod, 16, 28, 8);
   cl[ 4] = util_bitpack_uint(values->surfaces, 0, 63);
   cl[ 5] = util_bitpack_uint(values->surfaces, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->array_size - 1, 0, 15);
   cl[ 7] = util_bitpack_uint(values->depth - 1, 0, 15);
}


#define MALI_TEXTURE_LENGTH 32
#define MALI_TEXTURE_ALIGN 32
struct mali_texture_packed { uint32_t opaque[8]; };
static inline void
MALI_TEXTURE_unpack(const uint8_t * restrict cl,
                    struct MALI_TEXTURE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xc0) fprintf(stderr, "XXX: Invalid field of Texture unpacked at word 0\n");
   if (((const uint32_t *) cl)[2] & 0xe0e0e000) fprintf(stderr, "XXX: Invalid field of Texture unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xe0000000) fprintf(stderr, "XXX: Invalid field of Texture unpacked at word 3\n");
   if (((const uint32_t *) cl)[6] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Texture unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Texture unpacked at word 7\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->dimension = (enum mali_texture_dimension)__gen_unpack_uint(cl, 4, 5);
   values->sample_corner_position = __gen_unpack_uint(cl, 8, 8);
   values->normalize_coordinates = __gen_unpack_uint(cl, 9, 9);
   values->format = __gen_unpack_uint(cl, 10, 31);
   values->width = __gen_unpack_uint(cl, 32, 47) + 1;
   values->height = __gen_unpack_uint(cl, 48, 63) + 1;
   values->swizzle = __gen_unpack_uint(cl, 64, 75);
   values->texel_interleave = __gen_unpack_uint(cl, 76, 76);
   values->levels = __gen_unpack_uint(cl, 80, 84) + 1;
   values->minimum_level = __gen_unpack_uint(cl, 88, 92);
   values->minimum_lod = __gen_unpack_ulod(cl, 96, 108);
   values->sample_count = 1U << __gen_unpack_uint(cl, 109, 111);
   values->maximum_lod = __gen_unpack_ulod(cl, 112, 124);
   values->surfaces = __gen_unpack_uint(cl, 128, 191);
   values->array_size = __gen_unpack_uint(cl, 192, 207) + 1;
   values->depth = __gen_unpack_uint(cl, 224, 239) + 1;
}

static inline void
MALI_TEXTURE_print(FILE *fp, const struct MALI_TEXTURE * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sDimension: %s\n", indent, "", mali_texture_dimension_as_str(values->dimension));
   fprintf(fp, "%*sSample corner position: %s\n", indent, "", values->sample_corner_position ? "true" : "false");
   fprintf(fp, "%*sNormalize coordinates: %s\n", indent, "", values->normalize_coordinates ? "true" : "false");
   mali_pixel_format_print(fp, values->format);
   fprintf(fp, "%*sWidth: %u\n", indent, "", values->width);
   fprintf(fp, "%*sHeight: %u\n", indent, "", values->height);
   fprintf(fp, "%*sSwizzle: %u\n", indent, "", values->swizzle);
   fprintf(fp, "%*sTexel interleave: %s\n", indent, "", values->texel_interleave ? "true" : "false");
   fprintf(fp, "%*sLevels: %u\n", indent, "", values->levels);
   fprintf(fp, "%*sMinimum level: %u\n", indent, "", values->minimum_level);
   fprintf(fp, "%*sMinimum LOD: %f\n", indent, "", values->minimum_lod);
   fprintf(fp, "%*sSample count: %u\n", indent, "", values->sample_count);
   fprintf(fp, "%*sMaximum LOD: %f\n", indent, "", values->maximum_lod);
   fprintf(fp, "%*sSurfaces: 0x%" PRIx64 "\n", indent, "", values->surfaces);
   fprintf(fp, "%*sArray size: %u\n", indent, "", values->array_size);
   fprintf(fp, "%*sDepth: %u\n", indent, "", values->depth);
}

enum mali_shader_register_allocation {
        MALI_SHADER_REGISTER_ALLOCATION_64_PER_THREAD =      0,
        MALI_SHADER_REGISTER_ALLOCATION_32_PER_THREAD =      2,
};

static inline const char *
mali_shader_register_allocation_as_str(enum mali_shader_register_allocation imm)
{
    switch (imm) {
    case MALI_SHADER_REGISTER_ALLOCATION_64_PER_THREAD: return "64 Per Thread";
    case MALI_SHADER_REGISTER_ALLOCATION_32_PER_THREAD: return "32 Per Thread";
    default: return "XXX: INVALID";
    }
}

enum mali_flush_to_zero_mode {
        MALI_FLUSH_TO_ZERO_MODE_PRESERVE_SUBNORMALS =      0,
        MALI_FLUSH_TO_ZERO_MODE_DX11         =      1,
        MALI_FLUSH_TO_ZERO_MODE_ALWAYS       =      2,
        MALI_FLUSH_TO_ZERO_MODE_ABRUPT       =      3,
};

static inline const char *
mali_flush_to_zero_mode_as_str(enum mali_flush_to_zero_mode imm)
{
    switch (imm) {
    case MALI_FLUSH_TO_ZERO_MODE_PRESERVE_SUBNORMALS: return "Preserve subnormals";
    case MALI_FLUSH_TO_ZERO_MODE_DX11: return "DX11";
    case MALI_FLUSH_TO_ZERO_MODE_ALWAYS: return "Always";
    case MALI_FLUSH_TO_ZERO_MODE_ABRUPT: return "Abrupt";
    default: return "XXX: INVALID";
    }
}

struct MALI_PRELOAD {
   uint32_t                             r48_r63;
   bool                                 r55;
   bool                                 r56;
   bool                                 r57;
   bool                                 r58;
   bool                                 r59;
   bool                                 r60;
   bool                                 r61;
   bool                                 r62;
   bool                                 r63;
};

#define MALI_PRELOAD_header                     \
   0

static ALWAYS_INLINE void
MALI_PRELOAD_pack(uint32_t * restrict cl,
                  const struct MALI_PRELOAD * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->r48_r63, 0, 15) |
            util_bitpack_uint(values->r55, 7, 7) |
            util_bitpack_uint(values->r56, 8, 8) |
            util_bitpack_uint(values->r57, 9, 9) |
            util_bitpack_uint(values->r58, 10, 10) |
            util_bitpack_uint(values->r59, 11, 11) |
            util_bitpack_uint(values->r60, 12, 12) |
            util_bitpack_uint(values->r61, 13, 13) |
            util_bitpack_uint(values->r62, 14, 14) |
            util_bitpack_uint(values->r63, 15, 15);
}


#define MALI_PRELOAD_LENGTH 4
struct mali_preload_packed { uint32_t opaque[1]; };
static inline void
MALI_PRELOAD_unpack(const uint8_t * restrict cl,
                    struct MALI_PRELOAD * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Preload unpacked at word 0\n");
   values->r48_r63 = __gen_unpack_uint(cl, 0, 15);
   values->r55 = __gen_unpack_uint(cl, 7, 7);
   values->r56 = __gen_unpack_uint(cl, 8, 8);
   values->r57 = __gen_unpack_uint(cl, 9, 9);
   values->r58 = __gen_unpack_uint(cl, 10, 10);
   values->r59 = __gen_unpack_uint(cl, 11, 11);
   values->r60 = __gen_unpack_uint(cl, 12, 12);
   values->r61 = __gen_unpack_uint(cl, 13, 13);
   values->r62 = __gen_unpack_uint(cl, 14, 14);
   values->r63 = __gen_unpack_uint(cl, 15, 15);
}

static inline void
MALI_PRELOAD_print(FILE *fp, const struct MALI_PRELOAD * values, unsigned indent)
{
   fprintf(fp, "%*sR48-R63: 0x%x\n", indent, "", values->r48_r63);
   fprintf(fp, "%*sR55: %s\n", indent, "", values->r55 ? "true" : "false");
   fprintf(fp, "%*sR56: %s\n", indent, "", values->r56 ? "true" : "false");
   fprintf(fp, "%*sR57: %s\n", indent, "", values->r57 ? "true" : "false");
   fprintf(fp, "%*sR58: %s\n", indent, "", values->r58 ? "true" : "false");
   fprintf(fp, "%*sR59: %s\n", indent, "", values->r59 ? "true" : "false");
   fprintf(fp, "%*sR60: %s\n", indent, "", values->r60 ? "true" : "false");
   fprintf(fp, "%*sR61: %s\n", indent, "", values->r61 ? "true" : "false");
   fprintf(fp, "%*sR62: %s\n", indent, "", values->r62 ? "true" : "false");
   fprintf(fp, "%*sR63: %s\n", indent, "", values->r63 ? "true" : "false");
}

enum mali_coverage_bitmask_type {
        MALI_COVERAGE_BITMASK_TYPE_DX        =      0,
        MALI_COVERAGE_BITMASK_TYPE_GL        =      1,
};

static inline const char *
mali_coverage_bitmask_type_as_str(enum mali_coverage_bitmask_type imm)
{
    switch (imm) {
    case MALI_COVERAGE_BITMASK_TYPE_DX: return "DX";
    case MALI_COVERAGE_BITMASK_TYPE_GL: return "GL";
    default: return "XXX: INVALID";
    }
}

enum mali_warp_limit {
        MALI_WARP_LIMIT_FULL                 =      0,
        MALI_WARP_LIMIT_HALF                 =      1,
        MALI_WARP_LIMIT_ONE_QUARTER          =      2,
        MALI_WARP_LIMIT_ONE_HEIGHT           =      3,
};

static inline const char *
mali_warp_limit_as_str(enum mali_warp_limit imm)
{
    switch (imm) {
    case MALI_WARP_LIMIT_FULL: return "Full";
    case MALI_WARP_LIMIT_HALF: return "Half";
    case MALI_WARP_LIMIT_ONE_QUARTER: return "One-quarter";
    case MALI_WARP_LIMIT_ONE_HEIGHT: return "One-height";
    default: return "XXX: INVALID";
    }
}

struct MALI_SHADER_PROGRAM {
   enum mali_descriptor_type            type;
   enum mali_shader_stage               stage;
   enum mali_coverage_bitmask_type      fragment_coverage_bitmask_type;
   enum mali_warp_limit                 vertex_warp_limit;
   bool                                 suppress_nan;
   enum mali_flush_to_zero_mode         flush_to_zero_mode;
   bool                                 suppress_inf;
   bool                                 requires_helper_threads;
   bool                                 shader_contains_jump_ex;
   enum mali_shader_register_allocation register_allocation;
   struct MALI_PRELOAD                  preload;
   uint64_t                             binary;
};

#define MALI_SHADER_PROGRAM_header              \
   .type = MALI_DESCRIPTOR_TYPE_SHADER,  \
   .preload = { MALI_PRELOAD_header }

static ALWAYS_INLINE void
MALI_SHADER_PROGRAM_pack(uint32_t * restrict cl,
                         const struct MALI_SHADER_PROGRAM * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->stage, 4, 7) |
            util_bitpack_uint(values->fragment_coverage_bitmask_type, 8, 8) |
            util_bitpack_uint(values->vertex_warp_limit, 8, 9) |
            util_bitpack_uint(values->suppress_nan, 16, 16) |
            util_bitpack_uint(values->flush_to_zero_mode, 17, 18) |
            util_bitpack_uint(values->suppress_inf, 19, 19) |
            util_bitpack_uint(values->requires_helper_threads, 28, 28) |
            util_bitpack_uint(values->shader_contains_jump_ex, 29, 29) |
            util_bitpack_uint(values->register_allocation, 30, 31);
   cl[ 1] = util_bitpack_uint(values->preload.r48_r63, 0, 15) |
            util_bitpack_uint(values->preload.r55, 7, 7) |
            util_bitpack_uint(values->preload.r56, 8, 8) |
            util_bitpack_uint(values->preload.r57, 9, 9) |
            util_bitpack_uint(values->preload.r58, 10, 10) |
            util_bitpack_uint(values->preload.r59, 11, 11) |
            util_bitpack_uint(values->preload.r60, 12, 12) |
            util_bitpack_uint(values->preload.r61, 13, 13) |
            util_bitpack_uint(values->preload.r62, 14, 14) |
            util_bitpack_uint(values->preload.r63, 15, 15);
   cl[ 2] = util_bitpack_uint(values->binary, 0, 63);
   cl[ 3] = util_bitpack_uint(values->binary, 0, 63) >> 32;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_SHADER_PROGRAM_LENGTH 32
#define MALI_SHADER_PROGRAM_ALIGN 32
struct mali_shader_program_packed { uint32_t opaque[8]; };
static inline void
MALI_SHADER_PROGRAM_unpack(const uint8_t * restrict cl,
                           struct MALI_SHADER_PROGRAM * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff0fc00) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 1\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Program unpacked at word 7\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->stage = (enum mali_shader_stage)__gen_unpack_uint(cl, 4, 7);
   values->fragment_coverage_bitmask_type = (enum mali_coverage_bitmask_type)__gen_unpack_uint(cl, 8, 8);
   values->vertex_warp_limit = (enum mali_warp_limit)__gen_unpack_uint(cl, 8, 9);
   values->suppress_nan = __gen_unpack_uint(cl, 16, 16);
   values->flush_to_zero_mode = (enum mali_flush_to_zero_mode)__gen_unpack_uint(cl, 17, 18);
   values->suppress_inf = __gen_unpack_uint(cl, 19, 19);
   values->requires_helper_threads = __gen_unpack_uint(cl, 28, 28);
   values->shader_contains_jump_ex = __gen_unpack_uint(cl, 29, 29);
   values->register_allocation = (enum mali_shader_register_allocation)__gen_unpack_uint(cl, 30, 31);
   values->preload.r48_r63 = __gen_unpack_uint(cl, 32, 47);
   values->preload.r55 = __gen_unpack_uint(cl, 39, 39);
   values->preload.r56 = __gen_unpack_uint(cl, 40, 40);
   values->preload.r57 = __gen_unpack_uint(cl, 41, 41);
   values->preload.r58 = __gen_unpack_uint(cl, 42, 42);
   values->preload.r59 = __gen_unpack_uint(cl, 43, 43);
   values->preload.r60 = __gen_unpack_uint(cl, 44, 44);
   values->preload.r61 = __gen_unpack_uint(cl, 45, 45);
   values->preload.r62 = __gen_unpack_uint(cl, 46, 46);
   values->preload.r63 = __gen_unpack_uint(cl, 47, 47);
   values->binary = __gen_unpack_uint(cl, 64, 127);
}

static inline void
MALI_SHADER_PROGRAM_print(FILE *fp, const struct MALI_SHADER_PROGRAM * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sStage: %s\n", indent, "", mali_shader_stage_as_str(values->stage));
   fprintf(fp, "%*sFragment coverage bitmask type: %s\n", indent, "", mali_coverage_bitmask_type_as_str(values->fragment_coverage_bitmask_type));
   fprintf(fp, "%*sVertex warp limit: %s\n", indent, "", mali_warp_limit_as_str(values->vertex_warp_limit));
   fprintf(fp, "%*sSuppress NaN: %s\n", indent, "", values->suppress_nan ? "true" : "false");
   fprintf(fp, "%*sFlush to zero mode: %s\n", indent, "", mali_flush_to_zero_mode_as_str(values->flush_to_zero_mode));
   fprintf(fp, "%*sSuppress Inf: %s\n", indent, "", values->suppress_inf ? "true" : "false");
   fprintf(fp, "%*sRequires helper threads: %s\n", indent, "", values->requires_helper_threads ? "true" : "false");
   fprintf(fp, "%*sShader contains JUMP_EX: %s\n", indent, "", values->shader_contains_jump_ex ? "true" : "false");
   fprintf(fp, "%*sRegister allocation: %s\n", indent, "", mali_shader_register_allocation_as_str(values->register_allocation));
   fprintf(fp, "%*sPreload:\n", indent, "");
   MALI_PRELOAD_print(fp, &values->preload, indent + 2);
   fprintf(fp, "%*sBinary: 0x%" PRIx64 "\n", indent, "", values->binary);
}

struct MALI_SCISSOR {
   uint32_t                             scissor_minimum_x;
   uint32_t                             scissor_minimum_y;
   uint32_t                             scissor_maximum_x;
   uint32_t                             scissor_maximum_y;
};

#define MALI_SCISSOR_header                     \
   0

static ALWAYS_INLINE void
MALI_SCISSOR_pack(uint32_t * restrict cl,
                  const struct MALI_SCISSOR * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->scissor_minimum_x, 0, 15) |
            util_bitpack_uint(values->scissor_minimum_y, 16, 31);
   cl[ 1] = util_bitpack_uint(values->scissor_maximum_x, 0, 15) |
            util_bitpack_uint(values->scissor_maximum_y, 16, 31);
}


#define MALI_SCISSOR_LENGTH 8
struct mali_scissor_packed { uint32_t opaque[2]; };
static inline void
MALI_SCISSOR_unpack(const uint8_t * restrict cl,
                    struct MALI_SCISSOR * restrict values)
{
   values->scissor_minimum_x = __gen_unpack_uint(cl, 0, 15);
   values->scissor_minimum_y = __gen_unpack_uint(cl, 16, 31);
   values->scissor_maximum_x = __gen_unpack_uint(cl, 32, 47);
   values->scissor_maximum_y = __gen_unpack_uint(cl, 48, 63);
}

static inline void
MALI_SCISSOR_print(FILE *fp, const struct MALI_SCISSOR * values, unsigned indent)
{
   fprintf(fp, "%*sScissor Minimum X: %u\n", indent, "", values->scissor_minimum_x);
   fprintf(fp, "%*sScissor Minimum Y: %u\n", indent, "", values->scissor_minimum_y);
   fprintf(fp, "%*sScissor Maximum X: %u\n", indent, "", values->scissor_maximum_x);
   fprintf(fp, "%*sScissor Maximum Y: %u\n", indent, "", values->scissor_maximum_y);
}

struct MALI_LOCAL_STORAGE {
   uint32_t                             tls_size;
   uint32_t                             wls_instances;
#define MALI_LOCAL_STORAGE_NO_WORKGROUP_MEM      2147483648
   uint32_t                             wls_size_base;
   uint32_t                             wls_size_scale;
   uint64_t                             tls_base_pointer;
   enum mali_address_mode               tls_address_mode;
   uint64_t                             wls_base_pointer;
};

#define MALI_LOCAL_STORAGE_header               \
   .wls_instances = MALI_LOCAL_STORAGE_NO_WORKGROUP_MEM

static ALWAYS_INLINE void
MALI_LOCAL_STORAGE_pack(uint32_t * restrict cl,
                        const struct MALI_LOCAL_STORAGE * restrict values)
{
   assert(IS_POT_NONZERO(values->wls_instances));
   cl[ 0] = util_bitpack_uint(values->tls_size, 0, 4);
   cl[ 1] = util_bitpack_uint(util_logbase2(values->wls_instances), 0, 4) |
            util_bitpack_uint(values->wls_size_base, 5, 6) |
            util_bitpack_uint(values->wls_size_scale, 8, 12);
   cl[ 2] = util_bitpack_uint(values->tls_base_pointer, 0, 47);
   cl[ 3] = util_bitpack_uint(values->tls_base_pointer, 0, 47) >> 32 |
            util_bitpack_uint(values->tls_address_mode, 28, 31);
   cl[ 4] = util_bitpack_uint(values->wls_base_pointer, 0, 63);
   cl[ 5] = util_bitpack_uint(values->wls_base_pointer, 0, 63) >> 32;
   cl[ 6] = 0;
   cl[ 7] = 0;
}


#define MALI_LOCAL_STORAGE_LENGTH 32
#define MALI_LOCAL_STORAGE_ALIGN 64
struct mali_local_storage_packed { uint32_t opaque[8]; };
static inline void
MALI_LOCAL_STORAGE_unpack(const uint8_t * restrict cl,
                          struct MALI_LOCAL_STORAGE * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffe0) fprintf(stderr, "XXX: Invalid field of Local Storage unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffe080) fprintf(stderr, "XXX: Invalid field of Local Storage unpacked at word 1\n");
   if (((const uint32_t *) cl)[3] & 0xfff0000) fprintf(stderr, "XXX: Invalid field of Local Storage unpacked at word 3\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Local Storage unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Local Storage unpacked at word 7\n");
   values->tls_size = __gen_unpack_uint(cl, 0, 4);
   values->wls_instances = 1U << __gen_unpack_uint(cl, 32, 36);
   values->wls_size_base = __gen_unpack_uint(cl, 37, 38);
   values->wls_size_scale = __gen_unpack_uint(cl, 40, 44);
   values->tls_base_pointer = __gen_unpack_uint(cl, 64, 111);
   values->tls_address_mode = (enum mali_address_mode)__gen_unpack_uint(cl, 124, 127);
   values->wls_base_pointer = __gen_unpack_uint(cl, 128, 191);
}

static inline void
MALI_LOCAL_STORAGE_print(FILE *fp, const struct MALI_LOCAL_STORAGE * values, unsigned indent)
{
   fprintf(fp, "%*sTLS Size: %u\n", indent, "", values->tls_size);
   fprintf(fp, "%*sWLS Instances: %u\n", indent, "", values->wls_instances);
   fprintf(fp, "%*sWLS Size Base: %u\n", indent, "", values->wls_size_base);
   fprintf(fp, "%*sWLS Size Scale: %u\n", indent, "", values->wls_size_scale);
   fprintf(fp, "%*sTLS Base Pointer: 0x%" PRIx64 "\n", indent, "", values->tls_base_pointer);
   fprintf(fp, "%*sTLS Address Mode: %s\n", indent, "", mali_address_mode_as_str(values->tls_address_mode));
   fprintf(fp, "%*sWLS Base Pointer: 0x%" PRIx64 "\n", indent, "", values->wls_base_pointer);
}

enum mali_color_buffer_internal_format {
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW_VALUE =      0,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R8G8B8A8 =      1,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R10G10B10A2 =      2,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R8G8B8A2 =      3,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R4G4B4A4 =      4,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R5G6B5A0 =      5,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_R5G5B5A1 =      6,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW8 =     32,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW16 =     33,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW32 =     34,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW64 =     35,
        MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW128 =     36,
};

static inline const char *
mali_color_buffer_internal_format_as_str(enum mali_color_buffer_internal_format imm)
{
    switch (imm) {
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW_VALUE: return "Raw Value";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R8G8B8A8: return "R8G8B8A8";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R10G10B10A2: return "R10G10B10A2";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R8G8B8A2: return "R8G8B8A2";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R4G4B4A4: return "R4G4B4A4";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R5G6B5A0: return "R5G6B5A0";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_R5G5B5A1: return "R5G5B5A1";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW8: return "RAW8";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW16: return "RAW16";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW32: return "RAW32";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW64: return "RAW64";
    case MALI_COLOR_BUFFER_INTERNAL_FORMAT_RAW128: return "RAW128";
    default: return "XXX: INVALID";
    }
}

enum mali_color_format {
        MALI_COLOR_FORMAT_RAW8               =      0,
        MALI_COLOR_FORMAT_RAW16              =      1,
        MALI_COLOR_FORMAT_RAW24              =      2,
        MALI_COLOR_FORMAT_RAW32              =      3,
        MALI_COLOR_FORMAT_RAW48              =      4,
        MALI_COLOR_FORMAT_RAW64              =      5,
        MALI_COLOR_FORMAT_RAW96              =      6,
        MALI_COLOR_FORMAT_RAW128             =      7,
        MALI_COLOR_FORMAT_RAW192             =      8,
        MALI_COLOR_FORMAT_RAW256             =      9,
        MALI_COLOR_FORMAT_RAW384             =     10,
        MALI_COLOR_FORMAT_RAW512             =     11,
        MALI_COLOR_FORMAT_RAW768             =     12,
        MALI_COLOR_FORMAT_RAW1024            =     13,
        MALI_COLOR_FORMAT_RAW1536            =     14,
        MALI_COLOR_FORMAT_RAW2048            =     15,
        MALI_COLOR_FORMAT_R8                 =     16,
        MALI_COLOR_FORMAT_R8G8               =     17,
        MALI_COLOR_FORMAT_R8G8B8             =     18,
        MALI_COLOR_FORMAT_R8G8B8A8           =     19,
        MALI_COLOR_FORMAT_R4G4B4A4           =     20,
        MALI_COLOR_FORMAT_R5G6B5             =     21,
        MALI_COLOR_FORMAT_R8G8B8_FROM_R8G8B8A2 =     22,
        MALI_COLOR_FORMAT_R10G10B10A2        =     24,
        MALI_COLOR_FORMAT_A2B10G10R10        =     25,
        MALI_COLOR_FORMAT_R5G5B5A1           =     28,
        MALI_COLOR_FORMAT_A1B5G5R5           =     29,
        MALI_COLOR_FORMAT_NATIVE             =     31,
};

static inline const char *
mali_color_format_as_str(enum mali_color_format imm)
{
    switch (imm) {
    case MALI_COLOR_FORMAT_RAW8: return "RAW8";
    case MALI_COLOR_FORMAT_RAW16: return "RAW16";
    case MALI_COLOR_FORMAT_RAW24: return "RAW24";
    case MALI_COLOR_FORMAT_RAW32: return "RAW32";
    case MALI_COLOR_FORMAT_RAW48: return "RAW48";
    case MALI_COLOR_FORMAT_RAW64: return "RAW64";
    case MALI_COLOR_FORMAT_RAW96: return "RAW96";
    case MALI_COLOR_FORMAT_RAW128: return "RAW128";
    case MALI_COLOR_FORMAT_RAW192: return "RAW192";
    case MALI_COLOR_FORMAT_RAW256: return "RAW256";
    case MALI_COLOR_FORMAT_RAW384: return "RAW384";
    case MALI_COLOR_FORMAT_RAW512: return "RAW512";
    case MALI_COLOR_FORMAT_RAW768: return "RAW768";
    case MALI_COLOR_FORMAT_RAW1024: return "RAW1024";
    case MALI_COLOR_FORMAT_RAW1536: return "RAW1536";
    case MALI_COLOR_FORMAT_RAW2048: return "RAW2048";
    case MALI_COLOR_FORMAT_R8: return "R8";
    case MALI_COLOR_FORMAT_R8G8: return "R8G8";
    case MALI_COLOR_FORMAT_R8G8B8: return "R8G8B8";
    case MALI_COLOR_FORMAT_R8G8B8A8: return "R8G8B8A8";
    case MALI_COLOR_FORMAT_R4G4B4A4: return "R4G4B4A4";
    case MALI_COLOR_FORMAT_R5G6B5: return "R5G6B5";
    case MALI_COLOR_FORMAT_R8G8B8_FROM_R8G8B8A2: return "R8G8B8_FROM_R8G8B8A2";
    case MALI_COLOR_FORMAT_R10G10B10A2: return "R10G10B10A2";
    case MALI_COLOR_FORMAT_A2B10G10R10: return "A2B10G10R10";
    case MALI_COLOR_FORMAT_R5G5B5A1: return "R5G5B5A1";
    case MALI_COLOR_FORMAT_A1B5G5R5: return "A1B5G5R5";
    case MALI_COLOR_FORMAT_NATIVE: return "NATIVE";
    default: return "XXX: INVALID";
    }
}

enum mali_downsampling_accumulation_mode {
        MALI_DOWNSAMPLING_ACCUMULATION_MODE_UNSIGNED_NORMALIZED_INTEGER =      0,
        MALI_DOWNSAMPLING_ACCUMULATION_MODE_SIGNED_NORMALIZED_INTEGER =      1,
};

static inline const char *
mali_downsampling_accumulation_mode_as_str(enum mali_downsampling_accumulation_mode imm)
{
    switch (imm) {
    case MALI_DOWNSAMPLING_ACCUMULATION_MODE_UNSIGNED_NORMALIZED_INTEGER: return "Unsigned normalized integer";
    case MALI_DOWNSAMPLING_ACCUMULATION_MODE_SIGNED_NORMALIZED_INTEGER: return "Signed normalized integer";
    default: return "XXX: INVALID";
    }
}

enum mali_sample_layout {
        MALI_SAMPLE_LAYOUT_ORDERED_4X_GRID   =      0,
        MALI_SAMPLE_LAYOUT_ROTATED_4X_GRID   =      1,
        MALI_SAMPLE_LAYOUT_D3D_8X_GRID       =      2,
        MALI_SAMPLE_LAYOUT_D3D_16X_GRID      =      3,
};

static inline const char *
mali_sample_layout_as_str(enum mali_sample_layout imm)
{
    switch (imm) {
    case MALI_SAMPLE_LAYOUT_ORDERED_4X_GRID: return "Ordered 4x Grid";
    case MALI_SAMPLE_LAYOUT_ROTATED_4X_GRID: return "Rotated 4x Grid";
    case MALI_SAMPLE_LAYOUT_D3D_8X_GRID: return "D3D 8x Grid";
    case MALI_SAMPLE_LAYOUT_D3D_16X_GRID: return "D3D 16x Grid";
    default: return "XXX: INVALID";
    }
}

enum mali_zs_format {
        MALI_ZS_FORMAT_D16                   =      1,
        MALI_ZS_FORMAT_D24                   =      2,
        MALI_ZS_FORMAT_D24X8                 =      4,
        MALI_ZS_FORMAT_D24S8                 =      5,
        MALI_ZS_FORMAT_D32                   =     14,
};

static inline const char *
mali_zs_format_as_str(enum mali_zs_format imm)
{
    switch (imm) {
    case MALI_ZS_FORMAT_D16: return "D16";
    case MALI_ZS_FORMAT_D24: return "D24";
    case MALI_ZS_FORMAT_D24X8: return "D24X8";
    case MALI_ZS_FORMAT_D24S8: return "D24S8";
    case MALI_ZS_FORMAT_D32: return "D32";
    default: return "XXX: INVALID";
    }
}

enum mali_zs_preload_format {
        MALI_ZS_PRELOAD_FORMAT_D32_S8X24     =      4,
};

static inline const char *
mali_zs_preload_format_as_str(enum mali_zs_preload_format imm)
{
    switch (imm) {
    case MALI_ZS_PRELOAD_FORMAT_D32_S8X24: return "D32_S8X24";
    default: return "XXX: INVALID";
    }
}

enum mali_s_format {
        MALI_S_FORMAT_S8                     =      1,
        MALI_S_FORMAT_X24S8                  =      4,
};

static inline const char *
mali_s_format_as_str(enum mali_s_format imm)
{
    switch (imm) {
    case MALI_S_FORMAT_S8: return "S8";
    case MALI_S_FORMAT_X24S8: return "X24S8";
    default: return "XXX: INVALID";
    }
}

enum mali_tie_break_rule {
        MALI_TIE_BREAK_RULE_0_IN_180_OUT     =      0,
        MALI_TIE_BREAK_RULE_0_OUT_180_IN     =      1,
        MALI_TIE_BREAK_RULE_MINUS_180_IN_0_OUT =      2,
        MALI_TIE_BREAK_RULE_MINUS_180_OUT_0_IN =      3,
        MALI_TIE_BREAK_RULE_90_IN_270_OUT    =      4,
        MALI_TIE_BREAK_RULE_90_OUT_270_IN    =      5,
        MALI_TIE_BREAK_RULE_MINUS_90_IN_90_OUT =      6,
        MALI_TIE_BREAK_RULE_MINUS_90_OUT_90_IN =      7,
};

static inline const char *
mali_tie_break_rule_as_str(enum mali_tie_break_rule imm)
{
    switch (imm) {
    case MALI_TIE_BREAK_RULE_0_IN_180_OUT: return "0_IN_180_OUT";
    case MALI_TIE_BREAK_RULE_0_OUT_180_IN: return "0_OUT_180_IN";
    case MALI_TIE_BREAK_RULE_MINUS_180_IN_0_OUT: return "MINUS_180_IN_0_OUT";
    case MALI_TIE_BREAK_RULE_MINUS_180_OUT_0_IN: return "MINUS_180_OUT_0_IN";
    case MALI_TIE_BREAK_RULE_90_IN_270_OUT: return "90_IN_270_OUT";
    case MALI_TIE_BREAK_RULE_90_OUT_270_IN: return "90_OUT_270_IN";
    case MALI_TIE_BREAK_RULE_MINUS_90_IN_90_OUT: return "MINUS_90_IN_90_OUT";
    case MALI_TIE_BREAK_RULE_MINUS_90_OUT_90_IN: return "MINUS_90_OUT_90_IN";
    default: return "XXX: INVALID";
    }
}

struct MALI_RT_BUFFER {
   uint64_t                             base;
   uint32_t                             row_stride;
   uint32_t                             surface_stride;
};

#define MALI_RT_BUFFER_header                   \
   0

static ALWAYS_INLINE void
MALI_RT_BUFFER_pack(uint32_t * restrict cl,
                    const struct MALI_RT_BUFFER * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->base, 0, 63);
   cl[ 1] = util_bitpack_uint(values->base, 0, 63) >> 32;
   cl[ 2] = util_bitpack_uint(values->row_stride, 0, 31);
   cl[ 3] = util_bitpack_uint(values->surface_stride, 0, 31);
}


#define MALI_RT_BUFFER_LENGTH 16
struct mali_rt_buffer_packed { uint32_t opaque[4]; };
static inline void
MALI_RT_BUFFER_unpack(const uint8_t * restrict cl,
                      struct MALI_RT_BUFFER * restrict values)
{
   values->base = __gen_unpack_uint(cl, 0, 63);
   values->row_stride = __gen_unpack_uint(cl, 64, 95);
   values->surface_stride = __gen_unpack_uint(cl, 96, 127);
}

static inline void
MALI_RT_BUFFER_print(FILE *fp, const struct MALI_RT_BUFFER * values, unsigned indent)
{
   fprintf(fp, "%*sBase: 0x%" PRIx64 "\n", indent, "", values->base);
   fprintf(fp, "%*sRow Stride: %u\n", indent, "", values->row_stride);
   fprintf(fp, "%*sSurface Stride: %u\n", indent, "", values->surface_stride);
}

enum mali_sample_pattern {
        MALI_SAMPLE_PATTERN_SINGLE_SAMPLED   =      0,
        MALI_SAMPLE_PATTERN_ORDERED_4X_GRID  =      1,
        MALI_SAMPLE_PATTERN_ROTATED_4X_GRID  =      2,
        MALI_SAMPLE_PATTERN_D3D_8X_GRID      =      3,
        MALI_SAMPLE_PATTERN_D3D_16X_GRID     =      4,
};

static inline const char *
mali_sample_pattern_as_str(enum mali_sample_pattern imm)
{
    switch (imm) {
    case MALI_SAMPLE_PATTERN_SINGLE_SAMPLED: return "Single-sampled";
    case MALI_SAMPLE_PATTERN_ORDERED_4X_GRID: return "Ordered 4x Grid";
    case MALI_SAMPLE_PATTERN_ROTATED_4X_GRID: return "Rotated 4x Grid";
    case MALI_SAMPLE_PATTERN_D3D_8X_GRID: return "D3D 8x Grid";
    case MALI_SAMPLE_PATTERN_D3D_16X_GRID: return "D3D 16x Grid";
    default: return "XXX: INVALID";
    }
}

enum mali_z_internal_format {
        MALI_Z_INTERNAL_FORMAT_D16           =      0,
        MALI_Z_INTERNAL_FORMAT_D24           =      1,
        MALI_Z_INTERNAL_FORMAT_D32           =      2,
};

static inline const char *
mali_z_internal_format_as_str(enum mali_z_internal_format imm)
{
    switch (imm) {
    case MALI_Z_INTERNAL_FORMAT_D16: return "D16";
    case MALI_Z_INTERNAL_FORMAT_D24: return "D24";
    case MALI_Z_INTERNAL_FORMAT_D32: return "D32";
    default: return "XXX: INVALID";
    }
}

enum mali_pre_post_frame_shader_mode {
        MALI_PRE_POST_FRAME_SHADER_MODE_NEVER =      0,
        MALI_PRE_POST_FRAME_SHADER_MODE_ALWAYS =      1,
        MALI_PRE_POST_FRAME_SHADER_MODE_INTERSECT =      2,
        MALI_PRE_POST_FRAME_SHADER_MODE_EARLY_ZS_ALWAYS =      3,
};

static inline const char *
mali_pre_post_frame_shader_mode_as_str(enum mali_pre_post_frame_shader_mode imm)
{
    switch (imm) {
    case MALI_PRE_POST_FRAME_SHADER_MODE_NEVER: return "Never";
    case MALI_PRE_POST_FRAME_SHADER_MODE_ALWAYS: return "Always";
    case MALI_PRE_POST_FRAME_SHADER_MODE_INTERSECT: return "Intersect";
    case MALI_PRE_POST_FRAME_SHADER_MODE_EARLY_ZS_ALWAYS: return "Early ZS always";
    default: return "XXX: INVALID";
    }
}

enum mali_downscale {
        MALI_DOWNSCALE_NONE                  =      0,
        MALI_DOWNSCALE_2X                    =      1,
        MALI_DOWNSCALE_4X                    =      2,
};

static inline const char *
mali_downscale_as_str(enum mali_downscale imm)
{
    switch (imm) {
    case MALI_DOWNSCALE_NONE: return "None";
    case MALI_DOWNSCALE_2X: return "2x";
    case MALI_DOWNSCALE_4X: return "4x";
    default: return "XXX: INVALID";
    }
}

struct MALI_FRAMEBUFFER_PARAMETERS {
   enum mali_pre_post_frame_shader_mode pre_frame_0;
   enum mali_pre_post_frame_shader_mode pre_frame_1;
   enum mali_pre_post_frame_shader_mode post_frame;
   enum mali_downscale                  downscale_geometry;
   uint32_t                             internal_layer_index;
   uint64_t                             frame_argument;
   uint64_t                             sample_locations;
   uint64_t                             frame_shader_dcds;
   uint32_t                             width;
   uint32_t                             height;
   uint32_t                             bound_min_x;
   uint32_t                             bound_min_y;
   uint32_t                             bound_max_x;
   uint32_t                             bound_max_y;
   uint32_t                             sample_count;
   enum mali_sample_pattern             sample_pattern;
   enum mali_tie_break_rule             tie_break_rule;
   uint32_t                             effective_tile_size;
   bool                                 first_provoking_vertex;
   bool                                 point_sprite_coord_origin_max_y;
   bool                                 blend_suppress_inf;
   bool                                 blend_suppress_nan;
   bool                                 blend_suppress_denorm;
   uint32_t                             render_target_count;
   uint32_t                             color_buffer_allocation;
   uint32_t                             s_clear;
   bool                                 s_write_enable;
   bool                                 s_preload_enable;
   bool                                 s_unload_enable;
   enum mali_z_internal_format          z_internal_format;
   bool                                 z_write_enable;
   bool                                 z_preload_enable;
   bool                                 z_unload_enable;
   bool                                 has_zs_crc_extension;
   bool                                 empty_tile_read_enable;
   bool                                 empty_tile_write_enable;
   bool                                 crc_read_enable;
   bool                                 crc_write_enable;
   float                                z_clear;
   uint64_t                             tiler;
};

#define MALI_FRAMEBUFFER_PARAMETERS_header      \
   .sample_count = 1,  \
   .point_sprite_coord_origin_max_y = true

static ALWAYS_INLINE void
MALI_FRAMEBUFFER_PARAMETERS_pack(uint32_t * restrict cl,
                                 const struct MALI_FRAMEBUFFER_PARAMETERS * restrict values)
{
   assert(values->width >= 1);
   assert(values->height >= 1);
   assert(IS_POT_NONZERO(values->sample_count));
   assert(IS_POT_NONZERO(values->effective_tile_size));
   assert(values->render_target_count >= 1);
   assert((values->color_buffer_allocation & 0x3ff) == 0);
   cl[ 0] = util_bitpack_uint(values->pre_frame_0, 0, 2) |
            util_bitpack_uint(values->pre_frame_1, 3, 5) |
            util_bitpack_uint(values->post_frame, 6, 8) |
            util_bitpack_uint(values->downscale_geometry, 9, 10) |
            util_bitpack_uint(values->internal_layer_index, 24, 31);
   cl[ 1] = 0;
   cl[ 2] = util_bitpack_uint(values->frame_argument, 0, 63);
   cl[ 3] = util_bitpack_uint(values->frame_argument, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->sample_locations, 0, 63);
   cl[ 5] = util_bitpack_uint(values->sample_locations, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->frame_shader_dcds, 0, 63);
   cl[ 7] = util_bitpack_uint(values->frame_shader_dcds, 0, 63) >> 32;
   cl[ 8] = util_bitpack_uint(values->width - 1, 0, 15) |
            util_bitpack_uint(values->height - 1, 16, 31);
   cl[ 9] = util_bitpack_uint(values->bound_min_x, 0, 15) |
            util_bitpack_uint(values->bound_min_y, 16, 31);
   cl[10] = util_bitpack_uint(values->bound_max_x, 0, 15) |
            util_bitpack_uint(values->bound_max_y, 16, 31);
   cl[11] = util_bitpack_uint(util_logbase2(values->sample_count), 0, 2) |
            util_bitpack_uint(values->sample_pattern, 3, 5) |
            util_bitpack_uint(values->tie_break_rule, 6, 8) |
            util_bitpack_uint(util_logbase2(values->effective_tile_size), 9, 12) |
            util_bitpack_uint(values->first_provoking_vertex, 14, 14) |
            util_bitpack_uint(values->point_sprite_coord_origin_max_y, 15, 15) |
            util_bitpack_uint(values->blend_suppress_inf, 16, 16) |
            util_bitpack_uint(values->blend_suppress_nan, 17, 17) |
            util_bitpack_uint(values->blend_suppress_denorm, 18, 18) |
            util_bitpack_uint(values->render_target_count - 1, 19, 22) |
            util_bitpack_uint(values->color_buffer_allocation >> 10, 24, 31);
   cl[12] = util_bitpack_uint(values->s_clear, 0, 7) |
            util_bitpack_uint(values->s_write_enable, 8, 8) |
            util_bitpack_uint(values->s_preload_enable, 9, 9) |
            util_bitpack_uint(values->s_unload_enable, 10, 10) |
            util_bitpack_uint(values->z_internal_format, 16, 17) |
            util_bitpack_uint(values->z_write_enable, 18, 18) |
            util_bitpack_uint(values->z_preload_enable, 19, 19) |
            util_bitpack_uint(values->z_unload_enable, 20, 20) |
            util_bitpack_uint(values->has_zs_crc_extension, 21, 21) |
            util_bitpack_uint(values->empty_tile_read_enable, 28, 28) |
            util_bitpack_uint(values->empty_tile_write_enable, 29, 29) |
            util_bitpack_uint(values->crc_read_enable, 30, 30) |
            util_bitpack_uint(values->crc_write_enable, 31, 31);
   cl[13] = util_bitpack_float(values->z_clear);
   cl[14] = util_bitpack_uint(values->tiler, 0, 63);
   cl[15] = util_bitpack_uint(values->tiler, 0, 63) >> 32;
}


#define MALI_FRAMEBUFFER_PARAMETERS_LENGTH 64
#define MALI_FRAMEBUFFER_PARAMETERS_ALIGN 64
struct mali_framebuffer_parameters_packed { uint32_t opaque[16]; };
static inline void
MALI_FRAMEBUFFER_PARAMETERS_unpack(const uint8_t * restrict cl,
                                   struct MALI_FRAMEBUFFER_PARAMETERS * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfff800) fprintf(stderr, "XXX: Invalid field of Framebuffer Parameters unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Parameters unpacked at word 1\n");
   if (((const uint32_t *) cl)[11] & 0x802000) fprintf(stderr, "XXX: Invalid field of Framebuffer Parameters unpacked at word 11\n");
   if (((const uint32_t *) cl)[12] & 0xfc0f800) fprintf(stderr, "XXX: Invalid field of Framebuffer Parameters unpacked at word 12\n");
   values->pre_frame_0 = (enum mali_pre_post_frame_shader_mode)__gen_unpack_uint(cl, 0, 2);
   values->pre_frame_1 = (enum mali_pre_post_frame_shader_mode)__gen_unpack_uint(cl, 3, 5);
   values->post_frame = (enum mali_pre_post_frame_shader_mode)__gen_unpack_uint(cl, 6, 8);
   values->downscale_geometry = (enum mali_downscale)__gen_unpack_uint(cl, 9, 10);
   values->internal_layer_index = __gen_unpack_uint(cl, 24, 31);
   values->frame_argument = __gen_unpack_uint(cl, 64, 127);
   values->sample_locations = __gen_unpack_uint(cl, 128, 191);
   values->frame_shader_dcds = __gen_unpack_uint(cl, 192, 255);
   values->width = __gen_unpack_uint(cl, 256, 271) + 1;
   values->height = __gen_unpack_uint(cl, 272, 287) + 1;
   values->bound_min_x = __gen_unpack_uint(cl, 288, 303);
   values->bound_min_y = __gen_unpack_uint(cl, 304, 319);
   values->bound_max_x = __gen_unpack_uint(cl, 320, 335);
   values->bound_max_y = __gen_unpack_uint(cl, 336, 351);
   values->sample_count = 1U << __gen_unpack_uint(cl, 352, 354);
   values->sample_pattern = (enum mali_sample_pattern)__gen_unpack_uint(cl, 355, 357);
   values->tie_break_rule = (enum mali_tie_break_rule)__gen_unpack_uint(cl, 358, 360);
   values->effective_tile_size = 1U << __gen_unpack_uint(cl, 361, 364);
   values->first_provoking_vertex = __gen_unpack_uint(cl, 366, 366);
   values->point_sprite_coord_origin_max_y = __gen_unpack_uint(cl, 367, 367);
   values->blend_suppress_inf = __gen_unpack_uint(cl, 368, 368);
   values->blend_suppress_nan = __gen_unpack_uint(cl, 369, 369);
   values->blend_suppress_denorm = __gen_unpack_uint(cl, 370, 370);
   values->render_target_count = __gen_unpack_uint(cl, 371, 374) + 1;
   values->color_buffer_allocation = __gen_unpack_uint(cl, 376, 383) << 10;
   values->s_clear = __gen_unpack_uint(cl, 384, 391);
   values->s_write_enable = __gen_unpack_uint(cl, 392, 392);
   values->s_preload_enable = __gen_unpack_uint(cl, 393, 393);
   values->s_unload_enable = __gen_unpack_uint(cl, 394, 394);
   values->z_internal_format = (enum mali_z_internal_format)__gen_unpack_uint(cl, 400, 401);
   values->z_write_enable = __gen_unpack_uint(cl, 402, 402);
   values->z_preload_enable = __gen_unpack_uint(cl, 403, 403);
   values->z_unload_enable = __gen_unpack_uint(cl, 404, 404);
   values->has_zs_crc_extension = __gen_unpack_uint(cl, 405, 405);
   values->empty_tile_read_enable = __gen_unpack_uint(cl, 412, 412);
   values->empty_tile_write_enable = __gen_unpack_uint(cl, 413, 413);
   values->crc_read_enable = __gen_unpack_uint(cl, 414, 414);
   values->crc_write_enable = __gen_unpack_uint(cl, 415, 415);
   values->z_clear = __gen_unpack_float(cl, 416, 447);
   values->tiler = __gen_unpack_uint(cl, 448, 511);
}

static inline void
MALI_FRAMEBUFFER_PARAMETERS_print(FILE *fp, const struct MALI_FRAMEBUFFER_PARAMETERS * values, unsigned indent)
{
   fprintf(fp, "%*sPre Frame 0: %s\n", indent, "", mali_pre_post_frame_shader_mode_as_str(values->pre_frame_0));
   fprintf(fp, "%*sPre Frame 1: %s\n", indent, "", mali_pre_post_frame_shader_mode_as_str(values->pre_frame_1));
   fprintf(fp, "%*sPost Frame: %s\n", indent, "", mali_pre_post_frame_shader_mode_as_str(values->post_frame));
   fprintf(fp, "%*sDownscale geometry: %s\n", indent, "", mali_downscale_as_str(values->downscale_geometry));
   fprintf(fp, "%*sInternal layer index: %u\n", indent, "", values->internal_layer_index);
   fprintf(fp, "%*sFrame argument: 0x%" PRIx64 "\n", indent, "", values->frame_argument);
   fprintf(fp, "%*sSample Locations: 0x%" PRIx64 "\n", indent, "", values->sample_locations);
   fprintf(fp, "%*sFrame Shader DCDs: 0x%" PRIx64 "\n", indent, "", values->frame_shader_dcds);
   fprintf(fp, "%*sWidth: %u\n", indent, "", values->width);
   fprintf(fp, "%*sHeight: %u\n", indent, "", values->height);
   fprintf(fp, "%*sBound Min X: %u\n", indent, "", values->bound_min_x);
   fprintf(fp, "%*sBound Min Y: %u\n", indent, "", values->bound_min_y);
   fprintf(fp, "%*sBound Max X: %u\n", indent, "", values->bound_max_x);
   fprintf(fp, "%*sBound Max Y: %u\n", indent, "", values->bound_max_y);
   fprintf(fp, "%*sSample Count: %u\n", indent, "", values->sample_count);
   fprintf(fp, "%*sSample Pattern: %s\n", indent, "", mali_sample_pattern_as_str(values->sample_pattern));
   fprintf(fp, "%*sTie-Break Rule: %s\n", indent, "", mali_tie_break_rule_as_str(values->tie_break_rule));
   fprintf(fp, "%*sEffective Tile Size: %u\n", indent, "", values->effective_tile_size);
   fprintf(fp, "%*sFirst provoking vertex: %s\n", indent, "", values->first_provoking_vertex ? "true" : "false");
   fprintf(fp, "%*sPoint sprite coord origin max Y: %s\n", indent, "", values->point_sprite_coord_origin_max_y ? "true" : "false");
   fprintf(fp, "%*sBlend suppress Inf: %s\n", indent, "", values->blend_suppress_inf ? "true" : "false");
   fprintf(fp, "%*sBlend suppress NaN: %s\n", indent, "", values->blend_suppress_nan ? "true" : "false");
   fprintf(fp, "%*sBlend suppress denorm: %s\n", indent, "", values->blend_suppress_denorm ? "true" : "false");
   fprintf(fp, "%*sRender Target Count: %u\n", indent, "", values->render_target_count);
   fprintf(fp, "%*sColor Buffer Allocation: %u\n", indent, "", values->color_buffer_allocation);
   fprintf(fp, "%*sS Clear: %u\n", indent, "", values->s_clear);
   fprintf(fp, "%*sS Write Enable: %s\n", indent, "", values->s_write_enable ? "true" : "false");
   fprintf(fp, "%*sS Preload Enable: %s\n", indent, "", values->s_preload_enable ? "true" : "false");
   fprintf(fp, "%*sS Unload Enable: %s\n", indent, "", values->s_unload_enable ? "true" : "false");
   fprintf(fp, "%*sZ Internal Format: %s\n", indent, "", mali_z_internal_format_as_str(values->z_internal_format));
   fprintf(fp, "%*sZ Write Enable: %s\n", indent, "", values->z_write_enable ? "true" : "false");
   fprintf(fp, "%*sZ Preload Enable: %s\n", indent, "", values->z_preload_enable ? "true" : "false");
   fprintf(fp, "%*sZ Unload Enable: %s\n", indent, "", values->z_unload_enable ? "true" : "false");
   fprintf(fp, "%*sHas ZS CRC Extension: %s\n", indent, "", values->has_zs_crc_extension ? "true" : "false");
   fprintf(fp, "%*sEmpty Tile Read Enable: %s\n", indent, "", values->empty_tile_read_enable ? "true" : "false");
   fprintf(fp, "%*sEmpty Tile Write Enable: %s\n", indent, "", values->empty_tile_write_enable ? "true" : "false");
   fprintf(fp, "%*sCRC Read Enable: %s\n", indent, "", values->crc_read_enable ? "true" : "false");
   fprintf(fp, "%*sCRC Write Enable: %s\n", indent, "", values->crc_write_enable ? "true" : "false");
   fprintf(fp, "%*sZ Clear: %f\n", indent, "", values->z_clear);
   fprintf(fp, "%*sTiler: 0x%" PRIx64 "\n", indent, "", values->tiler);
}

struct MALI_ZS_CRC_EXTENSION {
   enum mali_zs_format                  zs_write_format;
   enum mali_block_format               zs_block_format;
   enum mali_msaa                       zs_msaa;
   uint32_t                             crc_render_target;
   enum mali_s_format                   s_write_format;
   enum mali_block_format               s_block_format;
   enum mali_msaa                       s_msaa;
   bool                                 afbc_reverse_issue_order;
   bool                                 zs_clean_pixel_write_enable;
   uint32_t                             crc_row_stride;
   uint64_t                             crc_clear_color;
   uint64_t                             crc_base;
   uint64_t                             zs_writeback_base;
   uint32_t                             zs_writeback_row_stride;
   uint32_t                             zs_writeback_surface_stride;
   uint32_t                             zs_afbc_body_offset;
   uint64_t                             s_writeback_base;
   uint32_t                             s_writeback_row_stride;
   uint32_t                             s_writeback_surface_stride;
   uint32_t                             s_afbc_body_offset;
};

#define MALI_ZS_CRC_EXTENSION_header            \
   .zs_msaa = MALI_MSAA_SINGLE,  \
   .s_msaa = MALI_MSAA_SINGLE

static ALWAYS_INLINE void
MALI_ZS_CRC_EXTENSION_pack(uint32_t * restrict cl,
                           const struct MALI_ZS_CRC_EXTENSION * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->zs_write_format, 0, 3) |
            util_bitpack_uint(values->zs_block_format, 4, 7) |
            util_bitpack_uint(values->zs_msaa, 8, 9) |
            util_bitpack_uint(values->crc_render_target, 13, 16) |
            util_bitpack_uint(values->s_write_format, 16, 19) |
            util_bitpack_uint(values->s_block_format, 20, 23) |
            util_bitpack_uint(values->s_msaa, 24, 25) |
            util_bitpack_uint(values->afbc_reverse_issue_order, 30, 30) |
            util_bitpack_uint(values->zs_clean_pixel_write_enable, 31, 31);
   cl[ 1] = util_bitpack_uint(values->crc_row_stride, 0, 31);
   cl[ 2] = util_bitpack_uint(values->crc_clear_color, 0, 63);
   cl[ 3] = util_bitpack_uint(values->crc_clear_color, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->crc_base, 0, 63);
   cl[ 5] = util_bitpack_uint(values->crc_base, 0, 63) >> 32;
   cl[ 6] = 0;
   cl[ 7] = 0;
   cl[ 8] = util_bitpack_uint(values->zs_writeback_base, 0, 63);
   cl[ 9] = util_bitpack_uint(values->zs_writeback_base, 0, 63) >> 32;
   cl[10] = util_bitpack_uint(values->zs_writeback_row_stride, 0, 31);
   cl[11] = util_bitpack_uint(values->zs_writeback_surface_stride, 0, 31) |
            util_bitpack_uint(values->zs_afbc_body_offset, 0, 31);
   cl[12] = util_bitpack_uint(values->s_writeback_base, 0, 63);
   cl[13] = util_bitpack_uint(values->s_writeback_base, 0, 63) >> 32;
   cl[14] = util_bitpack_uint(values->s_writeback_row_stride, 0, 31);
   cl[15] = util_bitpack_uint(values->s_writeback_surface_stride, 0, 31) |
            util_bitpack_uint(values->s_afbc_body_offset, 0, 31);
}


#define MALI_ZS_CRC_EXTENSION_LENGTH 64
#define MALI_ZS_CRC_EXTENSION_ALIGN 64
struct mali_zs_crc_extension_packed { uint32_t opaque[16]; };
static inline void
MALI_ZS_CRC_EXTENSION_unpack(const uint8_t * restrict cl,
                             struct MALI_ZS_CRC_EXTENSION * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x3c001c00) fprintf(stderr, "XXX: Invalid field of ZS CRC Extension unpacked at word 0\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of ZS CRC Extension unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of ZS CRC Extension unpacked at word 7\n");
   values->zs_write_format = (enum mali_zs_format)__gen_unpack_uint(cl, 0, 3);
   values->zs_block_format = (enum mali_block_format)__gen_unpack_uint(cl, 4, 7);
   values->zs_msaa = (enum mali_msaa)__gen_unpack_uint(cl, 8, 9);
   values->crc_render_target = __gen_unpack_uint(cl, 13, 16);
   values->s_write_format = (enum mali_s_format)__gen_unpack_uint(cl, 16, 19);
   values->s_block_format = (enum mali_block_format)__gen_unpack_uint(cl, 20, 23);
   values->s_msaa = (enum mali_msaa)__gen_unpack_uint(cl, 24, 25);
   values->afbc_reverse_issue_order = __gen_unpack_uint(cl, 30, 30);
   values->zs_clean_pixel_write_enable = __gen_unpack_uint(cl, 31, 31);
   values->crc_row_stride = __gen_unpack_uint(cl, 32, 63);
   values->crc_clear_color = __gen_unpack_uint(cl, 64, 127);
   values->crc_base = __gen_unpack_uint(cl, 128, 191);
   values->zs_writeback_base = __gen_unpack_uint(cl, 256, 319);
   values->zs_writeback_row_stride = __gen_unpack_uint(cl, 320, 351);
   values->zs_writeback_surface_stride = __gen_unpack_uint(cl, 352, 383);
   values->zs_afbc_body_offset = __gen_unpack_uint(cl, 352, 383);
   values->s_writeback_base = __gen_unpack_uint(cl, 384, 447);
   values->s_writeback_row_stride = __gen_unpack_uint(cl, 448, 479);
   values->s_writeback_surface_stride = __gen_unpack_uint(cl, 480, 511);
   values->s_afbc_body_offset = __gen_unpack_uint(cl, 480, 511);
}

static inline void
MALI_ZS_CRC_EXTENSION_print(FILE *fp, const struct MALI_ZS_CRC_EXTENSION * values, unsigned indent)
{
   fprintf(fp, "%*sZS Write Format: %s\n", indent, "", mali_zs_format_as_str(values->zs_write_format));
   fprintf(fp, "%*sZS Block Format: %s\n", indent, "", mali_block_format_as_str(values->zs_block_format));
   fprintf(fp, "%*sZS MSAA: %s\n", indent, "", mali_msaa_as_str(values->zs_msaa));
   fprintf(fp, "%*sCRC Render Target: %u\n", indent, "", values->crc_render_target);
   fprintf(fp, "%*sS Write Format: %s\n", indent, "", mali_s_format_as_str(values->s_write_format));
   fprintf(fp, "%*sS Block Format: %s\n", indent, "", mali_block_format_as_str(values->s_block_format));
   fprintf(fp, "%*sS MSAA: %s\n", indent, "", mali_msaa_as_str(values->s_msaa));
   fprintf(fp, "%*sAFBC Reverse Issue Order: %s\n", indent, "", values->afbc_reverse_issue_order ? "true" : "false");
   fprintf(fp, "%*sZS Clean Pixel Write Enable: %s\n", indent, "", values->zs_clean_pixel_write_enable ? "true" : "false");
   fprintf(fp, "%*sCRC Row Stride: %u\n", indent, "", values->crc_row_stride);
   fprintf(fp, "%*sCRC Clear Color: 0x%" PRIx64 "\n", indent, "", values->crc_clear_color);
   fprintf(fp, "%*sCRC Base: 0x%" PRIx64 "\n", indent, "", values->crc_base);
   fprintf(fp, "%*sZS Writeback Base: 0x%" PRIx64 "\n", indent, "", values->zs_writeback_base);
   fprintf(fp, "%*sZS Writeback Row Stride: %u\n", indent, "", values->zs_writeback_row_stride);
   fprintf(fp, "%*sZS Writeback Surface Stride: %u\n", indent, "", values->zs_writeback_surface_stride);
   fprintf(fp, "%*sZS AFBC Body Offset: %u\n", indent, "", values->zs_afbc_body_offset);
   fprintf(fp, "%*sS Writeback Base: 0x%" PRIx64 "\n", indent, "", values->s_writeback_base);
   fprintf(fp, "%*sS Writeback Row Stride: %u\n", indent, "", values->s_writeback_row_stride);
   fprintf(fp, "%*sS Writeback Surface Stride: %u\n", indent, "", values->s_writeback_surface_stride);
   fprintf(fp, "%*sS AFBC Body Offset: %u\n", indent, "", values->s_afbc_body_offset);
}

enum mali_yuv_conv_k6 {
        MALI_YUV_CONV_K6_0                   =      0,
        MALI_YUV_CONV_K6_16                  =      1,
};

static inline const char *
mali_yuv_conv_k6_as_str(enum mali_yuv_conv_k6 imm)
{
    switch (imm) {
    case MALI_YUV_CONV_K6_0: return "0";
    case MALI_YUV_CONV_K6_16: return "16";
    default: return "XXX: INVALID";
    }
}

enum mali_yuv_conv_k7_clamp {
        MALI_YUV_CONV_K7_CLAMP_MINUS_128_TO_127 =      0,
        MALI_YUV_CONV_K7_CLAMP_MINUS_112_TO_111 =      1,
        MALI_YUV_CONV_K7_CLAMP_0_TO_255      =      2,
        MALI_YUV_CONV_K7_CLAMP_16_TO_239     =      3,
};

static inline const char *
mali_yuv_conv_k7_clamp_as_str(enum mali_yuv_conv_k7_clamp imm)
{
    switch (imm) {
    case MALI_YUV_CONV_K7_CLAMP_MINUS_128_TO_127: return "MINUS_128_TO_127";
    case MALI_YUV_CONV_K7_CLAMP_MINUS_112_TO_111: return "MINUS_112_TO_111";
    case MALI_YUV_CONV_K7_CLAMP_0_TO_255: return "0_TO_255";
    case MALI_YUV_CONV_K7_CLAMP_16_TO_239: return "16_TO_239";
    default: return "XXX: INVALID";
    }
}

enum mali_yuv_conv_k8 {
        MALI_YUV_CONV_K8_220                 =      0,
        MALI_YUV_CONV_K8_256                 =      1,
};

static inline const char *
mali_yuv_conv_k8_as_str(enum mali_yuv_conv_k8 imm)
{
    switch (imm) {
    case MALI_YUV_CONV_K8_220: return "220";
    case MALI_YUV_CONV_K8_256: return "256";
    default: return "XXX: INVALID";
    }
}

struct MALI_RENDER_TARGET_YUV_OVERLAY {
   enum mali_yuv_swizzle                swizzle;
   bool                                 full_range;
   enum mali_yuv_conversion_mode        conversion_mode;
   enum mali_yuv_cr_siting              cr_siting;
   bool                                 unsigned_cr_range;
   uint64_t                             plane_0_base;
   uint64_t                             plane_1_base;
   uint64_t                             plane_2_base;
   uint32_t                             plane_0_stride;
   uint32_t                             plane_1_2_stride;
};

#define MALI_RENDER_TARGET_YUV_OVERLAY_header   \
   0

static ALWAYS_INLINE void
MALI_RENDER_TARGET_YUV_OVERLAY_pack(uint32_t * restrict cl,
                                    const struct MALI_RENDER_TARGET_YUV_OVERLAY * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = 0;
   cl[ 2] = util_bitpack_uint(values->swizzle, 16, 18) |
            util_bitpack_uint(values->full_range, 20, 20) |
            util_bitpack_uint(values->conversion_mode, 21, 24) |
            util_bitpack_uint(values->cr_siting, 25, 27) |
            util_bitpack_uint(values->unsigned_cr_range, 28, 28);
   cl[ 3] = 0;
   cl[ 4] = util_bitpack_uint(values->plane_0_base, 0, 63);
   cl[ 5] = util_bitpack_uint(values->plane_0_base, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->plane_1_base, 0, 63);
   cl[ 7] = util_bitpack_uint(values->plane_1_base, 0, 63) >> 32;
   cl[ 8] = util_bitpack_uint(values->plane_2_base, 0, 63);
   cl[ 9] = util_bitpack_uint(values->plane_2_base, 0, 63) >> 32;
   cl[10] = util_bitpack_uint(values->plane_0_stride, 0, 31);
   cl[11] = util_bitpack_uint(values->plane_1_2_stride, 0, 31);
   cl[12] = 0;
   cl[13] = 0;
   cl[14] = 0;
   cl[15] = 0;
}


#define MALI_RENDER_TARGET_YUV_OVERLAY_LENGTH 64
struct mali_render_target_yuv_overlay_packed { uint32_t opaque[16]; };
static inline void
MALI_RENDER_TARGET_YUV_OVERLAY_unpack(const uint8_t * restrict cl,
                                      struct MALI_RENDER_TARGET_YUV_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xe008ffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[12] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 12\n");
   if (((const uint32_t *) cl)[13] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 13\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target YUV Overlay unpacked at word 15\n");
   values->swizzle = (enum mali_yuv_swizzle)__gen_unpack_uint(cl, 80, 82);
   values->full_range = __gen_unpack_uint(cl, 84, 84);
   values->conversion_mode = (enum mali_yuv_conversion_mode)__gen_unpack_uint(cl, 85, 88);
   values->cr_siting = (enum mali_yuv_cr_siting)__gen_unpack_uint(cl, 89, 91);
   values->unsigned_cr_range = __gen_unpack_uint(cl, 92, 92);
   values->plane_0_base = __gen_unpack_uint(cl, 128, 191);
   values->plane_1_base = __gen_unpack_uint(cl, 192, 255);
   values->plane_2_base = __gen_unpack_uint(cl, 256, 319);
   values->plane_0_stride = __gen_unpack_uint(cl, 320, 351);
   values->plane_1_2_stride = __gen_unpack_uint(cl, 352, 383);
}

static inline void
MALI_RENDER_TARGET_YUV_OVERLAY_print(FILE *fp, const struct MALI_RENDER_TARGET_YUV_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sSwizzle: %s\n", indent, "", mali_yuv_swizzle_as_str(values->swizzle));
   fprintf(fp, "%*sFull Range: %s\n", indent, "", values->full_range ? "true" : "false");
   fprintf(fp, "%*sConversion Mode: %s\n", indent, "", mali_yuv_conversion_mode_as_str(values->conversion_mode));
   fprintf(fp, "%*sCr Siting: %s\n", indent, "", mali_yuv_cr_siting_as_str(values->cr_siting));
   fprintf(fp, "%*sUnsigned Cr Range: %s\n", indent, "", values->unsigned_cr_range ? "true" : "false");
   fprintf(fp, "%*sPlane 0 Base: 0x%" PRIx64 "\n", indent, "", values->plane_0_base);
   fprintf(fp, "%*sPlane 1 Base: 0x%" PRIx64 "\n", indent, "", values->plane_1_base);
   fprintf(fp, "%*sPlane 2 Base: 0x%" PRIx64 "\n", indent, "", values->plane_2_base);
   fprintf(fp, "%*sPlane 0 Stride: %u\n", indent, "", values->plane_0_stride);
   fprintf(fp, "%*sPlane 1 2 Stride: %u\n", indent, "", values->plane_1_2_stride);
}

struct MALI_RENDER_TARGET_AFBC_OVERLAY {
   bool                                 yuv_transform;
   bool                                 split_block;
   bool                                 wide_block;
   bool                                 reverse_issue_order;
   bool                                 front_buffer;
   bool                                 alpha_hint;
   enum mali_afbc_compression_mode      compression_mode;
   uint64_t                             header;
   uint32_t                             row_stride;
   uint32_t                             body_offset;
};

#define MALI_RENDER_TARGET_AFBC_OVERLAY_header  \
   0

static ALWAYS_INLINE void
MALI_RENDER_TARGET_AFBC_OVERLAY_pack(uint32_t * restrict cl,
                                     const struct MALI_RENDER_TARGET_AFBC_OVERLAY * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = 0;
   cl[ 2] = util_bitpack_uint(values->yuv_transform, 0, 0) |
            util_bitpack_uint(values->split_block, 1, 1) |
            util_bitpack_uint(values->wide_block, 2, 2) |
            util_bitpack_uint(values->reverse_issue_order, 3, 3) |
            util_bitpack_uint(values->front_buffer, 4, 4) |
            util_bitpack_uint(values->alpha_hint, 5, 5) |
            util_bitpack_uint(values->compression_mode, 10, 15);
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
   cl[ 8] = util_bitpack_uint(values->header, 0, 63);
   cl[ 9] = util_bitpack_uint(values->header, 0, 63) >> 32;
   cl[10] = util_bitpack_uint(values->row_stride, 0, 31);
   cl[11] = util_bitpack_uint(values->body_offset, 0, 31);
   cl[12] = 0;
   cl[13] = 0;
   cl[14] = 0;
   cl[15] = 0;
}


#define MALI_RENDER_TARGET_AFBC_OVERLAY_LENGTH 64
struct mali_render_target_afbc_overlay_packed { uint32_t opaque[16]; };
static inline void
MALI_RENDER_TARGET_AFBC_OVERLAY_unpack(const uint8_t * restrict cl,
                                       struct MALI_RENDER_TARGET_AFBC_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffff03c0) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 7\n");
   if (((const uint32_t *) cl)[12] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 12\n");
   if (((const uint32_t *) cl)[13] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 13\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFBC Overlay unpacked at word 15\n");
   values->yuv_transform = __gen_unpack_uint(cl, 64, 64);
   values->split_block = __gen_unpack_uint(cl, 65, 65);
   values->wide_block = __gen_unpack_uint(cl, 66, 66);
   values->reverse_issue_order = __gen_unpack_uint(cl, 67, 67);
   values->front_buffer = __gen_unpack_uint(cl, 68, 68);
   values->alpha_hint = __gen_unpack_uint(cl, 69, 69);
   values->compression_mode = (enum mali_afbc_compression_mode)__gen_unpack_uint(cl, 74, 79);
   values->header = __gen_unpack_uint(cl, 256, 319);
   values->row_stride = __gen_unpack_uint(cl, 320, 351);
   values->body_offset = __gen_unpack_uint(cl, 352, 383);
}

static inline void
MALI_RENDER_TARGET_AFBC_OVERLAY_print(FILE *fp, const struct MALI_RENDER_TARGET_AFBC_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sYUV Transform: %s\n", indent, "", values->yuv_transform ? "true" : "false");
   fprintf(fp, "%*sSplit block: %s\n", indent, "", values->split_block ? "true" : "false");
   fprintf(fp, "%*sWide block: %s\n", indent, "", values->wide_block ? "true" : "false");
   fprintf(fp, "%*sReverse issue order: %s\n", indent, "", values->reverse_issue_order ? "true" : "false");
   fprintf(fp, "%*sFront buffer: %s\n", indent, "", values->front_buffer ? "true" : "false");
   fprintf(fp, "%*sAlpha hint: %s\n", indent, "", values->alpha_hint ? "true" : "false");
   fprintf(fp, "%*sCompression mode: %s\n", indent, "", mali_afbc_compression_mode_as_str(values->compression_mode));
   fprintf(fp, "%*sHeader: 0x%" PRIx64 "\n", indent, "", values->header);
   fprintf(fp, "%*sRow stride: %u\n", indent, "", values->row_stride);
   fprintf(fp, "%*sBody offset: %u\n", indent, "", values->body_offset);
}

struct MALI_RENDER_TARGET_AFRC_OVERLAY {
   enum mali_color_format               writeback_format;
   enum mali_afrc_block_size            block_size;
   enum mali_afrc_format                format;
};

#define MALI_RENDER_TARGET_AFRC_OVERLAY_header  \
   0

static ALWAYS_INLINE void
MALI_RENDER_TARGET_AFRC_OVERLAY_pack(uint32_t * restrict cl,
                                     const struct MALI_RENDER_TARGET_AFRC_OVERLAY * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = util_bitpack_uint(values->writeback_format, 0, 7);
   cl[ 2] = util_bitpack_uint(values->block_size, 4, 7) |
            util_bitpack_uint(values->format, 8, 15);
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
   cl[ 8] = 0;
   cl[ 9] = 0;
   cl[10] = 0;
   cl[11] = 0;
   cl[12] = 0;
   cl[13] = 0;
   cl[14] = 0;
   cl[15] = 0;
}


#define MALI_RENDER_TARGET_AFRC_OVERLAY_LENGTH 64
struct mali_render_target_afrc_overlay_packed { uint32_t opaque[16]; };
static inline void
MALI_RENDER_TARGET_AFRC_OVERLAY_unpack(const uint8_t * restrict cl,
                                       struct MALI_RENDER_TARGET_AFRC_OVERLAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffff000f) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 7\n");
   if (((const uint32_t *) cl)[8] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 8\n");
   if (((const uint32_t *) cl)[9] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 9\n");
   if (((const uint32_t *) cl)[10] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 10\n");
   if (((const uint32_t *) cl)[11] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 11\n");
   if (((const uint32_t *) cl)[12] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 12\n");
   if (((const uint32_t *) cl)[13] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 13\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target AFRC Overlay unpacked at word 15\n");
   values->writeback_format = (enum mali_color_format)__gen_unpack_uint(cl, 32, 39);
   values->block_size = (enum mali_afrc_block_size)__gen_unpack_uint(cl, 68, 71);
   values->format = (enum mali_afrc_format)__gen_unpack_uint(cl, 72, 79);
}

static inline void
MALI_RENDER_TARGET_AFRC_OVERLAY_print(FILE *fp, const struct MALI_RENDER_TARGET_AFRC_OVERLAY * values, unsigned indent)
{
   fprintf(fp, "%*sWriteback Format: %s\n", indent, "", mali_color_format_as_str(values->writeback_format));
   fprintf(fp, "%*sBlock Size: %s\n", indent, "", mali_afrc_block_size_as_str(values->block_size));
   fprintf(fp, "%*sFormat: %s\n", indent, "", mali_afrc_format_as_str(values->format));
}

struct MALI_RT_CLEAR {
   uint32_t                             color_0;
   uint32_t                             color_1;
   uint32_t                             color_2;
   uint32_t                             color_3;
};

#define MALI_RT_CLEAR_header                    \
   0

static ALWAYS_INLINE void
MALI_RT_CLEAR_pack(uint32_t * restrict cl,
                   const struct MALI_RT_CLEAR * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->color_0, 0, 31);
   cl[ 1] = util_bitpack_uint(values->color_1, 0, 31);
   cl[ 2] = util_bitpack_uint(values->color_2, 0, 31);
   cl[ 3] = util_bitpack_uint(values->color_3, 0, 31);
}


#define MALI_RT_CLEAR_LENGTH 16
struct mali_rt_clear_packed { uint32_t opaque[4]; };
static inline void
MALI_RT_CLEAR_unpack(const uint8_t * restrict cl,
                     struct MALI_RT_CLEAR * restrict values)
{
   values->color_0 = __gen_unpack_uint(cl, 0, 31);
   values->color_1 = __gen_unpack_uint(cl, 32, 63);
   values->color_2 = __gen_unpack_uint(cl, 64, 95);
   values->color_3 = __gen_unpack_uint(cl, 96, 127);
}

static inline void
MALI_RT_CLEAR_print(FILE *fp, const struct MALI_RT_CLEAR * values, unsigned indent)
{
   fprintf(fp, "%*sColor 0: %u\n", indent, "", values->color_0);
   fprintf(fp, "%*sColor 1: %u\n", indent, "", values->color_1);
   fprintf(fp, "%*sColor 2: %u\n", indent, "", values->color_2);
   fprintf(fp, "%*sColor 3: %u\n", indent, "", values->color_3);
}

struct MALI_RENDER_TARGET {
   struct MALI_RENDER_TARGET_YUV_OVERLAY yuv;
   struct MALI_RENDER_TARGET_AFBC_OVERLAY afbc;
   struct MALI_RENDER_TARGET_AFRC_OVERLAY afrc;
   enum mali_writeback_mode             writeback_mode;
   uint32_t                             internal_buffer_offset;
   bool                                 yuv_enable;
   bool                                 dithered_clear;
   enum mali_color_buffer_internal_format internal_format;
   bool                                 write_enable;
   enum mali_color_format               writeback_format;
   enum mali_block_format               writeback_block_format;
   enum mali_msaa                       writeback_msaa;
   bool                                 srgb;
   bool                                 dithering_enable;
   uint32_t                             swizzle;
   bool                                 clean_pixel_write_enable;
   struct MALI_RT_BUFFER                rgb;
   struct MALI_RT_CLEAR                 clear;
};

#define MALI_RENDER_TARGET_header               \
   .yuv = { MALI_RENDER_TARGET_YUV_OVERLAY_header },  \
   .afbc = { MALI_RENDER_TARGET_AFBC_OVERLAY_header },  \
   .afrc = { MALI_RENDER_TARGET_AFRC_OVERLAY_header },  \
   .writeback_mode = MALI_WRITEBACK_MODE_COMPAT,  \
   .rgb = { MALI_RT_BUFFER_header },  \
   .clear = { MALI_RT_CLEAR_header }

static ALWAYS_INLINE void
MALI_RENDER_TARGET_pack(uint32_t * restrict cl,
                        const struct MALI_RENDER_TARGET * restrict values)
{
   assert((values->internal_buffer_offset & 0xf) == 0);
   cl[ 0] = util_bitpack_uint(values->writeback_mode, 0, 3) |
            util_bitpack_uint(values->internal_buffer_offset >> 4, 4, 15) |
            util_bitpack_uint(values->yuv_enable, 24, 24) |
            util_bitpack_uint(values->dithered_clear, 25, 25) |
            util_bitpack_uint(values->internal_format, 26, 31);
   cl[ 1] = util_bitpack_uint(values->afrc.writeback_format, 0, 7) |
            util_bitpack_uint(values->write_enable, 0, 0) |
            util_bitpack_uint(values->writeback_format, 3, 7) |
            util_bitpack_uint(values->writeback_block_format, 8, 11) |
            util_bitpack_uint(values->writeback_msaa, 12, 13) |
            util_bitpack_uint(values->srgb, 14, 14) |
            util_bitpack_uint(values->dithering_enable, 15, 15) |
            util_bitpack_uint(values->swizzle, 16, 27) |
            util_bitpack_uint(values->clean_pixel_write_enable, 31, 31);
   cl[ 2] = util_bitpack_uint(values->yuv.swizzle, 16, 18) |
            util_bitpack_uint(values->yuv.full_range, 20, 20) |
            util_bitpack_uint(values->yuv.conversion_mode, 21, 24) |
            util_bitpack_uint(values->yuv.cr_siting, 25, 27) |
            util_bitpack_uint(values->yuv.unsigned_cr_range, 28, 28) |
            util_bitpack_uint(values->afbc.yuv_transform, 0, 0) |
            util_bitpack_uint(values->afbc.split_block, 1, 1) |
            util_bitpack_uint(values->afbc.wide_block, 2, 2) |
            util_bitpack_uint(values->afbc.reverse_issue_order, 3, 3) |
            util_bitpack_uint(values->afbc.front_buffer, 4, 4) |
            util_bitpack_uint(values->afbc.alpha_hint, 5, 5) |
            util_bitpack_uint(values->afbc.compression_mode, 10, 15) |
            util_bitpack_uint(values->afrc.block_size, 4, 7) |
            util_bitpack_uint(values->afrc.format, 8, 15);
   cl[ 3] = 0;
   cl[ 4] = util_bitpack_uint(values->yuv.plane_0_base, 0, 63);
   cl[ 5] = util_bitpack_uint(values->yuv.plane_0_base, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->yuv.plane_1_base, 0, 63);
   cl[ 7] = util_bitpack_uint(values->yuv.plane_1_base, 0, 63) >> 32;
   cl[ 8] = util_bitpack_uint(values->yuv.plane_2_base, 0, 63) |
            util_bitpack_uint(values->afbc.header, 0, 63) |
            util_bitpack_uint(values->rgb.base, 0, 63);
   cl[ 9] = util_bitpack_uint(values->yuv.plane_2_base, 0, 63) >> 32 |
            util_bitpack_uint(values->afbc.header, 0, 63) >> 32 |
            util_bitpack_uint(values->rgb.base, 0, 63) >> 32;
   cl[10] = util_bitpack_uint(values->yuv.plane_0_stride, 0, 31) |
            util_bitpack_uint(values->afbc.row_stride, 0, 31) |
            util_bitpack_uint(values->rgb.row_stride, 0, 31);
   cl[11] = util_bitpack_uint(values->yuv.plane_1_2_stride, 0, 31) |
            util_bitpack_uint(values->afbc.body_offset, 0, 31) |
            util_bitpack_uint(values->rgb.surface_stride, 0, 31);
   cl[12] = util_bitpack_uint(values->clear.color_0, 0, 31);
   cl[13] = util_bitpack_uint(values->clear.color_1, 0, 31);
   cl[14] = util_bitpack_uint(values->clear.color_2, 0, 31);
   cl[15] = util_bitpack_uint(values->clear.color_3, 0, 31);
}


#define MALI_RENDER_TARGET_LENGTH 64
#define MALI_RENDER_TARGET_ALIGN 64
struct mali_render_target_packed { uint32_t opaque[16]; };
static inline void
MALI_RENDER_TARGET_unpack(const uint8_t * restrict cl,
                          struct MALI_RENDER_TARGET * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff0000) fprintf(stderr, "XXX: Invalid field of Render Target unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0x70000000) fprintf(stderr, "XXX: Invalid field of Render Target unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xe0080000) fprintf(stderr, "XXX: Invalid field of Render Target unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Render Target unpacked at word 3\n");
   values->yuv.swizzle = (enum mali_yuv_swizzle)__gen_unpack_uint(cl, 80, 82);
   values->yuv.full_range = __gen_unpack_uint(cl, 84, 84);
   values->yuv.conversion_mode = (enum mali_yuv_conversion_mode)__gen_unpack_uint(cl, 85, 88);
   values->yuv.cr_siting = (enum mali_yuv_cr_siting)__gen_unpack_uint(cl, 89, 91);
   values->yuv.unsigned_cr_range = __gen_unpack_uint(cl, 92, 92);
   values->yuv.plane_0_base = __gen_unpack_uint(cl, 128, 191);
   values->yuv.plane_1_base = __gen_unpack_uint(cl, 192, 255);
   values->yuv.plane_2_base = __gen_unpack_uint(cl, 256, 319);
   values->yuv.plane_0_stride = __gen_unpack_uint(cl, 320, 351);
   values->yuv.plane_1_2_stride = __gen_unpack_uint(cl, 352, 383);
   values->afbc.yuv_transform = __gen_unpack_uint(cl, 64, 64);
   values->afbc.split_block = __gen_unpack_uint(cl, 65, 65);
   values->afbc.wide_block = __gen_unpack_uint(cl, 66, 66);
   values->afbc.reverse_issue_order = __gen_unpack_uint(cl, 67, 67);
   values->afbc.front_buffer = __gen_unpack_uint(cl, 68, 68);
   values->afbc.alpha_hint = __gen_unpack_uint(cl, 69, 69);
   values->afbc.compression_mode = (enum mali_afbc_compression_mode)__gen_unpack_uint(cl, 74, 79);
   values->afbc.header = __gen_unpack_uint(cl, 256, 319);
   values->afbc.row_stride = __gen_unpack_uint(cl, 320, 351);
   values->afbc.body_offset = __gen_unpack_uint(cl, 352, 383);
   values->afrc.writeback_format = (enum mali_color_format)__gen_unpack_uint(cl, 32, 39);
   values->afrc.block_size = (enum mali_afrc_block_size)__gen_unpack_uint(cl, 68, 71);
   values->afrc.format = (enum mali_afrc_format)__gen_unpack_uint(cl, 72, 79);
   values->writeback_mode = (enum mali_writeback_mode)__gen_unpack_uint(cl, 0, 3);
   values->internal_buffer_offset = __gen_unpack_uint(cl, 4, 15) << 4;
   values->yuv_enable = __gen_unpack_uint(cl, 24, 24);
   values->dithered_clear = __gen_unpack_uint(cl, 25, 25);
   values->internal_format = (enum mali_color_buffer_internal_format)__gen_unpack_uint(cl, 26, 31);
   values->write_enable = __gen_unpack_uint(cl, 32, 32);
   values->writeback_format = (enum mali_color_format)__gen_unpack_uint(cl, 35, 39);
   values->writeback_block_format = (enum mali_block_format)__gen_unpack_uint(cl, 40, 43);
   values->writeback_msaa = (enum mali_msaa)__gen_unpack_uint(cl, 44, 45);
   values->srgb = __gen_unpack_uint(cl, 46, 46);
   values->dithering_enable = __gen_unpack_uint(cl, 47, 47);
   values->swizzle = __gen_unpack_uint(cl, 48, 59);
   values->clean_pixel_write_enable = __gen_unpack_uint(cl, 63, 63);
   values->rgb.base = __gen_unpack_uint(cl, 256, 319);
   values->rgb.row_stride = __gen_unpack_uint(cl, 320, 351);
   values->rgb.surface_stride = __gen_unpack_uint(cl, 352, 383);
   values->clear.color_0 = __gen_unpack_uint(cl, 384, 415);
   values->clear.color_1 = __gen_unpack_uint(cl, 416, 447);
   values->clear.color_2 = __gen_unpack_uint(cl, 448, 479);
   values->clear.color_3 = __gen_unpack_uint(cl, 480, 511);
}

static inline void
MALI_RENDER_TARGET_print(FILE *fp, const struct MALI_RENDER_TARGET * values, unsigned indent)
{
   fprintf(fp, "%*sYUV:\n", indent, "");
   MALI_RENDER_TARGET_YUV_OVERLAY_print(fp, &values->yuv, indent + 2);
   fprintf(fp, "%*sAFBC:\n", indent, "");
   MALI_RENDER_TARGET_AFBC_OVERLAY_print(fp, &values->afbc, indent + 2);
   fprintf(fp, "%*sAFRC:\n", indent, "");
   MALI_RENDER_TARGET_AFRC_OVERLAY_print(fp, &values->afrc, indent + 2);
   fprintf(fp, "%*sWriteback Mode: %s\n", indent, "", mali_writeback_mode_as_str(values->writeback_mode));
   fprintf(fp, "%*sInternal Buffer Offset: %u\n", indent, "", values->internal_buffer_offset);
   fprintf(fp, "%*sYUV Enable: %s\n", indent, "", values->yuv_enable ? "true" : "false");
   fprintf(fp, "%*sDithered Clear: %s\n", indent, "", values->dithered_clear ? "true" : "false");
   fprintf(fp, "%*sInternal Format: %s\n", indent, "", mali_color_buffer_internal_format_as_str(values->internal_format));
   fprintf(fp, "%*sWrite Enable: %s\n", indent, "", values->write_enable ? "true" : "false");
   fprintf(fp, "%*sWriteback Format: %s\n", indent, "", mali_color_format_as_str(values->writeback_format));
   fprintf(fp, "%*sWriteback Block Format: %s\n", indent, "", mali_block_format_as_str(values->writeback_block_format));
   fprintf(fp, "%*sWriteback MSAA: %s\n", indent, "", mali_msaa_as_str(values->writeback_msaa));
   fprintf(fp, "%*ssRGB: %s\n", indent, "", values->srgb ? "true" : "false");
   fprintf(fp, "%*sDithering Enable: %s\n", indent, "", values->dithering_enable ? "true" : "false");
   fprintf(fp, "%*sSwizzle: %u\n", indent, "", values->swizzle);
   fprintf(fp, "%*sClean Pixel Write Enable: %s\n", indent, "", values->clean_pixel_write_enable ? "true" : "false");
   fprintf(fp, "%*sRGB:\n", indent, "");
   MALI_RT_BUFFER_print(fp, &values->rgb, indent + 2);
   fprintf(fp, "%*sClear:\n", indent, "");
   MALI_RT_CLEAR_print(fp, &values->clear, indent + 2);
}

enum mali_chunk_size {
        MALI_CHUNK_SIZE_256_KIB              =      0,
        MALI_CHUNK_SIZE_512_KIB              =      1,
        MALI_CHUNK_SIZE_1_MIB                =      2,
        MALI_CHUNK_SIZE_2_MIB                =      3,
};

static inline const char *
mali_chunk_size_as_str(enum mali_chunk_size imm)
{
    switch (imm) {
    case MALI_CHUNK_SIZE_256_KIB: return "256 KiB";
    case MALI_CHUNK_SIZE_512_KIB: return "512 KiB";
    case MALI_CHUNK_SIZE_1_MIB: return "1 MiB";
    case MALI_CHUNK_SIZE_2_MIB: return "2 MiB";
    default: return "XXX: INVALID";
    }
}

enum mali_chunk_partition {
        MALI_CHUNK_PARTITION_DYNAMIC         =      0,
        MALI_CHUNK_PARTITION_STATIC_25       =      1,
        MALI_CHUNK_PARTITION_STATIC_50       =      2,
        MALI_CHUNK_PARTITION_STATIC_75       =      3,
};

static inline const char *
mali_chunk_partition_as_str(enum mali_chunk_partition imm)
{
    switch (imm) {
    case MALI_CHUNK_PARTITION_DYNAMIC: return "Dynamic";
    case MALI_CHUNK_PARTITION_STATIC_25: return "Static 25%";
    case MALI_CHUNK_PARTITION_STATIC_50: return "Static 50%";
    case MALI_CHUNK_PARTITION_STATIC_75: return "Static 75%";
    default: return "XXX: INVALID";
    }
}

struct MALI_TILER_HEAP {
   enum mali_descriptor_type            type;
   enum mali_buffer_type                buffer_type;
   enum mali_chunk_size                 chunk_size;
   enum mali_chunk_partition            partitioning;
   uint32_t                             size;
   uint64_t                             base;
   uint64_t                             bottom;
   uint64_t                             top;
};

#define MALI_TILER_HEAP_header                  \
   .type = MALI_DESCRIPTOR_TYPE_BUFFER,  \
   .buffer_type = MALI_BUFFER_TYPE_TILER_HEAP,  \
   .chunk_size = MALI_CHUNK_SIZE_256_KIB,  \
   .partitioning = MALI_CHUNK_PARTITION_DYNAMIC

static ALWAYS_INLINE void
MALI_TILER_HEAP_pack(uint32_t * restrict cl,
                     const struct MALI_TILER_HEAP * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->buffer_type, 4, 7) |
            util_bitpack_uint(values->chunk_size, 8, 9) |
            util_bitpack_uint(values->partitioning, 10, 11);
   cl[ 1] = util_bitpack_uint(ALIGN_POT(values->size, 4096), 0, 31);
   cl[ 2] = util_bitpack_uint(values->base, 0, 63);
   cl[ 3] = util_bitpack_uint(values->base, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->bottom, 0, 63);
   cl[ 5] = util_bitpack_uint(values->bottom, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->top, 0, 63);
   cl[ 7] = util_bitpack_uint(values->top, 0, 63) >> 32;
}


#define MALI_TILER_HEAP_LENGTH 32
#define MALI_TILER_HEAP_ALIGN 32
struct mali_tiler_heap_packed { uint32_t opaque[8]; };
static inline void
MALI_TILER_HEAP_unpack(const uint8_t * restrict cl,
                       struct MALI_TILER_HEAP * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xfffff000) fprintf(stderr, "XXX: Invalid field of Tiler Heap unpacked at word 0\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->buffer_type = (enum mali_buffer_type)__gen_unpack_uint(cl, 4, 7);
   values->chunk_size = (enum mali_chunk_size)__gen_unpack_uint(cl, 8, 9);
   values->partitioning = (enum mali_chunk_partition)__gen_unpack_uint(cl, 10, 11);
   values->size = __gen_unpack_uint(cl, 32, 63);
   assert(!(values->size & 0xfff));
   values->base = __gen_unpack_uint(cl, 64, 127);
   values->bottom = __gen_unpack_uint(cl, 128, 191);
   values->top = __gen_unpack_uint(cl, 192, 255);
}

static inline void
MALI_TILER_HEAP_print(FILE *fp, const struct MALI_TILER_HEAP * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sBuffer type: %s\n", indent, "", mali_buffer_type_as_str(values->buffer_type));
   fprintf(fp, "%*sChunk size: %s\n", indent, "", mali_chunk_size_as_str(values->chunk_size));
   fprintf(fp, "%*sPartitioning: %s\n", indent, "", mali_chunk_partition_as_str(values->partitioning));
   fprintf(fp, "%*sSize: %u\n", indent, "", values->size);
   fprintf(fp, "%*sBase: 0x%" PRIx64 "\n", indent, "", values->base);
   fprintf(fp, "%*sBottom: 0x%" PRIx64 "\n", indent, "", values->bottom);
   fprintf(fp, "%*sTop: 0x%" PRIx64 "\n", indent, "", values->top);
}

struct MALI_TILER_WEIGHTS {
   uint32_t                             weight0;
   uint32_t                             weight1;
   uint32_t                             weight2;
   uint32_t                             weight3;
   uint32_t                             weight4;
   uint32_t                             weight5;
   uint32_t                             weight6;
   uint32_t                             weight7;
};

#define MALI_TILER_WEIGHTS_header               \
   0

static ALWAYS_INLINE void
MALI_TILER_WEIGHTS_pack(uint32_t * restrict cl,
                        const struct MALI_TILER_WEIGHTS * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->weight0, 16, 31);
   cl[ 1] = util_bitpack_uint(values->weight1, 16, 31);
   cl[ 2] = util_bitpack_uint(values->weight2, 16, 31);
   cl[ 3] = util_bitpack_uint(values->weight3, 16, 31);
   cl[ 4] = util_bitpack_uint(values->weight4, 16, 31);
   cl[ 5] = util_bitpack_uint(values->weight5, 16, 31);
   cl[ 6] = util_bitpack_uint(values->weight6, 16, 31);
   cl[ 7] = util_bitpack_uint(values->weight7, 16, 31);
}


#define MALI_TILER_WEIGHTS_LENGTH 32
struct mali_tiler_weights_packed { uint32_t opaque[8]; };
static inline void
MALI_TILER_WEIGHTS_unpack(const uint8_t * restrict cl,
                          struct MALI_TILER_WEIGHTS * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffff) fprintf(stderr, "XXX: Invalid field of Tiler Weights unpacked at word 7\n");
   values->weight0 = __gen_unpack_uint(cl, 16, 31);
   values->weight1 = __gen_unpack_uint(cl, 48, 63);
   values->weight2 = __gen_unpack_uint(cl, 80, 95);
   values->weight3 = __gen_unpack_uint(cl, 112, 127);
   values->weight4 = __gen_unpack_uint(cl, 144, 159);
   values->weight5 = __gen_unpack_uint(cl, 176, 191);
   values->weight6 = __gen_unpack_uint(cl, 208, 223);
   values->weight7 = __gen_unpack_uint(cl, 240, 255);
}

static inline void
MALI_TILER_WEIGHTS_print(FILE *fp, const struct MALI_TILER_WEIGHTS * values, unsigned indent)
{
   fprintf(fp, "%*sWeight0: %u\n", indent, "", values->weight0);
   fprintf(fp, "%*sWeight1: %u\n", indent, "", values->weight1);
   fprintf(fp, "%*sWeight2: %u\n", indent, "", values->weight2);
   fprintf(fp, "%*sWeight3: %u\n", indent, "", values->weight3);
   fprintf(fp, "%*sWeight4: %u\n", indent, "", values->weight4);
   fprintf(fp, "%*sWeight5: %u\n", indent, "", values->weight5);
   fprintf(fp, "%*sWeight6: %u\n", indent, "", values->weight6);
   fprintf(fp, "%*sWeight7: %u\n", indent, "", values->weight7);
}

struct MALI_TILER_STATE {
   uint32_t                             word0;
   uint32_t                             word1;
   uint32_t                             word2;
   uint32_t                             word3;
   uint32_t                             word4;
   uint32_t                             word5;
   uint32_t                             word6;
   uint32_t                             word7;
};

#define MALI_TILER_STATE_header                 \
   0

static ALWAYS_INLINE void
MALI_TILER_STATE_pack(uint32_t * restrict cl,
                      const struct MALI_TILER_STATE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->word0, 0, 31);
   cl[ 1] = util_bitpack_uint(values->word1, 0, 31);
   cl[ 2] = util_bitpack_uint(values->word2, 0, 31);
   cl[ 3] = util_bitpack_uint(values->word3, 0, 31);
   cl[ 4] = util_bitpack_uint(values->word4, 0, 31);
   cl[ 5] = util_bitpack_uint(values->word5, 0, 31);
   cl[ 6] = util_bitpack_uint(values->word6, 0, 31);
   cl[ 7] = util_bitpack_uint(values->word7, 0, 31);
   cl[ 8] = 0;
   cl[ 9] = 0;
   cl[10] = 0;
   cl[11] = 0;
   cl[12] = 0;
   cl[13] = 0;
   cl[14] = 0;
   cl[15] = 0;
}


#define MALI_TILER_STATE_LENGTH 64
struct mali_tiler_state_packed { uint32_t opaque[16]; };
static inline void
MALI_TILER_STATE_unpack(const uint8_t * restrict cl,
                        struct MALI_TILER_STATE * restrict values)
{
   if (((const uint32_t *) cl)[8] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 8\n");
   if (((const uint32_t *) cl)[9] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 9\n");
   if (((const uint32_t *) cl)[10] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 10\n");
   if (((const uint32_t *) cl)[11] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 11\n");
   if (((const uint32_t *) cl)[12] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 12\n");
   if (((const uint32_t *) cl)[13] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 13\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler State unpacked at word 15\n");
   values->word0 = __gen_unpack_uint(cl, 0, 31);
   values->word1 = __gen_unpack_uint(cl, 32, 63);
   values->word2 = __gen_unpack_uint(cl, 64, 95);
   values->word3 = __gen_unpack_uint(cl, 96, 127);
   values->word4 = __gen_unpack_uint(cl, 128, 159);
   values->word5 = __gen_unpack_uint(cl, 160, 191);
   values->word6 = __gen_unpack_uint(cl, 192, 223);
   values->word7 = __gen_unpack_uint(cl, 224, 255);
}

static inline void
MALI_TILER_STATE_print(FILE *fp, const struct MALI_TILER_STATE * values, unsigned indent)
{
   fprintf(fp, "%*sWord0: %u\n", indent, "", values->word0);
   fprintf(fp, "%*sWord1: %u\n", indent, "", values->word1);
   fprintf(fp, "%*sWord2: %u\n", indent, "", values->word2);
   fprintf(fp, "%*sWord3: %u\n", indent, "", values->word3);
   fprintf(fp, "%*sWord4: %u\n", indent, "", values->word4);
   fprintf(fp, "%*sWord5: %u\n", indent, "", values->word5);
   fprintf(fp, "%*sWord6: %u\n", indent, "", values->word6);
   fprintf(fp, "%*sWord7: %u\n", indent, "", values->word7);
}

struct MALI_TILER_CONTEXT {
   uint64_t                             polygon_list;
   uint32_t                             hierarchy_mask;
   enum mali_sample_pattern             sample_pattern;
   bool                                 sample_test_disable;
   bool                                 first_provoking_vertex;
   uint32_t                             fb_width;
   uint32_t                             fb_height;
   uint32_t                             layer_count;
   uint32_t                             layer_offset;
   uint64_t                             heap;
   uint32_t                             geometry_buffer_size;
   uint64_t                             geometry_buffer;
   uint64_t                             completed_top;
   uint64_t                             completed_bottom;
   struct MALI_TILER_STATE              private_state;
};

#define MALI_TILER_CONTEXT_header               \
   .layer_count = 1,  \
   .geometry_buffer_size = 65536,  \
   .private_state = { MALI_TILER_STATE_header }

static ALWAYS_INLINE void
MALI_TILER_CONTEXT_pack(uint32_t * restrict cl,
                        const struct MALI_TILER_CONTEXT * restrict values)
{
   assert(values->fb_width >= 1);
   assert(values->fb_height >= 1);
   assert(values->layer_count >= 1);
   assert((values->geometry_buffer_size & 0xfff) == 0);
   assert((values->geometry_buffer & 0xfff) == 0);
   cl[ 0] = util_bitpack_uint(values->polygon_list, 0, 63);
   cl[ 1] = util_bitpack_uint(values->polygon_list, 0, 63) >> 32;
   cl[ 2] = util_bitpack_uint(values->hierarchy_mask, 0, 12) |
            util_bitpack_uint(values->sample_pattern, 13, 15) |
            util_bitpack_uint(values->sample_test_disable, 17, 17) |
            util_bitpack_uint(values->first_provoking_vertex, 18, 18);
   cl[ 3] = util_bitpack_uint(values->fb_width - 1, 0, 15) |
            util_bitpack_uint(values->fb_height - 1, 16, 31);
   cl[ 4] = util_bitpack_uint(values->layer_count - 1, 0, 7) |
            util_bitpack_uint(values->layer_offset, 8, 15);
   cl[ 5] = 0;
   cl[ 6] = util_bitpack_uint(values->heap, 0, 63);
   cl[ 7] = util_bitpack_uint(values->heap, 0, 63) >> 32;
   cl[ 8] = util_bitpack_uint(values->geometry_buffer_size >> 12, 0, 11) |
            util_bitpack_uint(values->geometry_buffer >> 12, 12, 63);
   cl[ 9] = util_bitpack_uint(values->geometry_buffer >> 12, 12, 63) >> 32;
   cl[10] = util_bitpack_uint(values->completed_top, 0, 63);
   cl[11] = util_bitpack_uint(values->completed_top, 0, 63) >> 32;
   cl[12] = util_bitpack_uint(values->completed_bottom, 0, 63);
   cl[13] = util_bitpack_uint(values->completed_bottom, 0, 63) >> 32;
   cl[14] = 0;
   cl[15] = 0;
   cl[16] = 0;
   cl[17] = 0;
   cl[18] = 0;
   cl[19] = 0;
   cl[20] = 0;
   cl[21] = 0;
   cl[22] = 0;
   cl[23] = 0;
   cl[24] = util_bitpack_uint(values->private_state.word0, 0, 31);
   cl[25] = util_bitpack_uint(values->private_state.word1, 0, 31);
   cl[26] = util_bitpack_uint(values->private_state.word2, 0, 31);
   cl[27] = util_bitpack_uint(values->private_state.word3, 0, 31);
   cl[28] = util_bitpack_uint(values->private_state.word4, 0, 31);
   cl[29] = util_bitpack_uint(values->private_state.word5, 0, 31);
   cl[30] = util_bitpack_uint(values->private_state.word6, 0, 31);
   cl[31] = util_bitpack_uint(values->private_state.word7, 0, 31);
}


#define MALI_TILER_CONTEXT_LENGTH 128
#define MALI_TILER_CONTEXT_ALIGN 64
struct mali_tiler_context_packed { uint32_t opaque[32]; };
static inline void
MALI_TILER_CONTEXT_unpack(const uint8_t * restrict cl,
                          struct MALI_TILER_CONTEXT * restrict values)
{
   if (((const uint32_t *) cl)[2] & 0xfff90000) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 2\n");
   if (((const uint32_t *) cl)[4] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 5\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 15\n");
   if (((const uint32_t *) cl)[16] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 16\n");
   if (((const uint32_t *) cl)[17] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 17\n");
   if (((const uint32_t *) cl)[18] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 18\n");
   if (((const uint32_t *) cl)[19] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 19\n");
   if (((const uint32_t *) cl)[20] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 20\n");
   if (((const uint32_t *) cl)[21] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 21\n");
   if (((const uint32_t *) cl)[22] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 22\n");
   if (((const uint32_t *) cl)[23] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Tiler Context unpacked at word 23\n");
   values->polygon_list = __gen_unpack_uint(cl, 0, 63);
   values->hierarchy_mask = __gen_unpack_uint(cl, 64, 76);
   values->sample_pattern = (enum mali_sample_pattern)__gen_unpack_uint(cl, 77, 79);
   values->sample_test_disable = __gen_unpack_uint(cl, 81, 81);
   values->first_provoking_vertex = __gen_unpack_uint(cl, 82, 82);
   values->fb_width = __gen_unpack_uint(cl, 96, 111) + 1;
   values->fb_height = __gen_unpack_uint(cl, 112, 127) + 1;
   values->layer_count = __gen_unpack_uint(cl, 128, 135) + 1;
   values->layer_offset = __gen_unpack_uint(cl, 136, 143);
   values->heap = __gen_unpack_uint(cl, 192, 255);
   values->geometry_buffer_size = __gen_unpack_uint(cl, 256, 267) << 12;
   values->geometry_buffer = __gen_unpack_uint(cl, 268, 319) << 12;
   values->completed_top = __gen_unpack_uint(cl, 320, 383);
   values->completed_bottom = __gen_unpack_uint(cl, 384, 447);
   values->private_state.word0 = __gen_unpack_uint(cl, 768, 799);
   values->private_state.word1 = __gen_unpack_uint(cl, 800, 831);
   values->private_state.word2 = __gen_unpack_uint(cl, 832, 863);
   values->private_state.word3 = __gen_unpack_uint(cl, 864, 895);
   values->private_state.word4 = __gen_unpack_uint(cl, 896, 927);
   values->private_state.word5 = __gen_unpack_uint(cl, 928, 959);
   values->private_state.word6 = __gen_unpack_uint(cl, 960, 991);
   values->private_state.word7 = __gen_unpack_uint(cl, 992, 1023);
}

static inline void
MALI_TILER_CONTEXT_print(FILE *fp, const struct MALI_TILER_CONTEXT * values, unsigned indent)
{
   fprintf(fp, "%*sPolygon List: 0x%" PRIx64 "\n", indent, "", values->polygon_list);
   fprintf(fp, "%*sHierarchy Mask: %u\n", indent, "", values->hierarchy_mask);
   fprintf(fp, "%*sSample Pattern: %s\n", indent, "", mali_sample_pattern_as_str(values->sample_pattern));
   fprintf(fp, "%*sSample test disable: %s\n", indent, "", values->sample_test_disable ? "true" : "false");
   fprintf(fp, "%*sFirst provoking vertex: %s\n", indent, "", values->first_provoking_vertex ? "true" : "false");
   fprintf(fp, "%*sFB Width: %u\n", indent, "", values->fb_width);
   fprintf(fp, "%*sFB Height: %u\n", indent, "", values->fb_height);
   fprintf(fp, "%*sLayer count: %u\n", indent, "", values->layer_count);
   fprintf(fp, "%*sLayer offset: %u\n", indent, "", values->layer_offset);
   fprintf(fp, "%*sHeap: 0x%" PRIx64 "\n", indent, "", values->heap);
   fprintf(fp, "%*sGeometry buffer size: %u\n", indent, "", values->geometry_buffer_size);
   fprintf(fp, "%*sGeometry buffer: 0x%" PRIx64 "\n", indent, "", values->geometry_buffer);
   fprintf(fp, "%*sCompleted top: 0x%" PRIx64 "\n", indent, "", values->completed_top);
   fprintf(fp, "%*sCompleted bottom: 0x%" PRIx64 "\n", indent, "", values->completed_bottom);
   fprintf(fp, "%*sPrivate state:\n", indent, "");
   MALI_TILER_STATE_print(fp, &values->private_state, indent + 2);
}

struct MALI_FRAMEBUFFER_PADDING {
   int dummy;
};

#define MALI_FRAMEBUFFER_PADDING_header         \
   0

static ALWAYS_INLINE void
MALI_FRAMEBUFFER_PADDING_pack(uint32_t * restrict cl,
                              const struct MALI_FRAMEBUFFER_PADDING * restrict values)
{
   cl[ 0] = 0;
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
   cl[ 8] = 0;
   cl[ 9] = 0;
   cl[10] = 0;
   cl[11] = 0;
   cl[12] = 0;
   cl[13] = 0;
   cl[14] = 0;
   cl[15] = 0;
}


#define MALI_FRAMEBUFFER_PADDING_LENGTH 64
struct mali_framebuffer_padding_packed { uint32_t opaque[16]; };
static inline void
MALI_FRAMEBUFFER_PADDING_unpack(const uint8_t * restrict cl,
                                struct MALI_FRAMEBUFFER_PADDING * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 7\n");
   if (((const uint32_t *) cl)[8] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 8\n");
   if (((const uint32_t *) cl)[9] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 9\n");
   if (((const uint32_t *) cl)[10] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 10\n");
   if (((const uint32_t *) cl)[11] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 11\n");
   if (((const uint32_t *) cl)[12] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 12\n");
   if (((const uint32_t *) cl)[13] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 13\n");
   if (((const uint32_t *) cl)[14] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 14\n");
   if (((const uint32_t *) cl)[15] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Framebuffer Padding unpacked at word 15\n");
}

static inline void
MALI_FRAMEBUFFER_PADDING_print(FILE *fp, const struct MALI_FRAMEBUFFER_PADDING * values, unsigned indent)
{
}

struct mali_framebuffer_packed {
   uint32_t opaque[32];
};

#define MALI_FRAMEBUFFER_LENGTH 128
#define MALI_FRAMEBUFFER_ALIGN 64
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_TYPE struct MALI_FRAMEBUFFER_PARAMETERS
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_header MALI_FRAMEBUFFER_PARAMETERS_header
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_pack MALI_FRAMEBUFFER_PARAMETERS_pack
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_unpack MALI_FRAMEBUFFER_PARAMETERS_unpack
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_print MALI_FRAMEBUFFER_PARAMETERS_print
#define MALI_FRAMEBUFFER_SECTION_PARAMETERS_OFFSET 0
#define MALI_FRAMEBUFFER_SECTION_PADDING_TYPE struct MALI_FRAMEBUFFER_PADDING
#define MALI_FRAMEBUFFER_SECTION_PADDING_header MALI_FRAMEBUFFER_PADDING_header
#define MALI_FRAMEBUFFER_SECTION_PADDING_pack MALI_FRAMEBUFFER_PADDING_pack
#define MALI_FRAMEBUFFER_SECTION_PADDING_unpack MALI_FRAMEBUFFER_PADDING_unpack
#define MALI_FRAMEBUFFER_SECTION_PADDING_print MALI_FRAMEBUFFER_PADDING_print
#define MALI_FRAMEBUFFER_SECTION_PADDING_OFFSET 64

struct MALI_FRAMEBUFFER_POINTER {
   bool                                 type;
   bool                                 zs_crc_extension_present;
   uint32_t                             render_target_count;
   uint64_t                             pointer;
};

#define MALI_FRAMEBUFFER_POINTER_header         \
   .type = true

static ALWAYS_INLINE void
MALI_FRAMEBUFFER_POINTER_pack(uint32_t * restrict cl,
                              const struct MALI_FRAMEBUFFER_POINTER * restrict values)
{
   assert(values->render_target_count >= 1);
   assert((values->pointer & 0x3f) == 0);
   cl[ 0] = util_bitpack_uint(values->type, 0, 0) |
            util_bitpack_uint(values->zs_crc_extension_present, 1, 1) |
            util_bitpack_uint(values->render_target_count - 1, 2, 5) |
            util_bitpack_uint(values->pointer >> 6, 6, 63);
   cl[ 1] = util_bitpack_uint(values->pointer >> 6, 6, 63) >> 32;
}


#define MALI_FRAMEBUFFER_POINTER_LENGTH 8
struct mali_framebuffer_pointer_packed { uint32_t opaque[2]; };
static inline void
MALI_FRAMEBUFFER_POINTER_unpack(const uint8_t * restrict cl,
                                struct MALI_FRAMEBUFFER_POINTER * restrict values)
{
   values->type = __gen_unpack_uint(cl, 0, 0);
   values->zs_crc_extension_present = __gen_unpack_uint(cl, 1, 1);
   values->render_target_count = __gen_unpack_uint(cl, 2, 5) + 1;
   values->pointer = __gen_unpack_uint(cl, 6, 63) << 6;
}

static inline void
MALI_FRAMEBUFFER_POINTER_print(FILE *fp, const struct MALI_FRAMEBUFFER_POINTER * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", values->type ? "true" : "false");
   fprintf(fp, "%*sZS CRC Extension present: %s\n", indent, "", values->zs_crc_extension_present ? "true" : "false");
   fprintf(fp, "%*sRender target count: %u\n", indent, "", values->render_target_count);
   fprintf(fp, "%*sPointer: 0x%" PRIx64 "\n", indent, "", values->pointer);
}

struct MALI_FRAGMENT_JOB_PAYLOAD {
   uint32_t                             bound_min_x;
   uint32_t                             bound_min_y;
   uint32_t                             bound_max_x;
   uint32_t                             bound_max_y;
   enum mali_tile_render_order          tile_render_order;
   bool                                 has_tile_enable_map;
   uint64_t                             framebuffer;
   uint64_t                             tile_enable_map;
   uint32_t                             tile_enable_map_row_stride;
};

#define MALI_FRAGMENT_JOB_PAYLOAD_header        \
   .tile_render_order = MALI_TILE_RENDER_ORDER_Z_ORDER

static ALWAYS_INLINE void
MALI_FRAGMENT_JOB_PAYLOAD_pack(uint32_t * restrict cl,
                               const struct MALI_FRAGMENT_JOB_PAYLOAD * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->bound_min_x, 0, 11) |
            util_bitpack_uint(values->bound_min_y, 16, 27);
   cl[ 1] = util_bitpack_uint(values->bound_max_x, 0, 11) |
            util_bitpack_uint(values->bound_max_y, 16, 27) |
            util_bitpack_uint(values->tile_render_order, 28, 30) |
            util_bitpack_uint(values->has_tile_enable_map, 31, 31);
   cl[ 2] = util_bitpack_uint(values->framebuffer, 0, 63);
   cl[ 3] = util_bitpack_uint(values->framebuffer, 0, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->tile_enable_map, 0, 63);
   cl[ 5] = util_bitpack_uint(values->tile_enable_map, 0, 63) >> 32;
   cl[ 6] = util_bitpack_uint(values->tile_enable_map_row_stride, 0, 7);
   cl[ 7] = 0;
}


#define MALI_FRAGMENT_JOB_PAYLOAD_LENGTH 32
struct mali_fragment_job_payload_packed { uint32_t opaque[8]; };
static inline void
MALI_FRAGMENT_JOB_PAYLOAD_unpack(const uint8_t * restrict cl,
                                 struct MALI_FRAGMENT_JOB_PAYLOAD * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xf000f000) fprintf(stderr, "XXX: Invalid field of Fragment Job Payload unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xf000) fprintf(stderr, "XXX: Invalid field of Fragment Job Payload unpacked at word 1\n");
   if (((const uint32_t *) cl)[6] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of Fragment Job Payload unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Fragment Job Payload unpacked at word 7\n");
   values->bound_min_x = __gen_unpack_uint(cl, 0, 11);
   values->bound_min_y = __gen_unpack_uint(cl, 16, 27);
   values->bound_max_x = __gen_unpack_uint(cl, 32, 43);
   values->bound_max_y = __gen_unpack_uint(cl, 48, 59);
   values->tile_render_order = (enum mali_tile_render_order)__gen_unpack_uint(cl, 60, 62);
   values->has_tile_enable_map = __gen_unpack_uint(cl, 63, 63);
   values->framebuffer = __gen_unpack_uint(cl, 64, 127);
   values->tile_enable_map = __gen_unpack_uint(cl, 128, 191);
   values->tile_enable_map_row_stride = __gen_unpack_uint(cl, 192, 199);
}

static inline void
MALI_FRAGMENT_JOB_PAYLOAD_print(FILE *fp, const struct MALI_FRAGMENT_JOB_PAYLOAD * values, unsigned indent)
{
   fprintf(fp, "%*sBound Min X: %u\n", indent, "", values->bound_min_x);
   fprintf(fp, "%*sBound Min Y: %u\n", indent, "", values->bound_min_y);
   fprintf(fp, "%*sBound Max X: %u\n", indent, "", values->bound_max_x);
   fprintf(fp, "%*sBound Max Y: %u\n", indent, "", values->bound_max_y);
   fprintf(fp, "%*sTile render order: %s\n", indent, "", mali_tile_render_order_as_str(values->tile_render_order));
   fprintf(fp, "%*sHas Tile Enable Map: %s\n", indent, "", values->has_tile_enable_map ? "true" : "false");
   fprintf(fp, "%*sFramebuffer: 0x%" PRIx64 "\n", indent, "", values->framebuffer);
   fprintf(fp, "%*sTile Enable Map: 0x%" PRIx64 "\n", indent, "", values->tile_enable_map);
   fprintf(fp, "%*sTile Enable Map Row Stride: %u\n", indent, "", values->tile_enable_map_row_stride);
}

struct MALI_SHADER_ENVIRONMENT {
   uint32_t                             attribute_offset;
   uint32_t                             fau_count;
   uint64_t                             resources;
   uint64_t                             shader;
   uint64_t                             thread_storage;
   uint64_t                             fau;
};

#define MALI_SHADER_ENVIRONMENT_header          \
   0

static ALWAYS_INLINE void
MALI_SHADER_ENVIRONMENT_pack(uint32_t * restrict cl,
                             const struct MALI_SHADER_ENVIRONMENT * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->attribute_offset, 0, 31);
   cl[ 1] = util_bitpack_uint(values->fau_count, 0, 7);
   cl[ 2] = 0;
   cl[ 3] = 0;
   cl[ 4] = 0;
   cl[ 5] = 0;
   cl[ 6] = 0;
   cl[ 7] = 0;
   cl[ 8] = util_bitpack_uint(values->resources, 0, 63);
   cl[ 9] = util_bitpack_uint(values->resources, 0, 63) >> 32;
   cl[10] = util_bitpack_uint(values->shader, 0, 63);
   cl[11] = util_bitpack_uint(values->shader, 0, 63) >> 32;
   cl[12] = util_bitpack_uint(values->thread_storage, 0, 63);
   cl[13] = util_bitpack_uint(values->thread_storage, 0, 63) >> 32;
   cl[14] = util_bitpack_uint(values->fau, 0, 63);
   cl[15] = util_bitpack_uint(values->fau, 0, 63) >> 32;
}


#define MALI_SHADER_ENVIRONMENT_LENGTH 64
#define MALI_SHADER_ENVIRONMENT_ALIGN 64
struct mali_shader_environment_packed { uint32_t opaque[16]; };
static inline void
MALI_SHADER_ENVIRONMENT_unpack(const uint8_t * restrict cl,
                               struct MALI_SHADER_ENVIRONMENT * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 4\n");
   if (((const uint32_t *) cl)[5] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 5\n");
   if (((const uint32_t *) cl)[6] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 6\n");
   if (((const uint32_t *) cl)[7] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Shader Environment unpacked at word 7\n");
   values->attribute_offset = __gen_unpack_uint(cl, 0, 31);
   values->fau_count = __gen_unpack_uint(cl, 32, 39);
   values->resources = __gen_unpack_uint(cl, 256, 319);
   values->shader = __gen_unpack_uint(cl, 320, 383);
   values->thread_storage = __gen_unpack_uint(cl, 384, 447);
   values->fau = __gen_unpack_uint(cl, 448, 511);
}

static inline void
MALI_SHADER_ENVIRONMENT_print(FILE *fp, const struct MALI_SHADER_ENVIRONMENT * values, unsigned indent)
{
   fprintf(fp, "%*sAttribute offset: %u\n", indent, "", values->attribute_offset);
   fprintf(fp, "%*sFAU count: %u\n", indent, "", values->fau_count);
   fprintf(fp, "%*sResources: 0x%" PRIx64 "\n", indent, "", values->resources);
   fprintf(fp, "%*sShader: 0x%" PRIx64 "\n", indent, "", values->shader);
   fprintf(fp, "%*sThread storage: 0x%" PRIx64 "\n", indent, "", values->thread_storage);
   fprintf(fp, "%*sFAU: 0x%" PRIx64 "\n", indent, "", values->fau);
}

struct MALI_COMPUTE_SIZE_WORKGROUP {
   uint32_t                             workgroup_size_x;
   uint32_t                             workgroup_size_y;
   uint32_t                             workgroup_size_z;
   bool                                 allow_merging_workgroups;
};

#define MALI_COMPUTE_SIZE_WORKGROUP_header      \
   0

static ALWAYS_INLINE void
MALI_COMPUTE_SIZE_WORKGROUP_pack(uint32_t * restrict cl,
                                 const struct MALI_COMPUTE_SIZE_WORKGROUP * restrict values)
{
   assert(values->workgroup_size_x >= 1);
   assert(values->workgroup_size_y >= 1);
   assert(values->workgroup_size_z >= 1);
   cl[ 0] = util_bitpack_uint(values->workgroup_size_x - 1, 0, 9) |
            util_bitpack_uint(values->workgroup_size_y - 1, 10, 19) |
            util_bitpack_uint(values->workgroup_size_z - 1, 20, 29) |
            util_bitpack_uint(values->allow_merging_workgroups, 31, 31);
   cl[ 1] = 0;
   cl[ 2] = 0;
   cl[ 3] = 0;
}


#define MALI_COMPUTE_SIZE_WORKGROUP_LENGTH 16
struct mali_compute_size_workgroup_packed { uint32_t opaque[4]; };
static inline void
MALI_COMPUTE_SIZE_WORKGROUP_unpack(const uint8_t * restrict cl,
                                   struct MALI_COMPUTE_SIZE_WORKGROUP * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x40000000) fprintf(stderr, "XXX: Invalid field of Compute size workgroup unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Compute size workgroup unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Compute size workgroup unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Compute size workgroup unpacked at word 3\n");
   values->workgroup_size_x = __gen_unpack_uint(cl, 0, 9) + 1;
   values->workgroup_size_y = __gen_unpack_uint(cl, 10, 19) + 1;
   values->workgroup_size_z = __gen_unpack_uint(cl, 20, 29) + 1;
   values->allow_merging_workgroups = __gen_unpack_uint(cl, 31, 31);
}

static inline void
MALI_COMPUTE_SIZE_WORKGROUP_print(FILE *fp, const struct MALI_COMPUTE_SIZE_WORKGROUP * values, unsigned indent)
{
   fprintf(fp, "%*sWorkgroup size X: %u\n", indent, "", values->workgroup_size_x);
   fprintf(fp, "%*sWorkgroup size Y: %u\n", indent, "", values->workgroup_size_y);
   fprintf(fp, "%*sWorkgroup size Z: %u\n", indent, "", values->workgroup_size_z);
   fprintf(fp, "%*sAllow merging workgroups: %s\n", indent, "", values->allow_merging_workgroups ? "true" : "false");
}

struct MALI_RESOURCE {
   uint64_t                             address;
   bool                                 contains_descriptors;
   uint64_t                             size;
};

#define MALI_RESOURCE_header                    \
   .contains_descriptors = true

static ALWAYS_INLINE void
MALI_RESOURCE_pack(uint32_t * restrict cl,
                   const struct MALI_RESOURCE * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->address, 0, 55);
   cl[ 1] = util_bitpack_uint(values->address, 0, 55) >> 32 |
            util_bitpack_uint(values->contains_descriptors, 24, 24);
   cl[ 2] = util_bitpack_uint(values->size, 0, 63);
   cl[ 3] = util_bitpack_uint(values->size, 0, 63) >> 32;
}


#define MALI_RESOURCE_LENGTH 16
#define MALI_RESOURCE_ALIGN 16
struct mali_resource_packed { uint32_t opaque[4]; };
static inline void
MALI_RESOURCE_unpack(const uint8_t * restrict cl,
                     struct MALI_RESOURCE * restrict values)
{
   if (((const uint32_t *) cl)[1] & 0xfe000000) fprintf(stderr, "XXX: Invalid field of Resource unpacked at word 1\n");
   values->address = __gen_unpack_uint(cl, 0, 55);
   values->contains_descriptors = __gen_unpack_uint(cl, 56, 56);
   values->size = __gen_unpack_uint(cl, 64, 127);
}

static inline void
MALI_RESOURCE_print(FILE *fp, const struct MALI_RESOURCE * values, unsigned indent)
{
   fprintf(fp, "%*sAddress: 0x%" PRIx64 "\n", indent, "", values->address);
   fprintf(fp, "%*sContains descriptors: %s\n", indent, "", values->contains_descriptors ? "true" : "false");
   fprintf(fp, "%*sSize: 0x%" PRIx64 "\n", indent, "", values->size);
}

struct MALI_DEPTH_STENCIL {
   enum mali_descriptor_type            type;
   enum mali_func                       front_compare_function;
   enum mali_stencil_op                 front_stencil_fail;
   enum mali_stencil_op                 front_depth_fail;
   enum mali_stencil_op                 front_depth_pass;
   enum mali_func                       back_compare_function;
   enum mali_stencil_op                 back_stencil_fail;
   enum mali_stencil_op                 back_depth_fail;
   enum mali_stencil_op                 back_depth_pass;
   bool                                 stencil_from_shader;
   bool                                 stencil_test_enable;
   uint32_t                             front_write_mask;
   uint32_t                             back_write_mask;
   uint32_t                             front_value_mask;
   uint32_t                             back_value_mask;
   uint32_t                             front_reference_value;
   uint32_t                             back_reference_value;
   bool                                 shader_read_only_z_s;
   bool                                 depth_cull_enable;
   enum mali_depth_clamp_mode           depth_clamp_mode;
   enum mali_depth_source               depth_source;
   bool                                 depth_write_enable;
   bool                                 depth_bias_enable;
   enum mali_func                       depth_function;
   float                                depth_units;
   float                                depth_factor;
   float                                depth_bias_clamp;
};

#define MALI_DEPTH_STENCIL_header               \
   .type = MALI_DESCRIPTOR_TYPE_DEPTH_STENCIL,  \
   .depth_cull_enable = true,  \
   .depth_clamp_mode = MALI_DEPTH_CLAMP_MODE_0_1,  \
   .depth_source = MALI_DEPTH_SOURCE_FIXED_FUNCTION

static ALWAYS_INLINE void
MALI_DEPTH_STENCIL_pack(uint32_t * restrict cl,
                        const struct MALI_DEPTH_STENCIL * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->type, 0, 3) |
            util_bitpack_uint(values->front_compare_function, 4, 6) |
            util_bitpack_uint(values->front_stencil_fail, 7, 9) |
            util_bitpack_uint(values->front_depth_fail, 10, 12) |
            util_bitpack_uint(values->front_depth_pass, 13, 15) |
            util_bitpack_uint(values->back_compare_function, 16, 18) |
            util_bitpack_uint(values->back_stencil_fail, 19, 21) |
            util_bitpack_uint(values->back_depth_fail, 22, 24) |
            util_bitpack_uint(values->back_depth_pass, 25, 27) |
            util_bitpack_uint(values->stencil_from_shader, 30, 30) |
            util_bitpack_uint(values->stencil_test_enable, 31, 31);
   cl[ 1] = util_bitpack_uint(values->front_write_mask, 0, 7) |
            util_bitpack_uint(values->back_write_mask, 8, 15) |
            util_bitpack_uint(values->front_value_mask, 16, 23) |
            util_bitpack_uint(values->back_value_mask, 24, 31);
   cl[ 2] = util_bitpack_uint(values->front_reference_value, 0, 7) |
            util_bitpack_uint(values->back_reference_value, 8, 15);
   cl[ 3] = 0;
   cl[ 4] = util_bitpack_uint(values->shader_read_only_z_s, 21, 21) |
            util_bitpack_uint(values->depth_cull_enable, 22, 22) |
            util_bitpack_uint(values->depth_clamp_mode, 23, 24) |
            util_bitpack_uint(values->depth_source, 25, 26) |
            util_bitpack_uint(values->depth_write_enable, 27, 27) |
            util_bitpack_uint(values->depth_bias_enable, 28, 28) |
            util_bitpack_uint(values->depth_function, 29, 31);
   cl[ 5] = util_bitpack_float(values->depth_units);
   cl[ 6] = util_bitpack_float(values->depth_factor);
   cl[ 7] = util_bitpack_float(values->depth_bias_clamp);
}


#define MALI_DEPTH_STENCIL_LENGTH 32
#define MALI_DEPTH_STENCIL_ALIGN 32
struct mali_depth_stencil_packed { uint32_t opaque[8]; };
static inline void
MALI_DEPTH_STENCIL_unpack(const uint8_t * restrict cl,
                          struct MALI_DEPTH_STENCIL * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x30000000) fprintf(stderr, "XXX: Invalid field of Depth/stencil unpacked at word 0\n");
   if (((const uint32_t *) cl)[2] & 0xffff0000) fprintf(stderr, "XXX: Invalid field of Depth/stencil unpacked at word 2\n");
   if (((const uint32_t *) cl)[3] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Depth/stencil unpacked at word 3\n");
   if (((const uint32_t *) cl)[4] & 0x1fffff) fprintf(stderr, "XXX: Invalid field of Depth/stencil unpacked at word 4\n");
   values->type = (enum mali_descriptor_type)__gen_unpack_uint(cl, 0, 3);
   values->front_compare_function = (enum mali_func)__gen_unpack_uint(cl, 4, 6);
   values->front_stencil_fail = (enum mali_stencil_op)__gen_unpack_uint(cl, 7, 9);
   values->front_depth_fail = (enum mali_stencil_op)__gen_unpack_uint(cl, 10, 12);
   values->front_depth_pass = (enum mali_stencil_op)__gen_unpack_uint(cl, 13, 15);
   values->back_compare_function = (enum mali_func)__gen_unpack_uint(cl, 16, 18);
   values->back_stencil_fail = (enum mali_stencil_op)__gen_unpack_uint(cl, 19, 21);
   values->back_depth_fail = (enum mali_stencil_op)__gen_unpack_uint(cl, 22, 24);
   values->back_depth_pass = (enum mali_stencil_op)__gen_unpack_uint(cl, 25, 27);
   values->stencil_from_shader = __gen_unpack_uint(cl, 30, 30);
   values->stencil_test_enable = __gen_unpack_uint(cl, 31, 31);
   values->front_write_mask = __gen_unpack_uint(cl, 32, 39);
   values->back_write_mask = __gen_unpack_uint(cl, 40, 47);
   values->front_value_mask = __gen_unpack_uint(cl, 48, 55);
   values->back_value_mask = __gen_unpack_uint(cl, 56, 63);
   values->front_reference_value = __gen_unpack_uint(cl, 64, 71);
   values->back_reference_value = __gen_unpack_uint(cl, 72, 79);
   values->shader_read_only_z_s = __gen_unpack_uint(cl, 149, 149);
   values->depth_cull_enable = __gen_unpack_uint(cl, 150, 150);
   values->depth_clamp_mode = (enum mali_depth_clamp_mode)__gen_unpack_uint(cl, 151, 152);
   values->depth_source = (enum mali_depth_source)__gen_unpack_uint(cl, 153, 154);
   values->depth_write_enable = __gen_unpack_uint(cl, 155, 155);
   values->depth_bias_enable = __gen_unpack_uint(cl, 156, 156);
   values->depth_function = (enum mali_func)__gen_unpack_uint(cl, 157, 159);
   values->depth_units = __gen_unpack_float(cl, 160, 191);
   values->depth_factor = __gen_unpack_float(cl, 192, 223);
   values->depth_bias_clamp = __gen_unpack_float(cl, 224, 255);
}

static inline void
MALI_DEPTH_STENCIL_print(FILE *fp, const struct MALI_DEPTH_STENCIL * values, unsigned indent)
{
   fprintf(fp, "%*sType: %s\n", indent, "", mali_descriptor_type_as_str(values->type));
   fprintf(fp, "%*sFront compare function: %s\n", indent, "", mali_func_as_str(values->front_compare_function));
   fprintf(fp, "%*sFront stencil fail: %s\n", indent, "", mali_stencil_op_as_str(values->front_stencil_fail));
   fprintf(fp, "%*sFront depth fail: %s\n", indent, "", mali_stencil_op_as_str(values->front_depth_fail));
   fprintf(fp, "%*sFront depth pass: %s\n", indent, "", mali_stencil_op_as_str(values->front_depth_pass));
   fprintf(fp, "%*sBack compare function: %s\n", indent, "", mali_func_as_str(values->back_compare_function));
   fprintf(fp, "%*sBack stencil fail: %s\n", indent, "", mali_stencil_op_as_str(values->back_stencil_fail));
   fprintf(fp, "%*sBack depth fail: %s\n", indent, "", mali_stencil_op_as_str(values->back_depth_fail));
   fprintf(fp, "%*sBack depth pass: %s\n", indent, "", mali_stencil_op_as_str(values->back_depth_pass));
   fprintf(fp, "%*sStencil from shader: %s\n", indent, "", values->stencil_from_shader ? "true" : "false");
   fprintf(fp, "%*sStencil test enable: %s\n", indent, "", values->stencil_test_enable ? "true" : "false");
   fprintf(fp, "%*sFront write mask: 0x%x\n", indent, "", values->front_write_mask);
   fprintf(fp, "%*sBack write mask: 0x%x\n", indent, "", values->back_write_mask);
   fprintf(fp, "%*sFront value mask: 0x%x\n", indent, "", values->front_value_mask);
   fprintf(fp, "%*sBack value mask: 0x%x\n", indent, "", values->back_value_mask);
   fprintf(fp, "%*sFront reference value: 0x%x\n", indent, "", values->front_reference_value);
   fprintf(fp, "%*sBack reference value: 0x%x\n", indent, "", values->back_reference_value);
   fprintf(fp, "%*sShader read only Z/S: %s\n", indent, "", values->shader_read_only_z_s ? "true" : "false");
   fprintf(fp, "%*sDepth cull enable: %s\n", indent, "", values->depth_cull_enable ? "true" : "false");
   fprintf(fp, "%*sDepth clamp mode: %s\n", indent, "", mali_depth_clamp_mode_as_str(values->depth_clamp_mode));
   fprintf(fp, "%*sDepth source: %s\n", indent, "", mali_depth_source_as_str(values->depth_source));
   fprintf(fp, "%*sDepth write enable: %s\n", indent, "", values->depth_write_enable ? "true" : "false");
   fprintf(fp, "%*sDepth bias enable: %s\n", indent, "", values->depth_bias_enable ? "true" : "false");
   fprintf(fp, "%*sDepth function: %s\n", indent, "", mali_func_as_str(values->depth_function));
   fprintf(fp, "%*sDepth units: %f\n", indent, "", values->depth_units);
   fprintf(fp, "%*sDepth factor: %f\n", indent, "", values->depth_factor);
   fprintf(fp, "%*sDepth bias clamp: %f\n", indent, "", values->depth_bias_clamp);
}

struct MALI_VERTEX_ARRAY {
   bool                                 packet;
   uint64_t                             pointer;
   uint32_t                             vertex_packet_stride;
   uint32_t                             vertex_attribute_stride;
};

#define MALI_VERTEX_ARRAY_header                \
   0

static ALWAYS_INLINE void
MALI_VERTEX_ARRAY_pack(uint32_t * restrict cl,
                       const struct MALI_VERTEX_ARRAY * restrict values)
{
   assert((values->pointer & 0x3f) == 0);
   cl[ 0] = util_bitpack_uint(values->packet, 0, 0) |
            util_bitpack_uint(values->pointer >> 6, 6, 63);
   cl[ 1] = util_bitpack_uint(values->pointer >> 6, 6, 63) >> 32;
   cl[ 2] = util_bitpack_uint(values->vertex_packet_stride, 0, 15) |
            util_bitpack_uint(values->vertex_attribute_stride, 16, 31);
}


#define MALI_VERTEX_ARRAY_LENGTH 12
struct mali_vertex_array_packed { uint32_t opaque[3]; };
static inline void
MALI_VERTEX_ARRAY_unpack(const uint8_t * restrict cl,
                         struct MALI_VERTEX_ARRAY * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0x3e) fprintf(stderr, "XXX: Invalid field of Vertex Array unpacked at word 0\n");
   values->packet = __gen_unpack_uint(cl, 0, 0);
   values->pointer = __gen_unpack_uint(cl, 6, 63) << 6;
   values->vertex_packet_stride = __gen_unpack_uint(cl, 64, 79);
   values->vertex_attribute_stride = __gen_unpack_uint(cl, 80, 95);
}

static inline void
MALI_VERTEX_ARRAY_print(FILE *fp, const struct MALI_VERTEX_ARRAY * values, unsigned indent)
{
   fprintf(fp, "%*sPacket: %s\n", indent, "", values->packet ? "true" : "false");
   fprintf(fp, "%*sPointer: 0x%" PRIx64 "\n", indent, "", values->pointer);
   fprintf(fp, "%*sVertex packet stride: %u\n", indent, "", values->vertex_packet_stride);
   fprintf(fp, "%*sVertex attribute stride: %u\n", indent, "", values->vertex_attribute_stride);
}

struct MALI_DCD_FLAGS_0 {
   bool                                 allow_forward_pixel_to_kill;
   bool                                 allow_forward_pixel_to_be_killed;
   enum mali_pixel_kill                 pixel_kill_operation;
   enum mali_pixel_kill                 zs_update_operation;
   bool                                 allow_primitive_reorder;
   bool                                 overdraw_alpha0;
   bool                                 overdraw_alpha1;
   bool                                 clean_fragment_write;
   bool                                 primitive_barrier;
   bool                                 evaluate_per_sample;
   bool                                 single_sampled_lines;
   enum mali_occlusion_mode             occlusion_query;
   bool                                 front_face_ccw;
   bool                                 cull_front_face;
   bool                                 cull_back_face;
   bool                                 multisample_enable;
   bool                                 shader_modifies_coverage;
   bool                                 alpha_to_coverage_invert;
   bool                                 alpha_to_coverage;
   bool                                 scissor_to_bounding_box;
};

#define MALI_DCD_FLAGS_0_header                 \
   .occlusion_query = MALI_OCCLUSION_MODE_DISABLED

static ALWAYS_INLINE void
MALI_DCD_FLAGS_0_pack(uint32_t * restrict cl,
                      const struct MALI_DCD_FLAGS_0 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->allow_forward_pixel_to_kill, 0, 0) |
            util_bitpack_uint(values->allow_forward_pixel_to_be_killed, 1, 1) |
            util_bitpack_uint(values->pixel_kill_operation, 2, 3) |
            util_bitpack_uint(values->zs_update_operation, 4, 5) |
            util_bitpack_uint(values->allow_primitive_reorder, 6, 6) |
            util_bitpack_uint(values->overdraw_alpha0, 7, 7) |
            util_bitpack_uint(values->overdraw_alpha1, 8, 8) |
            util_bitpack_uint(values->clean_fragment_write, 9, 9) |
            util_bitpack_uint(values->primitive_barrier, 10, 10) |
            util_bitpack_uint(values->evaluate_per_sample, 11, 11) |
            util_bitpack_uint(values->single_sampled_lines, 13, 13) |
            util_bitpack_uint(values->occlusion_query, 14, 15) |
            util_bitpack_uint(values->front_face_ccw, 16, 16) |
            util_bitpack_uint(values->cull_front_face, 17, 17) |
            util_bitpack_uint(values->cull_back_face, 18, 18) |
            util_bitpack_uint(values->multisample_enable, 19, 19) |
            util_bitpack_uint(values->shader_modifies_coverage, 20, 20) |
            util_bitpack_uint(values->alpha_to_coverage_invert, 21, 21) |
            util_bitpack_uint(values->alpha_to_coverage, 22, 22) |
            util_bitpack_uint(values->scissor_to_bounding_box, 23, 23);
}


#define MALI_DCD_FLAGS_0_LENGTH 4
struct mali_dcd_flags_0_packed { uint32_t opaque[1]; };
static inline void
MALI_DCD_FLAGS_0_unpack(const uint8_t * restrict cl,
                        struct MALI_DCD_FLAGS_0 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff001000) fprintf(stderr, "XXX: Invalid field of DCD Flags 0 unpacked at word 0\n");
   values->allow_forward_pixel_to_kill = __gen_unpack_uint(cl, 0, 0);
   values->allow_forward_pixel_to_be_killed = __gen_unpack_uint(cl, 1, 1);
   values->pixel_kill_operation = (enum mali_pixel_kill)__gen_unpack_uint(cl, 2, 3);
   values->zs_update_operation = (enum mali_pixel_kill)__gen_unpack_uint(cl, 4, 5);
   values->allow_primitive_reorder = __gen_unpack_uint(cl, 6, 6);
   values->overdraw_alpha0 = __gen_unpack_uint(cl, 7, 7);
   values->overdraw_alpha1 = __gen_unpack_uint(cl, 8, 8);
   values->clean_fragment_write = __gen_unpack_uint(cl, 9, 9);
   values->primitive_barrier = __gen_unpack_uint(cl, 10, 10);
   values->evaluate_per_sample = __gen_unpack_uint(cl, 11, 11);
   values->single_sampled_lines = __gen_unpack_uint(cl, 13, 13);
   values->occlusion_query = (enum mali_occlusion_mode)__gen_unpack_uint(cl, 14, 15);
   values->front_face_ccw = __gen_unpack_uint(cl, 16, 16);
   values->cull_front_face = __gen_unpack_uint(cl, 17, 17);
   values->cull_back_face = __gen_unpack_uint(cl, 18, 18);
   values->multisample_enable = __gen_unpack_uint(cl, 19, 19);
   values->shader_modifies_coverage = __gen_unpack_uint(cl, 20, 20);
   values->alpha_to_coverage_invert = __gen_unpack_uint(cl, 21, 21);
   values->alpha_to_coverage = __gen_unpack_uint(cl, 22, 22);
   values->scissor_to_bounding_box = __gen_unpack_uint(cl, 23, 23);
}

static inline void
MALI_DCD_FLAGS_0_print(FILE *fp, const struct MALI_DCD_FLAGS_0 * values, unsigned indent)
{
   fprintf(fp, "%*sAllow forward pixel to kill: %s\n", indent, "", values->allow_forward_pixel_to_kill ? "true" : "false");
   fprintf(fp, "%*sAllow forward pixel to be killed: %s\n", indent, "", values->allow_forward_pixel_to_be_killed ? "true" : "false");
   fprintf(fp, "%*sPixel kill operation: %s\n", indent, "", mali_pixel_kill_as_str(values->pixel_kill_operation));
   fprintf(fp, "%*sZS update operation: %s\n", indent, "", mali_pixel_kill_as_str(values->zs_update_operation));
   fprintf(fp, "%*sAllow primitive reorder: %s\n", indent, "", values->allow_primitive_reorder ? "true" : "false");
   fprintf(fp, "%*sOverdraw alpha0: %s\n", indent, "", values->overdraw_alpha0 ? "true" : "false");
   fprintf(fp, "%*sOverdraw alpha1: %s\n", indent, "", values->overdraw_alpha1 ? "true" : "false");
   fprintf(fp, "%*sClean Fragment Write: %s\n", indent, "", values->clean_fragment_write ? "true" : "false");
   fprintf(fp, "%*sPrimitive Barrier: %s\n", indent, "", values->primitive_barrier ? "true" : "false");
   fprintf(fp, "%*sEvaluate per-sample: %s\n", indent, "", values->evaluate_per_sample ? "true" : "false");
   fprintf(fp, "%*sSingle-sampled lines: %s\n", indent, "", values->single_sampled_lines ? "true" : "false");
   fprintf(fp, "%*sOcclusion query: %s\n", indent, "", mali_occlusion_mode_as_str(values->occlusion_query));
   fprintf(fp, "%*sFront face CCW: %s\n", indent, "", values->front_face_ccw ? "true" : "false");
   fprintf(fp, "%*sCull front face: %s\n", indent, "", values->cull_front_face ? "true" : "false");
   fprintf(fp, "%*sCull back face: %s\n", indent, "", values->cull_back_face ? "true" : "false");
   fprintf(fp, "%*sMultisample enable: %s\n", indent, "", values->multisample_enable ? "true" : "false");
   fprintf(fp, "%*sShader modifies coverage: %s\n", indent, "", values->shader_modifies_coverage ? "true" : "false");
   fprintf(fp, "%*sAlpha-to-coverage Invert: %s\n", indent, "", values->alpha_to_coverage_invert ? "true" : "false");
   fprintf(fp, "%*sAlpha-to-coverage: %s\n", indent, "", values->alpha_to_coverage ? "true" : "false");
   fprintf(fp, "%*sScissor to bounding box: %s\n", indent, "", values->scissor_to_bounding_box ? "true" : "false");
}

struct MALI_DCD_FLAGS_1 {
   uint32_t                             sample_mask;
   uint32_t                             render_target_mask;
};

#define MALI_DCD_FLAGS_1_header                 \
   0

static ALWAYS_INLINE void
MALI_DCD_FLAGS_1_pack(uint32_t * restrict cl,
                      const struct MALI_DCD_FLAGS_1 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->sample_mask, 0, 15) |
            util_bitpack_uint(values->render_target_mask, 16, 23);
}


#define MALI_DCD_FLAGS_1_LENGTH 4
struct mali_dcd_flags_1_packed { uint32_t opaque[1]; };
static inline void
MALI_DCD_FLAGS_1_unpack(const uint8_t * restrict cl,
                        struct MALI_DCD_FLAGS_1 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff000000) fprintf(stderr, "XXX: Invalid field of DCD Flags 1 unpacked at word 0\n");
   values->sample_mask = __gen_unpack_uint(cl, 0, 15);
   values->render_target_mask = __gen_unpack_uint(cl, 16, 23);
}

static inline void
MALI_DCD_FLAGS_1_print(FILE *fp, const struct MALI_DCD_FLAGS_1 * values, unsigned indent)
{
   fprintf(fp, "%*sSample mask: %u\n", indent, "", values->sample_mask);
   fprintf(fp, "%*sRender target mask: 0x%x\n", indent, "", values->render_target_mask);
}

struct MALI_DCD_FLAGS_2 {
   uint32_t                             read_mask;
   uint32_t                             write_mask;
};

#define MALI_DCD_FLAGS_2_header                 \
   0

static ALWAYS_INLINE void
MALI_DCD_FLAGS_2_pack(uint32_t * restrict cl,
                      const struct MALI_DCD_FLAGS_2 * restrict values)
{
   cl[ 0] = util_bitpack_uint(values->read_mask, 0, 11) |
            util_bitpack_uint(values->write_mask, 12, 23);
}


#define MALI_DCD_FLAGS_2_LENGTH 4
struct mali_dcd_flags_2_packed { uint32_t opaque[1]; };
static inline void
MALI_DCD_FLAGS_2_unpack(const uint8_t * restrict cl,
                        struct MALI_DCD_FLAGS_2 * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff000000) fprintf(stderr, "XXX: Invalid field of DCD Flags 2 unpacked at word 0\n");
   values->read_mask = __gen_unpack_uint(cl, 0, 11);
   values->write_mask = __gen_unpack_uint(cl, 12, 23);
}

static inline void
MALI_DCD_FLAGS_2_print(FILE *fp, const struct MALI_DCD_FLAGS_2 * values, unsigned indent)
{
   fprintf(fp, "%*sRead mask: 0x%x\n", indent, "", values->read_mask);
   fprintf(fp, "%*sWrite mask: 0x%x\n", indent, "", values->write_mask);
}

struct MALI_DRAW {
   bool                                 allow_forward_pixel_to_kill;
   bool                                 allow_forward_pixel_to_be_killed;
   enum mali_pixel_kill                 pixel_kill_operation;
   enum mali_pixel_kill                 zs_update_operation;
   bool                                 allow_primitive_reorder;
   bool                                 overdraw_alpha0;
   bool                                 overdraw_alpha1;
   bool                                 clean_fragment_write;
   bool                                 primitive_barrier;
   bool                                 evaluate_per_sample;
   bool                                 single_sampled_lines;
   enum mali_occlusion_mode             occlusion_query;
   bool                                 front_face_ccw;
   bool                                 cull_front_face;
   bool                                 cull_back_face;
   bool                                 multisample_enable;
   bool                                 shader_modifies_coverage;
   bool                                 alpha_to_coverage_invert;
   bool                                 alpha_to_coverage;
   bool                                 scissor_to_bounding_box;
   uint32_t                             sample_mask;
   uint32_t                             render_target_mask;
   struct MALI_VERTEX_ARRAY             vertex_array;
   struct MALI_DCD_FLAGS_2              flags_2;
   float                                minimum_z;
   float                                maximum_z;
   uint64_t                             depth_stencil;
   uint32_t                             blend_count;
   uint64_t                             blend;
   uint64_t                             occlusion;
   struct MALI_SHADER_ENVIRONMENT       shader;
};

#define MALI_DRAW_header                        \
   .occlusion_query = MALI_OCCLUSION_MODE_DISABLED,  \
   .vertex_array = { MALI_VERTEX_ARRAY_header },  \
   .flags_2 = { MALI_DCD_FLAGS_2_header },  \
   .shader = { MALI_SHADER_ENVIRONMENT_header }

static ALWAYS_INLINE void
MALI_DRAW_pack(uint32_t * restrict cl,
               const struct MALI_DRAW * restrict values)
{
   assert((values->blend & 0xf) == 0);
   cl[ 0] = util_bitpack_uint(values->allow_forward_pixel_to_kill, 0, 0) |
            util_bitpack_uint(values->allow_forward_pixel_to_be_killed, 1, 1) |
            util_bitpack_uint(values->pixel_kill_operation, 2, 3) |
            util_bitpack_uint(values->zs_update_operation, 4, 5) |
            util_bitpack_uint(values->allow_primitive_reorder, 6, 6) |
            util_bitpack_uint(values->overdraw_alpha0, 7, 7) |
            util_bitpack_uint(values->overdraw_alpha1, 8, 8) |
            util_bitpack_uint(values->clean_fragment_write, 9, 9) |
            util_bitpack_uint(values->primitive_barrier, 10, 10) |
            util_bitpack_uint(values->evaluate_per_sample, 11, 11) |
            util_bitpack_uint(values->single_sampled_lines, 13, 13) |
            util_bitpack_uint(values->occlusion_query, 14, 15) |
            util_bitpack_uint(values->front_face_ccw, 16, 16) |
            util_bitpack_uint(values->cull_front_face, 17, 17) |
            util_bitpack_uint(values->cull_back_face, 18, 18) |
            util_bitpack_uint(values->multisample_enable, 19, 19) |
            util_bitpack_uint(values->shader_modifies_coverage, 20, 20) |
            util_bitpack_uint(values->alpha_to_coverage_invert, 21, 21) |
            util_bitpack_uint(values->alpha_to_coverage, 22, 22) |
            util_bitpack_uint(values->scissor_to_bounding_box, 23, 23);
   cl[ 1] = util_bitpack_uint(values->sample_mask, 0, 15) |
            util_bitpack_uint(values->render_target_mask, 16, 23);
   cl[ 2] = util_bitpack_uint(values->vertex_array.packet, 0, 0) |
            util_bitpack_uint(values->vertex_array.pointer >> 6, 6, 63);
   cl[ 3] = util_bitpack_uint(values->vertex_array.pointer >> 6, 6, 63) >> 32;
   cl[ 4] = util_bitpack_uint(values->vertex_array.vertex_packet_stride, 0, 15) |
            util_bitpack_uint(values->vertex_array.vertex_attribute_stride, 16, 31);
   cl[ 5] = util_bitpack_uint(values->flags_2.read_mask, 0, 11) |
            util_bitpack_uint(values->flags_2.write_mask, 12, 23);
   cl[ 6] = util_bitpack_float(values->minimum_z);
   cl[ 7] = util_bitpack_float(values->maximum_z);
   cl[ 8] = 0;
   cl[ 9] = 0;
   cl[10] = util_bitpack_uint(values->depth_stencil, 0, 63);
   cl[11] = util_bitpack_uint(values->depth_stencil, 0, 63) >> 32;
   cl[12] = util_bitpack_uint(values->blend_count, 0, 3) |
            util_bitpack_uint(values->blend >> 4, 4, 63);
   cl[13] = util_bitpack_uint(values->blend >> 4, 4, 63) >> 32;
   cl[14] = util_bitpack_uint(values->occlusion, 0, 63);
   cl[15] = util_bitpack_uint(values->occlusion, 0, 63) >> 32;
   cl[16] = util_bitpack_uint(values->shader.attribute_offset, 0, 31);
   cl[17] = util_bitpack_uint(values->shader.fau_count, 0, 7);
   cl[18] = 0;
   cl[19] = 0;
   cl[20] = 0;
   cl[21] = 0;
   cl[22] = 0;
   cl[23] = 0;
   cl[24] = util_bitpack_uint(values->shader.resources, 0, 63);
   cl[25] = util_bitpack_uint(values->shader.resources, 0, 63) >> 32;
   cl[26] = util_bitpack_uint(values->shader.shader, 0, 63);
   cl[27] = util_bitpack_uint(values->shader.shader, 0, 63) >> 32;
   cl[28] = util_bitpack_uint(values->shader.thread_storage, 0, 63);
   cl[29] = util_bitpack_uint(values->shader.thread_storage, 0, 63) >> 32;
   cl[30] = util_bitpack_uint(values->shader.fau, 0, 63);
   cl[31] = util_bitpack_uint(values->shader.fau, 0, 63) >> 32;
}


#define MALI_DRAW_LENGTH 128
#define MALI_DRAW_ALIGN 64
struct mali_draw_packed { uint32_t opaque[32]; };
static inline void
MALI_DRAW_unpack(const uint8_t * restrict cl,
                 struct MALI_DRAW * restrict values)
{
   if (((const uint32_t *) cl)[0] & 0xff001000) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 0\n");
   if (((const uint32_t *) cl)[1] & 0xff000000) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 1\n");
   if (((const uint32_t *) cl)[2] & 0x3e) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 2\n");
   if (((const uint32_t *) cl)[5] & 0xff000000) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 5\n");
   if (((const uint32_t *) cl)[8] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 8\n");
   if (((const uint32_t *) cl)[9] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 9\n");
   if (((const uint32_t *) cl)[17] & 0xffffff00) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 17\n");
   if (((const uint32_t *) cl)[18] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 18\n");
   if (((const uint32_t *) cl)[19] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 19\n");
   if (((const uint32_t *) cl)[20] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 20\n");
   if (((const uint32_t *) cl)[21] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 21\n");
   if (((const uint32_t *) cl)[22] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 22\n");
   if (((const uint32_t *) cl)[23] & 0xffffffff) fprintf(stderr, "XXX: Invalid field of Draw unpacked at word 23\n");
   values->allow_forward_pixel_to_kill = __gen_unpack_uint(cl, 0, 0);
   values->allow_forward_pixel_to_be_killed = __gen_unpack_uint(cl, 1, 1);
   values->pixel_kill_operation = (enum mali_pixel_kill)__gen_unpack_uint(cl, 2, 3);
   values->zs_update_operation = (enum mali_pixel_kill)__gen_unpack_uint(cl, 4, 5);
   values->allow_primitive_reorder = __gen_unpack_uint(cl, 6, 6);
   values->overdraw_alpha0 = __gen_unpack_uint(cl, 7, 7);
   values->overdraw_alpha1 = __gen_unpack_uint(cl, 8, 8);
   values->clean_fragment_write = __gen_unpack_uint(cl, 9, 9);
   values->primitive_barrier = __gen_unpack_uint(cl, 10, 10);
   values->evaluate_per_sample = __gen_unpack_uint(cl, 11, 11);
   values->single_sampled_lines = __gen_unpack_uint(cl, 13, 13);
   values->occlusion_query = (enum mali_occlusion_mode)__gen_unpack_uint(cl, 14, 15);
   values->front_face_ccw = __gen_unpack_uint(cl, 16, 16);
   values->cull_front_face = __gen_unpack_uint(cl, 17, 17);
   values->cull_back_face = __gen_unpack_uint(cl, 18, 18);
   values->multisample_enable = __gen_unpack_uint(cl, 19, 19);
   values->shader_modifies_coverage = __gen_unpack_uint(cl, 20, 20);
   values->alpha_to_coverage_invert = __gen_unpack_uint(cl, 21, 21);
   values->alpha_to_coverage = __gen_unpack_uint(cl, 22, 22);
   values->scissor_to_bounding_box = __gen_unpack_uint(cl, 23, 23);
   values->sample_mask = __gen_unpack_uint(cl, 32, 47);
   values->render_target_mask = __gen_unpack_uint(cl, 48, 55);
   values->vertex_array.packet = __gen_unpack_uint(cl, 64, 64);
   values->vertex_array.pointer = __gen_unpack_uint(cl, 70, 127) << 6;
   values->vertex_array.vertex_packet_stride = __gen_unpack_uint(cl, 128, 143);
   values->vertex_array.vertex_attribute_stride = __gen_unpack_uint(cl, 144, 159);
   values->flags_2.read_mask = __gen_unpack_uint(cl, 160, 171);
   values->flags_2.write_mask = __gen_unpack_uint(cl, 172, 183);
   values->minimum_z = __gen_unpack_float(cl, 192, 223);
   values->maximum_z = __gen_unpack_float(cl, 224, 255);
   values->depth_stencil = __gen_unpack_uint(cl, 320, 383);
   values->blend_count = __gen_unpack_uint(cl, 384, 387);
   values->blend = __gen_unpack_uint(cl, 388, 447) << 4;
   values->occlusion = __gen_unpack_uint(cl, 448, 511);
   values->shader.attribute_offset = __gen_unpack_uint(cl, 512, 543);
   values->shader.fau_count = __gen_unpack_uint(cl, 544, 551);
   values->shader.resources = __gen_unpack_uint(cl, 768, 831);
   values->shader.shader = __gen_unpack_uint(cl, 832, 895);
   values->shader.thread_storage = __gen_unpack_uint(cl, 896, 959);
   values->shader.fau = __gen_unpack_uint(cl, 960, 1023);
}

static inline void
MALI_DRAW_print(FILE *fp, const struct MALI_DRAW * values, unsigned indent)
{
   fprintf(fp, "%*sAllow forward pixel to kill: %s\n", indent, "", values->allow_forward_pixel_to_kill ? "true" : "false");
   fprintf(fp, "%*sAllow forward pixel to be killed: %s\n", indent, "", values->allow_forward_pixel_to_be_killed ? "true" : "false");
   fprintf(fp, "%*sPixel kill operation: %s\n", indent, "", mali_pixel_kill_as_str(values->pixel_kill_operation));
   fprintf(fp, "%*sZS update operation: %s\n", indent, "", mali_pixel_kill_as_str(values->zs_update_operation));
   fprintf(fp, "%*sAllow primitive reorder: %s\n", indent, "", values->allow_primitive_reorder ? "true" : "false");
   fprintf(fp, "%*sOverdraw alpha0: %s\n", indent, "", values->overdraw_alpha0 ? "true" : "false");
   fprintf(fp, "%*sOverdraw alpha1: %s\n", indent, "", values->overdraw_alpha1 ? "true" : "false");
   fprintf(fp, "%*sClean Fragment Write: %s\n", indent, "", values->clean_fragment_write ? "true" : "false");
   fprintf(fp, "%*sPrimitive Barrier: %s\n", indent, "", values->primitive_barrier ? "true" : "false");
   fprintf(fp, "%*sEvaluate per-sample: %s\n", indent, "", values->evaluate_per_sample ? "true" : "false");
   fprintf(fp, "%*sSingle-sampled lines: %s\n", indent, "", values->single_sampled_lines ? "true" : "false");
   fprintf(fp, "%*sOcclusion query: %s\n", indent, "", mali_occlusion_mode_as_str(values->occlusion_query));
   fprintf(fp, "%*sFront face CCW: %s\n", indent, "", values->front_face_ccw ? "true" : "false");
   fprintf(fp, "%*sCull front face: %s\n", indent, "", values->cull_front_face ? "true" : "false");
   fprintf(fp, "%*sCull back face: %s\n", indent, "", values->cull_back_face ? "true" : "false");
   fprintf(fp, "%*sMultisample enable: %s\n", indent, "", values->multisample_enable ? "true" : "false");
   fprintf(fp, "%*sShader modifies coverage: %s\n", indent, "", values->shader_modifies_coverage ? "true" : "false");
   fprintf(fp, "%*sAlpha-to-coverage Invert: %s\n", indent, "", values->alpha_to_coverage_invert ? "true" : "false");
   fprintf(fp, "%*sAlpha-to-coverage: %s\n", indent, "", values->alpha_to_coverage ? "true" : "false");
   fprintf(fp, "%*sScissor to bounding box: %s\n", indent, "", values->scissor_to_bounding_box ? "true" : "false");
   fprintf(fp, "%*sSample mask: %u\n", indent, "", values->sample_mask);
   fprintf(fp, "%*sRender target mask: 0x%x\n", indent, "", values->render_target_mask);
   fprintf(fp, "%*sVertex array:\n", indent, "");
   MALI_VERTEX_ARRAY_print(fp, &values->vertex_array, indent + 2);
   fprintf(fp, "%*sFlags 2:\n", indent, "");
   MALI_DCD_FLAGS_2_print(fp, &values->flags_2, indent + 2);
   fprintf(fp, "%*sMinimum Z: %f\n", indent, "", values->minimum_z);
   fprintf(fp, "%*sMaximum Z: %f\n", indent, "", values->maximum_z);
   fprintf(fp, "%*sDepth/stencil: 0x%" PRIx64 "\n", indent, "", values->depth_stencil);
   fprintf(fp, "%*sBlend count: %u\n", indent, "", values->blend_count);
   fprintf(fp, "%*sBlend: 0x%" PRIx64 "\n", indent, "", values->blend);
   fprintf(fp, "%*sOcclusion: 0x%" PRIx64 "\n", indent, "", values->occlusion);
   fprintf(fp, "%*sShader:\n", indent, "");
   MALI_SHADER_ENVIRONMENT_print(fp, &values->shader, indent + 2);
}

struct MALI_PRIMITIVE_SIZE {
   float                                constant;
   uint64_t                             size_array;
};

#define MALI_PRIMITIVE_SIZE_header              \
   0

static ALWAYS_INLINE void
MALI_PRIMITIVE_SIZE_pack(uint32_t * restrict cl,
                         const struct MALI_PRIMITIVE_SIZE * restrict values)
{
   cl[ 0] = util_bitpack_float(values->constant) |
            util_bitpack_uint(values->size_array, 0, 63);
   cl[ 1] = util_bitpack_uint(values->size_array, 0, 63) >> 32;
}


#define MALI_PRIMITIVE_SIZE_LENGTH 8
struct mali_primitive_size_packed { uint32_t opaque[2]; };
static inline void
MALI_PRIMITIVE_SIZE_unpack(const uint8_t * restrict cl,
                           struct MALI_PRIMITIVE_SIZE * restrict values)
{
   values->constant = __gen_unpack_float(cl, 0, 31);
   values->size_array = __gen_unpack_uint(cl, 0, 63);
}

static inline void
MALI_PRIMITIVE_SIZE_print(FILE *fp, const struct MALI_PRIMITIVE_SIZE * values, unsigned indent)
{
   fprintf(fp, "%*sConstant: %f\n", indent, "", values->constant);
   fprintf(fp, "%*sSize Array: 0x%" PRIx64 "\n", indent, "", values->size_array);
}

#include "panfrost-job.h"
#endif
